def min_seconds_to_meet(N):
    if N < 3:
        return -1

    alice_position = 1
    bob_position = N

    for t in range(1, N):
        alice_positions = {alice_position + 2 * i for i in range(t)} | {alice_position + 3 * i for i in range(t)}
        bob_positions = {bob_position - i for i in range(1, t+1)} | {bob_position - 2 * i for i in range(1, t+1)}

        if alice_positions & bob_positions:
            return t
        
    return -1

N = int(input())

result = min_seconds_to_meet(N)
print(result)
