def find_min_time_to_meet(n):
    # Если N слишком мал, Аліса и Боб не могут встретиться
    if n == 2 or n == 3:
        return -1
    
    # Для каждого шага смотрим возможные пересечения
    time = 0
    # Начальные позиции Аліси и Боба
    alice_pos = 1
    bob_pos = n
    
    # Пытаемся найти минимальное количество секунд
    while alice_pos <= bob_pos:
        time += 1
        # Аліса может перемещаться на 2 или 3 позиции вперед
        alice_pos = max(alice_pos + 2, alice_pos + 3)
        
        # Боб может перемещаться на 1 или 2 позиции назад
        bob_pos = min(bob_pos - 1, bob_pos - 2)
        
        # Проверяем, встретятся ли они
        if alice_pos >= bob_pos:
            return time
    
    # Если они не могут встретиться
    return -1

# Чтение входных данных
n = int(input())
print(find_min_time_to_meet(n))
