def find_min_time_to_meet(n):
    # Простая проверка для самых маленьких значений
    if n == 2 or n == 3:
        return -1

    # Определим, что минимальное количество шагов для нахождения точки пересечения — это просто проверка
    steps = 0
    while True:
        alice_position = 1 + 2 * steps
        bob_position = n - 1 - 2 * steps
        if alice_position >= bob_position:
            break
        steps += 1

    # Возвращаем количество шагов, за которое они могут встретиться
    return steps

# Чтение входных данных
n = int(input())
print(find_min_time_to_meet(n))
