def find_min_time_to_meet(n):
    # Если n слишком мал, то встреча невозможна
    if n == 2 or n == 3:
        return -1
    
    # Алгоритм для поиска минимального времени
    for t in range(1, (n // 2) + 1):
        # Аліса может достичь позиции 1 + 2 * t или 1 + 3 * t
        for alice_pos in [1 + 2 * t, 1 + 3 * t]:
            if alice_pos >= n:
                break
            # Боб может достичь позиции n - 1 - t или n - 2 - t
            for bob_pos in [n - 1 - t, n - 2 - t]:
                if alice_pos == bob_pos:
                    return t

    return -1

# Чтение входных данных
n = int(input())
print(find_min_time_to_meet(n))
