private int rishennya(int n) {
    final int[] aliceSteps = new int[n];
    final int[] bobSteps = new int[n];

    // ne potribno dlia java, ale portibno dlia c
    aliceSteps[0] = 0;
    bobSteps[n - 1] = 0;

    for (int i = 1; i < n; i++) {
        aliceSteps[i] = Math.min(
                aliceSteps[i - 1] + 1,
                (i < 2 ? 0 : aliceSteps[i - 2]) + 1);
    }
    for (int i = n - 2; i >= 0; i--) {
        bobSteps[i] = Math.min(
                bobSteps[i + 1] + 1,
                (i >= n - 2 ? 0 : bobSteps[i + 2]) + 1);
    }
    for (int i = 0; i < n; i++) {
        if (aliceSteps[i] == bobSteps[i]) {
            return aliceSteps[i];
        }
    }
    return -1;
}