import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int N = in.nextInt();  // кількість боксів

        // Перевірка на можливість зустрічі
        int result = findMeetingTime(N);
        
        System.out.println(result);
    }

    private static int findMeetingTime(int N) {
        // Якщо число N є меншим за 6, то вони обов'язково зустрінуться через 1 секунду.
        if (N < 6) {
            return 1;
        }

        // Перевірка на можливість зустрічі
        for (int t = 1; t <= N; t++) {
            // Аліса може потрапити в бокс k = 1 + 2t або k = 1 + 3t
            int alice1 = 1 + 2 * t;
            int alice2 = 1 + 3 * t;
            
            // Боб може потрапити в бокс k = N - t або k = N - 2t
            int bob1 = N - t;
            int bob2 = N - 2 * t;

            // Якщо є спільний бокс
            if (alice1 == bob1 || alice1 == bob2 || alice2 == bob1 || alice2 == bob2) {
                return t;  // Вивести кількість секунд
            }
        }

        return -1;  // Якщо неможливо зустрітися
    }
}
