import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int N = in.nextInt();  // кількість боксів

        // Перевірка на можливість зустрічі
        int result = findMeetingTime(N);
        
        System.out.println(result);
    }

    private static int findMeetingTime(int N) {
        // Якщо число N менше 6, Аліса і Боб точно зустрінуться за 1 секунду
        if (N < 6) {
            return 1;
        }
        
        // Шукаємо по черзі час, при якому Аліса та Боб можуть зустрітися
        for (int t = 1; t <= 1000; t++) {
            // Перевіряємо можливі позиції Аліси та Боба на кожному кроці
            int alice1 = 1 + 2 * t;
            int alice2 = 1 + 3 * t;
            
            int bob1 = N - t;
            int bob2 = N - 2 * t;

            // Якщо Аліса та Боб можуть зустрітися в одному боксі
            if (alice1 == bob1 || alice1 == bob2 || alice2 == bob1 || alice2 == bob2) {
                return t;
            }
        }

        // Якщо Аліса і Боб не можуть зустрітися, виводимо -1
        return -1;
    }
}
