import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int N = in.nextInt();  // кількість боксів

        // Перевірка на можливість зустрічі
        int result = findMeetingTime(N);
        
        System.out.println(result);
    }

    private static int findMeetingTime(int N) {
        // Якщо N дуже маленьке, вони завжди зустрінуться за 1 секунду.
        if (N == 2) {
            return 1;
        }

        // Використовуємо цикл для пошуку зустрічі
        for (int t = 1; t <= N; t++) {
            // Визначення можливих позицій Аліси та Боба
            int alicePosition1 = 1 + 2 * t;
            int alicePosition2 = 1 + 3 * t;
            
            int bobPosition1 = N - t;
            int bobPosition2 = N - 2 * t;

            // Перевіряємо, чи можуть Аліса та Боб опинитися в одному боксі.
            if (alicePosition1 == bobPosition1 || alicePosition1 == bobPosition2 ||
                alicePosition2 == bobPosition1 || alicePosition2 == bobPosition2) {
                return t;
            }
        }

        // Якщо Аліса і Боб не можуть зустрітися, виводимо -1.
        return -1;
    }
}
