import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
       
        int n = in.nextInt();
       
        int m = in.nextInt();
        final List<Integer> rishennya = rishennya(n, m);
        for (Integer i : rishennya) {
            System.out.printf("%d \n", i);
        }
    }

    public static List<Integer> rishennya(int N, int b) {
        List<Integer> result = new ArrayList<>();

        for (int i = N - 1; i >= 0 && b > 0; i--) {
            final int price = i + 1;
            if (price <= b) {
                result.add(price);
                b -= price;
            }
        }

        if (b > 0) {
            result.clear();
            result.add(0);
        }

        return result;
    }
}
