import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);

        int n = in.nextInt();
        int m = in.nextInt();
        List<Integer> rishennya = rishennya(n, m);
        
        // Виведення результату
        for (Integer i : rishennya) {
            System.out.printf("%d\n", i);
        }
    }

    public static List<Integer> rishennya(int N, int b) {
        List<Integer> result = new ArrayList<>();

        // Знаходимо максимальну кількість чисел, які можна вибрати
        int maxPossible = Math.min(N, b);  // Найбільше число, яке можемо використати

        // Якщо сума чисел більше або дорівнює необхідній сумі b
        if (maxPossible * (maxPossible + 1) / 2 <= b) {
            // Додаємо всі числа від 1 до maxPossible
            for (int i = maxPossible; i > 0; i--) {
                result.add(i);
                b -= i;
            }
        }
        
        // Якщо залишок більше нуля, виводимо [0]
        if (b > 0) {
            result.clear();
            result.add(0);
        }

        return result;
    }
}
