#include <iostream>
#include <unordered_map>
#include <climits>
using namespace std;

int main() {
    int N;
    cin >> N;
    
    unordered_map<int, int> freq;
    int num;
    
    // Зчитуємо всі числа і підраховуємо їх кількість
    for (int i = 0; i < N; ++i) {
        cin >> num;
        freq[num]++;
    }
    
    // Знайдемо мінімальне унікальне число
    int result = INT_MAX;
    
    for (const auto& entry : freq) {
        if (entry.second == 1) {  // Якщо число унікальне
            result = min(result, entry.first);  // Зберігаємо мінімальне унікальне
        }
    }
    
    // Якщо результат не змінився, це означає, що вибори не відбулися
    if (result == INT_MAX) {
        cout << -1 << endl;
    } else {
        cout << result << endl;
    }
    
    return 0;
}
