#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    vector<vector<int>> grid(n, vector<int>(n));

    // Введення даних про кольори точок
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> grid[i][j];
        }
    }

    int count = 0;

    // Перевірка квадратів різних розмірів
    for (int size = 2; size <= n; size++) { // розміри квадратів від 2 до N
        for (int i = 0; i <= n - size; i++) { // верхня ліва точка по x
            for (int j = 0; j <= n - size; j++) { // верхня ліва точка по y
                int color = grid[i][j];
                bool is_square = true;
                
                // Перевіряємо всі чотири вершини квадрата розміру size
                for (int di = 0; di < size; di++) {
                    for (int dj = 0; dj < size; dj++) {
                        if (grid[i + di][j + dj] != color) {
                            is_square = false;
                            break;
                        }
                    }
                    if (!is_square) break;
                }

                if (is_square) {
                    count++;
                }
            }
        }
    }

    cout << count << endl;

    return 0;
}
