def main():
    N = int(input())  # Вхідне значення N
    grid = [list(map(int, input().split())) for _ in range(N)]  # Вхідна сітка
    
    # Лічильник квадратів з однаковим кольором
    count = 0
    
    # Перебираємо всі можливі квадрати 2x2
    for i in range(N-1):  # i - це рядок
        for j in range(N-1):  # j - це стовпець
            # Перевіряємо чотири точки квадрата
            color = grid[i][j]
            if grid[i][j] == grid[i+1][j] == grid[i][j+1] == grid[i+1][j+1]:
                count += 1
    
    # Виводимо результат
    print(count)

if __name__ == "__main__":
    main()
