def solve():
    t = int(input())  # кількість тестів
    
    for _ in range(t):
        N = int(input())  # кількість точок кожного кольору
        
        blue_points = []
        red_points = []
        
        # Зчитуємо сині точки
        for i in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y, i + 1))  # додаємо номер точки
        
        # Зчитуємо червоні точки
        for i in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y, i + 1))  # додаємо номер точки
        
        # Сортуємо точки за координатами
        blue_points.sort()  # сортуємо сині точки
        red_points.sort()   # сортуємо червоні точки
        
        # Якщо можна з'єднати без перетинів
        possible = True
        result = []
        for i in range(N):
            result.append((blue_points[i][2], red_points[i][2]))
        
        # Виводимо з'єднання
        if possible:
            for r in result:
                print(r[0], r[1])
        else:
            print(0)

# Запускаємо основну функцію
solve()
