#include <iostream>
#include <vector>
using namespace std;

vector<int> find_stamps(int N, int M) {
    vector<int> result;
    int i = N;
    while (M > 0 && i > 0) {
        if (M >= i) {
            result.push_back(i);
            M -= i;
        }
        --i;
    }
    if (M != 0) {
        return {0};
    }
    return result;
}

int main() {
    int N, M;
    cin >> N >> M;

    vector<int> result = find_stamps(N, M);

    for (int i = 0; i < result.size(); ++i) {
        if (i > 0) cout << " ";
        cout << result[i];
    }
    cout << endl;

    return 0;
}