def find_stamps(N, M):
    result = []
    current_sum = 0
    
    # Починаємо з найбільшої можливої марки
    for i in range(N, 0, -1):
        if current_sum + i <= M:
            result.append(i)
            current_sum += i
        if current_sum == M:
            break
    
    if current_sum == M:
        return result
    else:
        return [0]

def main():
    import sys
    input = sys.stdin.read
    data = input().split()
    
    N = int(data[0])
    M = int(data[1])
    
    result = find_stamps(N, M)
    print(" ".join(map(str, result)))

if __name__ == "__main__":
    main()