using System;
using System.Collections.Generic;

class Program
{
    static List<int> FindStamps(int N, int M)
    {
        List<int> result = new List<int>();
        int currentSum = 0;

        for (int i = N; i > 0; i--)
        {
            if (currentSum + i <= M)
            {
                result.Add(i);
                currentSum += i;
            }
            if (currentSum == M)
            {
                break;
            }
        }

        if (currentSum == M)
        {
            return result;
        }
        else
        {
            return new List<int> { 0 };
        }
    }

    static void Main(string[] args)
    {
        int N = int.Parse(Console.ReadLine());
        int M = int.Parse(Console.ReadLine());

        List<int> result = FindStamps(N, M);
        Console.WriteLine(string.Join(" ", result));
    }
}