#include <iostream>
#include <map>
#include <limits>
using namespace std;

int main() {
    int N;
    cin >> N;

    map<int, int> countMap; // Зберігаємо частоти чисел
    int number;

    // Зчитуємо всі числа і підраховуємо їх частоти
    for (int i = 0; i < N; ++i) {
        cin >> number;
        countMap[number]++;
    }

    int minUnique = numeric_limits<int>::max(); // Мінімальне унікальне число
    bool found = false;

    // Знаходимо мінімальне унікальне число
    for (const auto& entry : countMap) {
        if (entry.second == 1) { // Якщо число унікальне
            minUnique = min(minUnique, entry.first);
            found = true;
        }
    }

    // Вивід результату
    if (found) {
        cout << minUnique << endl;
    } else {
        cout << -1 << endl; // Якщо немає унікального мінімального числа
    }

    return 0;
}
