#include <iostream>
#include <vector>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    
    int N;
    cin >> N;
    
    // Зчитуємо матрицю кольорів
    vector<vector<int>> grid(N, vector<int>(N));
    for(int i = 0; i < N; i++) {
        for(int j = 0; j < N; j++) {
            cin >> grid[i][j];
        }
    }
    
    int count = 0;
    
    // Перебираємо першу вершину квадрата
    for(int y1 = 0; y1 < N - 1; y1++) {
        for(int x1 = 0; x1 < N - 1; x1++) {
            // Перебираємо довжину сторони квадрата
            for(int len = 1; len < N; len++) {
                // Обчислюємо координати інших вершин
                int x2 = x1 + len;
                int y2 = y1;
                int x3 = x1;
                int y3 = y1 + len;
                int x4 = x1 + len;
                int y4 = y1 + len;
                
                // Перевіряємо чи всі вершини в межах квадрата
                if(x4 >= N || y4 >= N) continue;
                
                // Перевіряємо квадрат з однаковим кольором вершин
                if(grid[y1][x1] == grid[y2][x2] && 
                   grid[y2][x2] == grid[y3][x3] && 
                   grid[y3][x3] == grid[y4][x4]) {
                    count++;
                }
            }
        }
    }
    
    cout << count << endl;
    return 0;
}