def solve(points):
    points.sort(key=lambda p: (p[0], p[1]))
    n = len(points) // 2
    pairs = [-1] * n * 2

    def find_pair(i):
        for j in range(n, n * 2):
            if pairs[j] == -1 and points[i][0] != points[j][0] and points[i][1] != points[j][1]:
                pairs[i] = j - n
                pairs[j] = i
                return True
        return False

    for i in range(n):
        if not find_pair(i):
            return None

    return pairs

points = [(1, 1), (3, 5), (4, 10), (2, 2), (1, 1)]
result = solve(points)

if result:
    for i, j in enumerate(result):
        print(f"{i+1} {j+1}")
else:
    print("Решение не найдено")