n = int(input())
print ("%d %d\n" % (n/10, n%10))
def minimum_time_to_meet(N):
    """
    Обчислює мінімальну кількість секунд для зустрічі Аліси та Боба або повертає -1, якщо це неможливо.
    :param N: Кількість боксів (2 ≤ N ≤ 10^9)
    :return: Мінімальна кількість секунд або -1
    """
    remainder = N % 5
    if remainder == 0 or remainder == 2:
        return N // 5
    else:
        return -1

try:
    # Зчитування вхідного числа
    N = int(input().strip())

    # Перевірка вхідних даних
    if not (2 <= N <= 1_000_000_000):
        raise ValueError("N має бути в межах 2 ≤ N ≤ 10^9.")

    # Обчислення та виведення результату
    print(minimum_time_to_meet(N))
except Exception as e:
    # Вивід повідомлення про помилку, якщо вхідні дані некоректні
    print(f"Помилка: {e}")
