#include <iostream>
using namespace std;

int min_seconds_to_meet(int N) {
    // Аліса починає з 1, а Боб з N
    int alice = 1;
    int bob = N;
    int seconds = 0;

    // Шукаємо, коли вони можуть зустрітися
    while (alice < bob) {
        seconds++;

        // Крок Аліси: може йти на +2 або +3
        if (alice + 2 <= bob) {
            alice += 2;
        } else {
            alice += 3;
        }

        // Крок Боба: може йти на -1 або -2
        if (bob - 1 >= alice) {
            bob -= 1;
        } else {
            bob -= 2;
        }
    }

    // Якщо вони зустрілися, виводимо кількість секунд
    if (alice == bob) {
        return seconds;
    } else {
        return -1;
    }
}

int main() {
    int N;
    cin >> N;  // Вхід: кількість боксів
    
    // Виведення мінімальної кількості секунд для зустрічі
    cout << min_seconds_to_meet(N) << endl;
    return 0;
}

