#include <iostream>
#include <cmath>
using namespace std;

int min_time_to_meet(int N) {
    for (int t = 1; t <= N; ++t) {  // Перевіряємо всі значення t
        for (int a = 0; a <= t; ++a) {
            int b = t - a;
            // Позиція Аліси: 1 + 2a + 3b
            int alice_pos = 1 + 2 * a + 3 * b;

            for (int c = 0; c <= t; ++c) {
                int d = t - c;
                // Позиція Боба: N - c - 2d
                int bob_pos = N - c - 2 * d;

                if (alice_pos == bob_pos) {
                    return t;  // Знайшли мінімальний час t
                }
            }
        }
    }

    return -1;  // Якщо не знайшли час для зустрічі
}

int main() {
    int N;
    cin >> N;  // Вхідне значення N
    int result = min_time_to_meet(N);
    cout << result << endl;  // Вивести результат
    return 0;
}
