#include <iostream>
#include <unordered_map>
#include <climits>
using namespace std;

int main() {
    int N;
    cin >> N;

    unordered_map<int, int> freq;
    int a;
    for (int i = 0; i < N; ++i) {
        cin >> a;
        freq[a]++;
    }

    int min_unique = INT_MAX;
    for (const auto& entry : freq) {
        if (entry.second == 1) {  
            min_unique = min(min_unique, entry.first);
        }
    }
    if (min_unique != INT_MAX) {
        cout << min_unique << endl;
    } else {
        cout << -1 << endl;
    }

    return 0;
}
