#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N;
    cin >> N;

    // Вхідні дані: матриця кольорів (0 - синій, 1 - червоний)
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int squareCount = 0;

    // Перевірка квадратів
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            // Проходимо по всіх можливих квадратах, починаючи з (i, j)
            for (int size = 1; i + size < N && j + size < N; ++size) {
                // Вершини квадрата: (i, j), (i+size, j), (i, j+size), (i+size, j+size)
                int color = grid[i][j];
                if (grid[i + size][j] == color && grid[i][j + size] == color && grid[i + size][j + size] == color) {
                    ++squareCount;
                }
            }
        }
    }

    cout << squareCount << endl;

    return 0;
}
