#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N;
    cin >> N;

    // Зчитуємо вхідні дані
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int squareCount = 0;

    // Перевіряємо всі можливі квадрати
    for (int size = 1; size < N; ++size) { // Розмір квадрата
        for (int i = 0; i + size < N; ++i) {
            for (int j = 0; j + size < N; ++j) {
                int color = grid[i][j];

                // Перевіряємо чотири вершини квадрата
                if (grid[i + size][j] == color && // верхня права
                    grid[i][j + size] == color && // нижня ліва
                    grid[i + size][j + size] == color) { // нижня права

                    squareCount++; // Збільшуємо лічильник
                }
            }
        }
    }

    cout << squareCount << endl;
    return 0;
}


