def find_stamps(N, M):
    dp = [float('inf')] * (M + 1)
    dp[0] = 0
    used = [-1] * (M + 1)
    for i in range(1, N + 1):
        for j in range(M, i - 1, -1):
            if dp[j - i] + 1 < dp[j]:
                dp[j] = dp[j - i] + 1
                used[j] = i
    if dp[M] == float('inf'):
        print(0)
        return
    selected_stamps = []
    while M > 0:
        selected_stamps.append(used[M])
        M -= used[M]
    print(*selected_stamps)
N = int(input()) 
M = int(input()) 
find_stamps(N, M)
