#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    cout<<n/10<<" "<<n%10<<"\n";
}
def min_time_to_meet(N):
    # На першому кроці Аліса знаходиться в боксі 1, Боб — в боксі N.
    
    # Набори можливих боксів для кожного з роботів
    alice_positions = {1}
    bob_positions = {N}
    
    # Лічильник секунд
    time = 0
    
    while time <= N:
        time += 1
        # Для Аліси можливі нові бокси через 2 або 3 одиниці
        new_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= N:
                new_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                new_alice_positions.add(pos + 3)
        
        # Для Боба можливі нові бокси через 1 або 2 одиниці в зворотному напрямку
        new_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                new_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_positions.add(pos - 2)
        
        # Перевіряємо, чи є спільний бокс
        if new_alice_positions & new_bob_positions:
            return time
        
        # Оновлюємо набір можливих боксов для Аліси та Боба
        alice_positions = new_alice_positions
        bob_positions = new_bob_positions
    
    # Якщо не знайшли спільного боксу, повертаємо -1
    return -1

# Зчитуємо вхід
N = int(input())

# Викликаємо функцію для отримання результату
print(min_time_to_meet(N))
