#include <bits/stdc++.h>

 int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    cout<<n/10<<" "<<n%10<<"\n";
}
#include <iostream>
#include <queue>
#include <unordered_set>
using namespace std;

int main() {
    // Вхідні дані
    long long N;
    cin >> N;

    // Перевірка на прості випадки
    if (N == 2) {
        cout << "1\n";
        return 0;
    }

    // BFS для Аліси
    unordered_set<long long> alice_positions;
    queue<pair<long long, int>> q_a;  // пара (позиція, кількість секунд)
    q_a.push({1, 0});  // Аліса починає з позиції 1
    alice_positions.insert(1);

    // BFS для Боба
    unordered_set<long long> bob_positions;
    queue<pair<long long, int>> q_b;  // пара (позиція, кількість секунд)
    q_b.push({N, 0});  // Боб починає з позиції N
    bob_positions.insert(N);

    // Пошук по часу
    while (!q_a.empty() || !q_b.empty()) {
        // Рух Аліси
        if (!q_a.empty()) {
            auto [pos_a, time_a] = q_a.front(); q_a.pop();
            if (bob_positions.find(pos_a) != bob_positions.end()) {
                cout << time_a << "\n";  // Знайшли спільну позицію
                return 0;
            }
            if (pos_a + 2 <= N && alice_positions.find(pos_a + 2) == alice_positions.end()) {
                alice_positions.insert(pos_a + 2);
                q_a.push({pos_a + 2, time_a + 1});
            }
            if (pos_a + 3 <= N && alice_positions.find(pos_a + 3) == alice_positions.end()) {
                alice_positions.insert(pos_a + 3);
                q_a.push({pos_a + 3, time_a + 1});
            }
        }

        // Рух Боба
        if (!q_b.empty()) {
            auto [pos_b, time_b] = q_b.front(); q_b.pop();
            if (alice_positions.find(pos_b) != alice_positions.end()) {
                cout << time_b << "\n";  // Знайшли спільну позицію
                return 0;
            }
            if (pos_b - 1 >= 1 && bob_positions.find(pos_b - 1) == bob_positions.end()) {
                bob_positions.insert(pos_b - 1);
                q_b.push({pos_b - 1, time_b + 1});
            }
            if (pos_b - 2 >= 1 && bob_positions.find(pos_b - 2) == bob_positions.end()) {
                bob_positions.insert(pos_b - 2);
                q_b.push({pos_b - 2, time_b + 1});
            }
        }
    }

    // Якщо не знайшли спільну позицію
    cout << "-1\n";
    return 0;
}

