from collections import deque

N = int(input())
if N <= 1:
    print(-1)
else:
    alice_queue = deque([1])
    bob_queue = deque([N])
    visited_alice = {1}
    visited_bob = {N}
    seconds = 0

    while alice_queue and bob_queue:
        # Менше ітерацій, починаємо з того, у кого черга коротша
        if len(alice_queue) > len(bob_queue):
            alice_queue, bob_queue = bob_queue, alice_queue
            visited_alice, visited_bob = visited_bob, visited_alice

        for _ in range(len(alice_queue)):
            pos = alice_queue.popleft()
            for next_pos in (pos + 2, pos + 3) if pos in visited_alice else (pos - 1, pos - 2):
                if 1 <= next_pos <= N:
                    if next_pos in visited_bob:  # Перетин знайдено
                        print(seconds + 1)
                        exit()
                    if next_pos not in visited_alice:
                        visited_alice.add(next_pos)
                        alice_queue.append(next_pos)

        seconds += 1

    print(-1)
