def decompose_number(M, N):
  if M <= 0 or N <= 0:
    return 0

  numbers = list(range(N, 0, -1))
  used_numbers = set()
  result = []

  while M > 0:
    for num in numbers:
      if num <= M and num not in used_numbers:
        M -= num
        result.append(num)
        used_numbers.add(num)
        break
    else:
      return 0

  return result
N = int(input())
M = int(input())
result = decompose_number(M, N)
if result:
  print(result)
else:
  print(0)