def decompose_number(M, N):
    result = []
    while M > 0 and N > 0:
        if N * (N + 1) // 2 >= M:
            if M >= N:
                result.append(N)
                M -= N
            N -= 1
        else:
            return "0"
    return " ".join(map(str, result)) if M == 0 else "0"

N = int(input())
M = int(input())

result = decompose_number(M, N)

print(result)
