def decompose_number(M, N):
    dp = [None] * (M + 1)
    dp[0] = []
    
    for i in range(1, N + 1):
        for j in range(M, i - 1, -1):
            if dp[j - i] is not None:
                dp[j] = dp[j - i] + [i]
    
    return " ".join(map(str, dp[M])) if dp[M] else "0"

N = int(input())
M = int(input())

result = decompose_number(M, N)

print(result)
