using System;

class Solution {
  public static void Main() {
      int n = int.Parse(Console.ReadLine());

       if (n >= 2 && n <= 1000000000)
    {
            int result = Calculation(n);
            Console.WriteLine(result);
    }
        else {
            Console.WriteLine("N має бути в діапазоні від 2 до 1 000 000 000.");
        }
  }

  public static int Calculation(int N) {
    int a_box = 1;
    int b_box = N;

    for (int i = 1; i <= N / 2; i++) {
        int[] alice_available_pos = {a_box + 2 * i, a_box + 3 * i};
        int[] bob_available_pos = {b_box - i, b_box - 2 * i};

        foreach (var alice_pos in alice_available_pos) {
            foreach (var bob_pos in bob_available_pos) {
                if (bob_pos == alice_pos) {
                    return i;
                }
            }
        }
    }

    return -1;
  }
}
