using System;

class Solution {
    public static void Main() {
        int n = int.Parse(Console.ReadLine());

        if (n < 2 || n > 1000000000) {
            Console.WriteLine("-1");
            return;
        }

        int result = FindMinimumTime(n);
        Console.WriteLine(result);
    }

    public static int FindMinimumTime(int N) {
        int seconds = 0; // каунтер секунд

        while (true) {
            int aliceStart = 1 + 2 * seconds; 
            int aliceEnd = 1 + 3 * seconds; 

            int bobStart = N - seconds; 
            int bobEnd = N - 2 * seconds; 

            if (aliceStart > N) break;

            if (bobEnd < 1) {
                seconds++;
                continue;
            }

            if ((bobStart >= aliceStart && bobStart <= aliceEnd) || 
                (bobEnd >= aliceStart && bobEnd <= aliceEnd) || 
                (aliceStart >= bobEnd && aliceStart <= bobStart)) {
                return seconds; 
            }
            seconds++;
        }

        return -1; 
    }
}