// Переробив з використанням HashSetу!
using System;
using System.Collections.Generic;

class Solution
{
    public static void Main()
    {
        int N = int.Parse(Console.ReadLine());

        // Початкові позиції роботів
        int alicePosition = 1;
        int bobPosition = N;

        // Множини для можливих позицій кожного робота.
        HashSet<int> alicePositions = new HashSet<int> { alicePosition };
        HashSet<int> bobPositions = new HashSet<int> { bobPosition };

        int seconds = 0;

        while (true)
        {
            seconds++;

            HashSet<int> newAlicePositions = new HashSet<int>();
            foreach (var position in alicePositions)
            {
                if (position + 2 <= N) newAlicePositions.Add(position + 2);
                if (position + 3 <= N) newAlicePositions.Add(position + 3);
            }

            HashSet<int> newBobPositions = new HashSet<int>();
            foreach (var position in bobPositions)
            {
                if (position - 1 >= 1) newBobPositions.Add(position - 1);
                if (position - 2 >= 1) newBobPositions.Add(position - 2);
            }

            // Перевірка 
            foreach (var position in newAlicePositions)
            {
                if (newBobPositions.Contains(position))
                {
                    Console.WriteLine(seconds);
                    return;
                }
            }

            alicePositions = newAlicePositions;
            bobPositions = newBobPositions;

            if (alicePositions.Count == 0 || bobPositions.Count == 0)
            {
                Console.WriteLine(-1);
                return;
            }
        }
    }
}