def teleportation(N):
    # Якщо кількість боксів менша за 2, неможливо зустрітись
    if N < 2:
        return -1
    
    # Якщо кількість боксів 2, Аліса та Боб зустрінуться через 1 секунду
    if N == 2:
        return 1

    # позиці] Аліси і Боба
    alice = 1
    bob = N

    seconds = 0
    
    # кроки для обох роботів
    while alice < bob:
        seconds += 1
        
        if alice + 3 <= N:
            alice += 3
        elif alice + 2 <= N:
            alice += 2
        
        if bob - 2 >= 1:
            bob -= 2
        elif bob - 1 >= 1:
            bob -= 1

        if alice == bob:
            return seconds
    
    # Якщо вони не зустрілись
    return -1

N = int(input())

# Виводимо відповідь
print(teleportation(N))
