def teleportation(N):
    # Якщо кількість боксів менша за 2, неможливо зустрітись
    if N < 2:
        return -1
    
    # Якщо кількість боксів 2, Аліса та Боб зустрінуться через 1 секунду
    if N == 2:
        return 1

    # Початкові позиції Аліси та Боба
    alice = 1
    bob = N
    
    seconds = 0
    
    while alice < bob:
        seconds += 1
        
        # Аліса рухається максимально швидко (на 3, якщо можливо)
        if alice + 3 <= N:
            alice += 3
        elif alice + 2 <= N:
            alice += 2
        
        # Боб рухається назад (на 2, якщо можливо)
        if bob - 2 >= 1:
            bob -= 2
        elif bob - 1 >= 1:
            bob -= 1

        # Якщо позиції Аліси та Боба співпали
        if alice == bob:
            return seconds
    
    # Якщо вони не зустрілись
    return -1

# Введення
N = int(input())

# Виведення результату
print(teleportation(N))
