import math

def select_stamps(N, M):
    
    stamp_sum = N * (N + 1) // 2

    if M > stamp_sum:
        return [0]

    selected_stamps = []

    # Шукаємо числа з кінця діапазону
    while M > 0:
        k = int((math.sqrt(8 * M + 1) - 1) // 2)
        if k > N:
            k = N
        selected_stamps.append(k)
        M -= k
        N = k - 1  

    if M == 0:
        return selected_stamps
    else:
        return [0]

# Зчитуємо дані
input = sys.stdin.read
N, M = map(int, input().split())

# Отримуємо результат
result = select_stamps(N, M)

print("\n".join(map(str, result)) + "\n")

