def count_uniform_squares(N, grid):
    count = 0
    
    # Перебираємо всі можливі верхні ліві кути квадратів  
    for x in range(N):
        for y in range(N):
            # Перебираємо можливі розміри квадратів  
            for size in range(1, N - max(x, y) + 1):
                # Визначаємо координати всіх чотирьох вершин  
                a = grid[x][y]           # Верхній лівий кут  
                b = grid[x][y + size - 1]  # Верхній правий кут  
                c = grid[x + size - 1][y]  # Нижній лівий кут  
                d = grid[x + size - 1][y + size - 1]  # Нижній правий кут
                
                # Перевіряємо, чи всі чотири кути однакові  
                if a == b == c == d:
                    count += 1
                    
    return count

# Зчитування вводу  
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Виводимо відповідь  
print(count_uniform_squares(N, grid))