def count_uniform_squares(N, grid):
    count = 0
    
    # Перебираємо всі можливі розміри квадратів  
    for size in range(1, N):  # Розмір квадратів від 1 до N-1  
        for x in range(N - size):
            for y in range(N - size):
                # Кути квадрата  
                a = grid[x][y]  # Верхній лівий кут  
                b = grid[x][y + size]  # Верхній правий кут  
                c = grid[x + size][y]  # Нижній лівий кут  
                d = grid[x + size][y + size]  # Нижній правий кут
                
                # Перевіряємо, чи всі кути однакові  
                if a == b == c == d:
                    count += 1
                    
    return count

# Зчитування вводу  
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Виводимо відповідь  
print(count_uniform_squares(N, grid) + 1)