#include <bits/stdc++.h>
using namespace std;

vector<int> choose_stamps(int N, int M) {
    vector<int> result;
    int remaining_sum = M;

    // Оптимізація: починаємо з найбільшої марки
    for (int i = N; i >= 1 && remaining_sum > 0; i--) {
        if (i <= remaining_sum) {
            result.push_back(i);
            remaining_sum -= i;
        }
    }

    return remaining_sum == 0 ? result : vector<int>();
}

int main() {
    int N, M;
    cin >> N >> M;

    vector<int> selected_stamps = choose_stamps(N, M);

    if (!selected_stamps.empty()) {
        for (int stamp : selected_stamps) {
            cout << stamp << " ";
        }
    } else {
        cout << 0;
    }

    return 0;
}