#include <bits/stdc++.h>
using namespace std;

struct Point {
    int x, y, index;
};

bool compare(const Point &a, const Point &b) {
    return a.x < b.x;
}

bool doIntersect(Point a, Point b, Point c, Point d) {
    return (a.x < c.x && b.x > d.x) || (a.x > c.x && b.x < d.x);
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<Point> blue(N), red(N);

        for (int i = 0; i < N; i++) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1;
        }

        for (int i = 0; i < N; i++) {
            cin >> red[i].x >> red[i].y;
            red[i].index = i + 1;
        }

        sort(blue.begin(), blue.end(), compare);
        sort(red.begin(), red.end(), compare);

        bool possible = true;
        for (int i = 1; i < N; i++) {
            if (doIntersect(blue[i - 1], red[i - 1], blue[i], red[i])) {
                possible = false;
                break;
            }
        }

        if (possible) {
            for (int i = 0; i < N; i++) {
                cout << blue[i].index << " " << red[i].index << endl;
            }
        } else {
            cout << 0 << endl;
        }
    }

    return 0;
}