from collections import deque

def min_seconds_to_meet(N):
    alice_queue = deque([1]) 
    bob_queue = deque([N]) 
    
    alice_visited = set([1])
    bob_visited = set([N])
    
    seconds = 0
    while alice_queue and bob_queue:
        seconds += 1

        for _ in range(len(alice_queue)):
            pos = alice_queue.popleft()
            for next_pos in [pos + 2, pos + 3]:
                if next_pos <= N and next_pos not in alice_visited:
                    alice_visited.add(next_pos)
                    alice_queue.append(next_pos)
                    if next_pos in bob_visited:
                        return seconds
        
        for _ in range(len(bob_queue)):
            pos = bob_queue.popleft()
            for next_pos in [pos - 1, pos - 2]:
                if next_pos >= 1 and next_pos not in bob_visited:
                    bob_visited.add(next_pos)
                    bob_queue.append(next_pos)
                    if next_pos in alice_visited:
                        return seconds
    
    return -1
N = int(input())
print(min_seconds_to_meet(N))