def find_president(N, numbers):
    from collections import Counter
    
    counts = Counter(numbers)
    
    unique_numbers = [num for num, count in counts.items() if count == 1]
    
    if not unique_numbers:
        return -1
    else:
        return min(unique_numbers)

N = int(input())
numbers = list(map(int, input().split()))

print(find_president(N, numbers))