def solve_test_cases(t, test_cases):
    results = []
    for case in test_cases:
        N, blue_points, red_points = case
        
        blue_points = [(x, y, i + 1) for i, (x, y) in enumerate(blue_points)]
        red_points = [(x, y, i + 1) for i, (x, y) in enumerate(red_points)]
        
        blue_points.sort()
        red_points.sort()
        
        result = []
        for i in range(N):
            result.append((blue_points[i][2], red_points[i][2]))
        results.append(result)
    return results


t = int(input())
test_cases = []
for _ in range(t):
    N = int(input())
    blue_points = [tuple(map(int, input().split())) for _ in range(N)]
    red_points = [tuple(map(int, input().split())) for _ in range(N)]
    test_cases.append((N, blue_points, red_points))

results = solve_test_cases(t, test_cases)

for result in results:
    if not result:
        print(0)
    else:
        for blue_idx, red_idx in result:
            print(blue_idx, red_idx)