def solve():
    t = int(input())  # Number of test cases
    for _ in range(t):
        N = int(input())  # Number of points of each color
        blue_points = []
        red_points = []
        
        # Reading blue points
        for i in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y, i + 1))  # Save coordinates with index (1-based)
        
        # Reading red points
        for i in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y, i + 1))  # Save coordinates with index (1-based)
        
        # Sort blue points by (x, y)
        blue_points.sort()
        # Sort red points by (x, y)
        red_points.sort()
        
        # Output the pairs: blue point to red point in reverse order of red points
        for i in range(N):
            print(blue_points[i][2], red_points[N - 1 - i][2])  # Reverse the red point order

# Call the function to process the input and output
solve()
