#include <iostream>
#include <algorithm> 
using namespace std;

long long lcm(long long a, long long b) {
    return (a * b) / std::gcd(a, b);
}
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long N, A, B;
    cin >> N >> A >> B;
    
    // Підраховуємо кількість елементів, які діляться на A, B і LCM(A, B)
    long long countA = N / A;
    long long countB = N / B;
    long long countLCM = N / lcm(A, B);
    
    // Використовуємо принцип включень та виключень
    long long result = countA + countB - countLCM;
    
    cout << result << endl;
    
    return 0;
}
