#include <iostream>
#include <vector>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

   int N;
    cin >> N;

    // Введення сітки кольорів (0 - синій, 1 - червоний)
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int count = 0;

    // Перебираємо всі можливі квадрати
    for (int size = 2; size <= N; ++size) {  // Розмір квадрата від 2 до N
        for (int i = 0; i <= N - size; ++i) {  // Верхній лівий кут по x
            for (int j = 0; j <= N - size; ++j) {  // Верхній лівий кут по y
                // Вершини квадрата (i,j), (i+size-1,j), (i,j+size-1), (i+size-1,j+size-1)
                int color = grid[i][j];  // Колір верхнього лівого кута
                if (grid[i + size - 1][j] == color &&
                    grid[i][j + size - 1] == color &&
                    grid[i + size - 1][j + size - 1] == color) {
                    count++;
                }
            }
        }
    }

    cout << count << endl;

    return 0;
}
