#include <iostream>
#include <vector>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

   int N;
    cin >> N;

    // Зчитуємо матрицю кольорів
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int count = 0;

    // Перебираємо всі можливі квадрати
    for (int i = 0; i < N - 1; ++i) {        // Верхній лівий кут
        for (int j = 0; j < N - 1; ++j) {    // Верхній лівий кут
            for (int size = 1; size < N; ++size) {  // Розмір квадрата
                if (i + size < N && j + size < N) { // Перевірка на вихід за межі
                    // Перевіряємо всі чотири вершини квадрата
                    if (grid[i][j] == grid[i + size][j] && 
                        grid[i][j] == grid[i][j + size] && 
                        grid[i][j] == grid[i + size][j + size]) {
                        count++; // Збільшуємо лічильник, якщо всі вершини однакові
                    }
                }
            }
        }
    }

    cout << count << endl;

    return 0;
}
