def solve():
    N = int(input())
    
    alice_positions = set([1])
    bob_positions = set([N])
    time = 0
    
    while alice_positions.isdisjoint(bob_positions):
        time += 1
        
        next_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= N:
                next_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                next_alice_positions.add(pos + 3)
        
        next_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                next_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                next_bob_positions.add(pos - 2)
        
        alice_positions = next_alice_positions
        bob_positions = next_bob_positions
        
        if alice_positions & bob_positions:
            print(time)
            return
    
    print(-1)

solve()
