def count_same_color_squares(N, grid):
    count = 0

    for i in range(N - 1):
        for j in range(N - 1):
            
            if (grid[i][j] == grid[i + 1][j] == grid[i][j + 1] == grid[i + 1][j + 1]):
                count += 1
    return count

def main():
    import sys
    input = sys.stdin.read
    data = input().split()
    
    N = int(data[0])
    grid = []
    
    index = 1
    for i in range(N):
        grid.append([int(data[index + j]) for j in range(N)])
        index += N
    
    result = count_same_color_squares(N, grid)
    print(result)

if __name__ == "__main__":
    main()
