def count_colored_squares(N, grid):
    count = 0
   
    for size in range(1, N):  
        for i in range(N - size):  
            for j in range(N - size):  
                
                color = grid[i][j]
                all_same = True
                for di in range(size + 1):
                    for dj in range(size + 1):
                        if grid[i + di][j + dj] != color:
                            all_same = False
                            break
                    if not all_same:
                        break
                if all_same:
                    count += 1
    return count

N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

result = count_colored_squares(N, grid)
print(result)
