def solve(test_cases):
    for case in test_cases:
        N, blue_points, red_points = case
        
        indexed_blue = [(x, y, i + 1) for i, (x, y) in enumerate(blue_points)]
        indexed_red = [(x, y, i + 1) for i, (x, y) in enumerate(red_points)]
        
        indexed_blue.sort(key=lambda p: (p[0], p[1]))
        indexed_red.sort(key=lambda p: (p[0], p[1]))
        
        for i in range(N):
            blue_index = indexed_blue[i][2]
            red_index = indexed_red[i][2]
            print(blue_index, red_index)


t = int(input())
test_cases = []

for _ in range(t):
    N = int(input())
    blue_points = [tuple(map(int, input().split())) for _ in range(N)]
    red_points = [tuple(map(int, input().split())) for _ in range(N)]
    test_cases.append((N, blue_points, red_points))

solve(test_cases)
