def solve(test_cases):
    results = []
    for case in test_cases:
        N, blue_points, red_points = case

        indexed_blue = [(x, y, i + 1) for i, (x, y) in enumerate(blue_points)]
        indexed_red = [(x, y, i + 1) for i, (x, y) in enumerate(red_points)]

        indexed_blue.sort(key=lambda p: (p[0], p[1]))
        indexed_red.sort(key=lambda p: (p[0], p[1]))

        solution = []
        for i in range(N):
            blue_index = indexed_blue[i][2]
            red_index = indexed_red[i][2]
            solution.append((blue_index, red_index))
        
        results.append(solution)

    for result in results:
        for blue_index, red_index in result:
            print(blue_index, red_index)

t = int(input())
test_cases = []