#include <iostream>
#include <queue>
#include <set>
using namespace std;
struct State {
    int alice, bob, time;
};
int minTimeToMeet(int N) {
    queue<State> q;
    set<pair<int, int>> visited;
    q.push({1, N, 0});
    visited.insert({1, N});
    while (!q.empty()) {
        State current = q.front();
        q.pop();
        int alice = current.alice;
        int bob = current.bob;
        int time = current.time;
        if (alice == bob) {
        return time;
        }
        vector<int> aliceMoves = {alice + 2, alice + 3};
        vector<int> bobMoves = {bob - 1, bob - 2};
        for (int newAlice : aliceMoves) {
            if (newAlice > 0 && newAlice <= N) {
                for (int newBob : bobMoves) {
                    if (newBob > 0 && newBob <= N) {
                        if (!visited.count({newAlice, newBob})) {
                            visited.insert({newAlice, newBob});
                            q.push({newAlice, newBob, time + 1});
                        }
                    }
                }
            }
        }
    }
    return -1;
}
int main() {
    int N;
    cin >> N;
    int result = minTimeToMeet(N);
    if (result == -1) {
    } else {
        cout<< result << endl;
    }
    return 0;
}