#include <iostream>
#include <queue>
#include <vector>
#include <unordered_set>
using namespace std;
long long findMeetingTime(long long N) {
    queue<long long> aliceQueue, bobQueue;
    unordered_set<long long> aliceVisited, bobVisited;
    aliceQueue.push(1);  
    bobQueue.push(N);    
    aliceVisited.insert(1);
    bobVisited.insert(N);
    long long t = 0;
    while (!aliceQueue.empty() && !bobQueue.empty()) {
        t++;
        int sizeA = aliceQueue.size();
        for (int i = 0; i < sizeA; ++i) {
            long long alicePos = aliceQueue.front();
            aliceQueue.pop();
            for (long long newPos : {alicePos + 2, alicePos + 3}) {
                if (newPos <= N && bobVisited.count(newPos)) {
                    return t;
                }
                if (newPos <= N && aliceVisited.count(newPos) == 0) {
                    aliceQueue.push(newPos);
                    aliceVisited.insert(newPos);
                }
            }
        }
        int sizeB = bobQueue.size();
        for (int i = 0; i < sizeB; ++i) {
            long long bobPos = bobQueue.front();
            bobQueue.pop();
            for (long long newPos : {bobPos - 1, bobPos - 2}) {
                if (newPos >= 1 && aliceVisited.count(newPos)) {
                    return t;
                }
                if (newPos >= 1 && bobVisited.count(newPos) == 0) {
                    bobQueue.push(newPos);
                    bobVisited.insert(newPos);
                }
            }
        }
    }
    
    return -1;
}

int main() {
    long long N;
    cin >> N;
    cout << findMeetingTime(N) << endl;
    return 0;
}
