#include <iostream>
#include <queue>
#include <unordered_set>
using namespace std;

long long findMeetingTime(long long N) {
    queue<pair<long long, int>> q;
    unordered_set<long long> visited;  
    q.push({1, 0});
    q.push({N, 1}); 
    visited.insert(1);
    visited.insert(N);

    long long t = 0;
    while (!q.empty()) {
        t++;
        long long size = q.size();
        for (long long i = 0; i < size; ++i) {
            auto [pos, person] = q.front();
            q.pop();

            if (person == 0) {  
                for (long long newPos : {pos + 2, pos + 3}) {
                    if (newPos <= N && visited.count(newPos)) {
                        return t;
                    }
                    if (newPos <= N && visited.count(newPos) == 0) {
                        visited.insert(newPos);
                        q.push({newPos, 0});
                    }
                }
            } else {  
                for (long long newPos : {pos - 1, pos - 2}) {
                    if (newPos >= 1 && visited.count(newPos)) {
                        return t;
                    }
                    if (newPos >= 1 && visited.count(newPos) == 0) {
                        visited.insert(newPos);
                        q.push({newPos, 1});
                    }
                }
            }
        }
    }
    return -1;
}

int main() {
    long long N;
    cin >> N;
    cout << findMeetingTime(N) << endl;
    return 0;
}
