#include <iostream>
#include <unordered_map>
#include <vector>
#include <limits>
using namespace std;
int main() {
    int N;
    cin >> N;
    vector<int> a(N);
    unordered_map<int, int> frequency;
    for (int i = 0; i < N; ++i) {
        cin >> a[i];
        frequency[a[i]]++;
    }
    int minUnik = numLimits<int>::max();
    for (int num : a) {
        if (frequency[num] == 1) {
            minUnik = min(minUnik, num);
        }
    }
    if (minUnik == numLimits<int>::max()) {
        cout << -1 << endl;
    } else {
        cout << minUnik << endl;
    }
    return 0;
}
