#include <iostream>
#include <algorithm> 
using namespace std;
int gcd(int a, int b) {
    while (b != 0) {
        int temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

int lcm(int a, int b) {
    return (a / gcd(a, b)) * b;
}

int countOnes(int N, int A, int B) {
    if (A <= 0 || B <= 0 || N <= 0) {
        return -1;
    }
    int countA = N / A;
    int countB = N / B;
    int countAB = N / lcm(A, B);
    return countA + countB - countAB;
}

int main() {
    int N, A, B;
    cin >> N >> A >> B;
    int result = countOnes(N, A, B);
    if (result != -1) {
        cout  << result << endl;
    }
    return 0;
}
