#include <iostream>
#include <vector>
using namespace std;

int countMonochroms(int N, const vector<vector<int>>& grid) {
    int count = 0;

    for (int size = 1; size < N; ++size) { 
        for (int x1 = 0; x1 + size < N; ++x1) {
            for (int y1 = 0; y1 + size < N; ++y1) {
                int x2 = x1 + size, y2 = y1;
                int x3 = x1, y3 = y1 + size;
                int x4 = x1 + size, y4 = y1 + size;
                if (grid[x1][y1] == grid[x2][y2] &&
                    grid[x2][y2] == grid[x3][y3] &&
                    grid[x3][y3] == grid[x4][y4]) {
                    ++count;
                }
            }
        }
    }
    return count;
}
int main() {
    int N;
    cin >> N;
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }
    int result = countMonochroms(N, grid);
    cout << result << endl;
    return 0;
}
