#include <iostream>
#include <vector>
using namespace std;
int countSameColorSquares(int N, const vector<vector<int>>& grid) {
    int count = 0;
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            for (int k = 1; i + k < N && j + k < N; k++) {
                if (grid[i][j] == grid[i][j + k] && 
                    grid[i][j] == grid[i + k][j] && 
                    grid[i][j] == grid[i + k][j + k]) {
                    count++;
                }
            }
        }
    }
    return count;
}
int main() {
    int N;
    cin >> N;
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            cin >> grid[i][j];
        }
    }
    cout << countSameColorSquares(N, grid) + 1 << endl;
    return 0;
}
