#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N;
    cin >> N;
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            cin >> grid[i][j];
        }
    }
    int squareCount = 0;
    for (int i = 0; i < N - 1; i++) {
        for (int j = 0; j < N - 1; j++) {
            int color = grid[i][j];
            if (grid[i][j] == grid[i+1][j] && 
                grid[i][j] == grid[i][j+1] && 
                grid[i][j] == grid[i+1][j+1]) {
                squareCount++;
            }
        }
    }

    cout << squareCount + 1<< endl;
    return 0;
}
