#include <iostream>
#include <vector>
using namespace std;
bool isSquareSameColor(const vector<vector<int>>& grid, int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4) {
    int color = grid[x1][y1];
    return (grid[x2][y2] == color && grid[x3][y3] == color && grid[x4][y4] == color);
}
int main() {
    int N;
    cin >> N;    
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            cin >> grid[i][j];
        }
    }
    int squareCount = 0;
    for (int side = 1; side < N; ++side) { 
        for (int i = 0; i + side < N; ++i) {
            for (int j = 0; j + side < N; ++j) {
                int x1 = i, y1 = j;
                int x2 = i + side, y2 = j;
                int x3 = i, y3 = j + side;
                int x4 = i + side, y4 = j + side;
                if (isSquareSameColor(grid, x1, y1, x2, y2, x3, y3, x4, y4)) {
                    squareCount++;
                }
            }
        }
    }
    cout << squareCount << endl;
    return 0;
}
