#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Point {
    int x, y, index;
    bool operator<(const Point& other) const {
        if (x != other.x)
            return x < other.x;
        return y < other.y;
    }
};

void solve() {
    int t;
    cin >> t;  
    while (t--) {
        int N;
        cin >> N; 
        vector<Point> blue_points(N), red_points(N);

        for (int i = 0; i < N; ++i) {
            cin >> blue_points[i].x >> blue_points[i].y;
            blue_points[i].index = i + 1; 
        }
    
        for (int i = 0; i < N; ++i) {
            cin >> red_points[i].x >> red_points[i].y;
            red_points[i].index = i + 1;  
        }
        sort(blue_points.begin(), blue_points.end());
        sort(red_points.begin(), red_points.end());
        for (int i = 0; i < N; ++i) {
            cout << blue_points[i].index << " " << red_points[i].index << endl;
        }
    }
}

int main() {
    solve();
    return 0;
}
