def robot_meeting(N):
    """
    Находит минимальное количество шагов для встречи роботов.

    Args:
        N: Количество боксов.

    Returns:
        Минимальное количество шагов или -1, если встреча невозможна.
    """

    # Инициализируем позиции роботов
    alice, bob = 1, N

    # Счетчик шагов
    steps = 0

    while alice < bob:
        steps += 1

        # Минимальное возможное перемещение Алисы
        alice = min(alice + 2, N)

        # Минимальное возможное перемещение Боба
        bob = max(bob - 2, 1)

    return steps if alice == bob else -1

# Пример использования:
N = int(input(': '))
result = robot_meeting(N)
print(result)  # Вывод: 1