def select_stamps(N, M):  
    # Максимальна сума всіх марок  
    max_sum = N * (N + 1) // 2  
    if M > max_sum:  
        return [0]  

    selected_stamps = []  
    
    # Вибір марок, починаючи з 1 до N  
    for i in range(N, 0, -1):  
        if M >= i:  # Поки ще можемо взяти марку  
            selected_stamps.append(i)  # Додаємо марку  
            M -= i  # Зменшуємо залишок M  

        if M == 0:  # Якщо досягнули точного M  
            break  

    # Якщо не вдалося вийти на 0, то виводимо 0  
    if M > 0:  
        return [0]  
    
    return sorted(selected_stamps)  # Повертаємо номери марок у зростаючому порядку  

# Вхідні дані  
N = int(input())  
M = int(input())  

# Отримання вибраних марок  
result = select_stamps(N, M)  

# Вивід результатів  
if result == [0]:  
    print(0)  
else:  
    print(" ".join(map(str, result)))  