from itertools import combinations

def find_all_solutions(N, M):
    stamps = list(range(1, N + 1))
    solutions = []

    for r in range(1, N + 1):
        for combo in combinations(stamps, r):
            if sum(combo) == M:
                solutions.append(list(combo))

    return solutions if solutions else [[0]]

# Тестування
N = 10
M = 12
all_solutions = find_all_solutions(N, M)
print("Усі можливі рішення:", all_solutions)