def find_president_candidate(N, numbers):  
    # Словник для підрахунку повторень  
    count = {}  
    
    for num in numbers:  
        if num in count:  
            count[num] += 1  
        else:  
            count[num] = 1  

    # Знайдемо номер з найбільшою кількістю повторень  
    max_count = -1  
    candidate = None  
    
    for num, cnt in count.items():  
        # Якщо знайшли більше повторень, оновлюємо кандидата  
        if cnt > max_count:  
            max_count = cnt  
            candidate = num  
    
    return candidate  

# Зчитування вхідних даних  
N = int(input())  
numbers = list(map(int, input().split()))  

# Отримуємо результат  
result = find_president_candidate(N, numbers)  

# Виводимо результат  
print(result)  