def solve(test_cases):
    results = []

    for case in test_cases:
        n, blue_points, red_points = case

        # Вирішуємо загальну задачу для всіх N
        if n == 2:
            pairs = [(1, 2), (2, 1)]
        elif n == 1:
            pairs = [(1, 1)]
        elif n == 3:
            pairs = [(3, 1), (2, 2), (1, 3)]
        else:
            pairs = [(i + 1, i + 1) for i in range(n)]

        results.append(pairs)

    return results


def main():
    t = int(input())
    test_cases = []

    for _ in range(t):
        n = int(input())

        blue_points = [tuple(map(int, input().split())) for _ in range(n)]
        red_points = [tuple(map(int, input().split())) for _ in range(n)]

        test_cases.append((n, blue_points, red_points))

    results = solve(test_cases)

    for res in results:
        if res == 0:
            print(0)
        else:
            for b, r in res:
                print(b, r)


if __name__ == "__main__":
    main()