def solve_matching_problems(test_cases):
    results = []
    
    for n, blue_points, red_points in test_cases:
        sorted_blue = sorted((x, y, i + 1) for i, (x, y) in enumerate(blue_points))  # Додаємо індекси
        sorted_red = sorted((x, y, i + 1) for i, (x, y) in enumerate(red_points))    # Додаємо індекси
        matching = [(sorted_blue[i][2], sorted_red[i][2]) for i in range(n)]
        results.append(matching)   
    return results
t = int(input())
test_cases = []
for _ in range(t):
    n = int(input())
    blue_points = [tuple(map(int, input().split())) for _ in range(n)]
    red_points = [tuple(map(int, input().split())) for _ in range(n)]
    test_cases.append((n, blue_points, red_points))
answers = solve_matching_problems(test_cases)
for answer in answers:
    if answer == 0:
        print(0)
    else:
        for b, r in answer:
            print(b, r)

