#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N;
    cin >> N;

    // Зчитуємо матрицю кольорів
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            cin >> grid[i][j];
        }
    }

    int count = 0;

    // Перебираємо всі квадрати зі стороною >= 2
    for (int side = 1; side < N; side++) { // side — це розмір сторони квадрата
        for (int i = 0; i + side < N; i++) { // i — координата верхньої лівої точки по X
            for (int j = 0; j + side < N; j++) { // j — координата верхньої лівої точки по Y
                // Перевіряємо 4 вершини квадрата
                if (grid[i][j] == grid[i + side][j] && 
                    grid[i][j] == grid[i][j + side] && 
                    grid[i][j] == grid[i + side][j + side]) {
                    count++;
                }
            }
        }
    }

    cout << count << endl;
    return 0;
}
