#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N;
    cin >> N;

    // Зчитуємо матрицю кольорів
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            cin >> grid[i][j];
        }
    }

    int count = 0;

    // Перебираємо всі можливі квадрати
    for (int x1 = 0; x1 < N; x1++) {
        for (int y1 = 0; y1 < N; y1++) {
            for (int x2 = x1 + 1; x2 < N; x2++) {
                for (int y2 = y1 + 1; y2 < N; y2++) {
                    // Перевіряємо чи всі 4 вершини одного кольору
                    if (grid[x1][y1] == grid[x1][y2] && 
                        grid[x1][y1] == grid[x2][y1] && 
                        grid[x1][y1] == grid[x2][y2]) {
                        count++;
                    }
                }
            }
        }
    }

    cout << count << endl;

    return 0;
}