using System;

class Solution {
  public static void Main(string[] args) {
      ulong N = ulong.Parse(Console.ReadLine());

        ulong difference = N - 1;

        ulong gcd = Check(2, 3);
        if (difference % gcd != 0)
        {
            Console.WriteLine("-1");
            return;
        }

        ulong result = MinTime(N);
        if (result == 0)
            Console.WriteLine("-1");
        else
            Console.WriteLine(result);
    }

    static ulong Check(ulong a, ulong b)
    {
        while (b != 0)
        {
            ulong temp = b;
            b = a % b;
            a = temp;
        }
        return a;
    }

    static ulong MinTime(ulong N)
    {
        ulong alice = 1;
        ulong bob = N;
        ulong time = 0;

        while (alice < bob)
        {
            if (bob - alice > 3)
            {
                alice += 3;
            }
            else
            {
                alice += 2;
            }

            if (bob - alice > 2)
            {
                bob -= 2;
            }
            else
            {
                bob -= 1;
            }

            time++;

            if (alice >= bob)
                return time;
        }

        return 0;
    }
}
