use std::io;

fn main() {
    let mut input = String::new();
    io::stdin().read_line(&mut input).expect("Failed to read line");
    let N: i64 = input.trim().parse().expect("Please enter a number");

    input.clear();
    io::stdin().read_line(&mut input).expect("Failed to read line");
    let mut M: i64 = input.trim().parse().expect("Please enter a number");

    let mut result = Vec::new();

    for i in (1..=N.min(M)).rev() {
        if M >= i {
            result.push(i);
            M -= i;
        }
        if M == 0 {
            break;
        }
    }

    if M > 0 {
        println!("0");
    } else {
        for num in result {
            println!("{}", num);
        }
    }
}