use std::io;

fn main() {
    let mut input = String::new();
    io::stdin().read_line(&mut input).expect("Failed to read line");
    let N: usize = input.trim().parse().expect("Please enter a number");

    let mut grid = vec![vec![0; N]; N];
    for i in 0..N {
        input.clear();
        io::stdin().read_line(&mut input).expect("Failed to read line");
        let row: Vec<i32> = input
            .trim()
            .split_whitespace()
            .map(|x| x.parse().expect("Please enter a number"))
            .collect();
        for j in 0..N {
            grid[i][j] = row[j];
        }
    }

    let mut count = 0;

    for i in 0..N-1 {
        for j in 0..N-1 {
            if grid[i][j] == grid[i][j+1] && grid[i][j] == grid[i+1][j] && grid[i][j] == grid[i+1][j+1] {
                count += 1;
            }
        }
    }

    println!("{}", count);
}