def can_meet(alice, bob, steps, N):
    if alice == bob:
        return steps
    
    if alice > bob or alice > N or bob < 1:
        return float('inf')
    
    steps1 = can_meet(alice + 2, bob - 1, steps + 1, N)
    steps2 = can_meet(alice + 2, bob - 2, steps + 1, N)
    steps3 = can_meet(alice + 3, bob - 1, steps + 1, N)
    steps4 = can_meet(alice + 3, bob - 2, steps + 1, N)
    
    return min(steps1, steps2, steps3, steps4)

def min_steps_to_meet(N):
    result = can_meet(1, N, 0, N)
    return result if result != float('inf') else -1

# Приклад використання
N = int(input())
result = min_steps_to_meet(N)
print(, result)
