def find_min_stamps(N, M):
    # Найгірший випадок - жодне рішення не знайдено
    best_solution = [0]
    
    # Перебір всіх можливих підмножин
    for mask in range(1, 1 << N):
        current_sum = 0
        current_solution = []
        
        # Перевірка кожного біта в масці
        for i in range(N):
            if mask & (1 << i):
                current_sum += (i + 1)
                current_solution.append(i + 1)
        
        # Якщо знайшли потрібну суму і кількість марок менша за поточне найкраще рішення
        if current_sum == M:
            if best_solution == [0] or len(current_solution) < len(best_solution):
                best_solution = current_solution
                
    return best_solution

# Читання вхідних даних
N = int(input().strip())
M = int(input().strip())

# Знаходження рішення
result = find_min_stamps(N, M)

# Виведення результату
print(" ".join(map(str, result)))
