#include <bits/stdc++.h>
using namespace std;

int count_same_color_squares(const vector<vector<int>>& grid, int N) {
    int count = 0;

    // Iterate over all possible top-left corners of squares
    for (int i = 0; i < N - 1; ++i) {
        for (int j = 0; j < N - 1; ++j) {
            // Check all possible sizes of squares starting from (i, j)
            for (int size = 1; i + size < N && j + size < N; ++size) {
                int color = grid[i][j];
                if (grid[i][j + size] == color && grid[i + size][j] == color && grid[i + size][j + size] == color) {
                    ++count;
                }
            }
        }
    }

    return count;
}

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int result = count_same_color_squares(grid, N);
    cout << result << endl;

    return 0;
}