import java.util.Scanner;
import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);

        int N = (int) in.nextLong();
        int[] num = new int[N];

        for (int i = 0; i < N; i++) {
            num[i] = in.nextInt();
        }

        Map<Integer, Integer> fm = new HashMap<>();
        int uniqueMin = Integer.MAX_VALUE;
        
        for (int number : num) {
            fm.put(number, fm.getOrDefault(number, 0) + 1);
        }
        
        for (int number : fm.keySet()) {
            if (fm.get(number) == 1) {
                uniqueMin = Math.min(uniqueMin, number);
            }
        }

        System.out.println(uniqueMin == Integer.MAX_VALUE ? -1 : uniqueMin);
    }
}
