import java.util.Scanner;
import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);

        int N = in.nextInt();
        int[] num = new int[N];
        for (int i = 0; i < N; i++) {
            num[i] = in.nextInt();
        }

        int MAX_VALUE = 100_001;
        int[] freq = new int[MAX_VALUE];
        for (int number : num) {
            freq[number]++;
        }

        int uniqueMin = Integer.MAX_VALUE;

        for (int i = 0; i < MAX_VALUE; i++) {
            if (freq[i] == 1) {
                uniqueMin = Math.min(uniqueMin, i);
            }
        }

        System.out.println(uniqueMin == Integer.MAX_VALUE ? -1 : uniqueMin);
    }
}
