import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;

public class Main {
    public static void main(String[] args) {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

        int N = Integer.parseInt(br.readLine());
        String[] num = br.readLine().split(" ");

        Map<Integer, Integer> fm = new HashMap<>(N);
        int uniqueMin = Integer.MAX_VALUE;

        for (int i = 0; i < N; i++) {
            int number = Integer.parseInt(num[i]);
            fm.put(number, fm.getOrDefault(number, 0) + 1);
        }

        for (int number : fm.keySet()) {
            if (fm.get(number) == 1) {
                uniqueMin = Math.min(uniqueMin, number);
            }
        }

        System.out.println(uniqueMin == Integer.MAX_VALUE ? -1 : uniqueMin);
    }
}
