import math

t = int(input())
for _ in range(t):
    numPoints = int(input())
    bluePoints = [tuple(map(int, input().split())) for _ in range(numPoints)]
    redPoints = [tuple(map(int, input().split())) for _ in range(numPoints)]
    distanceMatrix = []
    for i in range(numPoints):
        distanceMatrix.append([])
        for j in range(numPoints):
            distance = (bluePoints[i][0] - redPoints[j][0]) ** 2 + (bluePoints[i][1] - redPoints[j][1]) ** 2
            distanceMatrix[i].append((distance, j))
    for i in range(numPoints):
        distanceMatrix[i].sort()
    usedRedPoints = [False] * numPoints
    matches = []
    for i in range(numPoints):
        matched = False
        for distance, j in distanceMatrix[i]:
            if not usedRedPoints[j]:
                usedRedPoints[j] = True
                matches.append((i + 1, j + 1))
                matched = True
                break
        if not matched:
            print(0)
            break
    else:
        for blue, red in matches:
            print(blue, red)
