n = int(input())

q = [(1, n, 0)]  # (alice_pos, bob_pos, time)
visited = set()
visited.add((1, n))

while q:
    alice_pos, bob_pos, time = q.pop(0)

    if alice_pos == bob_pos:
        print(time)
        exit()

    next_alice_moves = []
    if alice_pos + 2 <= n:
        next_alice_moves.append(alice_pos + 2)
    if alice_pos + 3 <= n:
        next_alice_moves.append(alice_pos + 3)
    
    next_bob_moves = []
    if bob_pos - 1 >= 1:
        next_bob_moves.append(bob_pos - 1)
    if bob_pos - 2 >= 1:
        next_bob_moves.append(bob_pos - 2)

    for next_alice in next_alice_moves:
        for next_bob in next_bob_moves:
            if (next_alice, next_bob) not in visited:
                visited.add((next_alice, next_bob))
                q.append((next_alice, next_bob, time + 1))

print("-1")
