import math

def count_units(N, A, B):
    # Функція для обчислення найменшого спільного кратного (LCM)
    def lcm(x, y):
        return (x * y) // math.gcd(x, y)
    
    # Кількість чисел, кратних A
    count_a = N // A
    # Кількість чисел, кратних B
    count_b = N // B
    # Кількість чисел, кратних обом A і B (найменше спільне кратне)
    count_ab = N // lcm(A, B)
    
    # Загальна кількість одиничних значень
    result = count_a + count_b - count_ab
    return result

# Вхідні дані
N = int(input())  # кількість комірок пам'яті
A, B = map(int, input().split())  # числа A і B

# Викликаємо функцію для підрахунку кількості одиничних значень
print(count_units(N, A, B))
