N = int(input())

alice_positions = {1}
bob_positions = {N}
seconds = 0

while alice_positions and bob_positions:
    seconds += 1
    alice_next = set()
    bob_next = set()
    
    for pos in alice_positions:
        if pos + 2 <= N:
            alice_next.add(pos + 2)
        if pos + 3 <= N:
            alice_next.add(pos + 3)
    
    for pos in bob_positions:
        if pos - 1 > 0:
            bob_next.add(pos - 1)
        if pos - 2 > 0:
            bob_next.add(pos - 2)
    
    if alice_next & bob_next:
        print(seconds)
        break
    
    alice_positions = alice_next
    bob_positions = bob_next
else:
    print(-1)
