N = int(input())

def minimum_time(N):
    if N == 2:
        return 1
    
    steps_A = set([1])
    steps_B = set([N])
    time = 0
    
    while steps_A and steps_B:
        time += 1
        new_A = set()
        new_B = set()
        
        for a in steps_A:
            if a + 2 <= N:
                new_A.add(a + 2)
            if a + 3 <= N:
                new_A.add(a + 3)
        
        for b in steps_B:
            if b - 1 >= 1:
                new_B.add(b - 1)
            if b - 2 >= 1:
                new_B.add(b - 2)
        
        if new_A & new_B:
            return time
        
        steps_A = new_A
        steps_B = new_B
    
    return -1

print(minimum_time(N))
