def min_meeting_time(n: int) -> int:
    """
    Знаходить мінімальну кількість секунд для зустрічі Аліси та Боба або повертає -1, якщо це неможливо.
    
    :param n: Кількість боксів (2 <= N <= 10^9)
    :return: Мінімальна кількість секунд або -1
    """
    # Різниця між початковими позиціями Аліси та Боба
    distance = n - 1
    
    # Якщо різниця непарна, зустріч неможлива
    if distance % 2 != 0:
        return -1
    
    # Мінімальна кількість секунд для зустрічі
    return distance // 2


if __name__ == "__main__":
    n = int(input("Введіть кількість боксів N: "))
    print(min_meeting_time(n))
