def solve(t: int, test_cases: list):
    results = []
    
    for case in test_cases:
        N, blue_points, red_points = case
        # Сортуємо за координатами y
        sorted_blue = sorted((y, x, i + 1) for i, (x, y) in enumerate(blue_points))
        sorted_red = sorted((y, x, i + 1) for i, (x, y) in enumerate(red_points))

        # З'єднуємо точки
        pairs = []
        for i in range(N):
            blue_index = sorted_blue[i][2]
            red_index = sorted_red[i][2]
            pairs.append((blue_index, red_index))
        
        # Додаємо результат
        results.append(pairs)
    
    # Виводимо результати
    for result in results:
        for blue_index, red_index in result:
            print(f"{blue_index} {red_index}")

# Вхідні дані
t = int(input())  # Кількість тестів
test_cases = []

for _ in range(t):
    N = int(input())  # Кількість точок одного кольору
    blue_points = [tuple(map(int, input().split())) for _ in range(N)]
    red_points = [tuple(map(int, input().split())) for _ in range(N)]
    test_cases.append((N, blue_points, red_points))

# Викликаємо функцію для розв'язку задачі
solve(t, test_cases)
