from collections import Counter

def elect_president(N, numbers):
   
    count = Counter(numbers)
    

    min_number = float('inf')
    for num, freq in count.items():
        if freq == 1 and num < min_number:
            min_number = num
    

    if min_number == float('inf'):
        return -1
    return min_number


N = int(input())  
numbers = list(map(int, input().split()))  


print(elect_president(N, numbers))
