def solve_case(N, blue_points, red_points):
    blue_sorted = sorted(blue_points)
    red_sorted = sorted(red_points)
    result = []

    for i in range(N):
        result.append((blue_sorted[i][2], red_sorted[i][2]))
    
    return result

def main():
    t = int(input())
    for _ in range(t):
        N = int(input())
        blue_points = [tuple(map(int, input().split())) + (i + 1,) for i in range(N)]
        red_points = [tuple(map(int, input().split())) + (i + 1,) for i in range(N)]
        
        result = solve_case(N, blue_points, red_points)
        
        for pair in result:
            print(pair[0], pair[1])

main()
