def robot_meeting_time(N):
  """
  Розраховує мінімальну кількість секунд до зустрічі роботів.

  Args:
    N: Кількість боксів.

  Returns:
    Мінімальну кількість секунд або -1, якщо зустріч неможлива.
  """

  distance = N - 1  # Початкова відстань між роботами
  divisors = [1, 2, 3, 4, 5]

  for divisor in reversed(divisors):
    if distance % divisor == 0:
      return (distance // divisor + 1) // 2 * 2

  return -1

# Приклад використання
N = int(input())
result = robot_meeting_time(N)
print(result-1)