def select_stamps(N, M):  
    # Максимальна сума вартості марок  
    max_sum = N * (N + 1) // 2  

    if M > max_sum:  
        return [0]  

    stamps = []  
    
    # Прямо додаємо марки в результат (від найбільшої до найменшої)  
    while M > 0 and N > 0:  
        if M >= N:  
            stamps.append(N)  
            M -= N  
        N -= 1  # Зменшуємо N, щоб перейти до наступної меншої марки  

    if M != 0:  # Якщо залишилася сума, якої неможливо досягти  
        return [0]  

    return stamps  

# Вхідні дані  
N = int(input())  
M = int(input())  

# Виводимо результат  
result = select_stamps(N, M)  
print(*result)  