def count_uniform_squares(N, grid):  
    count = 0  
    
    # Перебираємо всі можливі координати верхнього лівого кута квадрата  
    for i in range(N):  
        for j in range(N):  
            # Перебираємо всі можливі розміри квадратів  
            for k in range(1, min(N - i, N - j) + 1):  
                # Визначаємо координати чотирьох вершин квадрата  
                if all(grid[x][y] == grid[i][j] for x in range(i, i + k) for y in range(j, j + k)):  
                    count += 1  
                    
    return count  

# Зчитування вхідних даних  
N = int(input().strip())  
grid = [list(map(int, input().strip().split())) for _ in range(N)]  

# Виклик функції та вивід результату  
result = count_uniform_squares(N, grid)  
print(result)  