#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N, M;
    cin >> N >> M;
    
    // Загальна сума всіх марок від 1 до N
    int totalSum = N * (N + 1) / 2;
    
    // Якщо загальна сума менша за M, такого набору марок не існує
    if (totalSum < M) {
        cout << 0 << endl;
        return 0;
    }

    // Масив для зберігання вибраних марок
    vector<int> selectedMarks;

    // Починаємо вибір марок з найбільших
    for (int i = N; i >= 1; --i) {
        if (M >= i) {
            M -= i;
            selectedMarks.push_back(i);
        }
        if (M == 0) break;
    }

    // Якщо сума M не дорівнює 0, вивести 0
    if (M != 0) {
        cout << 0 << endl;
    } else {
        // Вивести вибрані марки
        for (int i = 0; i < selectedMarks.size(); ++i) {
            cout << selectedMarks[i] << " ";
        }
        cout << endl;
    }
    
    return 0;
}
