#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N;
    cin >> N;
    vector<vector<int>> grid(N, vector<int>(N));
    
    // Читаємо сітку
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int count = 0;

    // Перебираємо всі можливі квадрати
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            // Розмір квадрата
            for (int size = 1; size <= N - max(i, j); ++size) {
                // Перевіряємо квадрат зліва вниз від точки (i,j) з розміром size
                if (i + size < N && j + size < N) {
                    int color = grid[i][j];
                    // Перевіряємо чотири вершини
                    if (grid[i][j] == grid[i+size][j] && grid[i][j] == grid[i][j+size] && grid[i][j] == grid[i+size][j+size]) {
                        ++count;
                    }
                }
            }
        }
    }

    cout << count << endl;

    return 0;  // Закриваємо функцію main
}