#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N;
    cin >> N;
    
    // Зчитуємо кольори сітки
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int count = 0;

    // Перебираємо всі можливі квадрати
    // Початкова точка квадрата (i, j)
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            // Перебираємо всі можливі розміри квадрата
            for (int size = 1; i + size < N && j + size < N; ++size) {
                // Перевіряємо, чи всі 4 вершини квадрата одного кольору
                int color = grid[i][j];
                if (grid[i][j] == grid[i + size][j] &&   // ліва верхня та ліва нижня
                    grid[i][j] == grid[i][j + size] &&   // ліва верхня та права верхня
                    grid[i][j] == grid[i + size][j + size]) { // ліва верхня та права нижня
                    ++count;  // Збільшуємо лічильник
                }
            }
        }
    }

    cout << count << endl;
    return 0;
}