#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));
    
    // Читання сітки
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int count = 0;

    // Перебір всіх можливих квадратів
    for (int i = 0; i < N - 1; ++i) {
        for (int j = 0; j < N - 1; ++j) {
            // Перевіряємо квадрат розміру 2x2 з верхнім лівим кутом у (i, j)
            if (grid[i][j] == grid[i+1][j] && grid[i][j] == grid[i][j+1] && grid[i][j] == grid[i+1][j+1]) {
                count++;  // Збільшуємо лічильник
            }
        }
    }

    // Виводимо результат
    cout << count << endl;
    return 0;
}
