#include <bits/stdc++.h>
#include <iostream>
#include <queue>
#include <unordered_set>

using namespace std;


int findMeetingTime(int n) {
    if (n % 2 == 0) {
        return -1;
    }

    queue<pair<int, int>> alice, bob;
    unordered_set<int> visitedAlice, visitedBob;

    alice.push({1, 0}); // Початкова позиція Аліси (позиція, час)
    bob.push({n, 0});   // Початкова позиція Боба (позиція, час)

    while (!alice.empty() && !bob.empty()) {
        auto [posA, timeA] = alice.front();
        alice.pop();

        if (visitedBob.count(posA)) {
            return timeA; // Аліса і Боб зустрілися
        }
        visitedAlice.insert(posA);
        if (posA + 2 <= n) alice.push({posA + 2, timeA + 1});
        if (posA + 3 <= n) alice.push({posA + 3, timeA + 1});

        auto [posB, timeB] = bob.front();
        bob.pop();

        if (visitedAlice.count(posB)) {
            return timeB; // Боб і Аліса зустрілися
        }
        visitedBob.insert(posB);
        if (posB - 1 > 0) bob.push({posB - 1, timeB + 1});
        if (posB - 2 > 0) bob.push({posB - 2, timeB + 1});
    }

    return -1;
}



int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    cout << findMeetingTime(n) << endl;
    return 0;

}
