#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <unordered_map>
#include <limits>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int N;
    cin >> N;

    vector<int> numbers(N);
    for (int i = 0; i < N; ++i) {
        cin >> numbers[i];
    }

    unordered_map<int, int> frequency;

    for (int num : numbers) {
        frequency[num]++;
    }

    int minUnique = numeric_limits<int>::max();
    bool found = false;

    for (int num : numbers) {
        if (frequency[num] == 1 && num < minUnique) {
            minUnique = num;
            found = true;
        }
    }

    if (found) {
        cout << minUnique << endl;
    } else {
        cout << -1 << endl;
    }

    return 0;
}
