def find_meeting_time(N):
    
    
    if N <= 1:
        return -1

    alice_positions = set()
    bob_positions = set()
    
    
    alice_current = [1]
    bob_current = [N]
    time = 0

    while True:
        
        if set(alice_current).intersection(bob_current):
            return time

        
        next_alice_positions = set()
        next_bob_positions = set()

        for pos in alice_current:
            if pos + 2 <= N:
                next_alice_positions.add(pos + 2)
           

            if pos + 3 <= N:
                next_alice_positions.add(pos + 3)

        for pos in bob_current:
            if pos - 1 >= 1:
                next_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                next_bob_positions.add(pos - 2)

        
        alice_current = next_alice_positions
        bob_current = next_bob_positions

        
        time += 1

        
        if not alice_current or not bob_current:
            return -1



n = int(input())
print(find_meeting_time(n))