from collections import Counter

def find_president(N, numbers):
    # Підрахуємо кількість кожного числа
    count = Counter(numbers)
    
    # Знайдемо мінімальне число з кількістю 1
    min_number = float('inf')
    
    for num, cnt in count.items():
        if cnt == 1:
            min_number = min(min_number, num)
    
    # Якщо мінімальне число не змінено, значить вибори не відбудуться
    return min_number if min_number != float('inf') else -1

# Зчитуємо вхід
N = int(input())
numbers = list(map(int, input().split()))

# Виводимо результат
print(find_president(N, numbers))