function min_seconds(N)
    local alice_positions = {1}
    local bob_positions = {N}
    local seconds = 0
    
    while true do
        seconds = seconds + 1
        local new_alice_positions = {}
        local new_bob_positions = {}
        
        for _, pos in ipairs(alice_positions) do
            if pos + 2 <= N then table.insert(new_alice_positions, pos + 2) end
            if pos + 3 <= N then table.insert(new_alice_positions, pos + 3) end
        end
        
        for _, pos in ipairs(bob_positions) do
            if pos - 1 >= 1 then table.insert(new_bob_positions, pos - 1) end
            if pos - 2 >= 1 then table.insert(new_bob_positions, pos - 2) end
        end
        
        for _, a_pos in ipairs(new_alice_positions) do
            for _, b_pos in ipairs(new_bob_positions) do
                if a_pos == b_pos then return seconds end
            end
        end
        
        alice_positions = new_alice_positions
        bob_positions = new_bob_positions
        
        if #alice_positions == 0 or #bob_positions == 0 then
            return -1
        end
    end
end

local N = tonumber(io.read())
print(min_seconds(N))
