function gcd(a, b)
    while b ~= 0 do
        a, b = b, a % b
    end
    return a
end

function lcm(a, b)
    return (a * b) / gcd(a, b)
end

function customSplit(input, delimiter)
    local result = {}
    for part in input:gmatch("[^" .. delimiter .. "]+") do
        table.insert(result, part)
    end
    return result
end

local N = tonumber(io.read())
local AB = customSplit(io.read(), " ")

local A = tonumber(AB[1])
local B = tonumber(AB[2])


local countA = math.floor(N / A)
local countB = math.floor(N / B)
local countAB = math.floor(N / lcm(A, B))

local amount = countA + countB - countAB

print(amount)
