def min_seconds_to_meet(N):
    alice_positions = {1}
    bob_positions = {N}

    for t in range(1, N + 1):
        alice_next = set()
        for pos in alice_positions:
            if pos + 2 <= N:
                alice_next.add(pos + 2)
            if pos + 3 <= N:
                alice_next.add(pos + 3)

        bob_next = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                bob_next.add(pos - 1)
            if pos - 2 >= 1:
                bob_next.add(pos - 2)

        if alice_next & bob_next:
            return t

        alice_positions = alice_next
        bob_positions = bob_next

    return -1

N = int(input())
print(min_seconds_to_meet(N))
