#include <iostream>
#include <numeric>

using namespace std;
using ll = int;

ll lcm(ll A, ll B) {
    ll stA = A, stB = B;
    while (A > 0 && B > 0) {
        if (A > B) {
            A %= B;
        }
        else {
            B %= A;
        }
    }
    return stA / (A + B) * stB;
}

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0); cout.tie(0);
    ll N, A, B, ans = 0, lcm1;
    cin >> N >> A >> B;
    ans += N / A + N / B;
    lcm1 = lcm(A, B);
    for (ll i = 1; lcm1 * i <= N; i++) {
        ans--;
    }
    cout << ans << '\n';
}