#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

struct aba {
    ll x, y, ind;
};

bool comp(aba a, aba b) {
    if (a.y == b.y) {
        return a.x < b.x;
    }
    return a.y < b.y;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    ll t;
    cin >> t;
    vector<aba> red, blue;
    while (t--) {
        ll N;
        cin >> N;
        red.resize(N);
        blue.resize(N);
        for (ll i = 0; i < N; i++) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].ind = i + 1;
        }
        for (ll i = 0; i < N; i++) {
            cin >> red[i].x >> red[i].y;
            red[i].ind = i + 1;
        }
        sort(red.begin(), red.end(), comp);
        sort(blue.begin(), blue.end(), comp);
        for (ll i = 0; i < N; i++) {
            cout << blue[i].ind << ' ' << red[i].ind << '\n';
        }
    }
}