#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

struct aba {
    ll x, y, ind;
};

bool comp(aba a, aba b) {
    if (a.y == b.y) {
        return a.x < b.x;
    }
    return a.y < b.y;
}
bool inter(aba p1, aba q1, aba p2, aba q2) {
    auto ava = [](aba p, aba q, aba r) {
        ll val = (q.y - p.y) * (r.x - q.x) - (q.x - p.x) * (r.y - q.y);
        return (val > 0) ? 1 : 2;
    };
    ll o1 = ava(p1, q1, p2);
    ll o2 = ava(p1, q1, q2);
    ll o3 = ava(p2, q2, p1);
    ll o4 = ava(p2, q2, q1);
    if (o1 != o2 && o3 != o4) {
        return true;
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    ll t;
    cin >> t;
    vector<aba> red, blue;
    while (t--) {
        ll N;
        cin >> N;
        red.resize(N);
        blue.resize(N);
        for (ll i = 0; i < N; i++) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].ind = i + 1;
        }
        for (ll i = 0; i < N; i++) {
            cin >> red[i].x >> red[i].y;
            red[i].ind = i + 1;
        }
        sort(red.begin(), red.end(), comp);
        sort(blue.begin(), blue.end(), comp);
        bool ans = true;
        for (ll i = 0; i < N; i++) {
            for (ll j = i + 1; j < N; j++) {
                if (inter(blue[i], red[i], blue[j], red[j])) {
                    cout << 0 << '\n';
                    return 0;
                }
            }
        }
        for (ll i = 0; i < N; i++) {
            cout << blue[i].ind << ' ' << red[i].ind << '\n';
        }
    }
}