-- Function to find minimal pair that sums up to `n` from 1 to `m` within 0.2 seconds
local function findMinimalPair(m, n)
    local seen = {}
    
    for i = 1, m do
        local complement = n - i
        if seen[complement] then
            return 2, {complement, i}
        end
        seen[i] = true
    end
    
    return 0, {}
end

-- Read input for `m` and `n`

local m = tonumber(io.read())

local n = tonumber(io.read())

-- Example usage
local count, numbers = findMinimalPair(m, n)
if count == 0 then
    print(0)
else
    print(numbers[1])
    print(numbers[2])
end
