def smallest_combination(n, m):
    left, right = 1, n
    while left < right:
        current_sum = left + right
        if current_sum == m:
            return (left, right)
        elif current_sum < m:
            left += 1
        else:
            right -= 1
    return 0

n = int(input())
m = int(input())

result = smallest_combination(n, m)
if result != 0:
    print(result[0])
    print(result[1])
else:
    print(0)
