def solve():
    import sys
    input = sys.stdin.read
    data = int(input().strip())

    N = data

    # Якщо чітності не співпадають, зустріч неможлива
    if (1 % 2) != (N % 2):
        print(-1)
        return

    # Рахуємо мінімальний час зустрічі
    t = 0
    while True:
        # Можливі позиції Аліси та Боба через t секунд
        alice_positions = {1 + 2 * a + 3 * (t - a) for a in range(t + 1) if t - a >= 0}
        bob_positions = {N - c - 2 * (t - c) for c in range(t + 1) if t - c >= 0}

        # Перетин множин - точки зустрічі
        if alice_positions & bob_positions:
            print(t)
            return
        t += 1
solve()