import math

def count_ram(N, A, B):
    # Найменше спільне кратне (LCM)
    def lcm(x, y):
        return (x * y) // math.gcd(x, y)
    
    countA = N // A
    countB = N // B
    countAB = N // lcm(A, B)
    
    return countA + countB - countAB

# Введення
N = int(input())
A, B = map(int, input().split())

# Виведення
print(count_ram(N, A, B))