def solve():
    import sys
    input = sys.stdin.read
    data = input().splitlines()

    t = int(data[0])  # кількість тестових блоків
    index = 1  # поточний індекс у вході
    results = []

    for _ in range(t):
        N = int(data[index])  # кількість точок одного кольору
        index += 1

        blue_points = []
        for i in range(N):
            x, y = map(int, data[index + i].split())
            blue_points.append((x, y, i + 1))  # додаємо індекс точки
        index += N

        red_points = []
        for i in range(N):
            x, y = map(int, data[index + i].split())
            red_points.append((x, y, i + 1))  # додаємо індекс точки
        index += N

        # Сортуємо точки за координатою x (якщо x рівні — за y)
        blue_points.sort(key=lambda p: (p[0], p[1]))
        red_points.sort(key=lambda p: (p[0], p[1]))

        # З'єднуємо кожну синю точку з відповідною червоною
        result = []
        for i in range(N):
            result.append(f"{blue_points[i][2]} {red_points[i][2]}")

        results.append("\n".join(result))

    # Виводимо результати для всіх блоків
    sys.stdout.write("\n\n".join(results) + "\n")


# Запуск програми
solve()