def solve():
    import sys
    input = sys.stdin.read
    data = input().split()
    
    t = int(data[0])  # кількість блоків тестових даних
    index = 1
    results = []
    
    for _ in range(t):
        N = int(data[index])  # кількість точок одного кольору
        index += 1
        
        blue_points = []
        red_points = []
        
        # Зчитуємо координати синіх точок
        for i in range(N):
            x, y = map(int, data[index:index + 2])
            blue_points.append((x, y, i + 1))  # додаємо індекс точки
            index += 2
        
        # Зчитуємо координати червоних точок
        for i in range(N):
            x, y = map(int, data[index:index + 2])
            red_points.append((x, y, i + 1))  # додаємо індекс точки
            index += 2
        
        # Сортуємо точки за координатами x (якщо x однаковий, то за y)
        blue_points.sort()
        red_points.sort()
        
        # З'єднуємо точки
        result = []
        for i in range(N):
            result.append(f"{blue_points[i][2]} {red_points[i][2]}")
        
        results.append("\n".join(result))
    
    # Вивід результатів
    sys.stdout.write("\n\n".join(results) + "\n")