N = int(input())
a = [list(map(int, input().split())) for _ in range(N)]
points_by_color = [[], []]
point_set_by_color = [set(), set()]

for y in range(N):
    for x in range(N):
        color = a[y][x]
        points_by_color[color].append((x, y))
        point_set_by_color[color].add((x, y))

res = 0

for color in range(2):
    points = points_by_color[color]
    point_set = point_set_by_color[color]
    midpoints = {}

    for x1, y1 in points:
        for x2, y2 in points:
            if (x1, y1) != (x2, y2):
                mx, my = (x1 + x2) / 2, (y1 + y2) / 2
                if mx.is_integer() and my.is_integer():
                    mid = (int(mx), int(my))
                    if mid not in midpoints:
                        midpoints[mid] = []
                    midpoints[mid].append(((x1, y1), (x2, y2)))

    for mid, pairs in midpoints.items():
        for (x1, y1), (x2, y2) in pairs:
            vx, vy = x1 - mid[0], y1 - mid[1]
            x3, y3 = mid[0] - vy, mid[1] + vx
            x4, y4 = mid[0] + vy, mid[1] - vx
            if (x3, y3) in point_set and (x4, y4) in point_set:
                res += 1

print(res // 2)
