#include <iostream>
#include <vector>
#include <unordered_map>
using namespace std;
void findPresident(int N, const vector<int>& numbers) {
    unordered_map<int, int> countMap;
    for (int num : numbers) {
        countMap[num]++;
    }
    int uniqueMin = -1;
    for (int num : numbers) {
        if (countMap[num] == 1) {
            if (uniqueMin == -1 || num < uniqueMin) {
                uniqueMin = num;
            }
        }
    }
    cout << uniqueMin << endl;
}
int main() {
    int N;
    cin >> N;
    vector<int> numbers(N);
    for (int i = 0; i < N; ++i) {
        cin >> numbers[i];
    }
    findPresident(N, numbers);
    return 0;
}