import Foundation

if let n = Int(readLine() ?? ""), let m = Int(readLine() ?? "") {
    var remaining = m
    var selectedStamps = [Int]()
    
    for i in stride(from: n, to: 0, by: -1) {
        if remaining >= i {
            selectedStamps.append(i)
            remaining -= i
        }
    }
    
    if remaining == 0 {
        print(selectedStamps.map { String($0) }.joined(separator: " "))
    } else {
        print(0)
    }
}