using System;

class Solution {
  public static void Main(string[] args) {
        // Зчитуємо розмір квадрата
        int N = int.Parse(Console.ReadLine());

        // Зчитуємо кольори точки (0 для синього, 1 для червоного)
        int[,] grid = new int[N, N];
        for (int i = 0; i < N; i++)
        {
            var row = Console.ReadLine().Split();
            for (int j = 0; j < N; j++)
            {
                grid[i, j] = int.Parse(row[j]);
            }
        }

        int count = 0;

        // Перевіряємо всі можливі квадрати
        for (int size = 1; size < N; size++) // розмір квадрата від 1 до N-1
        {
            for (int i = 0; i < N - size; i++) // вертикальна координата верхнього лівого кута
            {
                for (int j = 0; j < N - size; j++) // горизонтальна координата верхнього лівого кута
                {
                    // Перевіряємо квадрат з верхнім лівим кутом (i, j) та розміром size
                    if (grid[i, j] == grid[i + size, j] && 
                        grid[i, j] == grid[i, j + size] && 
                        grid[i, j] == grid[i + size, j + size])
                    {
                        count++;
                    }
                }
            }
        }

        // Виводимо кількість квадратів
        Console.WriteLine(count);
    }
}
