using System;

class Solution
{
    static void Main()
    {
        int t = int.Parse(Console.ReadLine()); 

        for (int test = 0; test < t; test++)
        {
            int N = int.Parse(Console.ReadLine()); 


            (int x, int y, int index)[] bluePoints = new (int, int, int)[N];
            (int x, int y, int index)[] redPoints = new (int, int, int)[N];

            for (int i = 0; i < N; i++)
            {
                var coords = Console.ReadLine().Split();
                bluePoints[i] = (int.Parse(coords[0]), int.Parse(coords[1]), i + 1);
            }

            for (int i = 0; i < N; i++)
            {
                var coords = Console.ReadLine().Split();
                redPoints[i] = (int.Parse(coords[0]), int.Parse(coords[1]), i + 1); 
            }

           
            Array.Sort(bluePoints, (a, b) => a.x == b.x ? a.y.CompareTo(b.y) : a.x.CompareTo(b.x));
            Array.Sort(redPoints, (a, b) => a.x == b.x ? a.y.CompareTo(b.y) : a.x.CompareTo(b.x));

            
            for (int i = 0; i < N; i++)
            {
               
                Console.WriteLine($"{bluePoints[i].index} {redPoints[i].index}");
            }
        }
    }
}
