from collections import deque

def min_time_to_meet(N):
    alice_queue = deque([1])
    bob_queue = deque([N])

    alice_visited = set([1])
    bob_visited = set([N])

    time = 0

    while alice_queue and bob_queue:
        time += 1

        for _ in range(len(alice_queue)):
            pos = alice_queue.popleft()
            if pos + 2 <= N and pos + 2 not in alice_visited:
                if pos + 2 in bob_visited:
                    return time
                alice_queue.append(pos + 2)
                alice_visited.add(pos + 2)
            if pos + 3 <= N and pos + 3 not in alice_visited:
                if pos + 3 in bob_visited:
                    return time
                alice_queue.append(pos + 3)
                alice_visited.add(pos + 3)

        for _ in range(len(bob_queue)):
            pos = bob_queue.popleft()
            if pos - 1 >= 1 and pos - 1 not in bob_visited:
                if pos - 1 in alice_visited:
                    return time
                bob_queue.append(pos - 1)
                bob_visited.add(pos - 1)
            if pos - 2 >= 1 and pos - 2 not in bob_visited:
                if pos - 2 in alice_visited:
                    return time
                bob_queue.append(pos - 2)
                bob_visited.add(pos - 2)

    return -1

n = int(input())
print(min_time_to_meet(n))