def solve():
    N = int(input())
    
    def can_meet(time):
        alice_positions = {1 + 2 * i for i in range(time + 1)} | {1 + 3 * i for i in range(time + 1)}
        bob_positions = {N - i for i in range(1, time + 1)} | {N - i for i in range(2, time + 1)}
        return not alice_positions.isdisjoint(bob_positions)
    
    def find_time(time):
        if can_meet(time):
            print(time)
            return True
        if time == N:
            print(-1)
            return True
        return find_time(time + 1)

    find_time(1)

solve()