from collections import deque

def can_meet(N):
    alice_queue = deque([1])
    alice_time = {1: 0}

    bob_queue = deque([N])
    bob_time = {N: 0}
    
    while alice_queue or bob_queue:
        if alice_queue:
            k = alice_queue.popleft()
            current_time = alice_time[k]
            for move in [2, 3]:
                new_pos = k + move
                if new_pos <= N and new_pos not in alice_time:
                    alice_time[new_pos] = current_time + 1
                    alice_queue.append(new_pos)
                    if new_pos in bob_time:
                        return alice_time[new_pos] + bob_time[new_pos]

        if bob_queue:
            k = bob_queue.popleft()
            current_time = bob_time[k]
            for move in [1, 2]:
                new_pos = k - move
                if new_pos >= 1 and new_pos not in bob_time:
                    bob_time[new_pos] = current_time + 1
                    bob_queue.append(new_pos)
                    if new_pos in alice_time:
                        return alice_time[new_pos] + bob_time[new_pos]
    
    return -1

N = int(input())

print(can_meet(N))