import math

def lcm(a, b):
    return a * b // math.gcd(a, b)

def find_meeting_time(N):
    alice_steps = [2, 3]
    bob_steps = [1, 2]

    alice_lcm = lcm(alice_steps[0], alice_steps[1])
    bob_lcm = lcm(bob_steps[0], bob_steps[1])

    if (N - 1) % math.gcd(alice_lcm, bob_lcm) == 0:
        return math.lcm(alice_lcm, bob_lcm)
    return -1

N = int(input())

print(find_meeting_time(N))