def solve(N, M):
    total_sum = N * (N + 1) // 2

    if M > total_sum:
        print(0)
        return

    result = []
    remaining = M

    for i in range(N, 0, -1):
        if remaining >= i:
            result.append(i)
            remaining -= i
        if remaining == 0:
            break

    if remaining != 0:
        print(0)
    else:
        print(" ".join(map(str, result)))

N = int(input())
M = int(input())

solve(N, M)