#include <iostream>

int gcd(int x, int y) {
    while (y != 0) {
        int temp = y;
        y = x % y;
        x = temp;
    }
    return x;
}

int lcm(int x, int y) {
    return (x*y)/gcd(x, y);
}

int find_count_of_ones(int n, int a, int b) {
    int count_a = n/a;
    int count_b = n/b;
    int count_lcm = n/lcm(a, b);

    return count_a + count_b - count_lcm;
}

int main() {
    int n, a, b;
    std::cin >> n >> a >> b;

    std::cout << find_count_of_ones(n, a, b) << std::endl;

    return 0;
}