#include <iostream>

int gcd(int x, int y) {
    while (y != 0) {
        int temp = y;
        y = x % y;
        x = temp;
    }
    return x;
}

int lcm(int x, int y) {
    return (x * y) / gcd(x, y);
}

int count_units(int N, int A, int B) {
    int count_A = N / A;
    int count_B = N / B;
    int count_LCM = N / lcm(A, B);
    return count_A + count_B - count_LCM;
}

int main() {
    int N, A, B;
    std::cin >> N >> A >> B;
    std::cout << count_units(N, A, B) << std::endl;
    return 0;
}