#include <iostream>
#include <vector>

using namespace std;

int main() {
    int N;
    cin >> N;
    vector<vector<int>> grid(N, vector<int>(N));

    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int square_count = 0;

    for (int size = 2; size <= N; ++size) {
        for (int i = 0; i <= N - size; ++i) {
            for (int j = 0; j <= N - size; ++j) {
                int color = grid[i][j];
                bool is_square = true;
                for (int di = 0; di < size; ++di) {
                    for (int dj = 0; dj < size; ++dj) {
                        if (grid[i + di][j + dj] != color) {
                            is_square = false;
                            break;
                        }
                    }
                    if (!is_square) break;
                }
                if (is_square) {
                    square_count++;
                }
            }
        }
    }

    cout << square_count << endl;

    return 0;
}