def F(N, M):
    dp = [float('inf')] * (M + 1)
    dp[0] = 0
    stamp_combination = [[] for _ in range(M + 1)]
    
    for i in range(1, N + 1):
        for j in range(M, i - 1, -1):
            if dp[j - i] + 1 < dp[j]:
                dp[j] = dp[j - i] + 1
                stamp_combination[j] = stamp_combination[j - i] + [i]
    
    if dp[M] == float('inf'):
        return [0]
    return stamp_combination[M]

N = int(input())
M = int(input())
result = F(N, M)
print(" ".join(map(str, result)))
