#include <iostream>
#include <vector>
using namespace std;

int main() {
    long long n, m;
    cin >> n >> m;

    vector<long long> result;
    bool found = false;

    for (long long mask = 1; mask < (1 << n); ++mask) {
        vector<long long> subset;
        long long sum = 0;

        for (long long i = 0; i < n; ++i) {
            if (mask & (1 << i)) {
                subset.push_back(i + 1);
                sum += (i + 1);
            }
        }

        if (sum == m) {
            if (!found || subset.size() < result.size()) {
                result = subset;
                found = true;
            }
        }
    }

    if (found) {
        for (long long num : result) {
            cout << num << " ";
        }
        cout << endl;
    } else {
        cout << 0 << endl;
    }

    return 0;
}
