def find_stamps(N, M):
    stamps = list(range(1, N + 1))
    selected = []
    current_sum = 0

    for stamp in reversed(stamps):
        if current_sum + stamp <= M:
            selected.append(stamp)
            current_sum += stamp
        if current_sum == M:
            break

    if current_sum == M:
        return selected
    else:
        return [0]

N = int(input())
M = int(input())

result = find_stamps(N, M)
print(" ".join(map(str, result)))