#include <iostream>
#include <unordered_map>
#include <vector>
#include <climits>
using namespace std;

int findPresident(int N, const vector<int>& numbers) {
    unordered_map<int, int> freq;

    for (int num : numbers) {
        freq[num]++;
    }

    int minUnique = INT_MAX; 

    for (const auto& pair : freq) {
        if (pair.second == 1) { 
            minUnique = min(minUnique, pair.first);
        }
    }

    return (minUnique == INT_MAX) ? -1 : minUnique;
}

int main() {
    int N;
    cin >> N;
    vector<int> numbers(N);
    for (int i = 0; i < N; ++i) {
        cin >> numbers[i];
    }
    int result = findPresident(N, numbers);
    cout << result << endl;
    return 0;
}
