def find_meeting_time(N):
    alice_positions = {1}  
    bob_positions = {N}    
    time = 0

    while alice_positions and bob_positions:

        if alice_positions & bob_positions:
            return time


        alice_positions = {pos + 2 for pos in alice_positions if pos + 2 <= N} | \
                          {pos + 3 for pos in alice_positions if pos + 3 <= N}

        bob_positions = {pos - 1 for pos in bob_positions if pos - 1 > 0} | \
                        {pos - 2 for pos in bob_positions if pos - 2 > 0}

        time += 1

    return -1  


N = int(input("Введіть кількість боксів N: "))
result = find_meeting_time(N)
if result == -1:
    print(-1)
else:
    print(result)
