from collections import deque

n = int(input())

if n <= 1:
    print(-1)
else:
    alice_queue = deque([(1, 0)])
    bob_queue = deque([(n, 0)])
    alice_visited = set([1])
    bob_visited = set([n])

    while alice_queue and bob_queue:
        alice_pos, alice_time = alice_queue.popleft()
        for next_pos in (alice_pos + 2, alice_pos + 3):
            if next_pos > n:
                continue
            if next_pos in bob_visited:
                print(alice_time + 1)
                exit()
            if next_pos not in alice_visited:
                alice_visited.add(next_pos)
                alice_queue.append((next_pos, alice_time + 1))

        bob_pos, bob_time = bob_queue.popleft()
        for next_pos in (bob_pos - 1, bob_pos - 2):
            if next_pos < 1:
                continue
            if next_pos in alice_visited:
                print(bob_time + 1)
                exit()
            if next_pos not in bob_visited:
                bob_visited.add(next_pos)
                bob_queue.append((next_pos, bob_time + 1))

    print(-1)

