#include <iostream>
#include <vector>
using namespace std;

int main() {
    int n;
    cin >> n;

    vector<vector<int>> a(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
        }
    }

    int count = 0;

    for (int i = 0; i < n - 1; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            for (int k = i; k < n; ++k) {
                for (int l = j + 1; l < n; ++l) {
                    if ((i == k && j == l) || a[k][l] != a[i][j]) {
                        continue;
                    }

                    int x = l - j;
                    int y = k - i;

                    if (n > i + x && i + x >= 0 &&
                        n > j - y && j - y >= 0 &&
                        n > l - y && l - y >= 0 &&
                        n > k + x && k + x >= 0 &&
                        a[i + x][j - y] == a[i][j] &&
                        a[k + x][l - y] == a[i][j] &&
                        a[k][l] == a[i][j]) {
                        count++;
                    }
                }
            }
        }
    }

    cout << count << endl;

    return 0;
}
