def min_time_to_meet(N):
    # Початкові позиції
    alice_positions = [1]
    bob_positions = [N]

    # Відвідані позиції
    alice_visited = {1}
    bob_visited = {N}

    # Час
    time = 0

    while alice_positions and bob_positions:
        # Множини позицій для наступного кроку
        next_alice_positions = []
        next_bob_positions = []

        # Рух Аліси
        for current_pos in alice_positions:
            for next_pos in (current_pos + 2, current_pos + 3):
                if next_pos <= N and next_pos not in alice_visited:
                    alice_visited.add(next_pos)
                    next_alice_positions.append(next_pos)

        # Рух Боба
        for current_pos in bob_positions:
            for next_pos in (current_pos - 1, current_pos - 2):
                if next_pos >= 1 and next_pos not in bob_visited:
                    bob_visited.add(next_pos)
                    next_bob_positions.append(next_pos)

        # Перевірка на зустріч
        for pos in next_alice_positions:
            if pos in next_bob_positions:
                return time + 1

        alice_positions = next_alice_positions
        bob_positions = next_bob_positions
        time += 1

    return -1

# Приклад використання
 N = int(input())
result = min_time_to_meet(N)
if result != -1:
    print(f"Аліса та Боб зустрінуться через {result} секунд.")
else:
    print("Аліса та Боб ніколи не зустрінуться.")
