from math import gcd

def count_ones(N, A, B):
    # Функція для обчислення НСК
    def lcm(x, y):
        return x * y // gcd(x, y)
    
    # Підрахунок кратностей
    countA = N // A
    countB = N // B
    countAB = N // lcm(A, B)
    
    # Принцип включення-виключення
    return countA + countB - countAB

# Приклад введення
N = int(input("Введіть кількість комірок N: "))
A = int(input("Введіть число A: "))
B = int(input("Введіть число B: "))

# Виведення результату
print("Кількість одиниць у пам'яті:", count_ones(N, A, B))
