from math import gcd

def count_ones(N, A, B):
    # Функція для знаходження НСК
    def lcm(x, y):
        return x * y // gcd(x, y)
    
    # Кількість чисел, що діляться на A, B і обидва
    countA = N // A
    countB = N // B
    countAB = N // lcm(A, B)
    
    # Загальна кількість одиниць
    return countA + countB - countAB

# Зчитування вхідних даних
N = int(input("Введіть кількість комірок N: "))
A, B = map(int, input("Введіть числа A та B через пробіл: ").split())

# Виведення результату
print(count_ones(N, A, B))
