def count_uniform_squares(N, points):
    count = 0

    # Перетворити список точок у словник для швидкого доступу
    color_map = {(x, y): color for x, y, color in points}

    # Перебір усіх можливих квадратів
    for x1 in range(N):
        for y1 in range(N):
            for size in range(1, N - max(x1, y1)):
                x2, y2 = x1 + size, y1 + size

                # Перевірка квадрату за координатами вершин
                if (
                    color_map.get((x1, y1)) == color_map.get((x1, y2)) ==
                    color_map.get((x2, y1)) == color_map.get((x2, y2))
                ):
                    count += 1

    return count

# Введення
N = int(input())
points = []
for i in range(N):
    row = list(map(int, input().split()))
    for j, color in enumerate(row):
        points.append((i, j, color))

# Обчислення та виведення результату
result = count_uniform_squares(N, points)
print(result)
