from collections import deque

def teleportation(N):
    start = 1
    target = N
    if start == target:
        return 0
    
    visited = set()
    queue = deque([(start, 0), (target, 1)])
    
    while queue:
        position, steps = queue.popleft()
        
        if position in visited:
            continue
        
        visited.add(position)
        
        for new_pos in [position+2, position+3, position-1, position-2]:
            if new_pos == target:
                if steps == 0:
                    return 1
                return steps + 1
            if 0 < new_pos <= N:
                queue.append((new_pos, steps))
    
    return -1

N = int(input())
result = teleportation(N)
print(result)
