def solve():
    # Зчитування вхідних даних
    n = int(input())
    m = int(input())
    
    # Ініціалізація dp-масиву
    dp = [None] * (m + 1)
    dp[0] = []  # Для суми 0 потрібен порожній набір
    
    # Проходимо всі марки
    for i in range(1, n + 1):
        value = i  # Вартість марки
        for s in range(m, value - 1, -1):
            if dp[s - value] is not None:
                # Оновлюємо dp[s], якщо знаходимо кращий набір
                if dp[s] is None or len(dp[s]) > len(dp[s - value]) + 1:
                    dp[s] = dp[s - value] + [i]
    
    # Виведення результату
    if dp[m] is None:
        print(0)
    else:
        print(*dp[m])

# Запуск функції
solve()