def choose_stamps(n, m):
  """Функція для вибору марок."""
  stamps = list(range(1, n + 1))  # Список марок
  stamps.sort(reverse=True)  # Сортування за ціною
  chosen_stamps = []
  total_cost = 0
  for stamp in stamps:
    if total_cost + stamp <= m:
      chosen_stamps.append(stamp)
      total_cost += stamp
    else:
      break
  if total_cost == m:
    return chosen_stamps
  else:
    return [0]

n = int(input())
m = int(input())
chosen_stamps = choose_stamps(n, m)
if chosen_stamps == [0]:
  print(0)
else:
  for stamp in chosen_stamps:
    print(stamp, end=" ")
