def count_colored_squares(N, grid):
    count = 0

    # Перебір розмірів квадратів
    for size in range(1, N + 1):
        # Перебір верхнього лівого кута квадратів
        for i in range(N - size + 1):
            for j in range(N - size + 1):
                # Вершини квадрата
                top_left = grid[i][j]
                top_right = grid[i][j + size - 1]
                bottom_left = grid[i + size - 1][j]
                bottom_right = grid[i + size - 1][j + size - 1]

                # Перевірка, чи всі вершини мають однаковий колір
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1

    return count

# Вхідні дані
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Обчислення результату
result = count_colored_squares(N, grid)

# Вивід результату
print(result)