def count_squares(n, matrix):
  """Функція для підрахунку кількості квадратів з одноколірними вершинами."""
  count = 0
  for size in range(2, n + 1):  # Розмір квадрата
    for i in range(n - size + 1):  # Верхній лівий кут квадрата
      for j in range(n - size + 1):
        color = matrix[i][j]
        if (matrix[i][j + size - 1] == color and 
            matrix[i + size - 1][j] == color and 
            matrix[i + size - 1][j + size - 1] == color):
          count += 1
  return count

# Зчитування даних
n = int(input())
matrix = []
for _ in range(n):
  matrix.append(list(map(int, input().split())))

# Підрахунок квадратів
result = count_squares(n, matrix)

# Виведення результату
print(result)
