def count_colored_squares(n, grid):
    count = 0
    
    # Перебір всіх можливих розмірів квадратів
    for size in range(1, n):  # size від 1 до N-1
        for i in range(n - size):  # верхній лівий кут по осі x
            for j in range(n - size):  # верхній лівий кут по осі y
                # Вершини квадрата
                top_left = grid[i][j]
                top_right = grid[i][j + size]
                bottom_left = grid[i + size][j]
                bottom_right = grid[i + size][j + size]
                
                # Перевірка кольору
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1
                    
    return count

# Зчитування даних
n = int(input())
grid = [list(map(int, input().split())) for _ in range(n)]

# Обчислення результату
result = count_colored_squares(n, grid)

# Виведення результату
print(result)
