t = int(input())  # кількість тестів

for _ in range(t):
    N = int(input())  # кількість точок одного кольору
    blue_points = [tuple(map(int, input().split())) for _ in range(N)]
    red_points = [tuple(map(int, input().split())) for _ in range(N)]
    
    # Створимо пари для точок, щоб зберегти їх індекси
    indexed_blue = [(blue_points[i][0], blue_points[i][1], i + 1) for i in range(N)]
    indexed_red = [(red_points[i][0], red_points[i][1], i + 1) for i in range(N)]
    
    # Сортуємо точки за їхніми координатами
    indexed_blue.sort(key=lambda x: x[0])  # Сортуємо за x
    indexed_red.sort(key=lambda x: x[0])   # Сортуємо за x
    
    # Якщо з'єднання можливе, виводимо відповіді
    result = []
    for i in range(N):
        blue_index = indexed_blue[i][2]
        red_index = indexed_red[i][2]
        result.append(f"{blue_index} {red_index}")
    
    # Виводимо відповідь для поточного тесту
    print("\n".join(result))