def solve():
    import sys
    input = sys.stdin.read
    data = input().split()
    
    t = int(data[0])  # Кількість тестів
    index = 1
    results = []
    
    for _ in range(t):
        n = int(data[index])  # Кількість точок кожного кольору
        index += 1
        
        blue_points = []
        red_points = []
        
        # Зчитуємо сині точки
        for i in range(n):
            x, y = map(int, data[index:index + 2])
            blue_points.append((x, y, i + 1))  # (координати x, y, номер точки)
            index += 2
        
        # Зчитуємо червоні точки
        for i in range(n):
            x, y = map(int, data[index:index + 2])
            red_points.append((x, y, i + 1))  # (координати x, y, номер точки)
            index += 2
        
        # Сортуємо точки за x-координатою
        blue_points.sort()
        red_points.sort()
        
        # З'єднуємо точки
        pairs = []
        for i in range(n):
            pairs.append((blue_points[i][2], red_points[i][2]))
        
        results.append(pairs)
    
    # Виводимо результати
    for res in results:
        for pair in res:
            print(pair[0], pair[1])