from collections import deque
n = int(input())
m = int(input())
queue = deque([(1, n, 0)])
visited = set()
visited.add((1, n))
while queue:
    a, b, time = queue.popleft()
    if a == b:
        print(time)
        break
    alice_moves = [a + 2, a + 3]
    bob_moves = [b - 1, b - 2]
    for new_a in alice_moves:
        for new_b in bob_moves:
            if 1 <= new_a <= n and 1 <= new_b <= n and (new_a, new_b) not in visited:
                visited.add((new_a, new_b))
                queue.append((new_a, new_b, time + 1))
else:
    print(0)