N = int(input())  
grid = []
for i in range(N):
    row = list(map(int, input().split()))
    grid.append(row)
redp = []
bluep = []
for i in range(N):
    for j in range(N):
        if grid[i][j] == 1:
            redp.append((i, j))
        else:
            bluep.append((i, j))
def distance(p1, p2):
    return (p1[0] - p2[0]) ** 2 + (p1[1] - p2[1]) ** 2
def is_square(points):
    distances = []
    for i in range(4):
        for j in range(i + 1, 4):
            distances.append(distance(points[i], points[j]))
    distances.sort()
    return distances[0] == distances[1] == distances[2] == distances[3] and distances[4] == distances[5]
red_squares = 0
blue_squares = 0
for i in range(len(redp)):
    for j in range(i + 1, len(redp)):
        for k in range(j + 1, len(redp)):
            for l in range(k + 1, len(redp)):
                square_points = [redp[i], redp[j], redp[k], redp[l]]
                if is_square(square_points):
                    red_squares += 1
for i in range(len(bluep)):
    for j in range(i + 1, len(bluep)):
        for k in range(j + 1, len(bluep)):
            for l in range(k + 1, len(bluep)):
                square_points = [bluep[i], bluep[j], bluep[k], bluep[l]]
                if is_square(square_points):
                    blue_squares += 1
print(red_squares + blue_squares)