program ConnectPoints;

type
  TPoint = record
    x, y, index: Integer;
  end;

var
  t, N, i, j: Integer;
  blue, red: array of TPoint;
  tmp: TPoint;

procedure SortPoints(var points: array of TPoint; N: Integer);
var
  i, j: Integer;
begin
  for i := 0 to N - 2 do
    for j := i + 1 to N - 1 do
      if (points[i].x > points[j].x) or ((points[i].x = points[j].x) and (points[i].y > points[j].y)) then
      begin
        tmp := points[i];
        points[i] := points[j];
        points[j] := tmp;
      end;
end;

begin
  ReadLn(t);
  
  for i := 1 to t do
  begin
    ReadLn(N);
    
    SetLength(blue, N);
    SetLength(red, N);

    for j := 0 to N - 1 do
    begin
      ReadLn(blue[j].x, blue[j].y);
      blue[j].index := j + 1;
    end;

    for j := 0 to N - 1 do
    begin
      ReadLn(red[j].x, red[j].y);
      red[j].index := j + 1;
    end;

    SortPoints(blue, N);
    SortPoints(red, N);

    for j := 0 to N - 1 do
    begin
      WriteLn(blue[j].index, ' ', red[j].index);
    end;
  end;
end.
