def minimum_seconds(N):

    queue = [(1, N, 0)]
    
    visited_alice = {1}
    visited_bob = {N}
    
    while queue:
        alice_pos, bob_pos, seconds = queue.pop(0)

        if alice_pos == bob_pos:
            return seconds

        for alice_move in [2, 3]:
            new_alice_pos = alice_pos + alice_move
            if 1 <= new_alice_pos <= N and new_alice_pos not in visited_alice:
                visited_alice.add(new_alice_pos)
                queue.append((new_alice_pos, bob_pos, seconds + 1))

        for bob_move in [1, 2]:
            new_bob_pos = bob_pos - bob_move
            if 1 <= new_bob_pos <= N and new_bob_pos not in visited_bob:
                visited_bob.add(new_bob_pos)
                queue.append((alice_pos, new_bob_pos, seconds + 1))

    return -1
N = int(input())
N-1
print(minimum_seconds(N))