def min_meeting_time(N):
    # Множества для позиций Алисой и Бобом
    alice_positions = {1}  # Начальная позиция Алисы
    bob_positions = {N}    # Начальная позиция Боба
    
    # Временная переменная
    time = 0
    
    # Пока есть позиции для проверки
    while alice_positions and bob_positions:
        # Если есть пересечение, возвращаем время
        if alice_positions & bob_positions:
            return time
        
        # Обновляем позиции
        new_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= N:
                new_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                new_alice_positions.add(pos + 3)
        
        new_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                new_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_positions.add(pos - 2)
        
        # Переходим к следующим позициям
        alice_positions = new_alice_positions
        bob_positions = new_bob_positions
        
        # Увеличиваем время
        time += 1
    
    # Если пересечения не нашли
    return -1

# Чтение входных данных
N = int(input())
print(min_meeting_time(N))