import numpy as np
import sys

# Зчитуємо всі дані
data = sys.stdin.read().splitlines()

# Кількість тестових блоків
t = int(data[0])
index = 1
result = []

# Обробляємо кожен тестовий блок
for _ in range(t):
    n = int(data[index])  # Кількість точок одного кольору
    index += 1

    # Зчитуємо координати синіх точок
    blue_points = []
    for i in range(n):
        x, y = map(int, data[index + i].split())
        blue_points.append((x, y, i + 1))  # Додаємо індекс
    index += n

    # Зчитуємо координати червоних точок
    red_points = []
    for i in range(n):
        x, y = map(int, data[index + i].split())
        red_points.append((x, y, i + 1))  # Додаємо індекс
    index += n

    # Перетворюємо в масиви NumPy для зручності
    blue_points = np.array(blue_points)
    red_points = np.array(red_points)

    # Сортуємо за x-координатою
    blue_points = blue_points[blue_points[:, 0].argsort()]
    red_points = red_points[red_points[:, 0].argsort()]

    # Формуємо пари без перетинів
    pairs = [(blue_points[i][2], red_points[i][2]) for i in range(n)]
    
    result.append('\n'.join(f"{b} {r}" for b, r in pairs))

# Вивести всі результати
sys.stdout.write('\n\n'.join(result) + '\n')