using System;
using System.Collections.Generic;
using System.Linq;

class Solution {
    public static long LCM(long a, long b)
    {
        return a / GCD(a, b) * b; // Формула LCM через GCD
    }

    public static long GCD(long a, long b)
    {
        // Алгоритм Евкліда для обчислення НСД (GCD)
        while (b != 0)
        {
            long temp = b;
            b = a % b;
            a = temp;
        }
        return a;
    }
  public static void Main(string[] args) {
    long n = Convert.ToInt64(Console.ReadLine());

    string input = Console.ReadLine();
    List<long> numbers = input.Split(' ').Select(long.Parse).ToList();
    long a = numbers[0];
    long b = numbers[1];

    Console.WriteLine(n / a + n / b - n / LCM(a, b));
  }
}
