fun main() {
    val n = readln().toInt()
    val grid = Array(n) { readln().split(" ").map { it.toInt() }.toIntArray() }
    var count = 0

    fun isValid(x: Int, y: Int): Boolean = x in 0 until n && y in 0 until n

    for (x1 in 0 until n) {
        for (y1 in 0 until n) {
            for (x2 in 0 until n) {
                for (y2 in 0 until n) {
                    if (x1 == x2 && y1 == y2) continue

                    val dx = x2 - x1
                    val dy = y2 - y1
                    val x3 = x1 - dy
                    val y3 = y1 + dx
                    val x4 = x2 - dy
                    val y4 = y2 + dx

                    if (isValid(x3, y3) && isValid(x4, y4)) {
                        if (grid[x1][y1] == grid[x2][y2] &&
                            grid[x2][y2] == grid[x3][y3] &&
                            grid[x3][y3] == grid[x4][y4]
                        ) {
                            count++
                        }
                    }
                }
            }
        }
    }

    println(count / 4)
}