def can_meet(N):
    alice_positions = {1}
    bob_positions = {N}

    time = 0

    while alice_positions and bob_positions:
        time += 1

        # Update Alice's positions
        alice_positions = {pos + step for pos in alice_positions for step in [2, 3] if 1 <= pos + step <= N}
        
        # Update Bob's positions
        bob_positions = {pos + step for pos in bob_positions for step in [-1, -2] if 1 <= pos + step <= N}

        # Check if they meet
        if alice_positions & bob_positions:
            return time

    return -1

n = int(input())  
print(can_meet(n))
