def solve(N, M):
    # If M is too large to be formed by distinct numbers from 1 to N
    if M > (N * (N + 1)) // 2:
        print(0)
        return
    
    result = []
    while M > 0 and N > 0:
        if M >= N:
            result.append(N)
            M -= N
        N -= 1
    
    # If we have successfully reduced M to 0, print the result
    if M == 0:
        print(*result)
    else:
        print(0)

# Reading input
solve(int(input()), int(input()))
