def count_uniform_squares(N, grid):
    count = 0

    for i in range(N):
        for j in range(N):

            for size in range(2, N - max(i, j) + 1):

                top_left = grid[i][j]
                top_right = grid[i][j + size - 1]
                bottom_left = grid[i + size - 1][j]
                bottom_right = grid[i + size - 1][j + size - 1]

                if top_left == top_right == bottom_left == bottom_right:
                    count += 1
    
    return count

N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

print(count_uniform_squares(N, grid))