def solve():
    t = int(input())  # Читаємо кількість тестів
    
    for _ in range(t):
        N = int(input())  # Читаємо кількість точок одного кольору
        
        blue_points = []
        red_points = []
        
        # Читання синіх точок
        for i in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y, i + 1))  # Додаємо точку синього кольору з її індексом (1-based)
        
        # Читання червоних точок
        for i in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y, i + 1))  # Додаємо точку червоного кольору з її індексом (1-based)
        
        # Сортуємо точки за x, а потім за y
        blue_points.sort()
        red_points.sort()
        
        # Формуємо пари індексів
        result = []
        for i in range(N):
            result.append((blue_points[i][2], red_points[i][2]))  # З'єднуємо точки по порядку
        
        # Виводимо результат
        for pair in result:
            print(pair[0], pair[1])

# Викликаємо функцію для обробки вхідних даних
solve()
