#include <bits/stdc++.h>
using namespace std;



struct Vector 
{
    int x;
    int y;
};

float calcLength(Vector point1, Vector point2) 
{
    return sqrt((point1.x - point2.x)^2 + (point1.y - point2.y)^2);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin>>t;

    for (int iMain = 0; iMain < t; iMain++) 
    {
        int N;
        cin >> N;

        Vector redDots[N];
        Vector blueDots[N];

        for (int i = 0; i < N; i++) 
        {
            cin >> redDots[i].x;
            cin >> redDots[i].y;
        }

        for (int i = 0; i < N; i++) 
        {
            cin >> blueDots[i].x;
            cin >> blueDots[i].y;
        }

        for (int i = 0; i < N; i++) 
        {
            float minDis = FLT_MAX;
            int curIndex;
            for (int j = 0; j < N; j++) 
            {
                float dis = calcLength(redDots[i], blueDots[j]);
                if (dis < minDis) 
                {
                    minDis = dis;
                    curIndex = j;
                }
            }

            cout << i << " " << curIndex << "\n";
        }
    }
}
