def teleportation_meeting(N):
    alice_positions = {1}
    bob_positions = {N}
    
    seconds = 0
    while True:
        seconds += 1
        
        new_alice_positions = set()
        for position in alice_positions:
            if position + 2 <= N:
                new_alice_positions.add(position + 2)
            if position + 3 <= N:
                new_alice_positions.add(position + 3)
        
        new_bob_positions = set()
        for position in bob_positions:
            if position - 1 >= 1:
                new_bob_positions.add(position - 1)
            if position - 2 >= 1:
                new_bob_positions.add(position - 2)
        
        if new_alice_positions & new_bob_positions:
            return seconds
        
        alice_positions = new_alice_positions
        bob_positions = new_bob_positions
        
        if not alice_positions or not bob_positions:
            return -1

N = int(input())
print(teleportation_meeting(N))
