from collections import deque

def teleport(N):
    if N == 2:
        return 1
    a_positions = {1}
    b_positions = {N}
    time = 0

    while time <= N:
        new_a_positions = set()
        new_b_positions = set()

        for pos in a_positions:
            if pos + 2 <= N:
                new_a_positions.add(pos + 2)
            if pos + 3 <= N:
                new_a_positions.add(pos + 3)

        for pos in b_positions:
            if pos - 1 >= 1:
                new_b_positions.add(pos - 1)
            if pos - 2 >= 1:
                new_b_positions.add(pos - 2)

        if new_a_positions & new_b_positions:
            return time + 1

        a_positions = new_a_positions
        b_positions = new_b_positions
        time += 1

    return -1

N = int(input())
print(teleport(N))
