from collections import Counter

def find_president(N, numbers):
    count = Counter(numbers)
    
    min_unique = float('inf')
    
    for num, freq in count.items():
        if freq == 1:
            min_unique = min(min_unique, num)
    
    if min_unique == float('inf'):
        return -1
    return min_unique

try:
    N = int(input())
    numbers = list(map(int, input().split()))

    if len(numbers) != N:
        print("Помилка: кількість чисел не співпадає з N.")
    else:
        print(find_president(N, numbers))

except ValueError:
    print("Помилка: некоректний ввід.")
