def solve(t, test_cases):
    results = []
    for case in test_cases:
        N, blue_points, red_points = case
        blue_points_sorted = sorted([(x, y, i+1) for i, (x, y) in enumerate(blue_points)], key=lambda p: (p[0], p[1]))
        red_points_sorted = sorted([(x, y, i+1) for i, (x, y) in enumerate(red_points)], key=lambda p: (p[0], p[1]))
        
        result = []
        for i in range(N):
            result.append(f"{blue_points_sorted[i][2]} {red_points_sorted[i][2]}")
        
        results.append("\n".join(result))
    
    return "\n\n".join(results)


# Читання вхідних даних
t = int(input())
test_cases = []
for _ in range(t):
    N = int(input())
    blue_points = [tuple(map(int, input().split())) for _ in range(N)]
    red_points = [tuple(map(int, input().split())) for _ in range(N)]
    test_cases.append((N, blue_points, red_points))

# Виведення результатів
print(solve(t, test_cases))
