def solve():
    t = int(input())  # Количество тестов
    
    for _ in range(t):
        N = int(input())  # Количество точек одного цвета
        
        blue_points = []
        red_points = []
        
        # Чтение синих точек
        for i in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y, i + 1))  # Добавляем координаты и индекс синих точек (с 1)
        
        # Чтение красных точек
        for i in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y, i + 1))  # Добавляем координаты и индекс красных точек (с 1)
        
        # Сортируем синие точки по x, потом по y
        blue_points.sort(key=lambda p: (p[0], p[1]))  # Сортировка по x и y для синих точек
        
        # Сортируем красные точки по x, потом по y
        red_points.sort(key=lambda p: (p[0], p[1]))  # Сортировка по x и y для красных точек
        
        # Выводим индексы точек в правильном порядке
        for i in range(N):
            print(blue_points[i][2], red_points[i][2])  # Выводим индексы синей и красной точки

solve()
