def solve():
    import sys
    input = sys.stdin.read
    data = input().splitlines()

    t = int(data[0])
    result = []
    idx = 1

    for _ in range(t):
        N = int(data[idx])
        idx += 1

        blue_points = []
        red_points = []

        for i in range(N):
            x, y = map(int, data[idx + i].split())
            blue_points.append((x, y, i + 1))
        idx += N

        for i in range(N):
            x, y = map(int, data[idx + i].split())
            red_points.append((x, y, i + 1))
        idx += N

        blue_points.sort(key=lambda p: (p[0], p[1]))  # Сортируем по x, затем по y
        red_points.sort(key=lambda p: (p[0], p[1]))   # То же самое для красных точек

        pairs = [(blue_points[i][2], red_points[i][2]) for i in range(N)]
        pairs.sort(reverse=True, key=lambda x: x[0])  # Обеспечиваем требуемый порядок

        result.append("\n".join(f"{b} {r}" for b, r in pairs))

    print("\n\n".join(result))


if __name__ == "__main__":
    solve()
