#include <iostream>
#include <unordered_map>
#include <vector>
#include <limits.h>

using namespace std;

int main() {
    int N;
    cin >> N;

    vector<int> a(N);
    unordered_map<int, int> freq;

    // Зчитуємо числа, що їх згенерували роботи, і підраховуємо їх частоти
    for (int i = 0; i < N; ++i) {
        cin >> a[i];
        freq[a[i]]++;
    }

    int min_num = INT_MAX;
    bool found = false;

    // Перевіряємо, яке число є унікальним мінімальним
    for (int i = 0; i < N; ++i) {
        if (freq[a[i]] == 1 && a[i] < min_num) {
            min_num = a[i];
            found = true;
        }
    }

    // Якщо таке число знайдено, виводимо його, інакше виводимо -1
    if (found) {
        cout << min_num << endl;
    } else {
        cout << -1 << endl;
    }

    return 0;
}
