def min_seconds_to_meet(N):
    if (N - 1) % 5 != 0:
        return -1

    t = 0
    alice_pos = {1}
    bob_pos = {N}

    while True:
        if alice_pos & bob_pos:
            return t

        alice_pos = {x + 2 for x in alice_pos} | {x + 3 for x in alice_pos}
        bob_pos = {x - 1 for x in bob_pos if x > 1} | {x - 2 for x in bob_pos if x > 2}
        
        t += 1

N = int(input())
print(min_seconds_to_meet(N))