class Point:
    def __init__(self, x, y, index):
        self.x = x
        self.y = y
        self.index = index

def solve():
    t = int(input())

    for _ in range(t):
        N = int(input())
        
        blue = []
        red = []

        for i in range(N):
            x, y = map(int, input().split())
            blue.append(Point(x, y, i + 1))

        for i in range(N):
            x, y = map(int, input().split())
            red.append(Point(x, y, i + 1))

        blue.sort(key=lambda p: (p.x, p.y))
        red.sort(key=lambda p: (p.x, p.y))

        for i in range(N):
            print(blue[i].index, red[i].index)

        if _ < t - 1:
            print()

if __name__ == "__main__":
    solve()