import itertools
import math

def check(p1, p2, p3, p4):
    d = [
        (p1[0] - p2[0])**2 + (p1[1] - p2[1])**2,
        (p1[0] - p3[0])**2 + (p1[1] - p3[1])**2,
        (p1[0] - p4[0])**2 + (p1[1] - p4[1])**2,
        (p2[0] - p3[0])**2 + (p2[1] - p3[1])**2,
        (p2[0] - p4[0])**2 + (p2[1] - p4[1])**2,
        (p3[0] - p4[0])**2 + (p3[1] - p4[1])**2]
    d.sort()
    return d[0] == d[1] == d[2] == d[3] and d[4] == d[5]

n = int(input())
a = [list(map(int, input().split())) for _ in range(n)]
rez = 0
points = [(i, j) for i in range(n) for j in range(n)]
for comb in itertools.combinations(points, 4):
    p1, p2, p3, p4 = comb
    if check(p1, p2, p3, p4):
        if a[p1[0]][p1[1]] == a[p2[0]][p2[1]] == a[p3[0]][p3[1]] == a[p4[0]][p4[1]]:
            rez += 1
print(rez)