N = int(input())
numbers = input().split()
from collections import Counter

def find_president(N, numbers):
    count = Counter(numbers)
    
    unique_numbers = [num for num, freq in count.items() if freq == 1]
    
    if not unique_numbers:
        return "No election"
    
    min_unique_number = min(unique_numbers)
    
    for i in range(N):
        if numbers[i] == min_unique_number:
            return i + 1  
    
    return "No election"  

result = find_president(N, numbers)
print(result)  
