def solve_blocks(t, test_cases):
    results = []
    for case in test_cases:
        n, blue_points, red_points = case
        blue = sorted((x, y, i + 1) for i, (x, y) in enumerate(blue_points))
        red = sorted((x, y, i + 1) for i, (x, y) in enumerate(red_points))
        
        pairs = [(blue[i][2], red[i][2]) for i in range(n)]
        
        results.append(pairs)
    return results
t = int(input())
test_cases = []
for _ in range(t):
    n = int(input())
    blue_points = [tuple(map(int, input().split())) for _ in range(n)]
    red_points = [tuple(map(int, input().split())) for _ in range(n)]
    test_cases.append((n, blue_points, red_points))

answers = solve_blocks(t, test_cases)

for result in answers:
    if result:
        for pair in result:
            print(*pair)
    else:
        print(0)
