def solve(n, m):
    if m > n * (n + 1) // 2 or m < 0:
        return 0
    
    stamps = []
    remaining = m
    
    for stamp in range(n, 0, -1):
        if stamp <= remaining:
            stamps.append(stamp)
            remaining -= stamp
        
        if remaining == 0:
            return "\n".join(map(str, sorted(stamps)))
    
    return 0

n = int(input())
m = int(input())

result = solve(n, m)
print(result)