def solve(N, target_amount):
    dp = [[False] * (target_amount + 1) for _ in range(N + 1)]
    
    for i in range(N + 1):
        dp[i][0] = True
    
    selected = [[[] for _ in range(target_amount + 1)] for _ in range(N + 1)]
    
    for i in range(1, N + 1):
        for j in range(1, target_amount + 1):
            if dp[i-1][j]:
                dp[i][j] = True
                selected[i][j] = selected[i-1][j].copy()
            
            if j >= i and dp[i-1][j-i]:
                if not dp[i][j] or len(selected[i-1][j-i]) + 1 < len(selected[i][j]):
                    dp[i][j] = True
                    selected[i][j] = selected[i-1][j-i] + [i]
    
    return "\n".join(map(str, selected[N][target_amount])) if dp[N][target_amount] else 0

n = int(input())
m = int(input())

result = solve(n, m)
print(result)