def solve(N, M):
    total_sum = N * (N + 1) // 2
    
    # If the total sum of the first N numbers is less than M, it's impossible
    if total_sum < M:
        print(0)
        return
    
    result = []
    
    # Greedy approach: Try to subtract the largest possible marks first
    for i in range(N, 0, -1):
        if M >= i:
            result.append(i)
            M -= i
        if M == 0:
            # As soon as M becomes 0, output the result and exit
            print(*result)
            return
    
    # If M is not zero by the end, print 0
    print(0)

# Read input
N = int(input())  # Number of stamps
M = int(input())  # Target value

# Call the function to solve the problem
solve(N, M)
