function memoryTest(N, A, B) {

    const gcd = (x, y) => (y === 0 ? x : gcd(y, x % y)); 
    const lcm = (x, y) => (x * y) / gcd(x, y);           


    const countA = Math.floor(N / A);
    const countB = Math.floor(N / B);
    const countAB = Math.floor(N / lcm(A, B));

    return countA + countB - countAB;
}


console.log(memoryTest(10, 2, 3));
console.log(memoryTest(5, 6, 7)); 
