def can_meet(N):
    if N < 2:
        return -1
    alice_positions = set([1])
    bob_positions = set([N])

    for t in range(1, N):
        new_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= N:
                new_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                new_alice_positions.add(pos + 3)
        alice_positions = new_alice_positions

        new_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                new_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_positions.add(pos - 2)
        bob_positions = new_bob_positions

        if alice_positions & bob_positions:
            return t

    return -1

N = int(input())

print(can_meet(N))