from collections import deque

def teleport(N):
    alice_positions = set([1]) 
    bob_positions = set([N])    
    
    time = 0
    
    alice_queue = deque([1])
    bob_queue = deque([N])
    
    while alice_queue and bob_queue:
        time += 1
        
        for _ in range(len(alice_queue)):
            position = alice_queue.popleft()
            if position + 2 <= N and position + 2 not in alice_positions:
                alice_positions.add(position + 2)
                alice_queue.append(position + 2)
            if position + 3 <= N and position + 3 not in alice_positions:
                alice_positions.add(position + 3)
                alice_queue.append(position + 3)
        
        if alice_positions & bob_positions:
            return time
        
        for _ in range(len(bob_queue)):
            position = bob_queue.popleft()
            if position - 1 >= 1 and position - 1 not in bob_positions:
                bob_positions.add(position - 1)
                bob_queue.append(position - 1)
            if position - 2 >= 1 and position - 2 not in bob_positions:
                bob_positions.add(position - 2)
                bob_queue.append(position - 2)
        
        if alice_positions & bob_positions:
            return time
    
    return -1

N = int(input())
print(teleport(N))
