def find_moves(N):
    moves = [3, 4, 5]
    
    # Массив для динамічного програмування
    dp = [float('inf')] * (N + 1)
    dp[0] = 0  # для нуля не потрібно ніяких рухів
    
    for i in range(1, N + 1):
        for move in moves:
            if i >= move:
                dp[i] = min(dp[i], dp[i - move] + 1)
                
    return dp[N]

N = int(input())  # зчитуємо число N
print(find_moves(N))
