def solve(N):
    # Якщо різниця між позиціями Аліси і Боба не є кратною 2, вони не можуть зустрітися
    if (N - 1) % 2 != 0:
        return -1
    
    # Потрібно провести бінарний пошук або інший ефективний підхід для знаходження мінімальної кількості секунд
    steps = 0
    while N > 1:
        # Приймаємо крок, де кожен робіт мінімізує свою відстань, зберігаючи умови
        if N % 3 == 0:
            N -= 3
        elif N % 2 == 0:
            N -= 2
        else:
            return -1
        steps += 1
        
    return steps

# Тестування функції
N = int(input())  # Вводимо число N
print(solve(N))  # Виводимо кількість секунд
