def find_minimum_stamps(N, M):
    dp = [float('inf')] * (M + 1)
    dp[0] = 0  
    
    for i in range(1, N + 1):
        for j in range(M, i - 1, -1):
            dp[j] = min(dp[j], dp[j - i] + 1)
    
    if dp[M] == float('inf'):
        return [0]
    
    result = []
    current_sum = M
    while current_sum > 0:
        for i in range(1, N + 1):
            if current_sum >= i and dp[current_sum - i] == dp[current_sum] - 1:
                result.append(i)
                current_sum -= i
                break
    return sorted(result)

N = int(input())
M = int(input())
result = find_minimum_stamps(N, M)
print(*result)
