def find_minimum_stamps(N, M):
    # Список для збереження вибраних марок
    result = []
    
    # Починаємо з найбільшої марки N і поступово зменшуємо
    for i in range(N, 0, -1):
        if M >= i:
            result.append(i)  # Додаємо марку
            M -= i  # Віднімаємо її вартість від M
        if M == 0:  # Якщо сума досягнута, зупиняємось
            break
    
    # Якщо сума M так і не стала рівною 0, повертаємо 0
    if M != 0:
        return [0]
    
    # Виводимо марки в зростаючому порядку
    return sorted(result)

# Вхідні дані
N = int(input())
M = int(input())

# Виведення результату
result = find_minimum_stamps(N, M)
print(*result)
