def solve():
    # Читання вхідних даних
    N = int(input())  # Кількість марок
    M = int(input())  # Загальна сума, яку потрібно досягти
    
    # Якщо сума всіх марок від 1 до N менша за M, то вирішити неможливо
    max_sum = N * (N + 1) // 2
    if max_sum < M:
        print(0)
        return
    
    # Використовуємо жадібний підхід: вибираємо марки від найбільших до найменших
    result = []
    for i in range(N, 0, -1):
        if M >= i:
            M -= i
            result.append(i)
        if M == 0:
            break
    
    # Якщо M не став 0, то рішення не знайдено
    if M > 0:
        print(0)
    else:
        # Виводимо номери марок, що складають необхідну суму
        print(" ".join(map(str, sorted(result))))

