from collections import Counter

def find_president(N, numbers):
    # Підраховуємо кількість кожного числа
    count = Counter(numbers)
    
    # Знайдемо мінімальне число, яке з'являється лише один раз
    min_number = float('inf')
    
    for num in count:
        if count[num] == 1:
            min_number = min(min_number, num)
    
    # Якщо ми не знайшли такого числа, виводимо -1
    if min_number == float('inf'):
        return -1
    else:
        return min_number

# Читання входу
N = int(input())
numbers = list(map(int, input().split()))

# Виведення результату
print(find_president(N, numbers))
