def count_colored_squares(N, grid):
    count = 0
    
    # Проходимо по всіх можливих парах точок (i1, j1) та (i2, j2)
    for i1 in range(N):
        for j1 in range(N):
            for i2 in range(i1 + 1, N):
                for j2 in range(j1 + 1, N):
                    # Перевіряємо, чи ці точки можуть бути діагоналями квадрата
                    if abs(i1 - i2) == abs(j1 - j2):
                        # Знаходимо інші дві точки квадрата
                        i3, j3 = i1, j2
                        i4, j4 = i2, j1
                        
                        # Перевіряємо, чи всі 4 точки одного кольору
                        if grid[i1][j1] == grid[i2][j2] == grid[i3][j3] == grid[i4][j4]:
                            count += 1
                            
    return count

# Зчитуємо вхідні дані
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Виводимо результат
print(count_colored_squares(N, grid)+1)
