def count_squares(n, grid):
    count = 0
    # Перебираємо всі пари точок (i1, j1) та (i2, j2)
    for i1 in range(n):
        for j1 in range(n):
            for i2 in range(i1 + 1, n):
                for j2 in range(j1 + 1, n):
                    # Перевіряємо, чи ці дві точки можуть бути діагоналями квадрата
                    if abs(i2 - i1) == abs(j2 - j1):
                        # Обчислюємо координати двох інших точок квадрата
                        i3, j3 = i1, j2
                        i4, j4 = i2, j1
                        
                        # Перевіряємо чи всі чотири точки однакового кольору
                        if grid[i1][j1] == grid[i2][j2] == grid[i3][j3] == grid[i4][j4]:
                            count += 1
    return count

# Читання вхідних даних
n = int(input())
grid = [list(map(int, input().split())) for _ in range(n)]

# Виведення результату
print(count_squares(n, grid))
