def count_uniform_squares(N, grid):
    count = 0
    
    # Перебираємо всі можливі розміри квадратів
    for size in range(1, N):  # Розмір квадратів від 1 до N-1
        # Перебираємо всі можливі верхні ліві кути квадрата
        for i in range(N - size):
            for j in range(N - size):
                # Перевіряємо всі чотири вершини квадрату
                if (grid[i][j] == grid[i + size][j] == grid[i][j + size] == grid[i + size][j + size]):
                    count += 1
    
    return count

# Зчитуємо вхідні дані
N = int(input())  # Сторона квадрата
grid = [list(map(int, input().split())) for _ in range(N)]  # Матриця кольорів

# Виводимо результат
print(count_uniform_squares(N, grid))
