def solve():
    t = int(input())  # Кількість блоків тестових даних
    
    for _ in range(t):
        N = int(input())  # Кількість точок одного кольору
        
        blue_points = []
        red_points = []
        
        # Зчитуємо координати синіх точок
        for i in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y, i + 1))  # Додаємо номер точки для подальшого виведення
        
        # Зчитуємо координати червоних точок
        for i in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y, i + 1))  # Додаємо номер точки для подальшого виведення
        
        # Сортуємо точки по x, а потім по y
        blue_points.sort()
        red_points.sort()
        
        # Пару точок з'єднуємо в порядку сортування
        result = []
        for i in range(N):
            result.append((blue_points[i][2], red_points[i][2]))
        
        # Виводимо відповідь для цього тесту
        for pair in result:
            print(pair[0], pair[1])

# Викликаємо функцію для запуску програми
solve()
