use std::io;

fn main() {
    let mut input = String::new();
    io::stdin().read_line(&mut input).unwrap();
    let mut distance = input.trim().parse::<i32>().unwrap() - 1;

    let mut time = 0;

    if distance <= 2 {
        println!("-1");
        return;
    }

    let mut solution = [0; 3];

    match distance % 3 {
        0 => solution[0] = distance/3,
        1 => {
            solution[0] = distance/3-1;
            solution[1] = 1;
        },
        2 => {
            solution[0] = distance/3-1;
            solution[2] = 1;
        },
        _ => {}
    }

    solution[2] += solution[0] * 3/5;
    solution[0] %= 5;

    solution[1] += solution[0] * 3/4;
    solution[0] %= 4;

    solution[2] += solution[1] * 4/5;
    solution[0] %= 5;

    println!("{}", solution[0] + solution[1] + solution[2])
}
