use std::io;

fn main() {
    let mut input = String::new();
    io::stdin().read_line(&mut input).unwrap();
    let n: u32 = input.trim().parse().unwrap();

    let mut input = String::new();
    io::stdin().read_line(&mut input).unwrap();
    let [a, b] = input.split(" ").map(|x| x.trim().parse::<u32>().unwrap()).collect::<Vec<_>>()[..] else {unreachable!()};

    println!("{}", n/a + n/b - n/gcd(a, b)/a/b)
}


fn gcd(mut a: u32, mut b: u32) -> u32 {
    if a > b {
        a %= b;

        if a == 0 {
            b
        } else {
            gcd(b, a)
        }
    } else if a == b {
        a
    } else {
        gcd(b, a)
    }
}