use std::io;

fn main() {
    let mut input = String::new();
    io::stdin().read_line(&mut input).unwrap();
    let n: usize = input.trim().parse().unwrap();

    let points = io::stdin()
        .lines()
        .map(|x| x
            .unwrap()
            .split("")
            .map(|y| y == "1")
            .collect::<Vec<_>>())
        .collect::<Vec<_>>();

    let mut counter = 0;

    for i in 0..n {
        for j in i..n-i {
            let i = i as usize;
            let j = j as usize;

            if points[i][j] 
            && points[n-j-1][i] 
            && points[j][n-i-1] 
            && points[n-i-1][n-j-1]
            || !points[i][j]
            && !points[n-j-1][i] 
            && !points[j][n-i-1] 
            && !points[n-i-1][n-j-1] {
                counter += 1;
            }
        }
    }

    println!("{counter}");
}
