use std::io;

fn main() {
    let mut input = String::new();
    io::stdin().read_line(&mut input).unwrap();
    let n: usize = input.trim().parse().unwrap();

    let points = io::stdin()
        .lines()
        .map(|x| x
            .unwrap()
            .split(" ")
            .map(|y| y == "1")
            .collect::<Vec<_>>())
        .collect::<Vec<_>>();

    /*
    for x in &points {
        for y in x {
            print!("{y} ");
        }
        println!("");
    }*/

    let mut counter = 0;

    for i in 0..n {
        for j in 0..n {
            let i = i as usize;
            let j = j as usize;

            let mut conditions = [
                points[i][j],
                points[n-j-1][i],
                points[j][n-i-1],
                points[n-i-1][n-j-1],
            ];

            if conditions.iter().all(|&x| x) || conditions.iter().all(|&x| !x) {
                counter += 1;

                //println!("{i}, {j}\n{conditions:?}");
                //println!("{i}, {j}");
                //println!("{}, {i}", n-j-1);
                //println!("{j}, {}", n-i-1);
                //println!("{}, {}", n-i-1, n-j-1);
            }
        }
    }

    println!("{}", counter/4);
}
