def solve():
    n = int(input())

    q = [(1, n, 0)]  # (alice_pos, bob_pos, time)
    visited = set()

    while q:
        alice_pos, bob_pos, time = q.pop(0)

        if alice_pos == bob_pos:
            print(time)
            return

        state = (alice_pos, bob_pos)
        if state in visited:
            continue
        visited.add(state)

        # Alice's moves
        for next_alice_pos in [alice_pos + 2, alice_pos + 3]:
            if 1 <= next_alice_pos <= n:
                # Bob's moves
                for next_bob_pos in [bob_pos - 1, bob_pos - 2]:
                    if 1 <= next_bob_pos <= n:
                        q.append((next_alice_pos, next_bob_pos, time + 1))

    print("-1")

solve()
