# n = int(input("Введіть кількість блоків"))
# m = 1
# sec = 0
# def mai():
#      random_number1 = random.randint(1, 2)
#     random_number2 = random.randint(2, 3)
#     m+random_number2
#     n-random_number1
#     sec++

# while(m!=n){
#    mai()
# }
# if(m==n){
#     print(sec)
# }
import random

def main():
    """
    Main function to execute the logic of counting the number of seconds
    it takes for the variable 'm' to reach the value of 'n' by randomly
    incrementing 'm' based on generated random numbers.

    The function prompts the user to input the number of blocks (n) and
    initializes the variables 'm' and 'sec'. It then enters a loop that
    continues until 'm' equals 'n', incrementing 'm' and counting seconds
    along the way.

    The user is expected to input a value for 'n' within the range of
    2 to 1,000,000,000. The function will print the total number of seconds
    taken for 'm' to reach 'n'.
    """

    # Prompting user to input the number of blocks
    n = int(input("Введіть кількість блоків (2≤N≤1000000000): "))
    
    # Validating the input to ensure it is within the specified range
    if n < 2 or n > 1000000000:
        raise ValueError("The value of n must be between 2 and 1,000,000,000.")

    # Initializing variables
    m = 1  # Starting value of m
    sec = 0  # Counter for seconds

    # Loop until m equals n
    while m < n:
        # Generate two random numbers
        random_number1 = random.randint(1, 2)  # Random number between 1 and 2
        random_number2 = random.randint(2, 3)  # Random number between 2 and 3
        
        # Increment m by random_number2
        m += random_number2
        
        # Decrement n by random_number1 (this line is not necessary for the logic)
        n -= random_number1
        
        # Increment the seconds counter
        sec += 1

    # When m equals or exceeds n, print the total seconds taken
    print(f"Total seconds taken for m to reach n: {sec}")

# Execute the main function
if __name__ == "__main__":
    main()