def min_meeting_time(N):
    # Ініціалізуємо позиції Аліси та Боба
    alice_positions = {1}  # Аліса починає з боксу 1
    bob_positions = {N}    # Боб починає з боксу N

    # Ітеративно перевіряємо кожен крок
    for t in range(1, N + 1):  # N - максимальна кількість кроків
        # Оновлюємо позиції Аліси
        next_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= N:
                next_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                next_alice_positions.add(pos + 3)
        
        # Оновлюємо позиції Боба
        next_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                next_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                next_bob_positions.add(pos - 2)
        
        # Перевіряємо перетин множин
        if next_alice_positions & next_bob_positions:
            return t
        
        # Оновлюємо позиції
        alice_positions = next_alice_positions
        bob_positions = next_bob_positions

    # Якщо не знайдено спільного боксу
    return -1

# Зчитування вхідних даних
N = int(input())
print(min_meeting_time(N))