def solve_test_case(N, blue_points, red_points):
    # Сортуємо точки за x-координатою для обох кольорів
    blue_sorted = sorted((x, y, i + 1) for i, (x, y) in enumerate(blue_points))
    red_sorted = sorted((x, y, i + 1) for i, (x, y) in enumerate(red_points))
    
    # Виводимо відповідь для цього теста
    result = []
    for i in range(N):
        blue_index = blue_sorted[i][2]  # оригінальний індекс синьої точки
        red_index = red_sorted[i][2]    # оригінальний індекс червоної точки
        result.append(f"{blue_index} {red_index}")
    
    return "\n".join(result)

def main():
    t = int(input())  # кількість тестових блоків
    results = []
    
    for _ in range(t):
        N = int(input())  # кількість точок одного кольору
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().split())) for _ in range(N)]
        
        result = solve_test_case(N, blue_points, red_points)
        results.append(result)
    
    # Вивести всі результати
    print("\n\n".join(results))

# Викликаємо основну функцію
if __name__ == "__main__":
    main()
