def find_stamps(N, M):
    dp = [float('inf')] * (M + 1)
    dp[0] = 0
    backtrack = [-1] * (M + 1)

    for i in range(1, N + 1):
        for j in range(i, M + 1):
            if dp[j - i] + 1 < dp[j]:
                dp[j] = dp[j - i] + 1
                backtrack[j] = i

    if dp[M] == float('inf'):
        return [0]

    result = []
    current = M
    while current > 0:
        result.append(backtrack[current])
        current -= backtrack[current]

    return result


N = int(input())
M = int(input())

result = find_stamps(N, M)
for value in result:
    print(value)
