def find_stamps_greedy(N, M):
    stamps = list(range(1, N + 1))
    stamps.sort(reverse=True)

    selected = []
    current_sum = 0

    for stamp in stamps:
        if current_sum + stamp <= M:
            selected.append(stamp)
            current_sum += stamp

        if current_sum == M:
            return sorted(selected) 
    return [0]
N = int(input())
M = int(input())

result = find_stamps_greedy(N, M)

print(*result)
