def find_president(N, numbers):
    frequency = {}

    for num in numbers:
        frequency[num] = frequency.get(num, 0) + 1

    min_unique = float('inf')
    for num, count in frequency.items():
        if count == 1 and num < min_unique:
            min_unique = num

    return min_unique if min_unique != float('inf') else -1
N = int(input())
numbers = list(map(int, input().split()))
print(find_president(N, numbers))


