from math import gcd

def count_ones_optimized(N, A, B):
    lcm = (A * B) // gcd(A, B)

    count_A = N // A
    count_B = N // B
    count_lcm = N // lcm

    return count_A + count_B - count_lcm


N = int(input())
A, B = map(int, input().split())

print(count_ones_optimized(N, A, B))
