def count_colored_squares(N, grid):
    count = 0
    
    for x in range(N):
        for y in range(N):
            max_size = min(N - x, N - y)
            for size in range(1, max_size + 1):
                top_left = grid[x][y]
                top_right = grid[x][y + size - 1]
                bottom_left = grid[x + size - 1][y]
                bottom_right = grid[x + size - 1][y + size - 1]
                
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1

    return count

N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

result = count_colored_squares(N, grid)
print(int(result/16))
