def min_meeting_time(N):
    min_time = float('inf')

    equations = [
        lambda t: 1 + 2 * t - (N - t),
        lambda t: 1 + 2 * t - (N - 2 * t),
        lambda t: 1 + 3 * t  - (N - t),
        lambda t: 1 + 3 * t - (N - 2 * t)
    ]

    for eq in equations:
        for t in range(0, 2 * N):
            if eq(t) == 0:
                min_time = min(min_time, t) 

    return min_time if  min_time != float('inf') else -1

N = int(input())
print(min_meeting_time(N))