def count_uniform_color_squares(N, grid):
    count = 0
    
    # Перебираємо всі можливі квадрати зі сторонами від 1 до N-1
    for size in range(1, N):
        for i in range(N - size):
            for j in range(N - size):
                # Координати вершин поточного квадрата
                top_left = grid[i][j]
                top_right = grid[i][j + size]
                bottom_left = grid[i + size][j]
                bottom_right = grid[i + size][j + size]
                
                # Перевірка, чи всі вершини одного кольору
                if (top_left == top_right == bottom_left == bottom_right):
                    count += 1
    
    return count

# Зчитування даних
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Обчислення та виведення результату
result = count_uniform_color_squares(N, grid)
print(result)