def count_uniform_color_squares(N, grid):
    count = 0
    
    # Перебираємо всі можливі квадрати
    for x1 in range(N):
        for y1 in range(N):
            # Максимальний розмір квадрата, який може починатися з точки (x1, y1)
            for size in range(1, N - max(x1, y1)):
                x2, y2 = x1 + size, y1 + size
                # Перевіряємо вершини квадрата
                if grid[x1][y1] == grid[x1][y2] == grid[x2][y1] == grid[x2][y2]:
                    count += 1
    return count

# Зчитування даних
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Обчислення та виведення результату
result = count_uniform_color_squares(N, grid)
print(result)