def solve_test_case(N, blue_points, red_points):
    # Сортуємо точки кожного кольору за координатами x, а якщо рівні, то за y
    blue_points = sorted((x, y, i + 1) for i, (x, y) in enumerate(blue_points))
    red_points = sorted((x, y, i + 1) for i, (x, y) in enumerate(red_points))

    # Жадібно з'єднуємо точки
    result = []
    for b, r in zip(blue_points, red_points):
        result.append((b[2], r[2]))  # Додаємо індекси точок

    return result


def main():
    # Читання кількості тестових блоків
    t = int(input())
    results = []

    for _ in range(t):
        # Читання розміру блоку
        N = int(input())
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().split())) for _ in range(N)]

        # Обчислення результату для поточного блоку
        solution = solve_test_case(N, blue_points, red_points)
        if solution:
            results.append("\n".join(f"{b} {r}" for b, r in solution))
        else:
            results.append("0")

    # Виведення результатів
    print("\n\n".join(results))