def solve_matching_problems(test_cases):
    results = []
    for t in range(test_cases):
        N = int(input().strip())
        blue_points = [tuple(map(int, input().strip().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().strip().split())) for _ in range(N)]

        blue_sorted = sorted(blue_points, key=lambda p: (p[0], p[1]))
        red_sorted = sorted(red_points, key=lambda p: (p[0], p[1]))

        matches = [(i+1, j+1) for i, j in zip(range(N), range(N-1, -1, -1))]
        results.append(matches)

    return results

if __name__ == "__main__":
    t = int(input().strip())
    results = solve_matching_problems(t)

    for result in results:
        for match in result:
            print(match[0], match[1])
