#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;
#define int long long

int n;
vector<pair<int, int>> a, b;
pair<int, int> sh;


bool cmp(pair<pair<int, int>, int> p1, pair<pair<int, int>, int> p2) {
    pair<int, int> v = { p1.first.first - sh.first, p1.first.second - sh.second };
    pair<int, int> u = { p2.first.first - sh.first, p2.first.second - sh.second };
    return (0 <= v.first * u.second - v.second * u.first);
}

void rec(vector<int>& ai, vector<int>& bi, int k) {

    /*cerr << k << endl << "ai =";
    for (int i : ai)
        cerr << " " << i;
    cerr << endl << "bi =";
    for (int i : bi)
        cerr << " " << i;
    cerr << endl;*/

    if (k == 1) {
        cout << ai[0] + 1 << " " << bi[0] + 1 << "\n";
        return;
    }
    if (!k) {
        return;
    }
    int ma = ai[0];
    int mb = bi[0];
    for (int i = 0; i < k; i++)
        if (a[ai[i]].first < a[ma].first)
            ma = ai[i];
    for (int i = 0; i < k; i++)
        if (b[bi[i]].first < b[mb].first)
            mb = bi[i];
    sh = b[mb];
    bool isa = false;
    if (a[ma].first < b[mb].first) {
        isa = true;
        sh = a[ma];
    }
    vector<pair<pair<int, int>, int>> dd;
    dd.reserve(2 * k - 1);
    for (int i = 0; i < k; i++)
        if (sh != a[ai[i]]) {
            dd.emplace_back(a[ai[i]], -ai[i] - 1);
            //cerr << "Added to dd from ai " << dd.back().second << endl;
        }
    for (int i = 0; i < k; i++)
        if (sh != b[bi[i]]) {
            dd.emplace_back(b[bi[i]], bi[i] + 1);
            //cerr << "Added to dd from bi " << dd.back().second << endl;
        }
    sort(dd.begin(), dd.end(), cmp);

    int ans = -1;
    vector<int> nwai;
    vector<int> nwbi;

    /*cerr << "ma = " << ma << "; mb = " << mb;
    if (isa)
        cerr << ", A is better" << endl;
    else
        cerr << ", B is better" << endl; */

    for (auto& w : dd) {
        if ((isa == (bool)(w.second > 0)) && nwai.size() == nwbi.size()) {
            ans = abs(w.second) - 1;
            //cerr << "ans is " << ans << endl;
            break;
        }
        //cerr << "Adding " << w.second << endl;
        if (w.second > 0) {
            nwbi.push_back(w.second - 1);
        }
        else {
            nwai.push_back(-w.second - 1);
        }
    }
    //assert(ans != -1);
    if (ans == -1) {
        cout << "-1\n";
        exit(0);
    }
    if (isa)
        cout << ma + 1 << " " << ans + 1 << "\n";
    else
        cout << ans + 1 << " " << mb + 1 << "\n";
    vector<int> scai, scbi;
    int j = 0;
    for (int i : ai) {
        if (j < nwai.size() && nwai[j] == i)
            j++;
        else {
            if (!(isa && i == ma || !isa && i == ans))
                scai.push_back(i);
        }
    }
    ai.clear();
    j = 0;
    for (int i : bi) {
        if (j < nwbi.size() && nwbi[j] == i)
            j++;
        else {
            if (!(isa && i == ans || !isa && i == mb))
                scbi.push_back(i);
        }
    }
    bi.clear();
    rec(nwai, nwbi, (int)nwai.size());
    rec(scai, scbi, (int)scai.size());
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        a.resize(n);
        b.resize(n);
        for (int i = 0; i < n; i++)
            cin >> a[i].first >> a[i].second;
        for (int i = 0; i < n; i++)
            cin >> b[i].first >> b[i].second;
        vector<int> i1(n), i2(n);
        for (int i = 0; i < n; i++) {
            i1[i] = i;
            i2[i] = i;
        }
        rec(i1, i2, n);
    }
}
