import java.util.*;

public class Teleportation {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        
        int N = scanner.nextInt();
        
        if (N < 2) {
            System.out.println(-1);
            return;
        }
        
        int alice = 1;
        int bob = N;

        int seconds = 0;
        while (alice < bob) {
            seconds++;
            alice += (seconds % 2 == 0) ? 3 : 2;
            bob -= (seconds % 2 == 0) ? 2 : 1;
        }

        if (alice == bob) {
            System.out.println(seconds);
        } else {
            System.out.println(-1);
        }
    }
}
