import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int N = scanner.nextInt(); // кількість марок
        int M = scanner.nextInt(); // сума, яку потрібно витратити

        // Якщо сума занадто велика для найбільших марок
        if (M > (N * (N + 1)) / 2) {
            System.out.println(0);
            return;
        }
        
        for (int i = N; i >= 1; i--) {
            if (M >= i) {
                System.out.println(i); // Вибираємо марку i
                M -= i; // Віднімаємо її від суми
            }
            if (M == 0) break; // Якщо сума рівна нулю, припиняємо
        }
        
        if (M > 0) {
            System.out.println(0); // Якщо сума залишилася невикористаною
        }
    }
}
