import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int N = scanner.nextInt();
        Map<Integer, Integer> countMap = new HashMap<>();
        
        for (int i = 0; i < N; i++) {
            int num = scanner.nextInt();
            countMap.put(num, countMap.getOrDefault(num, 0) + 1);
        }
        
        int minUnique = Integer.MAX_VALUE;
        
        for (int key : countMap.keySet()) {
            if (countMap.get(key) == 1) {
                minUnique = Math.min(minUnique, key);
            }
        }
        
        if (minUnique == Integer.MAX_VALUE) {
            System.out.println(-1);
        } else {
            System.out.println(minUnique);
        }
    }
}
