import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = Integer.parseInt(scanner.nextLine());
        String[] input = scanner.nextLine().split(" ");
        Map<Integer, Integer> a = new HashMap<>();
        
        for (String s : input) {
            int b = Integer.parseInt(s);
            a.put(b, a.getOrDefault(b, 0) + 1);
        }
        
        int c = Integer.MAX_VALUE;
        for (Map.Entry<Integer, Integer> entry : a.entrySet()) {
            if (entry.getValue() == 1 && entry.getKey() < c) {
                c = entry.getKey();
            }
        }
        
        if (c == Integer.MAX_VALUE) {
            System.out.println(-1);
        } else {
            System.out.println(c);
        }
        
        scanner.close();
    }
}

