import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        
        // Читання вхідних даних
        int N = sc.nextInt();
        int[][] grid = new int[N][N];
        
        // Заповнення сітки
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                grid[i][j] = sc.nextInt();
            }
        }
        
        int count = 0;
        
        // Перевірка квадратів розміру 2x2
        for (int i = 0; i < N - 1; i++) {  // Верхній лівий кут квадрата по i
            for (int j = 0; j < N - 1; j++) {  // Верхній лівий кут квадрата по j
                // Вершини квадрата 2x2
                if (grid[i][j] == grid[i+1][j] && 
                    grid[i][j] == grid[i][j+1] && 
                    grid[i][j] == grid[i+1][j+1]) {
                    count++;
                }
            }
        }
        
        // Виведення результату
        System.out.println(count);
    }
}
