import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int N = sc.nextInt();
        int[][] grid = new int[N][N];

        // Читання вхідних даних
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                grid[i][j] = sc.nextInt();
            }
        }

        int count = 0;

        // Перевіряємо квадрати всіх можливих розмірів
        for (int size = 1; size < N; size++) {  // Розмір квадрата
            for (int i = 0; i + size < N; i++) {  // Верхній лівий кут по осі X
                for (int j = 0; j + size < N; j++) {  // Верхній лівий кут по осі Y
                    // Перевірка квадрату з 4-ма вершинами
                    if (grid[i][j] == grid[i + size][j] &&
                        grid[i][j] == grid[i][j + size] &&
                        grid[i][j] == grid[i + size][j + size]) {
                        count++;
                    }
                }
            }
        }

        // Виводимо кількість квадратів
        System.out.println(count);
    }
}
