import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int N = sc.nextInt();
        
        // Створюємо матрицю для збереження кольорів
        int[][] grid = new int[N][N];
        
        // Зчитуємо кольори точок
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                grid[i][j] = sc.nextInt();
            }
        }
        
        int count = 0;

        // Перебираємо квадрати розміром від 2x2 до NxN
        for (int size = 1; size < N; size++) { // Розмір квадрата від 2 до N
            for (int i = 0; i + size < N; i++) { // Початкова точка по рядках
                for (int j = 0; j + size < N; j++) { // Початкова точка по стовпцях
                    int color = grid[i][j];
                    // Перевіряємо чотири вершини квадрата
                    if (grid[i + size][j] == color && grid[i][j + size] == color && grid[i + size][j + size] == color) {
                        count++;
                    }
                }
            }
        }
        
        System.out.println(count);
    }
}
