import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        long N = sc.nextLong();
        long target = N - 1;

        long minT = Long.MAX_VALUE;
        boolean found = false;

        // Перебираем все возможные значения y
        for (long y = 0; 5 * y <= target; y++) {
            long remainder = target - 5 * y;

            if (remainder % 3 == 0) {
                long x = remainder / 3;
                if (x >= 0) {
                    long t = x + y;
                    minT = Math.min(minT, t);
                    found = true;
                }
            }
        }

        if (found) {
            System.out.println(minT);
        } else {
            System.out.println(-1);
        }
    }
}
