import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        Map<Integer, Integer> frequency = new HashMap<>();
        
        // Чтение чисел и подсчет их частоты
        for (int i = 0; i < n; i++) {
            int num = scanner.nextInt();
            frequency.put(num, frequency.getOrDefault(num, 0) + 1);
        }
        
        // Поиск минимального уникального числа
        int minUnique = Integer.MAX_VALUE;
        for (Map.Entry<Integer, Integer> entry : frequency.entrySet()) {
            if (entry.getValue() == 1 && entry.getKey() < minUnique) {
                minUnique = entry.getKey();
            }
        }
        
        // Вывод результата
        System.out.println(minUnique == Integer.MAX_VALUE ? -1 : minUnique);
    }
}
