import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        int[][] grid = new int[n][n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                grid[i][j] = scanner.nextInt();
            }
        }
        int count = 0;
        for (int size = 1; size <= n; size++) {
            for (int i = 0; i <= n - size; i++) {
                for (int j = 0; j <= n - size; j++) {
                    int topLeft = grid[i][j];
                    int topRight = grid[i][j + size - 1];
                    int bottomLeft = grid[i + size - 1][j];
                    int bottomRight = grid[i + size - 1][j + size - 1];
                    if (topLeft == topRight && topRight == bottomLeft && bottomLeft == bottomRight) {
                        count++;
                    }
                }
            }
        }
        System.out.println(count);
    }
}
