import java.util.*;

public class Main {
  static class Point {
    int x, y, index;
    
    Point(int x, int y, int index) {
      this.x = x;
      this.y = y;
      this.index = index;
    }
  }
  
  public static void main(String[] args) {
    Scanner sc = new Scanner(System.in);
    int t = sc.nextInt(); 
    StringBuilder result = new StringBuilder();
    
    for (int test = 0; test < t; test++) {
      int n = sc.nextInt();
      List<Point> blue = new ArrayList<>();
      List<Point> red = new ArrayList<>();
      
      for (int i = 0; i < n; i++) {
        int x = sc.nextInt();
        int y = sc.nextInt();
        blue.add(new Point(x, y, i + 1));
      }
      
      for (int i = 0; i < n; i++) {
        int x = sc.nextInt();
        int y = sc.nextInt();
        red.add(new Point(x, y, i + 1));
      }
      
      blue.sort(Comparator.comparingInt(p -> p.x));
      red.sort(Comparator.comparingInt(p -> p.x));
      
      for (int i = 0; i < n; i++) {
        result.append(blue.get(i).index).append(" ").append(red.get(i).index).append("\n");
      }
    }
    
    System.out.print(result);
  }
}
