from collections import deque

def find_meeting_time(N):
    if N == 1:
        return 0
    

    alice_queue = deque([(1, 0)])  
    bob_queue = deque([(N, 0)])    
    

    alice_visited = {1}
    bob_visited = {N}
    
    while alice_queue and bob_queue:

        alice_pos, alice_time = alice_queue.popleft()
        if alice_pos + 2 <= N and (alice_pos + 2) not in alice_visited:
            alice_visited.add(alice_pos + 2)
            alice_queue.append((alice_pos + 2, alice_time + 1))
        if alice_pos + 3 <= N and (alice_pos + 3) not in alice_visited:
            alice_visited.add(alice_pos + 3)
            alice_queue.append((alice_pos + 3, alice_time + 1))


        bob_pos, bob_time = bob_queue.popleft()
        if bob_pos - 1 >= 1 and (bob_pos - 1) not in bob_visited:
            bob_visited.add(bob_pos - 1)
            bob_queue.append((bob_pos - 1, bob_time + 1))
        if bob_pos - 2 >= 1 and (bob_pos - 2) not in bob_visited:
            bob_visited.add(bob_pos - 2)
            bob_queue.append((bob_pos - 2, bob_time + 1))


        if alice_visited & bob_visited:
            return alice_time + 1
    
    return -1

bob = int(input())
print(find_meeting_time(bob))