def find_meeting_time(n):

    alice_positions = {1}  
    bob_positions = {n}    
    
    seconds = 0
    
    while alice_positions and bob_positions:

        if alice_positions & bob_positions:
            return seconds

        alice_next_positions = set()
        for pos in alice_positions:
            if pos + 2 <= n:
                alice_next_positions.add(pos + 2)
            if pos + 3 <= n:
                alice_next_positions.add(pos + 3)
        
        bob_next_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                bob_next_positions.add(pos - 1)
            if pos - 2 >= 1:
                bob_next_positions.add(pos - 2)
        
        alice_positions = alice_next_positions
        bob_positions = bob_next_positions
        seconds += 1
    

    return -1



n = int(input())
print(find_meeting_time(n))
