#include <iostream>
#include <queue>
#include <unordered_set>
using namespace std;

bool canMeet(int N) {
    return (N - 1) % 2 == 0;
}

int minTimeToMeet(int N) {
    if (!canMeet(N)) return -1;

    int alice = 1, bob = N;
    int time = 0;

    while (alice < bob) {
        alice += (time % 2 == 0) ? 3 : 2;
        bob -= (time % 2 == 0) ? 1 : 2;
        time++;
    }

    return (alice == bob) ? time : -1;
}

int main() {
    int N;
    cin >> N;

    cout << minTimeToMeet(N) << endl;
    return 0;
}