def find_min_stamps(N, M):
    # Список для збереження номерів марок
    stamps = []
    
    # Починаємо з найбільшої марки, яку можемо вибрати
    for i in range(N, 0, -1):
        if M >= i:
            stamps.append(i)  # Додаємо марку до списку
            M -= i  # Зменшуємо суму, яку треба ще знайти
        if M == 0:
            break
    
    # Якщо M == 0, значить ми знайшли рішення, і кількість марок мінімальна
    if M == 0:
        return len(stamps), stamps
    else:
        return -1, []

# Читання вхідних даних
N = int(input())  # Кількість марок
M = int(input())  # Сума, яку Боб хоче витратити

# Викликаємо функцію для знаходження мінімальних марок
num_stamps, stamps = find_min_stamps(N, M)

# Виведення результату
if num_stamps == -1:
    print(-1)
else:
    print(num_stamps)
    print(" ".join(map(str, stamps)))