def find_min_stamps(N, M):
    stamps = []  # Список для зберігання вибраних марок
    for i in range(N, 0, -1):  # Починаємо з найбільших марок
        if M >= i:
            stamps.append(i)  # Додаємо марку в список
            M -= i  # Віднімаємо її вартість від M
        if M == 0:  # Якщо сума стала рівною нулю, зупиняємося
            break
    
    if M == 0:
        return len(stamps), stamps  # Повертаємо кількість марок та самі марки
    else:
        return -1, []  # Якщо сума не дорівнює нулю, неможливо отримати таку суму

# Читання вхідних даних
N = int(input())  # Кількість марок
M = int(input())  # Сума, яку Боб хоче витратити

# Викликаємо функцію для знаходження мінімальних марок
num_stamps, stamps = find_min_stamps(N, M)

# Виведення результату
if num_stamps == -1:
    print(-1)  # Якщо не можна отримати точну суму, виводимо -1
else:
    print(num_stamps)  # Виводимо кількість марок
    print(" ".join(map(str, stamps))) 
