N = int(input())  # розмір сторони квадрата
matrix = [list(map(int, input().split())) for _ in range(N)]

# Лічильник кількості квадратів з однаковими кольорами на всіх чотирьох вершинах
count = 0

# Перевіряємо всі можливі квадрати
for i in range(N):
    for j in range(N):
        # Перевіряємо квадрати різних розмірів, що починаються з (i, j)
        for size in range(1, min(N - i, N - j)):
            # Перевіряємо чи всі 4 кути квадрата однакові
            if (matrix[i][j] == matrix[i+size][j] == matrix[i][j+size] == matrix[i+size][j+size]):
                count += 1

# Виведення результату
print(count)