def count_same_color_squares(matrix):
    n = len(matrix)
    count = 0

    for size in range(2, n + 1):
        for i in range(n - size + 1):
            for j in range(n - size + 1):
                color = matrix[i][j]
                is_same_color = True
                for x in range(i, i + size):
                    for y in range(j, j + size):
                        if matrix[x][y] != color:
                            is_same_color = False
                            break
                    if not is_same_color:
                        break
                if is_same_color:
                    count += 1

    return count

# Зчитування вхідних даних
n = int(input())
matrix = []
for _ in range(n):
    row = list(map(int, input().split()))
    matrix.append(row)

# Виклик функції та виведення результату
result = count_same_color_squares(matrix)
print(result)