def count_squares(N, grid):
    count = 0
    # Перевіряємо всі можливі квадрати від розміру 2x2 до NxN
    for size in range(2, N+1):  # Розміри квадратів
        for i in range(N - size + 1):  # Початкова точка по рядку
            for j in range(N - size + 1):  # Початкова точка по стовпцю
                # Перевіряємо чотири вершини квадрата
                color = grid[i][j]
                all_same = True
                for x in range(size):
                    for y in range(size):
                        if grid[i+x][j+y] != color:
                            all_same = False
                            break
                    if not all_same:
                        break
                if all_same:
                    count += 1
    return count

# Вхідні дані
N = int(input())  # Читаємо розмір матриці
grid = [list(map(int, input().split())) for _ in range(N)]  # Читаємо саму матрицю

# Виводимо результат
print(count_squares(N, grid))