def count_squares(N, grid):
    square_count = 0

    # Check all possible side lengths for squares
    for side in range(1, N):
        for i in range(N - side):
            for j in range(N - side):
                # Check if the four corners of a square of side length 'side' are the same color
                # Corners of the square are: (i, j), (i+side, j), (i, j+side), (i+side, j+side)
                color = grid[i][j]
                if (grid[i + side][j] == color and
                    grid[i][j + side] == color and
                    grid[i + side][j + side] == color):
                    square_count += 1

    return square_count