def count_colored_squares(N, matrix):
    count = 0
    

    for x1 in range(N-1): 
        for y1 in range(N-1): 
            for size in range(1, N - max(x1, y1)): 
                x2, y2 = x1 + size, y1 
                x3, y3 = x1, y1 + size  
                x4, y4 = x1 + size, y1 + size  


                colors = [
                    matrix[y1][x1],
                    matrix[y1][x2],
                    matrix[y3][x1],
                    matrix[y4][x4]
                ]
                if all(c == colors[0] for c in colors):  
                    count += 1
    return count


N = int(input()) 
matrix = [list(map(int, input().split())) for _ in range(N)] 


print(count_colored_squares(N, matrix))