def solve_test_case(N, blue_points, red_points):
    # Сортуємо сині та червоні точки за координатами (спочатку по x, потім по y)
    blue_sorted = sorted([(x, y, i + 1) for i, (x, y) in enumerate(blue_points)], key=lambda p: (p[0], p[1]))
    red_sorted = sorted([(x, y, i + 1) for i, (x, y) in enumerate(red_points)], key=lambda p: (p[0], p[1]))

    # Виводимо пари індексів
    result = []
    for i in range(N):
        result.append(f"{blue_sorted[i][2]} {red_sorted[i][2]}")
    
    return "\n".join(result)

def solve():
    t = int(input())  # кількість тестових випадків
    results = []

    for _ in range(t):
        N = int(input())  # кількість точок одного кольору
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().split())) for _ in range(N)]
        
        # Для кожного тесту вирішуємо задачу
        result = solve_test_case(N, blue_points, red_points)
        results.append(result)
    
    # Виводимо всі результати
    print("\n\n".join(results))

# Читаємо вхідні дані та виконуємо програму
solve()