#include <stdio.h>
#include <stdlib.h>

typedef struct {
    int x, y, index;
} Point;

int compareBlue(const void *a, const void *b) {
    Point *point1 = (Point *)a;
    Point *point2 = (Point *)b;
    if (point1->x == point2->x) {
        return point1->y - point2->y;
    }
    return point1->x - point2->x;
}

int compareRed(const void *a, const void *b) {
    Point *point1 = (Point *)a;
    Point *point2 = (Point *)b;
    if (point1->x == point2->x) {
        return point1->y - point2->y;
    }
    return point1->x - point2->x;
}

int main() {
    int t;
    scanf("%d", &t);
    
    while (t--) {
        int N;
        scanf("%d", &N);

        Point blue[N], red[N];

        // Зчитуємо сині точки
        for (int i = 0; i < N; i++) {
            scanf("%d %d", &blue[i].x, &blue[i].y);
            blue[i].index = i + 1;
        }

        // Зчитуємо червоні точки
        for (int i = 0; i < N; i++) {
            scanf("%d %d", &red[i].x, &red[i].y);
            red[i].index = i + 1;
        }

        // Сортуємо сині й червоні точки
        qsort(blue, N, sizeof(Point), compareBlue);
        qsort(red, N, sizeof(Point), compareRed);

        // Виводимо відповіді, з'єднуючи точки
        for (int i = 0; i < N; i++) {
            printf("%d %d\n", blue[i].index, red[i].index);
        }
    }
    return 0;
}
