#include <stdio.h>
#include <stdlib.h>

typedef struct {
    int x, y, index;
} Point;

int compare_x(const void *a, const void *b) {
    Point *pa = (Point*)a;
    Point *pb = (Point*)b;
    if (pa->x == pb->x) return pa->y - pb->y;
    return pa->x - pb->x;
}

int main() {
    int t;
    scanf("%d", &t);
    
    while (t--) {
        int N;
        scanf("%d", &N);
        
        Point blue[N], red[N];
        
        // Читання синіх точок
        for (int i = 0; i < N; i++) {
            scanf("%d %d", &blue[i].x, &blue[i].y);
            blue[i].index = i + 1;
        }
        
        // Читання червоних точок
        for (int i = 0; i < N; i++) {
            scanf("%d %d", &red[i].x, &red[i].y);
            red[i].index = i + 1;
        }
        
        // Сортуємо точки
        qsort(blue, N, sizeof(Point), compare_x);
        qsort(red, N, sizeof(Point), compare_x);
        
        // Виведення відповідей
        for (int i = 0; i < N; i++) {
            printf("%d %d\n", blue[i].index, red[i].index);
        }
    }
    
    return 0;
}