def find_coins(n, m):
    max_m = m + 1
    dp = [float('inf')] * max_m
    last_coin_index = [-1] * max_m
    dp[0] = 0
    
    coins = list(range(1, n + 1))
    
    for i in range(1, m + 1):
        for index, coin in enumerate(coins):
            if i >= coin and dp[i - coin] + 1 < dp[i]:
                dp[i] = dp[i - coin] + 1
                last_coin_index[i] = index
    
    if dp[m] == float('inf'):
        return -1
    
    result_indices = []
    current_amount = m
    while current_amount > 0:
        coin_index = last_coin_index[current_amount]
        if coin_index == -1:
            return -1
        result_indices.append(coin_index)
        current_amount -= coins[coin_index]
    
    return result_indices

n = int(input())
m = int(input())
for c in find_coins(n, m):
    print(c+1)