from collections import Counter

_n = int(input())
xs = list(map(int, input().split()))
freqs = Counter(xs)

def non_unique(freqs):
    return all(f >= 2 for f in freqs.values())

def rarest(xs, freqs):
    min_freq = min(freqs.values())
    rare_numbers = [num for num, freq in freqs.items() if freq == min_freq]
    last_occurrence = {num: idx for idx, num in enumerate(xs, start=1) if num in rare_numbers}
    rarest_num = max(last_occurrence.items(), key=lambda x: x[1])[0]
    return rarest_num

if not non_unique(freqs):
    print(rarest(xs, freqs))
else:
    print(-1)