#include <bits/stdc++.h>
using namespace std;

int main() {
    long long N;
    cin >> N;
    
    if (N <= 2) {
        cout << -1 << endl;
        return 0;
    }

    unordered_set<long long> alice_positions, bob_positions;
    queue<pair<long long, int>> alice_queue, bob_queue;
    
    alice_queue.push({1, 0}); 
    bob_queue.push({N, 0});
    
    alice_positions.insert(1);
    bob_positions.insert(N);
    
    while (!alice_queue.empty() || !bob_queue.empty()) {
        if (!alice_queue.empty()) {
            long long alice_pos = alice_queue.front().first;
            int alice_time = alice_queue.front().second;
            alice_queue.pop();
            
            if (bob_positions.count(alice_pos)) {
                cout << alice_time << endl;
                return 0;
            }

            if (alice_pos + 2 <= N && !alice_positions.count(alice_pos + 2)) {
                alice_queue.push({alice_pos + 2, alice_time + 1});
                alice_positions.insert(alice_pos + 2);
            }
            if (alice_pos + 3 <= N && !alice_positions.count(alice_pos + 3)) {
                alice_queue.push({alice_pos + 3, alice_time + 1});
                alice_positions.insert(alice_pos + 3);
            }
        }

        if (!bob_queue.empty()) {
            long long bob_pos = bob_queue.front().first;
            int bob_time = bob_queue.front().second;
            bob_queue.pop();
            
            if (alice_positions.count(bob_pos)) {
                cout << bob_time << endl;
                return 0;
            }
            
            if (bob_pos - 1 >= 1 && !bob_positions.count(bob_pos - 1)) {
                bob_queue.push({bob_pos - 1, bob_time + 1});
                bob_positions.insert(bob_pos - 1);
            }
            if (bob_pos - 2 >= 1 && !bob_positions.count(bob_pos - 2)) {
                bob_queue.push({bob_pos - 2, bob_time + 1});
                bob_positions.insert(bob_pos - 2);
            }
        }
    }

    cout << -1 << endl;
    return 0;
}
