using System;
using System.Linq;

class Program
{
    static void Main()
    {
        int t = int.Parse(Console.ReadLine());

        while (t-- > 0)
        {
            int N = int.Parse(Console.ReadLine());
            
            var bluePoints = new (int x, int y, int idx)[N];
            var redPoints = new (int x, int y, int idx)[N];
            
            for (int i = 0; i < N; i++)
            {
                var coords = Console.ReadLine().Split();
                bluePoints[i] = (int.Parse(coords[0]), int.Parse(coords[1]), i + 1);
            }

            for (int i = 0; i < N; i++)
            {
                var coords = Console.ReadLine().Split();
                redPoints[i] = (int.Parse(coords[0]), int.Parse(coords[1]), i + 1);
            }

            var sortedBlue = bluePoints.OrderBy(p => p.x).ThenBy(p => p.y).ToArray();
            var sortedRed = redPoints.OrderBy(p => p.x).ThenBy(p => p.y).ToArray();
            
            for (int i = 0; i < N; i++)
            {
                Console.WriteLine($"{sortedBlue[i].idx} {sortedRed[i].idx}");
            }
        }
    }
}
