from collections import deque

N = int(input())
apos = 1
bpos = N
sec = 0

queue = deque([(apos, bpos, sec)])
visited = set()

visited.add((apos, bpos))

while queue:
    apos, bpos, sec = queue.popleft()

    if apos == bpos:
        print(sec)
        break

    for next_apos in [apos + 2, apos + 3]:
        if 1 <= next_apos <= N:
            for next_bpos in [bpos - 1, bpos - 2]:
                if 1 <= next_bpos <= N:
                    if (next_apos, next_bpos) not in visited:
                        visited.add((next_apos, next_bpos))
                        queue.append((next_apos, next_bpos, sec + 1))

else:
    print(-1)
