def find_minimum_stamps(n, m):
    s = n * (n + 1) // 2
    if s < n:
        return [0]
    
    def sum_k(k):
        return k * n - (k * (k - 1)) // 2
    
    left, right = 1, min(n, 2 * 10**9)
    k = -1
    while left <= right:
        mid = left + (right - left) // 2
        csum = sum_k(mid)
        if csum >= m:
            k = mid
            right = mid - 1
        else:
            left = mid + 1
    
    if k == -1:
        return [0]
    
    res = []
    rem = n
    curk = k
    for i in range(N, 0, -1):
        if i <= rem and curk > 0:
            res.append(i)
            rem -= i
            curk -= 1
            if rem == 0:
                break
    
    if rem != 0:
        return [0]

    return res

import sys
input = sys.stdin.read
data = input().split()
n = int(data[0])
m = int(data[1])
marks = find_minimum_stamps(n, m)
for i in marks:
    print(i)
