def connect_points(t, test_cases):
    results = []
    
    for i in range(t):
        n = test_cases[i]['N']
        blue_points = test_cases[i]['blue']
        red_points = test_cases[i]['red']
        
        if len(blue_points) != len(red_points) or len(blue_points) != n:
            results.append("0")
            continue
        
        connections = []
        
        for j in range(n):
            connections.append(f"{j + 1} {n - j}")
        
        results.append(connections)
    
    return results

t = int(input())
test_cases = []

for f in range(t):
    n = int(input())
    blue_points = [tuple(map(int, input().split())) for _ in range(n)]
    red_points = [tuple(map(int, input().split())) for _ in range(n)]
    
    test_cases.append({
        'N': n,
        'blue': blue_points,
        'red': red_points,
    })

results = connect_points(t, test_cases)

for result in results:
    for connection in result:
        print(connection)
