def connect_points(t, test_cases):
    results = []

    for i in range(t):
        n = test_cases[i]['N']
        blue_points = test_cases[i]['blue']
        red_points = test_cases[i]['red']

        if len(blue_points) != n or len(red_points) != n:
            results.append("0")
            continue

        blue_points_sorted = sorted(enumerate(blue_points, start=1), key=lambda x: x[1])
        red_points_sorted = sorted(enumerate(red_points, start=1), key=lambda x: x[1])

        connections = []
        for j in range(n):
            blue_index = blue_points_sorted[j][0]
            red_index = red_points_sorted[j][0]
            connections.append(f"{blue_index} {red_index}")

        results.append(connections)

    return results

t = int(input())
test_cases = []

for h in range(t):
    n = int(input())
    blue_points = []
    red_points = []

    for e in range(n):
        blue_points.append(tuple(map(int, input().split())))
    for e in range(n):
        red_points.append(tuple(map(int, input().split())))

    test_cases.append({
        'N': n,
        'blue': blue_points,
        'red': red_points,
    })

results = connect_points(t, test_cases)

for result in results:
    for connection in result:
        print(connection)
