def minimum_meeting_time(N):
    # Початкові позиції
    alice_positions = {1}  # множина позицій, досяжних Алісою
    bob_positions = {N}    # множина позицій, досяжних Бобом
    t = 0

    while alice_positions and bob_positions:  # поки є можливість телепортуватись
        if alice_positions & bob_positions:  # перевіряємо перетин множин
            return t
        # Оновлення множин позицій
        alice_positions = {x + 2 for x in alice_positions if x + 2 <= N} | \
                          {x + 3 for x in alice_positions if x + 3 <= N}
        bob_positions = {x - 1 for x in bob_positions if x - 1 >= 1} | \
                        {x - 2 for x in bob_positions if x - 2 >= 1}
        t += 1

    return -1  # Якщо не знайдено спільної позиції

# Приклад виклику функції
print(minimum_meeting_time(5))  # 1
print(minimum_meeting_time(9))  # 2
