from collections import deque

def minimum_seconds(N):
    if N == 2:
        return 1

    
    alice_queue = deque([1]) 
    bob_queue = deque([N])   

    alice_visited = set([1])
    bob_visited = set([N])

   
    time = 0


    while alice_queue and bob_queue:
        time += 1

       
        for _ in range(len(alice_queue)):
            current = alice_queue.popleft()
            for next_pos in [current + 2, current + 3]:
                if 1 <= next_pos <= N and next_pos not in alice_visited:
                    alice_visited.add(next_pos)
                    alice_queue.append(next_pos)

      
        for _ in range(len(bob_queue)):
            current = bob_queue.popleft()
            for next_pos in [current - 1, current - 2]:
                if 1 <= next_pos <= N and next_pos not in bob_visited:
                    bob_visited.add(next_pos)
                    bob_queue.append(next_pos)

        
        if alice_visited & bob_visited:
            return time

    return -1


N = int(input())
result = minimum_seconds(N)
print(result)
