from itertools import combinations

def find_elements_sum(M, n):
    numbers = list(range(1, n + 1))  # Створюємо список чисел від 1 до n
    for r in range(1, len(numbers) + 1):  # Перебираємо усі можливі розміри підмножин
        for comb in combinations(numbers, r):  # Генеруємо всі комбінації для поточного розміру
            if sum(comb) == M:  # Якщо сума комбінації дорівнює M
                return list(comb)  # Повертаємо перший знайдений варіант
    return []

N = int(input())
M = int(input())
result = find_elements_sum(M, N)
print(*result)
