def find_elements_sum(M, n):
    numbers = list(range(1, n + 1))
    dp = {0: []}  # Словник, який зберігає шлях до кожної суми
    for num in numbers:
        # Додаємо число до всіх можливих сум
        new_sums = {}
        for current_sum, path in dp.items():
            new_sum = current_sum + num
            if new_sum <= M and new_sum not in dp:
                new_sums[new_sum] = path + [num]
        
        # Оновлюємо словник dp з новими сумами
        dp.update(new_sums)

    # Повертаємо шлях до суми M, якщо він існує
    return dp.get(M, [])

N = int(input())
M = int(input())
result = find_elements_sum(M, N)
print(*result)
