def solve(t, test_cases):
    results = []
    
    for case in test_cases:
        N, blue_points, red_points = case
        # Сортуємо сині і червоні точки за x, а потім за y
        blue_points_sorted = sorted(blue_points, key=lambda p: (p[0], p[1]))
        red_points_sorted = sorted(red_points, key=lambda p: (p[0], p[1]))
        
        # Створюємо список пар індексів для з'єднання
        result = []
        for i in range(N):
            # Знаходимо оригінальні індекси після сортування
            blue_idx = blue_points.index(blue_points_sorted[i]) + 1
            red_idx = red_points.index(red_points_sorted[i]) + 1
            result.append((blue_idx, red_idx))
        
        results.append(result)
    
    # Виводимо всі результати
    for result in results:
        for pair in result:
            print(pair[0], pair[1])

# Читання вхідних даних
t = int(input())  # кількість тестових блоків
test_cases = []

for _ in range(t):
    N = int(input())  # кількість точок одного кольору
    blue_points = [tuple(map(int, input().split())) for _ in range(N)]
    red_points = [tuple(map(int, input().split())) for _ in range(N)]
    test_cases.append((N, blue_points, red_points))

# Викликаємо функцію для вирішення задачі
solve(t, test_cases)
