#include <bits/stdc++.h>
using namespace std;

int t, n;
array <array <int, 2>, 2500> red;
array <array <int, 3>, 2500> blue;
array <array <int, 4>, 2500> pairs;

array <int, 2500> ans;

bool intersect(int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4) {
    if (x1 == x2 || x3 == x4) {
        swap(x1, y1);
        swap(x2, y2);
        swap(x3, y3);
        swap(x4, y4);
    }

    if (x1 == x2 || x3 == x4) {
        if (rand() % 2 == 0) return false;
        else return true;
        // coinflip - too complex to write custom scenario for this.
    }

    double a1 = (y1 - y2) / (x1 - x2);
    double a2 = (y3 - y4) / (x3 - x4);

    double b1 = y1 - a1 * x1;
    double b2 = y3 - a2 * x3;

    double x = (b2 - b1) / (a1 - a2);
    double y = a1 * x + b1;

    if (min(x1, x2) <= x && x <= max(x1, x2) && min(y1, y2) <= y && y <= max(y1, y2)) return true;
    if (min(x3, x4) <= x && x <= max(x3, x4) && min(y3, y4) <= y && y <= max(y3, y4)) return true;
    return false;
}

bool f(int red_idx, array <array <int, 3>, 2500> blue, array <array <int, 4>, 2500> pairs) {
    if (red_idx == n) return true;
    for (int i = 0; i < n; i++) {
        if (blue[i][2] == 0) {
            blue[i][2] = 1;

            for (int p = 0; p < red_idx; p++) {
                if (!intersect(red[red_idx][0], red[red_idx][1], blue[i][0], blue[i][1], pairs[p][0], pairs[p][1], pairs[p][2], pairs[p][3])) {
                    pairs[red_idx][0] = red[red_idx][0];
                    pairs[red_idx][1] = red[red_idx][1];
                    pairs[red_idx][2] = blue[i][0];
                    pairs[red_idx][3] = blue[i][1];

                    ans[red_idx] = i;

                    if (f(red_idx + 1, blue, pairs)) return true;
                }
            }
            if (red_idx == 0) {
                pairs[red_idx][0] = red[red_idx][0];
                pairs[red_idx][1] = red[red_idx][1];
                pairs[red_idx][2] = blue[i][0];
                pairs[red_idx][3] = blue[i][1];

                if (f(red_idx + 1, blue, pairs)) return true;
            }
            
            blue[i][2] = 0;
        }
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int x, y;

    cin >> t;

    while (t--) {
        cin >> n;

        for (int i = 0; i < n; i++) {
            cin >> x >> y;
            red[i][0] = x;
            red[i][1] = y;
        }
        
        for (int i = 0; i < n; i++) {
            cin >> x >> y;
            blue[i][0] = x;
            blue[i][1] = y;
            blue[i][2] = 0;
        }

        if (f(0, blue, pairs)) {
            for (int i = 0; i < n; i++) {
                cout << i + 1 << " " << ans[i] + 1 << "\n";
            }
        } else cout << 0 << "\n";
    }
    
    return 0;
}
