import numpy as np

def count_square_colors(N, grid):
    count = 0
    # Перетворюємо grid в NumPy масив
    grid = np.array(grid)
    
    # Перевіряємо всі квадрати 2x2
    for i in range(N - 1):
        for j in range(N - 1):
            # Перевіряємо чи всі чотири точки квадрата мають однаковий колір
            if grid[i][j] == grid[i+1][j] == grid[i][j+1] == grid[i+1][j+1]:
                count += 1
    
    return count

# Вхідні дані
N = int(input())  # Розмір сторони квадрата
grid = [list(map(int, input().split())) for _ in range(N)]

# Виведення результату
print(count_square_colors(N, grid))
