def minimum_time_to_meet(N):
    # Поточні позиції Аліси та Боба
    alice_positions = set([1])
    bob_positions = set([N])
    
    # Час t
    t = 0
    
    # Поки існують позиції для обох
    while t < N:
        t += 1
        # Оновлюємо позиції Аліси
        new_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= N:
                new_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                new_alice_positions.add(pos + 3)
        
        # Оновлюємо позиції Боба
        new_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                new_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_positions.add(pos - 2)
        
        # Перевіряємо перетин
        if new_alice_positions & new_bob_positions:
            return t
        
        # Оновлюємо множини
        alice_positions = new_alice_positions
        bob_positions = new_bob_positions
    
    # Якщо Аліса і Боб не можуть зустрітися
    return -1

# Зчитування вхідних даних
N = int(input())
print(minimum_time_to_meet(N))
