# Вхідні дані
N = int(input())  # Кількість марок
M = int(input())  # Необхідна сума

# Загальна сума всіх марок від 1 до N
total_sum = N * (N + 1) // 2

# Якщо загальна сума менша за M, виводимо 0
if total_sum < M:
    print(0)
else:
    # Створюємо список для вибраних марок
    chosen_marks = []
    current_sum = 0
    
    # Перевіряємо від найбільших марок
    for i in range(N, 0, -1):
        if current_sum + i <= M:
            chosen_marks.append(i)
            current_sum += i
        if current_sum == M:
            break
    
    # Якщо ми змогли досягти точної суми M
    if current_sum == M:
        for mark in chosen_marks:
            print(mark)
    else:
        print(0)
