def count_squares(N, grid):
    count = 0
    # Перебираємо всі можливі розміри квадратів
    for size in range(1, N):
        # Перебираємо всі можливі координати верхнього лівого кута квадрата
        for i in range(N - size):
            for j in range(N - size):
                # Перевіряємо чи всі чотири вершини мають однаковий колір
                color = grid[i][j]
                if grid[i][j] == grid[i + size][j] == grid[i][j + size] == grid[i + size][j + size]:
                    count += 1
    return count

# Вхідні дані
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Виводимо результат
print(count_squares(N, grid))
