def count_same_color_squares(N: int, grid: list[list[int]]) -> int:
    count = 0
    # Перебираємо всі можливі квадрати
    for i in range(N):
        for j in range(N):
            # Довжина сторони квадрата (k + 1)
            for k in range(1, N - max(i, j)):
                # Координати вершин квадрата
                top_left = grid[i][j]
                top_right = grid[i][j + k]
                bottom_left = grid[i + k][j]
                bottom_right = grid[i + k][j + k]
                # Перевірка, чи всі вершини одного кольору
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1
    return count


# Читання вхідних даних
N = int(input("Введіть розмір квадрата (N): "))
print("Введіть матрицю кольорів:")
grid = [list(map(int, input().split())) for _ in range(N)]

# Обчислення та вивід результату
result = count_same_color_squares(N, grid)
print("Кількість квадратів одного кольору:", result)
