def count_same_color_squares(N, grid):
    count = 0
    # Перебираємо всі можливі квадрати
    for i in range(N):
        for j in range(N):
            for k in range(1, N - max(i, j)):
                # Отримуємо координати вершин квадрата
                top_left = grid[i][j]
                top_right = grid[i][j + k]
                bottom_left = grid[i + k][j]
                bottom_right = grid[i + k][j + k]
                # Перевіряємо, чи однакові кольори
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1
    return count

# Введення даних
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Обчислення та вивід результату
result = count_same_color_squares(N, grid)
print(result)
