def solve_case(N, blue_points, red_points):
    # Сортуємо обидва набори точок: спочатку за x, а потім за y
    blue_points_sorted = sorted((x, y, i + 1) for i, (x, y) in enumerate(blue_points))
    red_points_sorted = sorted((x, y, i + 1) for i, (x, y) in enumerate(red_points))
    
    # Після сортування будемо з'єднувати по порядку
    result = []
    for i in range(N):
        blue_idx = blue_points_sorted[i][2]
        red_idx = red_points_sorted[i][2]
        result.append(f"{blue_idx} {red_idx}")
    
    return result

def main():
    t = int(input())  # Кількість блоків тестових даних
    for _ in range(t):
        N = int(input())  # Кількість точок одного кольору
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().split())) for _ in range(N)]
        
        # Розв'язок для кожного тесту
        result = solve_case(N, blue_points, red_points)
        
        # Виведення результату
        if result:
            print("\n".join(result))
        else:
            print(0)

# Викликаємо основну функцію
if __name__ == "__main__":
    main()
