def solve_case(N, blue_points, red_points):
    # Сортуємо обидва набори точок за координатами
    blue_points_sorted = sorted(blue_points)
    red_points_sorted = sorted(red_points)
    
    # Виводимо пари для кожного з'єднання синіх та червоних точок
    result = []
    for i in range(N):
        # Додаємо в результат пару номерів точок
        result.append(f"{blue_points_sorted[i][2]} {red_points_sorted[i][2]}")
    
    return result

def main():
    t = int(input())  # Кількість тестових блоків
    for _ in range(t):
        N = int(input())  # Кількість точок одного кольору
        blue_points = [tuple(map(int, input().split())) + (i + 1,) for i in range(N)]
        red_points = [tuple(map(int, input().split())) + (i + 1,) for i in range(N)]
        
        # Отримуємо результат для кожного тесту
        result = solve_case(N, blue_points, red_points)
        
        # Виводимо результат
        if result:
            print("\n".join(result))
        else:
            print(0)

# Викликаємо основну функцію
if __name__ == "__main__":
    main()
