from collections import deque

def minimum_seconds_to_meet(N):
    alice = deque([1])  
    bob = deque([N])  
    visited_alice = set([1])  
    visited_bob = set([N])  
    seconds = 0
    
    while alice and bob:
        seconds += 1
        
        for _ in range(len(alice)):
            position = alice.popleft()
            for move in [2, 3]:
                next_position = position + move
                if next_position in visited_bob:
                    return seconds
                if next_position <= N and next_position not in visited_alice:
                    visited_alice.add(next_position)
                    alice.append(next_position)
        
        for _ in range(len(bob)):
            position = bob.popleft()
            for move in [1, 2]:
                next_position = position - move
                if next_position in visited_alice:
                    return seconds
                if next_position >= 1 and next_position not in visited_bob:
                    visited_bob.add(next_position)
                    bob.append(next_position)
    
    return -1

N = int(input())

print(minimum_seconds_to_meet(N))
