#include <iostream>
#include <queue>
#include <unordered_set>
using namespace std;

long long check(long long n) {
  unordered_set<long long> a, b;

  a.insert(1);
  b.insert(n);

  for (long long s = 1; s <= n; ++s) {
    unordered_set<long long> na, nb;

    for (long long i : a) {
      if (i + 2 <= n)
        na.insert(i + 2);
      if (i + 3 <= n)
        na.insert(i + 3);
    }

    for (long long i : b) {
      if (i - 1 >= 1)
        nb.insert(i - 1);
      if (i - 2 >= 1)
        nb.insert(i - 2);
    }

    for (long long i : na) {
      if (nb.count(i))
        return s;
    }

    a = move(na);
    b = move(nb);
  }

  return -1;
}

int main() {
  long long n;
  cin >> n;

  cout << check(n) << endl;
  return 0;
}