from collections import deque

def min_time_to_meet(n):    q = deque([(1, n, 0)])  # (alice_pos, bob_pos, time)    visited = set()    visited.add((1, n))
while q:
    alice_pos, bob_pos, time = q.popleft()

    if alice_pos == bob_pos:
        return time

    # Alice&#39;s moves
    next_alice_moves = [alice_pos + 2, alice_pos + 3]
    for next_alice_pos in next_alice_moves:
        if 1 &lt== next_alice_pos &lt== n and (next_alice_pos, bob_pos) not in visited:
            q.append((next_alice_pos, bob_pos, time + 1))
            visited.add((next_alice_pos, bob_pos))

    # Bob&#39;s moves
    next_bob_moves = [bob_pos - 1, bob_pos - 2]
    for next_bob_pos in next_bob_moves:
        if 1 &lt== next_bob_pos &lt;= n and (alice_pos, next_bob_pos) not in visited:
            q.append((alice_pos, next_bob_pos, time + 1))
            visited.add((alice_pos, next_bob_pos))

return -1  # Robots cannot meet

