from itertools import combinations

def find_stamps(N, M):
    # Формуємо список вартості марок
    stamps = list(range(1, N + 1))
    
    # Перебираємо підмножини різного розміру
    for r in range(1, N + 1):
        for subset in combinations(stamps, r):
            if sum(subset) == M:
                return subset  # Повертаємо відповідну підмножину
    
    # Якщо нічого не знайдено, повертаємо 0
    return [0]

# Зчитування вхідних даних
N = int(input())
M = int(input())

# Знаходимо рішення
result = find_stamps(N, M)

# Виводимо результат
print(*result)
