from collections import Counter

def find_president(N, numbers):
    # Підраховуємо кількість кожного числа
    count = Counter(numbers)
    
    # Знаходимо унікальні числа
    unique_numbers = [num for num, freq in count.items() if freq == 1]
    
    # Якщо є унікальні числа, повертаємо мінімальне, інакше -1
    if unique_numbers:
        return min(unique_numbers)
    else:
        return -1

# Зчитування вхідних даних
N = int(input())
numbers = list(map(int, input().split()))

# Виведення результату
print(find_president(N, numbers))
