def count_squares(matrix):
    n = len(matrix)
    count = 0
    for size in range(2, n + 1):
        for i in range(n - size + 1):
            for j in range(n - size + 1):
                color = matrix[i][j]
                is_valid = True
                for x in range(i, i + size):
                    for y in range(j, j + size):
                        if matrix[x][y] != color:
                            is_valid = False
                            break
                    if not is_valid:
                        break
                if is_valid:
                    count += 1
    return count
n = int(input())
matrix = []
for _ in range(n):
    row = list(map(int, input().split()))
    matrix.append(row)
result = count_squares(matrix)
print(result)