def find_meeting_time(n):
    alice_positions = {1}
    bob_positions = {n}
    t = 0

    while alice_positions and bob_positions:

        if alice_positions & bob_positions:
            return t

        next_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= n:
                next_alice_positions.add(pos + 2)
            if pos + 3 <= n:
                next_alice_positions.add(pos + 3)

        next_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                next_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                next_bob_positions.add(pos - 2)

        alice_positions = next_alice_positions
        bob_positions = next_bob_positions
        t += 1

    return -1

n = int(input())
print(find_meeting_time(n))
