from collections import deque

def solve(N, M):
    queue = deque([(0, [])])
    visited = set([0])
    
    while queue:
        current_sum, marks = queue.popleft()
        
        if current_sum == M:
            return marks
        
        for i in range(1, N + 1):
            new_sum = current_sum + i
            if new_sum <= M and new_sum not in visited:
    
                queue.append((new_sum, marks + [i]))
                visited.add(new_sum)
    
    return [0]

N = int(input())
M = int(input()) 

result = solve(N, M)
print(*result)
