import math

def find_stamps(N, M):
    if M > N * (N + 1) // 2:
        return [0]

    stamps = []
    k = N

    while M > 0 and k > 0:
        if M >= k:
            stamps.append(k)
            M -= k
        k -= 1

    if M != 0:
        return [0]

    return sorted(stamps)


N = int(input())
M = int(input())

result = find_stamps(N, M)
print(*result)