from collections import deque

def min_seconds_to_meet(N):
    if N == 1:
        return 0
    
    # Відвідані позиції для Аліси і Боба
    visited_alice = set()
    visited_bob = set()
    
    queue_alice = deque([(1, 0)])
    queue_bob = deque([(N, 0)]) 
    
    while queue_alice and queue_bob:
        pos_alice, time_alice = queue_alice.popleft()
        if pos_alice in visited_bob:
            return time_alice
        visited_alice.add(pos_alice)
        if pos_alice + 2 <= N:
            queue_alice.append((pos_alice + 2, time_alice + 1))
        if pos_alice + 3 <= N:
            queue_alice.append((pos_alice + 3, time_alice + 1))
        
        pos_bob, time_bob = queue_bob.popleft()
        if pos_bob in visited_alice:
            return time_bob
        visited_bob.add(pos_bob)
        if pos_bob - 1 > 0:
            queue_bob.append((pos_bob - 1, time_bob + 1))
        if pos_bob - 2 > 0:
            queue_bob.append((pos_bob - 2, time_bob + 1))
    
    return -1
print(min_seconds_to_meet(5))  
print(min_seconds_to_meet(9))
