def minimum_time_to_meet(N):
    if N == 2:
        return -1

    for t in range(1, N + 1):
        alice_reachable = {1 + 2 * a + 3 * b for a in range(t + 1) for b in range(t + 1 - a)}
        bob_reachable = {N - x - 2 * y for x in range(t + 1) for y in range(t + 1 - x)}
        
        if alice_reachable & bob_reachable:
            return t
    
    return -1

N = int(input())
print(minimum_time_to_meet(N))
