def find_stamps(N, M):
    dp = [float('inf')] * (M + 1)
    dp[0] = 0
    previous = [-1] * (M + 1)

    for value in range(1, N + 1):
        for current_sum in range(M, value - 1, -1):
            if dp[current_sum - value] + 1 < dp[current_sum]:
                dp[current_sum] = dp[current_sum - value] + 1
                previous[current_sum] = value

    if dp[M] == float('inf'):
        return [0]

    result = []
    while M > 0:
        result.append(previous[M])
        M -= previous[M]

    return result

N = int(input())
M = int(input())
print(*find_stamps(N, M))
