def can_meet(N):
    # Час і позиції Аліси та Боба
    alice_positions = {1}
    bob_positions = {N}
    time = 0

    while alice_positions and bob_positions:
        # Перетин позицій
        if alice_positions & bob_positions:
            return time

        # Оновлення позицій
        time += 1
        next_alice_positions = set()
        next_bob_positions = set()

        # Нові позиції Аліси
        for pos in alice_positions:
            if pos + 2 <= N:
                next_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                next_alice_positions.add(pos + 3)

        # Нові позиції Боба
        for pos in bob_positions:
            if pos - 1 >= 1:
                next_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                next_bob_positions.add(pos - 2)

        # Оновлення множин
        alice_positions = next_alice_positions
        bob_positions = next_bob_positions

    return -1  # Якщо неможливо зустрітися

# Зчитування даних
N = int(input())
print(can_meet(N))

