def find_president(robots):
    # Створимо словник для зберігання частоти кожного числа
    counts = {}
    
    # Заповнимо словник частоти
    for number in robots:
        if number in counts:
            counts[number] += 1
        else:
            counts[number] = 1
    
    # Знайдемо унікальне мінімальне число
    unique_min_number = None
    
    for number in counts:
        if counts[number] == 1:
            if unique_min_number is None or number < unique_min_number:
                unique_min_number = number
                
    # Перевіримо, чи був знайдений президент
    if unique_min_number is None:
        return "-1"
    else:
        return f"{unique_min_number}"

# Ввід даних
n = int(input())
robots = list(map(int, input("").split()))
print(find_president(robots))
