#include <bits/stdc++.h>
using namespace std;

struct Point {
    int x, y, index;
    
    Point(int x, int y, int index) : x(x), y(y), index(index) {}
    
    bool operator<(const Point& other) const {
        if(x == other.x) {
            return y < other.y;
        }
        return x < other.x;
    }
};

int main() {
    int t;
    cin >> t;

    while(t--) {
        int N;
        cin >> N;
        vector<Point> blue_points, red_points;

        for(int i = 0; i < N; i++) {
            int x, y;
            cin >> x >> y;
            blue_points.push_back(Point(x, y, i + 1));
        }
        
        for(int i = 0; i < N; i++) {
            int x, y;
            cin >> x >> y;
            red_points.push_back(Point(x, y, i + 1));
        }
        
        sort(blue_points.begin(), blue_points.end());
        sort(red_points.begin(), red_points.end());
        
        for(int i = 0; i < N; i++) {
            cout << blue_points[i].index << " " << red_points[i].index << endl;
        }
    }
    
    return 0;
}