import numpy as np

def select_stamps(N, M):
    max_sum = N * (N + 1) // 2
    if max_sum < M:
        print(0)
        return
    
    stamps = np.arange(1, N+1)
    selected_stamps = stamps[stamps <= M]
    
    sum_selected = np.sum(selected_stamps)
    
    while sum_selected > M:
        selected_stamps = selected_stamps[:-1]
        sum_selected = np.sum(selected_stamps)

    if sum_selected == M:
        print(" ".join(map(str, selected_stamps)))
    else:
        print(0)

N = int(input())
M = int(input())

select_stamps(N, M)
