# Вводимо розмір квадрата
N = int(input("Введіть розмір квадрата N: "))

# Вводимо сам масив
grid = []
print("Введіть строки масиву (кожна строка містить N чисел, розділених пробілами):")
for i in range(N):
    row = list(map(int, input().split()))
    grid.append(row)

# Перемінна для підрахунку квадратів з однаковими кольорами
count = 0

# Перебираємо всі можливі квадрати
for x1 in range(N):
    for y1 in range(N):
        for side in range(1, N - max(x1, y1)):  # side - довжина сторони квадрата
            x2, y2 = x1 + side, y1 + side
            # Перевіряємо, чи всі чотири вершини квадрата одного кольору
            if grid[x1][y1] == grid[x1][y2] == grid[x2][y1] == grid[x2][y2]:
                count += 1

# Виводимо результат
print(f"Кількість квадратів з однаковими вершинами одного кольору: {count}")
