#include <bits/stdc++.h>
#include <vector>
using namespace std;

// int main() {
//     int N, M;
//     cin >> N >> M;

//     vector<int> stamps;

//     int sum = 0;
//     for(int i = N; i >= 1; --i)
//     {
//         if(sum + i <= M)
//         {
//             stamps.push_back(i);
//             sum += i;
//         }
//         if(sum == M)
//         {
//             break;
//         }
//     }
//     if(sum != M)
//     {
//         cout << 0 << endl;
//     }
//     else 
//     {
//         cout << stamps.size() << endl;

//         for(int i = 0; i < stamps.size(); i++)
//         {
//             cout << stamps[i] << " ";
//         }
//     }
//     cout << endl;
// }

int main() {
    int N, M;
    cin >> N >> M;

    vector<bool> ar(M + 1, false);
    vector<int> parent(M + 1, -1);

    ar[0] = true;

    for (int i = 1; i <= N; ++i) 
    {
        int value = i;
        for (int j = M; j >= value; --j) 
        {
            if (ar[j - value])
            {
                ar[j] = true;
                parent[j] = i;
            }
        }
    }

    if (!ar[M])
    {
        cout << 0 << endl;
        return 0;
    }

    vector<int> result;
    int current = M;
    while (current > 0) 
    {
        result.push_back(parent[current]);
        current -= parent[current];
    }

    for (int i = 0; i < result.size(); ++i) 
    {
        cout << result[i] << " ";
    }
    cout << endl;
}
