def solve() :
    t = int(input())
    results = []

    for _ in range(t) :
        N = int(input())

        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().split())) for _ in range(N)]

        blue_sorted = sorted((x, y, i + 1) for i, (x, y) in enumerate(blue_points))
        red_sorted = sorted((x, y, i + 1) for i, (x, y) in enumerate(red_points))

        pairs = []
        for i in range(N) :
            blue_index = blue_sorted[i][2]
            red_index = red_sorted[i][2]
            pairs.append((blue_index, red_index))

            results.append(pairs)

        for res in results :
            if res :
                for pair in res :
                    print(pair[0], pair[1])
            else :
                print(0)
solve()