var scanf = require('scanf');

var n = scanf('%d');  

var numbers = [];

for (let i = 0; i < n; i++) {
  numbers.push(scanf('%d'));
}

var frequencyMap = {};

numbers.forEach(num => {
  if (frequencyMap[num]) {
    frequencyMap[num]++;
  } else {
    frequencyMap[num] = 1;
  }
});

var result = -1;
for (let num of numbers) {
  if (frequencyMap[num] === 1) {
    if (result === -1 || num < result) {
      result = num;
    }
  }
}

console.log(result);
