var scanf = require('scanf');

// Читання вхідних даних
var n = scanf('%d');  // Кількість роботів
var a = [];            // Массив чисел, згенерованих роботами

// Зчитуємо числа
for (let i = 0; i < n; i++) {
  a.push(scanf('%d'));
}

// Мапа для підрахунку частоти чисел
var b = {};  // Словник, де ключ - число, значення - кількість повторів числа

// Підрахунок частоти кожного числа
a.forEach(num => {
  if (b[num]) {
    b[num]++;
  } else {
    b[num] = 1;
  }
});

// Змінні для результату
var c = -1;  // Якщо не знайдемо унікального числа, виведемо -1

// Знайдемо мінімальне число, яке з'являється лише один раз
a.forEach(num => {
  if (b[num] === 1) {
    if (c === -1 || num < c) {
      c = num;
    }
  }
});

// Виведення результату
console.log(c);
