var scanf = require('scanf');

// Зчитуємо кількість роботів
var N = scanf('%d');

// Зчитуємо згенеровані числа
var numbers = scanf('%d'.repeat(N));

// Об'єкт для підрахунку кількості кожного числа
var count = {};

// Підраховуємо кількість кожного числа
for (let num of numbers) {
    if (count[num]) {
        count[num]++;
    } else {
        count[num] = 1;
    }
}

// Шукаємо мінімальне число, яке зустрічається тільки один раз
var minUnique = -1;

for (let num of numbers) {
    if (count[num] === 1) {
        if (minUnique === -1 || num < minUnique) {
            minUnique = num;
        }
    }
}

// Виводимо результат
console.log(minUnique);
