const scanf = require('scanf');

function solve() {
  const t = scanf('%d'); // кількість тестових блоків
  for (let i = 0; i < t; i++) {
    const N = scanf('%d'); // кількість точок одного кольору

    // Зчитуємо сині точки
    const bluePoints = [];
    for (let j = 0; j < N; j++) {
      const x = scanf('%d');
      const y = scanf('%d');
      bluePoints.push([x, y, j + 1]); // додаємо номер точки
    }

    // Зчитуємо червоні точки
    const redPoints = [];
    for (let j = 0; j < N; j++) {
      const x = scanf('%d');
      const y = scanf('%d');
      redPoints.push([x, y, j + 1]); // додаємо номер точки
    }

    // Сортуємо точки по координатах x (для запобігання перетину відрізків)
    bluePoints.sort((a, b) => a[0] - b[0]);
    redPoints.sort((a, b) => a[0] - b[0]);

    // Виводимо пари точок, які потрібно з'єднати
    let isPossible = true;
    const result = [];
    for (let j = 0; j < N; j++) {
      result.push(`${bluePoints[j][2]} ${redPoints[j][2]}`);
    }

    if (isPossible) {
      console.log(result.join('\n'));
    } else {
      console.log(0);
    }
  }
}

solve();