def solve():
    N = int(input())  # Кількість марок
    M = int(input())  # Загальна сума
    
    # Перевіряємо максимальну суму всіх марок
    total_sum = (N * (N + 1)) // 2
    if total_sum < M:
        print(0)
        return
    
    # Використовуємо жадібний підхід: починаємо з найбільших марок
    result = []
    for i in range(N, 0, -1):
        if M >= i:
            result.append(i)
            M -= i
        if M == 0:
            break
    
    if M == 0:
        # Виводимо номери марок
        print(' '.join(map(str, sorted(result))))
    else:
        print(0)

# Запуск рішення
solve()