def solve():
    import sys
    input = sys.stdin.read
    data = input().splitlines()
    
    t = int(data[0])  # Кількість тестів
    result = []
    idx = 1
    
    for _ in range(t):
        N = int(data[idx])  # Кількість точок одного кольору
        idx += 1
        
        # Зчитуємо сині точки
        blue = []
        for i in range(N):
            x, y = map(int, data[idx].split())
            blue.append((x, y, i + 1))  # Координати і номер
            idx += 1
        
        # Зчитуємо червоні точки
        red = []
        for i in range(N):
            x, y = map(int, data[idx].split())
            red.append((x, y, i + 1))  # Координати і номер
            idx += 1
        
        # Сортуємо точки
        blue.sort(key=lambda p: (p[1], p[0]))  # Спочатку за y, потім за x
        red.sort(key=lambda p: (p[1], p[0]))  # Спочатку за y, потім за x
        
        # Формуємо пари
        pairs = []
        for i in range(N):
            pairs.append((blue[i][2], red[i][2]))  # Номери точок
        
        # Додаємо результат для блоку
        result.append("\n".join(f"{b} {r}" for b, r in pairs))
    
    # Виводимо результат
    print("\n\n".join(result))