from collections import Counter

def find_president(N, a):
    count = Counter(a)
    
    min_value = float('inf')
    for number, freq in count.items():
        if freq == 1 and number < min_value:
            min_value = number
    
    return min_value if min_value != float('inf') else -1

N = int(input())
a = list(map(int, input().split()))

print(find_president(N, a))
