def count_squares(N, grid):
    count = 0
    
    # Перебираємо всі можливі розміри квадрата
    for size in range(1, N):  # size - це сторона квадрата
        for i in range(N - size):  # початкова точка по вертикалі
            for j in range(N - size):  # початкова точка по горизонталі
                # Перевіряємо чи всі 4 вершини квадрата одного кольору
                color = grid[i][j]
                if (grid[i][j] == color and 
                    grid[i + size][j] == color and 
                    grid[i][j + size] == color and 
                    grid[i + size][j + size] == color):
                    count += 1
                    
    return count

# Вхідні дані
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Виведення результату
print(count_squares(N, grid))
