#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int n;

int conv(int i, int j) {
    return i * n + j;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    
    cin >> n;

    bitset<1000> a;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            int here;
            cin >> here;
            a[conv(i, j)] = here;
        }
    }

    ll ans = 0;
    for (int ix = 0; ix < n; ix++) {
        for (int jx = 0; jx < n; jx++) {
            for (int iy = 0; iy < n; iy++) {
                for (int jy = 0; jy < n; jy++) {
                    if (ix == iy && jx == jy || a[conv(ix, jx)] != a[conv(iy, jy)]) continue;
                    bool our = a[conv(ix, jx)];
                    pair<int, int> vec = {ix - iy, jx - jy};
                    int first = abs(vec.first), second = abs(vec.second);

                    // first is positive
                    pair<int, int> newvec;
                    if (vec.first > 0) {
                        newvec.first = second;
                    }
                    else {
                        newvec.first = -second;
                    }

                    if (vec.second > 0) {
                        newvec.second = -first;
                    }
                    else {
                        newvec.second = first;
                    }
                    bool ok = true;
                    for (auto point : (vector<pair<int, int>>){{ix, jx}, {iy, jy}}) {
                        pair<int, int> newpoint = {point.first + newvec.first,
                                 point.second + newvec.second};
                        if (newpoint.first < 0 || newpoint.first >= n ||
                            newpoint.second < 0 || newpoint.second >= n ||
                            a[conv(newpoint.first, newpoint.second)] != our) {
                                ok = false;
                            }
                    }

                    if (ok) {
                        ans++;
                    }



                    // first is negative
                    if (vec.first > 0) {
                        newvec.first = -second;
                    }
                    else {
                        newvec.first = second;
                    }

                    if (vec.second > 0) {
                        newvec.second = first;
                    }
                    else {
                        newvec.second = -first;
                    }
                    ok = true;
                    for (auto point : (vector<pair<int, int>>){{ix, jx}, {iy, jy}}) {
                        pair<int, int> newpoint = {point.first + newvec.first,
                                 point.second + newvec.second};
                        if (newpoint.first < 0 || newpoint.first >= n ||
                            newpoint.second < 0 || newpoint.second >= n ||
                            a[conv(newpoint.first, newpoint.second)] != our) {
                                ok = false;
                            }
                    }

                    if (ok) {
                        ans++;
                    }
                }
            }
        }
    }

    printf("%lld\n", ans / 8);
}

