#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int n;

inline int conv(int i, int j) {
    return i * n + j;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    
    cin >> n;

    bitset<1000> a;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            int here;
            cin >> here;
            a[conv(i, j)] = here;
        }
    }

    ll ans = 0;
    for (int ix = 0; ix < n; ix++) {
        for (int jx = 0; jx < n; jx++) {
            for (int iy = 0; iy < n; iy++) {
                for (int jy = 0; jy < n; jy++) {
                    if (ix == iy && jx == jy || a[conv(ix, jx)] != a[conv(iy, jy)]) continue;

                    int first = (ix - iy > 0) * abs(jx - jy) - (ix - iy <= 0) * abs(jx - jy);
                    int second = -(jx - jy > 0) * abs(ix - iy) + (jx - jy <= 0) * abs(ix - iy);

                    ans += (ix + first >= 0 && iy + first >= 0 && ix + first < n && 
                        iy + first < n && jx + second >= 0 && jy + second >= 0 &&
                        jx + second < n && jy + second < n && 
                        a[conv(ix + first, jx + second)] == a[conv(ix, jx)] &&
                        a[conv(iy + first, jy + second)] == a[conv(iy, jy)]);
                }
            }
        }
    }

    printf("%lld\n", ans / 4);
}

