from collections import deque

N = int(input())

alice_moves = [2, 3]
bob_moves = [1, 2]

queue = deque([(1, 0), (N, 0)])

visited_alice = [False] * (N + 1)
visited_bob = [False] * (N + 1)

visited_alice[1] = True
visited_bob[N] = True

while queue:
    position, time = queue.popleft()

    if position <= N:
        for move in alice_moves:
            new_position = position + move
            if new_position <= N and not visited_alice[new_position]:
                visited_alice[new_position] = True
                queue.append((new_position, time + 1))

    if position >= 1:
        for move in bob_moves:
            new_position = position - move
            if new_position >= 1 and not visited_bob[new_position]:
                visited_bob[new_position] = True
                queue.append((new_position, time + 1))

    if visited_alice[position] and visited_bob[position]:
        print(time)
        break
else:
    print(-1)





