import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int n = in.nextInt();

        int[] a = new int[n];

        for (int i = 0; i < n; i++) {
            a[i] = in.nextInt();
        }

        Map<Integer, Integer> u = new HashMap<>();

        for (int i = 0; i < n; i++) {
            u.put(a[i], u.getOrDefault(a[i], 0) + 1);
        }

        int result = -1;
        for (int i = 0; i < n; i++) {
            if (u.get(a[i]) == 1) {
                result = (result == -1) ? a[i] : Math.min(result, a[i]);
            }
        }

        System.out.println(result);
    }
}
