import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int n = in.nextInt();
        
        int[] a = new int[n];
        
        for (int i = 0; i < n; i++) {
            a[i] = in.nextInt();
        }
        
        Map<Integer, Integer> countMap = new HashMap<>();
        
        for (int i = 0; i < n; i++) {
            countMap.put(a[i], countMap.getOrDefault(a[i], 0) + 1);
        }
        
        int result = -1;
        
        for (int num : countMap.keySet()) {
            if (countMap.get(num) == 1 && (result == -1 || num < result)) {
                result = num;
            }
        }
        
        System.out.println(result);
    }
}
