n = int(input())
print ((n/10, n%10))
from collections import deque

def min_seconds_to_meet(N):
    # Ініціалізація черги для BFS
    queue = deque(1, 5, )  # (позиція Аліси, позиція Боба, кількість секунд)
    visited = set([1, 5])     # Відвідані пари позицій Аліса-Боб

    while queue:
        alice, bob, time = queue.popleft()
        # Якщо Аліса та Боб у одному боксі
        if alice == bob:
            return time
        # Наступні позиції Аліси
        alice_next = [alice + 2, alice + 3]
        # Наступні позиції Боба
        bob_next = [bob - 1, bob - 2]
        # Оновлення позицій та додавання до черги
        for a in alice_next:
            for b in bob_next:
                if 1 <= a <= N and 1 <= b <= N and (a, b) not in visited:
                    visited.add((a, b))
                    queue.append((a, b, time + 1))
    return -1  # Якщо зустріч неможлива
def main():
    # Читання вхідних даних
    N = int(input().strip())
    # Виклик функції
    result = min_seconds_to_meet(N)
    # Виведення результату
    if result == -1:
        print(No)
    else:
        print(result)