
#include <iostream>
using namespace std;

int n;
struct node {
    int num;
    bool UniqeOrNot = 1;
}arr[100000];

void quicksort(int low, int high) {
    int i = low;
    int j = high;
    int pivot = arr[(i + j) / 2].num;
    while (i <= j) {
        while (arr[i].num < pivot) {
            i++;
        }
        while (arr[j].num > pivot) {
            j--;
        }
        if (i <= j) {
            node temp = arr[i];
            arr[i] = arr[j];
            arr[j] = temp;
            i++;
            j--;
        }
    }
    if (i < high) {
        quicksort(i, high);
    }
    if (j > low) {
        quicksort(low, j);
    }
}

int main()
{
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> arr[i].num;
    }
    quicksort(0, n - 1);
    for (int i = 0; i + 1 < n; i++) {
        if (arr[i].num == arr[i + 1].num) {
            int h = arr[i].num;
            arr[i].UniqeOrNot = 0;
            i++;
            while (arr[i].num == h) {
                arr[i].UniqeOrNot = 0;
                i++;
            }
            i--;
        }
    }
    for (int i = 0; i < n; i++) {
        if (arr[i].UniqeOrNot == 1) {
            cout << arr[i].num;
            return 0;
        }
    }
    cout << -1;
    return 0;
}