def select_stamps(N, M):
    # Перевіряємо, чи можливо досягти суми M
    total_sum = (N * (N + 1)) // 2
    if M > total_sum:
        return [0]  # Якщо сума більша, ніж загальна сума марок, то неможливо знайти таку підмножину

    # Список марок, які будемо вибирати
    selected_stamps = []
    for i in range(N, 0, -1):  # Перевіряємо марки з найбільшими номерами
        if M >= i:
            selected_stamps.append(i)
            M -= i
        if M == 0:
            break
    
    if M == 0:
        return selected_stamps
    else:
        return [0]

# Вхідні дані
N = int(input())  # Кількість марок
M = int(input())  # Загальна сума для вибору марок

# Виведення результату
result = select_stamps(N, M)
print(*result)
