from collections import Counter

def find_president(N, a):
    # Підрахуємо кількість кожного числа
    count = Counter(a)
    
    # Знайдемо найменше число, яке зустрічається лише один раз
    min_unique = float('inf')
    for num, freq in count.items():
        if freq == 1 and num < min_unique:
            min_unique = num
    
    # Якщо є таке число, виводимо його, інакше виводимо -1
    return min_unique if min_unique != float('inf') else -1

# Вхідні дані
N = int(input())  # Кількість роботів
a = list(map(int, input().split()))  # Список згенерованих чисел

# Виведення результату
print(find_president(N, a))