def count_uniform_squares(N, grid):
    count = 0
    
    # Пройдемо всі можливі пари точок
    for x1 in range(N):
        for y1 in range(N):
            for x2 in range(x1 + 1, N):
                for y2 in range(y1 + 1, N):
                    # Якщо квадрат має рівні сторони
                    if abs(x2 - x1) == abs(y2 - y1):
                        # Перевіримо, чи утворюється квадрат
                        x3, y3 = x1, y2
                        x4, y4 = x2, y1
                        
                        # Перевіримо чи всі чотири точки мають однаковий колір
                        if grid[x1][y1] == grid[x2][y2] == grid[x3][y3] == grid[x4][y4]:
                            count += 1
    return count

# Вхідні дані
N = int(input())  # Розмір квадрата
grid = [list(map(int, input().split())) for _ in range(N)]

# Виведення результату
print(count_uniform_squares(N, grid))
