var scanf = require('scanf');
var n = scanf('%d');

function canMeet(n) {
    let alisaPos = new Set();
    let bobPos = new Set();
    
    alisaPos.add(1);
    bobPos.add(n);
    
    for (let second = 1; second <= n; second++) {
        let newAlisaPos = new Set();
        let newBobPos = new Set();
        
        for (let pos of alisaPos) {
            if (pos + 2 <= n) newAlisaPos.add(pos + 2);
            if (pos + 3 <= n) newAlisaPos.add(pos + 3);
        }
        
        for (let pos of bobPos) {
            if (pos - 1 >= 1) newBobPos.add(pos - 1);
            if (pos - 2 >= 1) newBobPos.add(pos - 2);
        }
        
        for (let pos of newAlisaPos) {
            if (newBobPos.has(pos)) {
                return second;
            }
        }
        
        alisaPos = newAlisaPos;
        bobPos = newBobPos;
        
        if (alisaPos.size === 0 || bobPos.size === 0) {
            return -1;
        }
    }
    
    return -1;
}

console.log(canMeet(n));
