const scanf = require('scanf')

function solve(nums) {
    let count = {}
    
    for (let x of nums) {
        count[x] = (count[x] || 0) + 1
    }
    
    let minNum = -1
    
    for (let x of nums) {
        if (count[x] === 1) {
            if (minNum === -1 || x < minNum) {
                minNum = x
            }
        }
    }
    
    return minNum
}

let n = scanf('%d')
let numbers = []

for (let i = 0; i < n; i++) {
    numbers.push(scanf('%d'))
}

console.log(solve(numbers))