var scanf = require('scanf');

let n = scanf('%d');

let numbers = scanf('%d'.repeat(n));

let freq = new Map();
for(let num of numbers) {
    freq.set(num, (freq.get(num) || 0) + 1);
}

let minUnique = Infinity;
for(let [num, count] of freq) {
    if(count === 1 && num < minUnique) {
        minUnique = num;
    }
}

console.log(minUnique === Infinity ? -1 : minUnique);
