var scanf = require('scanf');

let n = scanf('%d');

let numbers = scanf('%d'.repeat(n));
let freq = new Map();
let indexMap = new Map();

for(let i = 0; i < n; i++) {
    let num = numbers[i];
    freq.set(num, (freq.get(num) || 0) + 1);
    if (!indexMap.has(num)) {
        indexMap.set(num, i + 1); 
    }
}

let minUnique = Infinity;
let winnerIndex = -1;

for(let [num, count] of freq) {
    if(count === 1 && num < minUnique) {
        minUnique = num;
        winnerIndex = indexMap.get(num);
    }
}

console.log(winnerIndex !== -1 ? numbers[winnerIndex - 1] : -1);
