const scanf = require('scanf')

function gcd(a, b) {
    while (b) {
        let temp = b
        b = a % b
        a = temp
    }
    return a
}

function lcm(a, b) {
    return Math.floor((a * b) / gcd(a, b))
}

function solve(n, a, b) {
    if (a > n && b > n) {
        return 0
    }
    
    let byA = Math.floor(n / a)
    let byB = Math.floor(n / b)
    
    let commonDivisor = lcm(a, b)
    let both = commonDivisor > n ? 0 : Math.floor(n / commonDivisor)
    
    return byA + byB - both
}

let n = scanf('%d')
let a = scanf('%d')
let b = scanf('%d')

console.log(solve(n, a, b))