def count_uniform_squares_fixed(N, grid):
    count = 0
    for size in range(1, N + 1):
        for i in range(N - size + 1):
            for j in range(N - size + 1):
                if (grid[i][j] == grid[i][j + size - 1] == 
                    grid[i + size - 1][j] == grid[i + size - 1][j + size - 1]):
                    count += 1
    return count


N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

result = count_uniform_squares_fixed(N, grid)
print(result//16 if result % 16 == 0 else result //16+1 )