def lesstime(N):
    target = (N - 1) % 6  
    
    alice_remainders = {1, 3, 4}  
    bob_remainders = {0, 4, 5}    
    
    if target not in {((a + b) % 6) for a in alice_remainders for b in bob_remainders}:
        return -1
    
    for t in range(0, 6):  
        for a in range(t + 1):
            b = t - a
            alice_pos = 1 + 2 * a + 3 * b
            bob_pos = N - a - 2 * b
            if alice_pos == bob_pos:
                return t
    
    return -1 

N = int(input())
print(lesstime(N))
