def find_stamps(N, M):
    # Загальна сума всіх марок від 1 до N
    total_sum = N * (N + 1) // 2
    
    # Якщо M більша за максимальну можливу суму, то неможливо вибрати марки
    if M > total_sum:
        return [0]
    
    result = []
    # Починаємо з найбільших марок і зменшуємо M
    for i in range(N, 0, -1):
        if i <= M:
            result.append(i)
            M -= i
        if M == 0:
            break
    
    # Якщо залишок суми не 0, виводимо 0
    if M != 0:
        return [0]
    
    return result

# Читання вхідних даних
N = int(input())
M = int(input())

# Викликаємо функцію і виводимо результат
result = find_stamps(N, M)
print(" ".join(map(str, result)))
