const readline = require('readline');

// Створюємо інтерфейс для введення з консолі
const rl = readline.createInterface({
  input: process.stdin,
  output: process.stdout
});

// Функція для пошуку марок
function findStamps(N, M) {
    let result = [];
    
    // Починаємо з найбільших марок, щоб мінімізувати кількість марок
    for (let i = N; i >= 1; i--) {
        if (M >= i) {
            result.push(i); // Додаємо марку до результату
            M -= i; // Зменшуємо залишок суми
        }
    }

    // Якщо залишок суми 0, то виводимо обрані марки
    if (M === 0) {
        console.log(result.join('\n'));
    } else {
        // Якщо не вдалося досягти суми M
        console.log(0);
    }
}

// Читання вводу користувача
rl.question('Введіть кількість марок (N): ', (N) => {
    rl.question('Введіть суму (M): ', (M) => {
        N = parseInt(N);
        M = parseInt(M);
        
        // Викликаємо функцію для пошуку марок
        findStamps(N, M);

        // Закриваємо інтерфейс після виконання
        rl.close();
    });
});
