import math

def find_ones(N, A, B):
    # Кількість комірок, які діляться на A
    count_A = N // A
    # Кількість комірок, які діляться на B
    count_B = N // B
    # Кількість комірок, які діляться на LCM(A, B)
    lcm_AB = (A * B) // math.gcd(A, B)
    count_AB = N // lcm_AB
    
    # Загальна кількість одиничок
    return count_A + count_B - count_AB

# Читання вхідних даних
N = int(input())
A, B = map(int, input().split())

# Викликаємо функцію і виводимо результат
result = find_ones(N, A, B)
print(result)
