# Файл: count_uniform_color_squares.py

def count_uniform_color_squares(grid, N):
    count = 0
    
    # Перебір розмірів квадратів (від 1x1 до NxN)
    for size in range(1, N + 1):  # Розмір квадрата
        for i in range(N - size + 1):  # Ліва верхня координата (i, j)
            for j in range(N - size + 1):
                # Перевірка кольорів вершин квадрата
                color = grid[i][j]
                all_same = True
                for x in range(i, i + size):
                    for y in range(j, j + size):
                        if grid[x][y] != color:
                            all_same = False
                            break
                    if not all_same:
                        break
                
                if all_same:
                    count += 1
    
    return count


# Читання вхідних даних
if __name__ == "__main__":
    N = int(input())
    grid = [list(map(int, input().split())) for _ in range(N)]
    result = count_uniform_color_squares(grid, N)
    print(result)
