function countSquares(N, grid) {
    let count = 0;

    // Перевіряємо всі квадрати розміру 2x2 до NxN
    for (let size = 2; size <= N; size++) { // Розмір квадрата від 2x2 до NxN
        for (let i = 0; i <= N - size; i++) { // Початок квадрата по x
            for (let j = 0; j <= N - size; j++) { // Початок квадрата по y
                let color = grid[i][j]; // Колір першої вершини
                let isValid = true;

                // Перевіряємо всі 4 вершини квадрата
                for (let x = i; x < i + size; x++) {
                    for (let y = j; y < j + size; y++) {
                        if (grid[x][y] !== color) {
                            isValid = false;
                            break;
                        }
                    }
                    if (!isValid) break;
                }

                // Якщо всі вершини одного кольору
                if (isValid) {
                    count++;
                }
            }
        }
    }

    return count;
}

// Приклад використання
let N = 4;
let grid = [
    [0, 1, 0, 0],
    [0, 0, 1, 1],
    [1, 0, 0, 0],
    [0, 1, 1, 1]
];

console.log(countSquares(N, grid)); // Виведе кількість квадратів з однаковим кольором
