#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N;
    cin >> N;
    vector<vector<int>> grid(N, vector<int>(N));
    
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            cin >> grid[i][j];
        }
    }

    int count = 0;
    
    for (int size = 2; size <= N; ++size) { 
        for (int i = 0; i <= N - size; ++i) {
            for (int j = 0; j <= N - size; ++j) { 
                int color = grid[i][j]; 
                bool isValid = true;
                
                for (int x = i; x < i + size; ++x) {
                    for (int y = j; y < j + size; ++y) {
                        if (grid[x][y] != color) {
                            isValid = false;
                            break;
                        }
                    }
                    if (!isValid) break;
                }
                
                if (isValid) {
                    ++count;
                }
            }
        }
    }

    cout << count << endl;
    return 0;
}