def count_squares(N, grid):
    count = 0
    
    # Перевіряємо всі можливі розміри квадратів
    for size in range(1, N):  # розмір квадратів від 1 до N-1
        # Перевіряємо всі можливі позиції верхнього лівого кута для квадратів цього розміру
        for i in range(N - size):  # по рядках
            for j in range(N - size):  # по стовпцях
                # Для кожного можливого квадрата перевіряємо 4 кути
                if (grid[i][j] == grid[i + size][j] == grid[i][j + size] == grid[i + size][j + size]):
                    count += 1
    return count

# Вхідні дані
N = int(input())  # розмір квадрата
grid = [list(map(int, input().split())) for _ in range(N)]

# Виводимо результат
print(count_squares(N, grid))
