def count_squares(N, grid):
    count = 0
    
    # Перевіряємо всі можливі розміри квадратів від 1 до N
    for size in range(1, N + 1):  
        # Перевіряємо всі можливі позиції верхнього лівого кута для квадратів цього розміру
        for i in range(N - size + 1):  
            for j in range(N - size + 1): 
                # Для кожної позиції перевіряємо 4 кути квадрата
                if grid[i][j] == grid[i + size - 1][j] == grid[i][j + size - 1] == grid[i + size - 1][j + size - 1]:
                    count += 1
    return count


# Вхідні дані
N = int(input())  # розмір квадрата
grid = [list(map(int, input().split())) for _ in range(N)]

# Виводимо результат
print(count_squares(N, grid))
