#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>

using namespace std;

#define LF '\n';
typedef long long lli;
typedef long double ld;


struct point
{
    lli x, y,ind,type;
};

const point P = { -10041,-21312 ,0,0};

vector<point> v;
vector<pair<lli, lli>> ans;


ld angle(point p1, point p2) {
    ld dx = p2.x - p1.x;
    ld dy = p2.y - p1.y;
    return dx / dy;
}

bool cmp(point p1, point p2) {
    return angle(P, p1) < angle(P, p2);
}

ld f(point p1, point p2) {
    return angle(p1, p2);
}

void func(vector<point> q){
    if (q.size() == 2) {
        lli a = q[0].ind;
        lli b = q[1].ind;
        if (q[0].type == 2)swap(a, b);
        ans.push_back({ a,b });
        return;
    }

    sort(q.begin(), q.end(), cmp);
    lli balance = 0;
    lli cnt = 0;
    for (auto to : q) {
        if (to.type == 1)balance++;
        else balance--;
        cnt++;
        if (balance == 0 && cnt != q.size()) {
            vector<point> q2;
            while (q.size() != cnt) {
                q2.push_back(q.back());
                q.pop_back();
            }
            func(q);
            func(q2);
            return;
        }
    }
    vector<point> z;
    z.push_back(q[0]);
    for (int i = 1; i < q.size(); i++) {
        while (z.size() > 1 && f(z[z.size() - 2], z[z.size() - 1]) > f(z[z.size() - 2], q[i]))z.pop_back();
        z.push_back(q[i]);
    }
    map<lli,lli> used;
    for (int i = 0; i < z.size() - 1; i++) {
        if (z[i].type != z[i + 1].type) {
            func({ z[i],z[i + 1] });
            used[i] = 1;
            used[i+1] = 1;
            break;
        }
    }
    z.clear();
    for (int i = 0; i < q.size();i++) if (used[i] == 0)z.push_back(q[i]);
    func(z);
}

void solve()
{
    lli n;
    cin >> n;
    v.clear();
    ans.clear();
    for (int i = 1; i <= n; i++) {
        lli x, y;
        cin >> x >> y;
        v.push_back({ x,y,i,1 });
    }
    for (int i = 1; i <= n; i++) {
        lli x, y;
        cin >> x >> y;
        v.push_back({ x,y,i,2 });
    }
    func(v);
    for (auto to : ans) {
        cout << to.first << " " <<  to.second << LF;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 

    lli t;
    cin >> t;
    while (t--)solve();
}

