#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>

using namespace std;

#define LF '\n';
typedef int lli;
typedef double ld;


struct point
{
    lli x, y,ind,type;
};

const point P = { -13341,-13123 ,0,0};

vector<point> v;
vector<pair<lli, lli>> ans;



ld angle(point p1, point p2) {
    ld dx = abs(p2.x - p1.x);
    ld dy = abs(p2.y - p1.y);
    return dx / dy;
}

bool cmp(point p1, point p2) {
    return angle(P, p1) < angle(P, p2);
}


bool check(point &p1, point &p2, point &p3) {
    if (p1.x <= p3.x) {
        if (p1.x == p3.x) {
            if (p1.y < p3.y) return p2.x < p1.x;
            else return p2.x > p1.x;
        }
        ld k = (ld)(p1.y - p3.y) / (ld)(p1.x - p3.x);
        ld b = p1.y - k * p1.x;
        ld y = k * p2.x + b;
        return p2.y > y;
    }
    else {
        ld k = (ld)(p1.y - p3.y) / (ld)(p1.x - p3.x);
        ld b = p1.y - k * p1.x;
        ld y = k * p2.x + b;
        return p2.y < y;
    }

}

vector<int> make_convex_hull(vector<int> &q) {
    vector<int> z;
    z.push_back(q[0]);
    for (int i = 1; i < q.size(); i++) {
        while (z.size() > 1 && !check(v[z[z.size()-2]],v[z[z.size()-1]],v[q[i]]) )z.pop_back();
        z.push_back(q[i]);
    }
    return z;
}


vector<lli> ind;
lli n;
lli num_color;
void func(){
    bool x = 1;
    while (x) {
        x = 0;
        //        vector<lli> q;
        lli s = 0;
        lli p = 0;
        lli cnt = 0;
        for (int i = 1; i <= 2 * n; i++) {
            if (ind[i] == 0)continue;
            else {
                x = 1;
                if (p == 0) {
                    p = ind[i];
                    s = i;
                    cnt = 1;
                }
                else {
                    if (p != ind[i]) {
                        if (cnt == 2) {
                            lli s2 = 0;
                            for (int j = s + 1; j < i; j++)if (ind[j])s2 = j;
                            lli a = v[s].ind;
                            lli b = v[s2].ind;
                            if (v[s].type == 2)swap(a, b);
                            ans.push_back({ a,b });
                            cnt = 1;
                            ind[s] = 0;
                            ind[s2] = 0;
                            s = i;
                            p = ind[i];
                        }
                        else {
                            lli balance = 0;
                            lli cnt2 = 0;
                            bool c = 0;
                            for (int j = s; j < i; j++) {
                                if (!ind[j])continue;
                                if (v[j].type == 1)balance++;
                                else balance--;
                                cnt2++;
                                if (balance == 0 && cnt2 != cnt) {
                                    c = 1;
                                    num_color++;
                                    for (int g = s; g <= j; g++) {
                                        if (ind[g])ind[g] = num_color;
                                    }
                                    break;
                                }
                            }

                            if (c) {
                                s = i;
                                p = ind[i];
                                cnt = 1;
                                continue;
                            }
                            vector<lli> q;
                            for (int j = s; j < i; j++)if (ind[j])q.push_back(j);
                            vector<int> z = make_convex_hull(q);
                            for (int k = 0; k < z.size() - 1; k++) {
                                if (v[z[k]].type != v[z[k + 1]].type) {
                                    num_color++;
                                    ind[z[k]] = 0;
                                    ind[z[k + 1]] = 0;
                                    lli a = v[z[k]].ind;
                                    lli b = v[z[k+1]].ind;
                                    if (v[z[k]].type == 2)swap(a, b);
                                    ans.push_back({ a,b });
                                    break;
                                }
                            }
                        }
                    }
                    else cnt++;
                }

            }
        }
        lli i = 2*n + 1;
        if (cnt == 2) {
            lli s2 = 0;
            for (int j = s + 1; j < i; j++)if (ind[j])s2 = j;
            lli a = v[s].ind;
            lli b = v[s2].ind;
            if (v[s].type == 2)swap(a, b);
            ans.push_back({ a,b });
            cnt = 1;
            ind[s] = 0;
            ind[s2] = 0;
        }
        else if (cnt>2){
            lli balance = 0;
            lli cnt2 = 0;
            bool c = 0;
            for (int j = s; j < i; j++) {
                if (!ind[j])continue;
                if (v[j].type == 1)balance++;
                else balance--;
                cnt2++;
                if (balance == 0 && cnt2 != cnt) {
                    c = 1;
                    num_color++;
                    for (int g = s; g <= j; g++) {
                        if (ind[g])ind[g] = num_color;
                    }
                    break;
                }
            }

            if (!c) {
                vector<lli> q;
                for (int j = s; j < i; j++)if (ind[j])q.push_back(j);
                vector<int> z = make_convex_hull(q);
                for (int k = 0; k < z.size() - 1; k++) {
                    if (v[z[k]].type != v[z[k + 1]].type) {
                        num_color++;
                        ind[z[k]] = 0;
                        ind[z[k + 1]] = 0;
                        lli a = v[z[k]].ind;
                        lli b = v[z[k + 1]].ind;
                        if (v[z[k]].type == 2)swap(a, b);
                        ans.push_back({ a,b });
                        break;
                    }
                }
            }
        }
    }
}

void solve()
{
    cin >> n;
    v.clear();
    ans.clear();
    v.push_back({ 0,0,0,0 });
    for (int i = 1; i <= n; i++) {
        lli x, y;
        cin >> x >> y;
        v.push_back({ x,y,i,1 });
    }
    for (int i = 1; i <= n; i++) {
        lli x, y;
        cin >> x >> y;
        v.push_back({ x,y,i,2 });
    }
    sort(v.begin()+1, v.end(), cmp);
    ind.resize(2 * n + 1,1);
    num_color = 1;
    func();
   
    for (auto to : ans) {
        cout << to.first << " " <<  to.second << LF;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 

    lli t;
    cin >> t;
    while (t--)solve();
}

