def min_time_to_meet(N):
    if N == 1:
        return 0
    
    alice_pos, bob_pos, time = [1], [N], 0
    while alice_pos and bob_pos:
        time += 1
        new_alice_pos = []
        new_bob_pos = []
        
        for pos in alice_pos:
            if pos + 2 <= N:
                new_alice_pos.append(pos + 2)
            if pos + 3 <= N:
                new_alice_pos.append(pos + 3)
        
        for pos in bob_pos:
            if pos - 1 >= 1:
                new_bob_pos.append(pos - 1)
            if pos - 2 >= 1:
                new_bob_pos.append(pos - 2)
        
        for a in new_alice_pos:
            if a in new_bob_pos:
                return time
        
        alice_pos = new_alice_pos
        bob_pos = new_bob_pos
    
    return -1

N = int(input())
print(min_time_to_meet(N))