#include <iostream>
#include <unordered_set>

int can_meet(int N) {
    std::unordered_set<int> alice_positions = {1};
    std::unordered_set<int> bob_positions = {N};
    int seconds = 0;

    while (seconds <= N) {
        seconds += 1;

        std::unordered_set<int> new_alice_positions;
        for (int pos : alice_positions) {
            if (pos + 2 <= N) {
                new_alice_positions.insert(pos + 2);
            }
            if (pos + 3 <= N) {
                new_alice_positions.insert(pos + 3);
            }
        }
        alice_positions = new_alice_positions;

        std::unordered_set<int> new_bob_positions;
        for (int pos : bob_positions) {
            if (pos - 1 >= 1) {
                new_bob_positions.insert(pos - 1);
            }
            if (pos - 2 >= 1) {
                new_bob_positions.insert(pos - 2);
            }
        }
        bob_positions = new_bob_positions;

        for (int pos : alice_positions) {
            if (bob_positions.find(pos) != bob_positions.end()) {
                return seconds;
            }
        }
    }
    return -1;
}

int main() {
    int N;
    std::cout << "";
    std::cin >> N;
    int result = can_meet(N);
    std::cout << "" << result << std::endl;
    return 0;
}
