#include <iostream>
#include <unordered_set>
#include <queue>
using namespace std;
int can_meet(int N) {
    if (N == 1) {
        return 0;
    }
    queue<int> alice_queue;
    queue<int> bob_queue;
    unordered_set<int> visited_alice;
    unordered_set<int> visited_bob;
    alice_queue.push(1);
    bob_queue.push(N);
    visited_alice.insert(1);
    visited_bob.insert(N);
    int seconds = 0;
    while (!alice_queue.empty() && !bob_queue.empty()) {
        seconds++;
        int alice_size = alice_queue.size();
        for (int i = 0; i < alice_size; ++i) {
            int pos = alice_queue.front();
            alice_queue.pop();
            for (int new_pos : {pos + 2, pos + 3}) {
                if (new_pos <= N && visited_alice.find(new_pos) == visited_alice.end()) {
                    if (visited_bob.find(new_pos) != visited_bob.end()) {
                        return seconds;
                    }
                    alice_queue.push(new_pos);
                    visited_alice.insert(new_pos);
                }
            }
        }
        int bob_size = bob_queue.size();
        for (int i = 0; i < bob_size; ++i) {
            int pos = bob_queue.front();
            bob_queue.pop();
            for (int new_pos : {pos - 1, pos - 2}) {
                if (new_pos >= 1 && visited_bob.find(new_pos) == visited_bob.end()) {
                    if (visited_alice.find(new_pos) != visited_alice.end()) {
                        return seconds;
                    }
                    bob_queue.push(new_pos);
                    visited_bob.insert(new_pos);
                }
            }
        }
    }
    return -1;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int N;
    cin >> N;
    int result = can_meet(N);
    cout << result << '\n';
    return 0;
}