#include <iostream>
#include <vector>
#include <unordered_map>
#include <algorithm>
using namespace std;
int find_president(int N, const vector<int>& votes) {
    unordered_map<int, int> count;
    for (int num : votes) {
        count[num]++;
    }
    vector<int> unique_numbers;
    for (const auto& pair : count) {
        if (pair.second == 1) {
            unique_numbers.push_back(pair.first);
        }
    }
    if (!unique_numbers.empty()) {
        return *min_element(unique_numbers.begin(), unique_numbers.end());
    } else {
        return -1;
    }
}
int main() {
    int N;
    cin >> N;
    vector<int> votes(N);
    for (int i = 0; i < N; ++i) {
        cin >> votes[i];
    }
    int result = find_president(N, votes);
    cout << result << endl;
    return 0;
}