with open("input.txt") as f:
    n = int(f.readline().strip()) # kiljkistj marok
    m = int(f.readline().strip()) # vartistj marok
def find_stamps(n, m):
    result = []
    
    max_sum = n * (n + 1) // 2
    if m > max_sum:
        return [0]
    
    while m > 0:
        k = min(n, m)
        result.append(k)
        m -= k
        n = k - 1
    
    return sorted(result)

result = find_stamps(n, m)

print("\n".join(map(str, result)))