with open("input.txt") as f:
    n = f.readline()
    candidates = list(map(int, f.readline().split()))
candidates = sorted(candidates)

counts = {}
for num in candidates:
    counts[num] = counts.get(num, 0) + 1

unique_candidates = [num for num in counts if counts[num] == 1]

if unique_candidates:
    print(min(unique_candidates))
else:
    print(-1)