def find_meeting_time(N):
    # Початкові позиції
    alice_positions = {1}
    bob_positions = {N}

    time = 0
    while time < N:
        # Перевірка перетину множин
        if alice_positions & bob_positions:
            return time
        
        # Оновлення позицій
        alice_positions = {pos + 2 for pos in alice_positions if pos + 2 <= N} | \
                          {pos + 3 for pos in alice_positions if pos + 3 <= N}
        bob_positions = {pos - 1 for pos in bob_positions if pos - 1 >= 1} | \
                        {pos - 2 for pos in bob_positions if pos - 2 >= 1}
        
        time += 1

    return -1  # Якщо не знайдено

# Зчитування вхідних даних
N = int(input())
print(find_meeting_time(N))
