def count_colored_squares(N, grid):
    count = 1
    # Проверяем только квадраты размера 2x2 и больше
    for size in range(1, N):  # size от 1 до N-1 (для квадратов размером 2x2 и больше)
        for i in range(N - size):
            for j in range(N - size):
                # Вершины квадрата
                top_left = grid[i][j]
                top_right = grid[i][j + size]
                bottom_left = grid[i + size][j]
                bottom_right = grid[i + size][j + size]
                
                # Если все вершины одного цвета, увеличиваем счетчик
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1
    return count

# Чтение входных данных
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Вывод результата
print(count_colored_squares(N, grid))
