def count_uniform_color_squares():
    import sys
    input = sys.stdin.read
    data = input().splitlines()

    # Зчитуємо розмір квадрата
    N = int(data[0])
    grid = [list(map(int, line.split())) for line in data[1:]]
    
    count = 0

    # Перебираємо всі можливі квадрати
    for x1 in range(N):  # Ліва верхня координата x
        for y1 in range(N):  # Ліва верхня координата y
            for size in range(2, N - max(x1, y1) + 1):  # Розмір квадрата
                x2, y2 = x1 + size - 1, y1 + size - 1  # Нижня права координата
                # Вершини квадрата
                if (grid[x1][y1] == grid[x1][y2] == grid[x2][y1] == grid[x2][y2]):
                    count += 1

    print(count)
