def solve():
    import sys
    input = sys.stdin.read
    data = input().splitlines()

    t = int(data[0])  # Кількість тестів
    results = []
    idx = 1

    for _ in range(t):
        N = int(data[idx])
        idx += 1
        blue_points = []
        red_points = []

        # Зчитуємо координати синіх точок
        for i in range(N):
            x, y = map(int, data[idx].split())
            blue_points.append((x, y, i + 1))  # Додаємо індекс точки
            idx += 1

        # Зчитуємо координати червоних точок
        for i in range(N):
            x, y = map(int, data[idx].split())
            red_points.append((x, y, i + 1))  # Додаємо індекс точки
            idx += 1

        # Сортуємо точки за x, потім за y
        blue_points.sort()
        red_points.sort()

        # З'єднуємо послідовно точки
        solution = []
        for i in range(N):
            bx, by, b_idx = blue_points[i]
            rx, ry, r_idx = red_points[i]
            solution.append((b_idx, r_idx))

        results.append("\n".join(f"{b} {r}" for b, r in solution))

    # Виводимо результати
    sys.stdout.write("\n\n".join(results) + "\n")
