def count_squares(matrix, n):
    total_squares = 0

    # Перевірка квадратів різного розміру
    for size in range(2, n):  # Розмір квадратів (від 1x1 до NxN)
        for i in range(n - size):  # Перебір рядків
            for j in range(n - size):  # Перебір колонок
                # Вершини квадрата
                top_left = matrix[i][j]
                top_right = matrix[i][j + size]
                bottom_left = matrix[i + size][j]
                bottom_right = matrix[i + size][j + size]

                # Якщо всі вершини однакового кольору
                if top_left == top_right == bottom_left == bottom_right:
                    total_squares += 1

    return total_squares

# Зчитування вхідних даних
n = int(input())
matrix = [list(map(int, input().split())) for _ in range(n)]

# Виведення результату
print(count_squares(matrix, n))
