def count_squares(matrix, n):
    total_squares = 0


    for size in range(1, n):
        for i in range(n - size):
            for j in range(n - size):

                top_left = matrix[i][j]
                top_right = matrix[i][j + size]
                bottom_left = matrix[i + size][j]
                bottom_right = matrix[i + size][j + size]

                if top_left == top_right == bottom_left == bottom_right:
                    total_squares += 1

    return total_squares


n = int(input())
matrix = [list(map(int, input().split())) for _ in range(n)]

print(count_squares(matrix, n))
