def solve():
    t = int(input())  # Кількість блоків тестових даних
    results = []
    
    for _ in range(t):
        N = int(input())  # Кількість точок одного кольору
        blue_points = []
        red_points = []
        
        # Зчитуємо сині точки
        for i in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y, i + 1))  # Зберігаємо також індекс (нумерація з 1)
        
        # Зчитуємо червоні точки
        for i in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y, i + 1))  # Зберігаємо також індекс (нумерація з 1)
        
        # Сортуємо точки за координатою x
        blue_points.sort()
        red_points.sort()
        
        # Формуємо пари
        pairs = []
        for i in range(N):
            pairs.append((blue_points[i][2], red_points[i][2]))  # Використовуємо індекси точок
        
        results.append(pairs)
    
    # Виводимо результати
    for result in results:
        if result:
            for blue, red in result:
                print(blue, red)
        else:
            print(0)

# Виклик функції
solve()
