#include <stdio.h>
#include <limits.h>

#define MAX_N 100000

int main() {
    int n;
    scanf("%d", &n);

    int a[MAX_N];
    int count[MAX_N] = {0};
    int min_val = INT_MAX;
    int min_idx = -1;

    for (int i = 0; i < n; i++) {
        scanf("%d", &a[i]);
        count[a[i]]++;
    }

    for (int i = 0; i < n; i++) {
        if (count[a[i]] == 1 && a[i] < min_val) {
            min_val = a[i];
            min_idx = i;
        }
    }

    if (min_idx == -1) {
        printf("-1\n");
    } else {
        printf("%d\n", a[min_idx]);
    }

    return 0;
}
