from collections import deque

def meet_time(N):
    # Черга для пошуку (пара - (поточна позиція Аліси, поточна позиція Боба, час))
    queue = deque([(1, N, 0)])
    visited = set([(1, N)])

    while queue:
        alice, bob, time = queue.popleft()

        # Якщо Аліса і Боб знаходяться в одному боксі
        if alice == bob:
            return time

        # Можливі переміщення Аліси
        for a_move in [2, 3]:
            new_alice = alice + a_move
            if new_alice <= N and (new_alice, bob) not in visited:
                visited.add((new_alice, bob))
                queue.append((new_alice, bob, time + 1))

        # Можливі переміщення Боба
        for b_move in [1, 2]:
            new_bob = bob - b_move
            if new_bob >= 1 and (alice, new_bob) not in visited:
                visited.add((alice, new_bob))
                queue.append((alice, new_bob, time + 1))

    # Якщо неможливо зустрітися
    return -1

# Вхідні дані
N = int(input())

# Виведення результату
print(meet_time(N))
