def count_squares(N, grid):
    count = 0
    for i in range(N - 1):  # Перебираємо всі можливі координати верхнього лівого кута
        for j in range(N - 1):
            # Перевіряємо всі можливі квадрати з верхнім лівим кутом (i, j)
            if grid[i][j] == grid[i + 1][j] == grid[i][j + 1] == grid[i + 1][j + 1]:
                count += 1
    return count

# Вхідні дані
N = int(input())  # Вводимо розмір квадрата
grid = [list(map(int, input().split())) for _ in range(N)]  # Вводимо матрицю

# Виведення результату
print(count_squares(N, grid))


