#include <bits/stdc++.h>
using namespace std;

struct Tcoord
{
    int row, col;
};

bool arr[55][55] = {0};

void in_arr(int n)
{
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= n; ++j)
            cin >> arr[i][j];
    }
}

long long cnt = 0;

bool check_square(int i, int j, int row, int col, int n)
{
    if (arr[i][j] != arr[row][col])
        return false;
    int ux = row - i;
    int uy = col - j;

    Tcoord p1, p2;
    p1 = {row + uy, col - ux};
    p2 = {i - ux, j + uy};

    if (p1.row < 1 || p1.row > n || p2.row < 1 || p2.row > n)
        return false;
    if (p1.col < 1 || p1.col > n || p2.col < 1 || p2.col > n)
        return false;

    if (arr[p1.row][p1.col] == arr[row][col] && arr[p2.row][p2.col] == arr[row][col])
        return true;
    return false;
}

void func(int n)
{
    for (int row = n; row > 1; --row)
    {
        for (int col = n; col > 1; --col)
        {
            for (int i = 1; i <= row; ++i)
            {
                for (int j = 1; j < col; ++j)
                {
                    if (check_square(i, j, row, col, n))
                        ++cnt;
                }
            }
        }
    }

}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    in_arr(n);
    func(n);
    cout << cnt + 1 << '\n';

    return 0;
}
