from collections import deque

def min_time_to_meet(N):
    queue = deque([(1, N, 0)])     
    visited = set([(1, N)])
    while queue:
        alice, bob, time = queue.popleft()
        if alice == bob:
            return time        
        for new_a in [alice + 2, alice + 3]:
            if 1 <= new_a <= N:  

                for new_b in [bob - 1, bob - 2]:
                    if 1 <= new_b <= N: 
                        if (new_a, new_b) not in visited:
                            visited.add((new_a, new_b))
                            queue.append((new_a, new_b, time + 1))
    
    return -1
N = int(input())
print(min_time_to_meet(N))
