#include <bits/stdc++.h>
using namespace std;

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    
    int N;
    cin >> N;
    

    vector<uint64_t> rows(N, 0);
    
    for(int y = 0; y < N; ++y){
        for(int x = 0; x < N; ++x){
            int c;
            cin >> c;
            if(c){
                rows[y] |= (1ULL << x);
            }
        }
    }
    
    int countSquares = 0;
    
    for(int d = 1; d < N; ++d){

        for(int y = 0; y + d < N; ++y){
            uint64_t row_top = rows[y];
            uint64_t row_bottom = rows[y + d];
            for(int x = 0; x + d < N; ++x){
                bool bit1 = (row_top >> x) & 1;
                bool bit2 = (row_top >> (x + d)) & 1;
                bool bit3 = (row_bottom >> x) & 1;
                bool bit4 = (row_bottom >> (x + d)) & 1;
                
                if( (bit1 == bit2) && (bit1 == bit3) && (bit1 == bit4) ){
                    countSquares++;
                }
            }
        }
    }
    
    cout << countSquares;
    
    return 0;
}