#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int N;
    cin >> N;
    vector<vector<int>> color(N, vector<int>(N));

    for (int y = 0; y < N; ++y) {
        for (int x = 0; x < N; ++x) {
            cin >> color[y][x];
        }
    }

    int countSquares = 0;

    for (int y = 0; y < N; ++y) {
        for (int x = 0; x < N; ++x) {
            for (int d = 1; x + d < N && y + d < N; ++d) {
                int c = color[y][x];
                if (color[y][x + d] == c && 
                    color[y + d][x] == c && 
                    color[y + d][x + d] == c) {
                    countSquares++;
                }
            }
        }
    }

    cout << countSquares+1 << "\n";

    return 0;
}