#include <bits/stdc++.h>
using namespace std;

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    
    int N;
    cin >> N;
    
    // Використовуємо 2D вектор для зберігання кольорів
    // color[y][x], де y від 0 (нижній рядок) до N-1 (верхній рядок)
    vector<vector<int>> color(N, vector<int>(N, 0));
    
    // Зчитуємо рядки введення. Перший рядок входу відповідає y = N-1 (верхній рядок)
    for(int y = N-1; y >=0; --y){
        for(int x =0; x < N; ++x){
            cin >> color[y][x];
        }
    }
    
    int countSquares =0;
    
    // Перебір всіх можливих квадратів
    for(int d =1; d <N; ++d){ // довжина сторони квадрата
        for(int y =0; y + d <N; ++y){
            for(int x =0; x + d <N; ++x){
                // Перевіряємо чотири вершини квадрата
                int c = color[y][x];
                if(color[y][x + d] == c && 
                   color[y + d][x] == c && 
                   color[y + d][x + d] == c){
                       countSquares++;
                }
            }
        }
    }
    
    cout << countSquares;
    
    return 0;
}