#include <bits/stdc++.h>
using namespace std;

// Структура для зберігання координат та індексу точки
struct Point {
    int x, y, index;
};

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);

    int t; // Кількість тестів
    cin >> t;

    while(t--){
        int N;
        cin >> N;

        vector<Point> blue(N);
        vector<Point> red(N);

        // Читаємо сині точки
        for(int i=0; i<N; ++i){
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i+1;
        }

        // Читаємо червоні точки
        for(int i=0; i<N; ++i){
            cin >> red[i].x >> red[i].y;
            red[i].index = i+1;
        }

        // Сортуємо сині точки за x, потім за y
        sort(blue.begin(), blue.end(), [&](const Point &a, const Point &b) -> bool{
            if(a.x != b.x) return a.x < b.x;
            return a.y < b.y;
        });

        // Сортуємо червоні точки за x, потім за y
        sort(red.begin(), red.end(), [&](const Point &a, const Point &b) -> bool{
            if(a.x != b.x) return a.x < b.x;
            return a.y < b.y;
        });

        // Формуємо відповідність
        // З'єднуємо i-ту синю точку з i-тою червоною точкою
        bool possible = true;
        // Ми припускаємо, що відповідність завжди можлива завдяки сортуванню

        // Виводимо відповідність
        if(possible){
            for(int i=0; i<N; ++i){
                cout << blue[i].index << " " << red[i].index << "\n";
            }
        }
        else{
            cout << "0\n";
        }
    }

    return 0;
}