#include <bits/stdc++.h>
using namespace std;


struct Point {
    int x;
    int y;
    int index; 
};


bool comparePoints(const Point &a, const Point &b) {
    if (a.x != b.x)
        return a.x < b.x;
    return a.y < b.y;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    
    int t;
    cin >> t;
    
    while(t--){
        int N;
        cin >> N;
        

        vector<Point> blue(N);
        for(int i=0; i<N; ++i){
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i+1; 
        }
        

        vector<Point> red(N);
        for(int i=0; i<N; ++i){
            cin >> red[i].x >> red[i].y;
            red[i].index = i+1; 
        }
        

        sort(blue.begin(), blue.end(), comparePoints);
        sort(red.begin(), red.end(), comparePoints);
        

        vector<pair<int, int>> matching;
        matching.reserve(N);
        for(int i=0; i<N; ++i){
            matching.emplace_back(blue[i].index, red[i].index);
        }

        for(auto &[b, r] : matching){
            cout << b << " " << r << "\n";
        }
    }
    
    return 0;
}