#include <iostream>
#include <unordered_set>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int N;
    cin >> N;

    vector<int> numbers(N);
    for (int i = 0; i < N; ++i) {
        cin >> numbers[i];
    }

    unordered_set<int> uniqueNumbers;
    for (int num : numbers) {
        uniqueNumbers.insert(num);
    }

    if (uniqueNumbers.size() == N) {
        int minNumber = *min_element(uniqueNumbers.begin(), uniqueNumbers.end());
        cout << minNumber << endl;
    } else {
        cout << -1 << endl;
    }

    return 0;
}
