import math

N = int(input())
matrix = []
for _ in range(N):
    row = input()
    rowtranslated = []
    for i in row.split():
        rowtranslated.append(int(i))
    matrix.append(rowtranslated)

def isvalidsquare(X, Y, size, angle):
    corners = [
        (X, Y),
        (X + size, Y),
        (X, Y + size),
        (X + size, Y + size)
    ]
    
    rotatedcorners = []
    for x, y in corners:
        x_rot = X + (x - X) * math.cos(angle) - (y - Y) * math.sin(angle)
        y_rot = Y + (x - X) * math.sin(angle) + (y - Y) * math.cos(angle)
        rotatedcorners.append((x_rot, y_rot))
    
    bit_value = None
    for x, y in rotatedcorners:
        if not (0 <= x < N - 1 and 0 <= y < N - 1):
            return False
        current_bit = matrix[int(round(y))][int(round(x))]
        if bit_value is None:
            bit_value = current_bit
        elif current_bit != bit_value:
            return False

    return True


squares = 0
for x in range(0, N):
    for y in range(0, N):
        for size in range(1,5):
            for angle in range(0,90,5):
                if isvalidsquare(x, y, size, angle):
                    squares += 1

print(squares)