def find_stamps(N, M):
    total_sum = N * (N + 1) // 2  # максимальна сума марок від 1 до N
    if M > total_sum:  # Якщо сума перевищує максимальну можливу суму
        return [0]
    
    result = []
    for i in range(N, 0, -1):  # Перевіряємо марки від N до 1
        if M >= i:  # Якщо поточну марку можна додати
            result.append(i)
            M -= i
        if M == 0:  # Якщо ми досягли потрібної суми
            break

    if M == 0:
        return result
    else:
        return [0]

# Читання вхідних даних
N = int(input())  # Кількість марок
M = int(input())  # Необхідна сума

# Виведення результату
result = find_stamps(N, M)
print(" ".join(map(str, result)))
