#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
using namespace std;

void find_min_combination(int len, int a, int b, int c) 
{
    vector<int> dp(len + 1, INT_MAX);
    dp[0] = 0; 
    for (int i = 0; i <= len; i++) 
    {
        if (dp[i] != INT_MAX) 
        {
            if (i + a <= len) dp[i + a] = min(dp[i + a], dp[i] + 1);
            if (i + b <= len) dp[i + b] = min(dp[i + b], dp[i] + 1);
            if (i + c <= len) dp[i + c] = min(dp[i + c], dp[i] + 1);
        }
    }
    if (dp[len]!=INT_MAX) 
    {
        cout << dp[len];
    } 
    else 
    {
        cout << "-1";
    }
}

int main() 
{
    int len;
    cin >> len;
    find_min_combination(len, 3, 4, 5);
    return 0;
}
