n = int(input())
print ("%d %d\n" % (n/10, n%10))
from collections import deque

def min_time_to_meet(N):
    # Черги для Аліси та Боба
    alice_positions = deque([1])  # Аліса починає з позиції 1
    bob_positions = deque([N])    # Боб починає з позиції N
    
    # Сети для відслідковування, в яких вже були
    alice_visited = set([1])
    bob_visited = set([N])
    
    # Лічильники секунд
    seconds = 0
    
    # Процес пошуку
    while alice_positions and bob_positions:
        seconds += 1
        # Аліса рухається
        for _ in range(len(alice_positions)):
            position = alice_positions.popleft()
            for move in [2, 3]:
                new_pos = position + move
                if new_pos <= N and new_pos not in alice_visited:
                    alice_visited.add(new_pos)
                    alice_positions.append(new_pos)
                    # Перевірка перетину
                    if new_pos in bob_visited:
                        return seconds
        
        # Боб рухається
        for _ in range(len(bob_positions)):
            position = bob_positions.popleft()
            for move in [1, 2]:
                new_pos = position - move
                if new_pos >= 1 and new_pos not in bob_visited:
                    bob_visited.add(new_pos)
                    bob_positions.append(new_pos)
                    # Перевірка перетину
                    if new_pos in alice_visited:
                        return seconds
    
    return -1  # Якщо не знайшли спільної позиції

# Вхідні дані
N = int(input())

# Виведення результату
print(min_time_to_meet(N))

