n = int(input())
print ("%d %d\n" % (n/10, n%10))
def min_time_to_meet(N):
    # Черга для Аліси і Боба
    alice_set = {1}  # Аліса починає з 1
    bob_set = {N}    # Боб починає з N
    
    # Лічильник секунд
    seconds = 0
    
    # Процес пошуку
    while alice_set and bob_set:
        seconds += 1
        
        # Рух Аліси: додаємо нові можливі позиції, де Аліса може опинитись
        next_alice = set()
        for pos in alice_set:
            next_alice.add(pos + 2)
            next_alice.add(pos + 3)
        alice_set = next_alice
        
        # Рух Боба: додаємо нові можливі позиції, де Боб може опинитись
        next_bob = set()
        for pos in bob_set:
            next_bob.add(pos - 1)
            next_bob.add(pos - 2)
        bob_set = next_bob
        
        # Перевірка перетину
        if alice_set & bob_set:
            return seconds
    
    return -1  # Якщо не знайшли спільної позиції

# Вхідні дані
N = int(input())

# Виведення результату
print(min_time_to_meet(N))

