#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n;
    cin >> n;

    vector<vector<int>> grid(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> grid[i][j];
        }
    }

    int count = 0;
    for (int i = 0; i < n - 1; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            int color = grid[i][j];
            for (int size = 2; i + size - 1 < n && j + size - 1 < n; ++size) {
                bool isSquare = true;
                for (int k = i; k < i + size && isSquare; ++k) {
                    for (int l = j; l < j + size && isSquare; ++l) {
                        if (grid[k][l] != color) {
                            isSquare = false;
                            break;
                        }
                    }
                }
                if (isSquare) {
                    count++;
                }
            }
        }
    }

    cout << count << endl;

    return 0;
}