#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

double dist(int x1, int y1, int x2, int y2) {
    return sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
}

int countSquares(const vector<vector<int>>& grid) {
    int n = grid.size();
    int count = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            for (int k = 0; k < n; ++k) {
                for (int l = k; l < n; ++l) {
                    if (i == k && j == l) continue; // пропускаємо однакові точки
                    double d1 = dist(i, j, k, l);
                    double d2 = dist(i, k, j, l);
                    double d3 = dist(i, j, i + k - l, j + l - k);
                    double d4 = dist(i, k, i + l - k, j + k - l);
                    if (d1 == d2 && d1 == d3 && d1 == d4) {
                        count++;
                    }
                }
            }
        }
    }

    return count;
}

int main() {
    // ... ваш код для введення даних
    cout << countSquares(grid) << endl;
    return 0;
}