N = int(input())
numbers = list(map(int, input().split()))

def find_president(N, numbers):
    from collections import Counter

    count = Counter(numbers)
    unique_minimum = float('inf')
    president_number = -1

    for number in numbers:
        if count[number] == 1 and number < unique_minimum:
            unique_minimum = number
            president_number = number

    if unique_minimum == float('inf'):
        return -1
    else:
        return president_number

president = find_president(N, numbers)
print(president)