def find_president(n, numbers):
    from collections import Counter
    number_counts = Counter(numbers)
    unique_numbers = [num for num, count in number_counts.items() if count == 1]
    if not unique_numbers:
        return -1  
    return min(unique_numbers)

n = int(input())
numbers = list(map(int, input().split()))
result = find_president(n, numbers)
print(result)