import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int N = sc.nextInt();
        HashMap<Integer, Integer> frequency = new HashMap<>();
        int num;
        for (int i = 0; i < N; ++i) {
            num = sc.nextInt();
            frequency.put(num, frequency.getOrDefault(num, 0) + 1);
        }
        int minUnique = Integer.MAX_VALUE;
        for (Map.Entry<Integer, Integer> entry : frequency.entrySet()) {
            if (entry.getValue() == 1 && entry.getKey() < minUnique) {
                minUnique = entry.getKey();
            }
        }
        if (minUnique == Integer.MAX_VALUE) {
            System.out.println(-1);
        } else {
            System.out.println(minUnique);
        }
        sc.close();
    }
}