#include <iostream>
#include <unordered_map>
#include <climits>

using namespace std;

int main() {
    int N;
    cin >> N;

    unordered_map<int, int> frequency;
    int num;

    for (int i = 0; i < N; ++i) {
        cin >> num;
        frequency[num]++;
    }

    int minUnique = INT_MAX;

    for (auto& pair : frequency) {
        if (pair.second == 1 && pair.first < minUnique) {
            minUnique = pair.first;
        }
    }

    if (minUnique == INT_MAX) {
        cout << -1 << endl;
    } else {
        cout << minUnique << endl;
    }

    return 0;
}