#include <iostream>
#include <vector>
using namespace std;

void findStamps(int N, int M) {
    vector<int> result;
    
    for (int mask = 0; mask < (1 << N); ++mask) {
        int sum = 0;
        vector<int> current;
        
        for (int i = 0; i < N; ++i) {
            if (mask & (1 << i)) {
                sum += (i + 1);
                current.push_back(i + 1);
            }
        }

        if (sum == M) {
            if (result.empty() || current.size() < result.size()) {
                result = current;
            }
        }
    }

    if (result.empty()) {
        cout << 0 << endl;
    } else {
        for (int stamp : result) {
            cout << stamp << endl;
        }
    }
}

int main() {
    int N, M;
    cin >> N >> M;
    findStamps(N, M);
    return 0;
}
