#include <iostream>
#include <vector>
using namespace std;

int countSameColorSquares(int N, vector<vector<int>>& grid) {
    int count = 0;
    for (int size = 2; size <= N; ++size) {
        for (int i = 0; i <= N - size; ++i) {
            for (int j = 0; j <= N - size; ++j) {
                int color = grid[i][j];
                if (grid[i + size - 1][j] == color &&
                    grid[i][j + size - 1] == color &&
                    grid[i + size - 1][j + size - 1] == color) {
                    count++;
                }
            }
        }
    }

    return count;
}

int main() {
    int N;
    cin >> N;
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }
    cout << countSameColorSquares(N, grid) << "\n";
    return 0;
}
