#include <iostream>
#include <vector>

using namespace std;

int main() {
    int N;
    cin >> N;
    
    vector<vector<int>> grid(N, vector<int>(N));
    for(int y = 0; y < N; y++) {
        for(int x = 0; x < N; x++) {
            cin >> grid[y][x];
        }
    }
    
    int count = 0;
    
    for(int s = 1; s < N; s++) {
        for(int x = 0; x < N - s; x++) {
            for(int y = 0; y < N - s; y++) {
                if(grid[y][x] == grid[y][x+s] && grid[y][x+s] == grid[y+s][x+s] && grid[y+s][x+s] == grid[y+s][x]) {
                    count++;
                }
            }
        }
    }
    
    cout << count << endl;
    
    return 0;
}