#include <iostream>
#include <vector>

using namespace std;

int main() {
    int N;
    cin >> N;
    vector<vector<int>> grid(N, vector<int>(N));
    
    for(int y = 0; y < N; y++) {
        for(int x = 0; x < N; x++) {
            cin >> grid[y][x];
        }
    }
    
    int count = 0;
    
    for(int size = 1; size < N; size++) {
        for(int x = 0; x + size < N; x++) {
            for(int y = 0; y + size < N; y++) {
                if(grid[y][x] == grid[y][x + size] && 
                   grid[y][x + size] == grid[y + size][x + size] && 
                   grid[y + size][x + size] == grid[y + size][x]) {
                    count++;
                }
                if(grid[y][x] == grid[y + size][x] && 
                   grid[y + size][x] == grid[y + size][x + size] && 
                   grid[y + size][x + size] == grid[y][x + size]) {
                    count++;
                }
            }
        }
    }
    
    cout << count << endl;
    
    return 0;
}
