#include <iostream>
#include <algorithm>  // Для std::gcd

using namespace std;

// Функція для обчислення найменшого спільного кратного (LCM)
long long lcm(long long a, long long b) {
    return (a * b) / gcd(a, b);
}

int main() {
    long long N, A, B;
    cin >> N >> A >> B;

    // Кількість чисел, що діляться на A, B і LCM(A, B)
    long long countA = N / A;
    long long countB = N / B;
    long long countAB = N / lcm(A, B);

    // Результат
    long long result = countA + countB - countAB;

    cout << result << endl;
    
    return 0;
}
