def meet_in_one_box(N):
    # Початкові позиції
    alice_pos = {1}
    bob_pos = {N}
    
    # Лічильник секунд
    t = 0
    
    # Встановлюємо максимальний ліміт кроків
    while t < N:
        t += 1
        
        # Нові позиції після t секунд
        new_alice_pos = set()
        new_bob_pos = set()
        
        # Рух Аліси: можливі кроки 2 та 3
        for pos in alice_pos:
            if pos + 2 <= N:
                new_alice_pos.add(pos + 2)
            if pos + 3 <= N:
                new_alice_pos.add(pos + 3)
        
        # Рух Боба: можливі кроки -1 та -2
        for pos in bob_pos:
            if pos - 1 >= 1:
                new_bob_pos.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_pos.add(pos - 2)
        
        # Перевіряємо перетин
        if new_alice_pos & new_bob_pos:
            return t
        
        # Оновлюємо позиції
        alice_pos = new_alice_pos
        bob_pos = new_bob_pos
        
        # Якщо немає нових можливих позицій для одного з роботів
        if not alice_pos or not bob_pos:
            break
    
    return -1

# Зчитуємо вхідні дані
N = int(input())

# Викликаємо функцію для знаходження мінімального часу зустрічі
result = meet_in_one_box(N)

# Виводимо результат
print(result)
