#include <iostream>
#include <vector>
using namespace std;

void solve() {
    int N, M;
    cin >> N >> M;

    // Максимальна можлива сума
    int max_sum = N * (N + 1) / 2;

    // Якщо M перевищує максимальну можливу суму, неможливо досягти цієї суми
    if (M > max_sum) {
        cout << 0 << endl;
        return;
    }

    vector<int> result;

    // Починаємо з найбільших марок
    for (int i = N; i >= 1; i--) {
        if (M >= i) {
            result.push_back(i);  // Додаємо марку i до вибору
            M -= i;  // Зменшуємо залишок суми
        }
        if (M == 0) break;  // Якщо сума M досягнута, зупиняємось
    }

    // Якщо сума не дорівнює 0, це означає, що ми не змогли скласти точну суму
    if (M > 0) {
        cout << 0 << endl;
    } else {
        for (int i = 0; i < result.size(); i++) {
            cout << result[i] << " ";
        }
        cout << endl;
    }
}

int main() {
    solve();
    return 0;
}
