def find_stamps(N, M):
    # Найбільша можлива сума марок від 1 до N
    total_sum = N * (N + 1) // 2
    
    # Якщо сума всіх марок менше за M, неможливо вибрати
    if total_sum < M:
        return [0]
    
    result = []
    
    # Починаємо з найбільших марок і віднімаємо їх від M
    for i in range(N, 0, -1):
        if M >= i:
            result.append(i)
            M -= i
        if M == 0:
            break
    
    # Якщо після всіх операцій сума не дорівнює нулю, повертаємо 0
    if M > 0:
        return [0]
    
    return sorted(result)

# Зчитуємо вхідні дані
N = int(input())
M = int(input())

# Викликаємо функцію для знаходження марок
result = find_stamps(N, M)

# Виводимо результат
print(*result)
