def count_same_color_squares(N, grid):
    count = 0
    
    # Перебираємо всі можливі розміри квадратів (від 2x2 до NxN)
    for size in range(1, N):  # розмір квадрата від 1 до N-1
        for i in range(N - size):
            for j in range(N - size):
                # Вершини квадрата з верхнім лівим кутом (i, j) і розміром size
                color = grid[i][j]
                # Перевірка всіх 4 вершин квадрата
                if (grid[i][j] == grid[i + size][j] == grid[i][j + size] == grid[i + size][j + size]):
                    count += 1
    
    return count

# Читання входу
N = int(input())  # сторона квадрата
grid = [list(map(int, input().split())) for _ in range(N)]

# Обчислення результату
result = count_same_color_squares(N, grid)

# Виведення результату
print(result)
