def count_squares(N, grid):
    count = 0
    
    # Перебираємо всі можливі квадрати
    for size in range(1, N):  # size - це розмір квадрата від 1 до N-1
        for i in range(N - size):  # i - початок квадрата по вертикалі
            for j in range(N - size):  # j - початок квадрата по горизонталі
                # Перевіряємо чи всі чотири вершини квадрата однакового кольору
                if (grid[i][j] == grid[i + size][j] == grid[i][j + size] == grid[i + size][j + size]):
                    count += 1
                    
    return count

# Вхід
N = int(input())  # Розмір квадрата
grid = [list(map(int, input().split())) for _ in range(N)]

# Виведення результату
print(count_squares(N, grid))
