def count_squares(N, grid):
    count = 0
    
    # Перебираємо всі можливі розміри квадратів (від 1x1 до (N-1)x(N-1))
    for size in range(1, N):  # розмір квадрата від 1 до N-1
        for i in range(N - size):  # i - початок квадрата по вертикалі
            for j in range(N - size):  # j - початок квадрата по горизонталі
                # Вершини квадрата (i, j) - верхній лівий кут
                # Перевіряємо всі чотири вершини квадрата
                if (grid[i][j] == grid[i + size][j] == grid[i][j + size] == grid[i + size][j + size]):
                    count += 1
    
    return count

# Вхід
N = int(input())  # Розмір квадрата
grid = [list(map(int, input().split())) for _ in range(N)]

# Виведення результату
print(count_squares(N, grid))
