def solve_test_case(N, blue_points, red_points):
    # Сортуємо точки за x, а якщо x рівні, то за y
    blue_sorted = sorted(enumerate(blue_points, start=1), key=lambda p: (p[1][0], p[1][1]))
    red_sorted = sorted(enumerate(red_points, start=1), key=lambda p: (p[1][0], p[1][1]))
    
    # Виводимо пари точок, з'єднуючи синю точку з червоною
    for i in range(N):
        print(blue_sorted[i][0], red_sorted[i][0])

def main():
    t = int(input())  # Кількість тестових блоків
    for _ in range(t):
        N = int(input())  # Кількість точок одного кольору
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().split())) for _ in range(N)]
        
        solve_test_case(N, blue_points, red_points)

if __name__ == "__main__":
    main()
