type Tmas = array[1..10000] of longint;
procedure read_mas(var A:Tmas; var n:longint);
var i:longword;
begin
    read(n);
    for i := 1 to n do
        read(A[i]);
end;

procedure swap(var X,Y:longint);
var temp:longint;
begin
    temp := X;
    X := Y;
    Y := temp;
end;

procedure bubble_sort(var mas:Tmas; n:longint);
var i,j:longint;
begin
    for i := 1 to n - 1 do
        for j := n - 1 downto 1 do
            if (mas[j] < mas[j+1]) then
                swap(mas[j],mas[j+1]);
end;

function elections(var m:Tmas; n:longint):longint;
var i,temp_elect:longint;
begin
    temp_elect := -1;
    for i := 2 to n - 1 do
        if ((m[i-1] <> m[i]) and (m[i] <> m[i+1])) then
            temp_elect := m[i];
    if m[n-1] <> m[n] then
                temp_elect := m[n];
    if (m[n] <> m[n - 1]) then
        temp_elect := m[n];
    elections := temp_elect;
end;

var mas:Tmas; n:longint;
begin
    read_mas(mas,n);
    bubble_sort(mas,n);
    writeln(elections(mas,n));
end.