type Tmas = array [1..50,1..50] of byte;
procedure read_mas(var A:Tmas; var n:byte);
var i,j:byte;
begin
    read(n);
    for i := 1 to n do
        for j := 1 to n do
            read(A[i,j]);
end;

function same_color(var grid:Tmas; x1, y1, x2, y2, x3, y3, x4, y4:byte):boolean;
begin
    if (grid[x1, y1] = grid[x1, y2]) and 
        (grid[x1, y1] = grid[x2, y1]) and
        (grid[x1, y1] = grid[x2, y2]) and  
        (grid[x1, y1] = grid[x1, y3]) and
        (grid[x1, y1] = grid[x3, y1]) and 
        (grid[x1, y1] = grid[x2, y3]) and 
        (grid[x1, y1] = grid[x3, y2]) and 
        (grid[x1, y1] = grid[x3, y3]) and 
        (grid[x1, y1] = grid[x1, y4]) and 
        (grid[x1, y1] = grid[x4, y1]) and
        (grid[x1, y1] = grid[x4, y2]) and
        (grid[x1, y1] = grid[x4, y3]) and
        (grid[x1, y1] = grid[x4, y4]) and
        (grid[x1, y1] = grid[x2, y4]) and
        (grid[x1, y1] = grid[x3, y4]) and//}
        (grid[x1, y1] = grid[x4, y4]) then        
        same_color := true
    else
        same_color := false;
end;

var A:Tmas; n,cnt,i,j,x,y,size:byte;
begin
    read_mas(A,n);
    cnt := 0;
    for x := 1 to n do
        for y := 1 to n do
            for size := 1 to n div 2 do
                begin
                    if (x - size >= 1) and (x + size <= n) and (y - size >= 1) and (y + size <= n) then
                        if same_color(A, x - size, y, x, y-size, x+size, y, x, y+size) then
                            inc(cnt);
                end;
    writeln(cnt);
end.