type
    Tmas = array[1..50, 1..50] of byte;

procedure read_mas(var A: Tmas; var n: byte);
var
    i, j: byte;
begin
    read(n);
    for i := 1 to n do
        for j := 1 to n do
            read(A[i, j]);
end;

function same_color(var grid: Tmas; x1, y1, x2, y2: byte): boolean;
begin
    if (grid[x1, y1] = grid[x1, y2]) and
       (grid[x1, y1] = grid[x2, y1]) and
       (grid[x1, y1] = grid[x2, y2]) then
        same_color := true
    else
        same_color := false;
end;

function same_color_rotated(var grid: Tmas; x, y, size: byte): boolean;
var
    cx, cy: integer;
begin
    cx := x + (size div 2);
    cy := y + (size div 2);
    if (grid[x, y] = grid[cx, cy - (y - cy)]) and
       (grid[x, y] = grid[cx + (x - cx), cy]) and
       (grid[x, y] = grid[cx, cy + (y - cy)]) and
       (grid[x, y] = grid[cx - (x - cx), cy]) then
        same_color_rotated := true
    else
        same_color_rotated := false;
end;

var
    A: Tmas;
    n, counter, i, j, k, l, m: byte;
begin
    read_mas(A, n);
    counter := 0;

    for i := 0 to n - 1 do
        for j := 0 to n - 1 do
            for l := 1 to n - 1 do
                if (i + l < n) and (j + l < n) then
                    for k := 0 to n - 1 do
                        if (j - k >= 0) and (i + l + k < n) then
                            if same_color(A, i, j, i + l, j + l) then
                                inc(counter)
                            else if same_color_rotated(A, i, j, l) then
                                inc(counter);

    writeln(counter);
end.
