type
    Tmas = array[1..50, 1..50] of byte;

procedure read_mas(var A: Tmas; var n: byte);
var
    i, j: byte;
begin
    read(n);
    for i := 1 to n do
        for j := 1 to n do
            read(A[i, j]);
end;

function same_color(var grid: Tmas; x1, y1, x2, y2: byte): boolean;
begin
    if (grid[x1, y1] = grid[x1, y2]) and
       (grid[x1, y1] = grid[x2, y1]) and
       (grid[x1, y1] = grid[x2, y2]) then
        same_color := true
    else
        same_color := false;
end;

function same_color_rotated(var grid: Tmas; x, y, size,n: byte): boolean;
var
    x1, y1, x2, y2, x3, y3, x4, y4: integer;
begin
    x1 := x - size;
    y1 := y;
    x2 := x;
    y2 := y + size;
    x3 := x + size;
    y3 := y;
    x4 := x;
    y4 := y - size;

    if (x1 > 0) and (x3 <= n) and (y2 <= n) and (y4 > 0) then
        if (grid[x, y] = grid[x1, y1]) and
           (grid[x, y] = grid[x2, y2]) and
           (grid[x, y] = grid[x3, y3]) and
           (grid[x, y] = grid[x4, y4]) then
            same_color_rotated := true
        else
            same_color_rotated := false
    else
        same_color_rotated := false;
end;

var
    A: Tmas;
    n, counter, i, j, l, m: byte;
begin
    read_mas(A, n);
    counter := 0;

    for i := 1 to n do
        for j := 1 to n do
            for l := 1 to n - 1 do
                if (i + l <= n) and (j + l <= n) then
                    if same_color(A, i, j, i + l, j + l) then
                        inc(counter)
                    else if same_color_rotated(A, i, j, l,n) then
                        inc(counter);

    writeln(counter);
end.
