def min_seconds_to_meet(N):
    if N < 2:
        return -1  

    for t in range(1, N):  
        alice_positions = set()
        bob_positions = set()

        
        alice_positions.add(1 + 2 * t)
        alice_positions.add(1 + 3 * t)

        
        bob_positions.add(N - t)
        bob_positions.add(N - 2 * t)

        
        if alice_positions.intersection(bob_positions):
            return t  

    return -1  

N = int(input().strip())
print(min_seconds_to_meet(N))