
def min_seconds_to_meet(N):
    if N < 2:
        return -1
    
    # Перевіримо всі можливі варіанти для t, щоб знайти збіг позицій Alice і Bob
    for t in range(1, N):
        alice_position1 = 1 + 2 * t
        alice_position2 = 1 + 3 * t
        bob_position1 = N - t
        bob_position2 = N - 2 * t

        # Перевірка збігу позицій
        if (alice_position1 == bob_position1 or
            alice_position1 == bob_position2 or
            alice_position2 == bob_position1 or
            alice_position2 == bob_position2):
            return t
    
    return -1

N = int(input().strip())
print(min_seconds_to_meet(N))