def min_seconds_to_meet(N):
    if N < 2:
        return -1
    
    # Перевіряємо всі можливі рівняння для t, щоб знайти найменше t >= 1
    t_values = []
    for formula in [(N - 1) / 3, (N - 1) / 4, (N - 1) / 5]:
        if formula >= 1 and formula.is_integer():
            t_values.append(int(formula))
    
    # Знаходимо найменше значення t, яке задовольняє умову
    if t_values:
        return min(t_values)
    else:
        return -1

N = int(input().strip())
print(min_seconds_to_meet(N))