def min_seconds_to_meet(N):
    if N < 2:
        return -1

    # Обчислюємо можливі значення t для кожного рівняння
    possible_t = []
    for divisor in [3, 4, 5]:
        t = (N - 1) / divisor
        if t >= 1 and t.is_integer():
            possible_t.append(int(t))
    
    # Повертаємо мінімальне значення t, якщо воно є
    return min(possible_t) if possible_t else -1

# Тестування на значення від 1 до 1,000,000
results = []
for N in range(1, 1000001):
    result = min_seconds_to_meet(N)
    if result != -1:
        results.append((N, result))

# Виведення результатів для перевірки
for N, t in results:
    print(f"N = {N}, t = {t}")
