import math

def find_numbers_for_sum(N, M):
    if N > 1000000000 or M > 1000000000:
        return "Невірні данні"
    
    # Перевірка, чи можна скласти M
    total_sum = N * (N + 1) // 2
    if M > total_sum:
        return 0

    result = []
    # Знайдемо найбільше k, таке що k * (k + 1) / 2 <= M
    k = int((-1 + math.sqrt(1 + 8 * M)) // 2)
    
    # Перевірка, чи k не перевищує N
    if k > N:
        k = N
    
    # Обчислення залишкової суми
    current_sum = k * (k + 1) // 2
    remaining_sum = current_sum - M

    # Вибираємо числа від 1 до k, але видаляємо залишкове число, якщо воно є
    result = list(range(1, k + 1))
    if remaining_sum > 0:
        result.remove(remaining_sum)

    return sorted(result)

N = int(input().strip())
M = int(input().strip())
result = find_numbers_for_sum(N, M)

if result == 0:
    print(0)
elif isinstance(result, str):
    print(result)
else:
    print(*result)
