def count_colored_squares(N, color_matrix):
    count = 1
    # Перебираємо всі можливі розміри квадратів від 2x2 до NxN
    for size in range(2, N + 1):  # Починаємо з 2x2
        # Перебираємо всі можливі координати лівого верхнього кута квадрата
        for i in range(N - size + 1):
            for j in range(N - size + 1):
                # Отримуємо координати чотирьох вершин квадрата
                bottom_left = color_matrix[i][j]
                bottom_right = color_matrix[i][j + size - 1]
                top_left = color_matrix[i + size - 1][j]
                top_right = color_matrix[i + size - 1][j + size - 1]
                
                # Перевіряємо, чи всі вершини однакового кольору
                if bottom_left == bottom_right == top_left == top_right:
                    count += 1
                    
    return count

# Зчитування вхідних даних
N = int(input())  # Зчитування розміру квадрата
color_matrix = []
for _ in range(N):
    row = list(map(int, input().split()))  # Зчитування рядка з кольорами
    color_matrix.append(row)

# Виклик функції та виведення результату
result = count_colored_squares(N, color_matrix)
print(result)