def count_red_squares(matrix, N):
    count = 0
    
    for size in range(1, N + 1):
        for i in range(N - size + 1):
            for j in range(N - size + 1):
                
                top_left = matrix[i][j]
                top_right = matrix[i][j + size - 1]
                bottom_left = matrix[i + size - 1][j]
                bottom_right = matrix[i + size - 1][j + size - 1]
                
                
                if top_left == top_right == bottom_left == bottom_right == 1:
                    count += 1
    return count


matrix = [
    [0, 1, 0, 0],
    [0, 0, 1, 1],
    [1, 0, 0, 0],
    [0, 1, 1, 1]
]

N = 4 
print("Кількість квадратів, де всі вершини мають колір 1:", count_red_squares(matrix, N))