def count_colored_squares(N, grid):
    count = 0

    # Перебираємо всі можливі довжини сторони квадрата (від 1 до N-1)
    for side in range(1, N):
        # Перебираємо всі можливі верхні ліві вершини квадрата
        for i in range(N - side):
            for j in range(N - side):
                # Отримуємо координати вершин квадрата
                top_left = grid[i][j]
                top_right = grid[i][j + side]
                bottom_left = grid[i + side][j]
                bottom_right = grid[i + side][j + side]

                # Перевіряємо, чи всі вершини одного кольору
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1

    return count

# Зчитування вхідних даних
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Обчислення і виведення результату
print(count_colored_squares(N, grid))