def count_colored_squares(N, grid):
    count = 0

   
    for side in range(1, N):
        
        for i in range(N - side):
            for j in range(N - side):
                
                top_left = grid[i][j]
                top_right = grid[i][j + side]
                bottom_left = grid[i + side][j]
                bottom_right = grid[i + side][j + side]

                
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1

    return count


N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]


print(count_colored_squares(N, grid))


