from collections import deque

def teleportation_meet(N):
   
    
  
    queue = deque([(1, N, 0)]) 
    visited = set()  
    while queue:
        alice_pos, bob_pos, time = queue.popleft()
        
        if alice_pos == bob_pos:
            return (True, time)
        
        if (alice_pos, bob_pos) in visited:
            continue
        visited.add((alice_pos, bob_pos))
        
        alice_moves = [alice_pos + 2, alice_pos + 3]
        alice_moves = [pos for pos in alice_moves if pos <= N]
        
        bob_moves = [bob_pos - 1, bob_pos - 2]
        bob_moves = [pos for pos in bob_moves if pos > 0]
        
        for a in alice_moves:
            for b in bob_moves:
                queue.append((a, b, time + 1))
    
    
    return (False, -1)

N = 10  
can_meet, min_time = teleportation_meet(N)
if can_meet:
    print(f"Вони можуть зустрітись через {min_time} секунд.")
else:
    print("Вони ніколи не зустрінуться.")