def count_ones(N, A, B):
    """ 
    Рахує кількість одиниць у пам'яті розміром N після тестування 
    із використанням чисел A та B.
    """
    # Встановлюємо всі комірки в 0
    memory = [0] * N
    
    # Проходимо по індексах, які кратні A або B, і записуємо 1
    for i in range(1, N + 1):
        if i % A == 0 or i % B == 0:
            memory[i - 1] = 1  # Індекси в масиві з 0, а комірки нумеруються з 1
    
    # Підраховуємо кількість одиниць
    count = sum(memory)
    
    return count


# Введення даних
N = int(input("Введіть кількість комірок N: "))
A = int(input("Введіть число A: "))
B = int(input("Введіть число B: "))

# Результат
result = count_ones(N, A, B)
print(f"Кількість одиниць у пам'яті: {result}")
