#include <iostream>
#include <queue>
#include <vector>

using namespace std;

int main() {
    int N;
        cin >> N;

            // Якщо кількість боксів менша за 3, то вони можуть зустрітися одразу
                if (N == 2) {
                        cout << 1 << endl;
                                return 0;
                                    }

                                        // Дві черги для Аліси і Боба, які зберігають можливі бокси
                                            queue<int> alice, bob;
                                                alice.push(1);  // Аліса починає з боксів 1
                                                    bob.push(N);    // Боб починає з боксів N

                                                        // Масиви для позначення, чи був бокс вже відвіданий
                                                            vector<bool> visitedAlice(N + 1, false), visitedBob(N + 1, false);
                                                                visitedAlice[1] = true; // Аліса починає з 1
                                                                    visitedBob[N] = true;   // Боб починає з N

                                                                        int seconds = 0;
                                                                            
                                                                                // Поки є бокс, до якого можна дістатися
                                                                                    while (!alice.empty() && !bob.empty()) {
                                                                                            int sizeAlice = alice.size(), sizeBob = bob.size();
                                                                                                    
                                                                                                            // Обробляємо всі варіанти для Аліси на поточній секунді
                                                                                                                    for (int i = 0; i < sizeAlice; ++i) {
                                                                                                                                int currentAlice = alice.front();
                                                                                                                                            alice.pop();
                                                                                                                                                        
                                                                                                                                                                    // Аліса може переміщатися на +2 або +3
                                                                                                                                                                                for (int nextAlice : {currentAlice + 2, currentAlice + 3}) {
                                                                                                                                                                                                if (nextAlice <= N && !visitedAlice[nextAlice]) {
                                                                                                                                                                                                                    visitedAlice[nextAlice] = true;
                                                                                                                                                                                                                                        alice.push(nextAlice);
                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                            }

                                                                                                                                                                                                                                                                                    // Обробляємо всі варіанти для Боба на поточній секунді
                                                                                                                                                                                                                                                                                            for (int i = 0; i < sizeBob; ++i) {
                                                                                                                                                                                                                                                                                                        int currentBob = bob.front();
                                                                                                                                                                                                                                                                                                                    bob.pop();
                                                                                                                                                                                                                                                                                                                                
                                                                                                                                                                                                                                                                                                                                            // Боб може переміщатися на -1 або -2
                                                                                                                                                                                                                                                                                                                                                        for (int nextBob : {currentBob - 1, currentBob - 2}) {
                                                                                                                                                                                                                                                                                                                                                                        if (nextBob >= 1 && !visitedBob[nextBob]) {
                                                                                                                                                                                                                                                                                                                                                                                            visitedBob[nextBob] = true;
                                                                                                                                                                                                                                                                                                                                                                                                                bob.push(nextBob);
                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                    }

                                                                                                                                                                                                                                                                                                                                                                                                                                                            // Перевіряємо, чи є спільні бокси для Аліси та Боба
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    for (int i = 1; i <= N; ++i) {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if (visitedAlice[i] && visitedBob[i]) {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cout << seconds + 1 << endl;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return 0;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }

                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            // Якщо на поточній секунді не знайдено спільного боксу, збільшуємо час
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    seconds++;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }

                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            // Якщо не знайшли спільний бокс
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cout << -1 << endl;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return 0;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    