#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>

using namespace std;

// Визначення орієнтації трьох точок
int orientation(pair<int, int> p, pair<int, int> q, pair<int, int> r) {
    int val = (q.second - p.second) * (r.first - q.first) - (q.first - p.first) * (r.second - q.second);
        if (val == 0)
                return 0;  // Колінеарні
                    return (val > 0) ? 1 : 2;  // 1 - за годинниковою стрілкою, 2 - проти
                    }

                    // Перевірка перетину двох відрізків
                    bool do_intersect(pair<int, int> p1, pair<int, int> q1, pair<int, int> p2, pair<int, int> q2) {
                        int o1 = orientation(p1, q1, p2);
                            int o2 = orientation(p1, q1, q2);
                                int o3 = orientation(p2, q2, p1);
                                    int o4 = orientation(p2, q2, q1);
                                        return o1 != o2 && o3 != o4;
                                        }

                                        vector<pair<int, int>> solve_test_case(int N, vector<pair<int, int>>& blue_points, vector<pair<int, int>>& red_points) {
                                            // Сортуємо точки для попарного з'єднання
                                                vector<pair<int, int>> connections;
                                                    for (int i = 0; i < N; ++i) {
                                                            connections.push_back({i + 1, i + 1});  // Під'єднуємо відповідні точки
                                                                }

                                                                    // Перевіряємо на перетини
                                                                        for (int i = 0; i < N; ++i) {
                                                                                for (int j = i + 1; j < N; ++j) {
                                                                                            pair<int, int> b1 = blue_points[connections[i].first - 1];
                                                                                                        pair<int, int> r1 = red_points[connections[i].second - 1];
                                                                                                                    pair<int, int> b2 = blue_points[connections[j].first - 1];
                                                                                                                                pair<int, int> r2 = red_points[connections[j].second - 1];
                                                                                                                                            if (do_intersect(b1, r1, b2, r2)) {
                                                                                                                                                            return {};  // Якщо відрізки перетинаються, повертаємо порожній вектор
                                                                                                                                                                        }
                                                                                                                                                                                }
                                                                                                                                                                                    }
                                                                                                                                                                                        
                                                                                                                                                                                            return connections;  // Повертаємо з'єднання
                                                                                                                                                                                            }

                                                                                                                                                                                            int main() {
                                                                                                                                                                                                int t;
                                                                                                                                                                                                    cin >> t;
                                                                                                                                                                                                        while (t--) {
                                                                                                                                                                                                                int N;
                                                                                                                                                                                                                        cin >> N;
                                                                                                                                                                                                                                vector<pair<int, int>> blue_points(N), red_points(N);
                                                                                                                                                                                                                                        
                                                                                                                                                                                                                                                // Зчитуємо координати синіх точок
                                                                                                                                                                                                                                                        for (int i = 0; i < N; ++i) {
                                                                                                                                                                                                                                                                    cin >> blue_points[i].first >> blue_points[i].second;
                                                                                                                                                                                                                                                                            }

                                                                                                                                                                                                                                                                                    // Зчитуємо координати червоних точок
                                                                                                                                                                                                                                                                                            for (int i = 0; i < N; ++i) {
                                                                                                                                                                                                                                                                                                        cin >> red_points[i].first >> red_points[i].second;
                                                                                                                                                                                                                                                                                                                }

                                                                                                                                                                                                                                                                                                                        // Сортуємо точки за координатами
                                                                                                                                                                                                                                                                                                                                sort(blue_points.begin(), blue_points.end());
                                                                                                                                                                                                                                                                                                                                        sort(red_points.begin(), red_points.end());

                                                                                                                                                                                                                                                                                                                                                // Отримуємо результат для тесту
                                                                                                                                                                                                                                                                                                                                                        vector<pair<int, int>> result = solve_test_case(N, blue_points, red_points);

                                                                                                                                                                                                                                                                                                                                                                if (result.empty()) {
                                                                                                                                                                                                                                                                                                                                                                            cout << "0\n";  // Якщо неможливо з'єднати без перетинів
                                                                                                                                                                                                                                                                                                                                                                                    } else {
                                                                                                                                                                                                                                                                                                                                                                                                for (auto& conn : result) {
                                                                                                                                                                                                                                                                                                                                                                                                                cout << conn.first << " " << conn.second << "\n";  // Виводимо з'єднання
                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                        }

                                                                                                                                                                                                                                                                                                                                                                                                                                            return 0;
                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                            
