#include <bits/stdc++.h>
using namespace std;

bool square[50][50];
int n;

struct Dot{
    int x, y;

    Dot(int t_x, int t_y){
        x = t_x; y = t_y;
    }
};

void input(){
    cin >> n;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j)
            cin >> square[i][j];
}

int q_on_frame(Dot A, Dot C){
    int res = 0;
    Dot tA(A.x, A.y), tB(A.x, C.y), tC(C.x, C.y), tD(C.x, A.y);

    while (tA.y != C.y){
        res += (square[tA.x][tA.y] == square[tB.x][tB.y] && square[tA.x][tA.y] == square[tC.x][tC.y] && square[tA.x][tA.y] == square[tD.x][tD.y]);
        ++tA.y; --tC.y; ++tB.x; --tD.x;
    }

    return res;
}

int q_on_square(){
    int res = 0;

    for (int side = 1; side < n; ++side)
        for (int i = 0; i < n - side; ++i)
            for (int j = 0; j < n - side; ++j)
                res += q_on_frame({i,j}, {i + side, j + side});
    
    return res;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    input();
    cout << q_on_square() << '\n';

    return 0;
}
