def count_squares(N, grid):
    count = 0
    # Перебираємо всі пари точок (i, j), що є лівим верхнім кутом квадрату
    for x1 in range(N):
        for y1 in range(N):
            for x2 in range(x1 + 1, N):
                for y2 in range(y1 + 1, N):
                    # Перевірка чи чотири точки утворюють квадрат
                    if grid[x1][y1] == grid[x2][y2] and grid[x1][y2] == grid[x2][y1]:
                        count += 1
    return count

# Вхідні дані
N = int(input())  # Розмір матриці
grid = [list(map(int, input().split())) for _ in range(N)]  # Матриця кольорів

# Результат
print(count_squares(N, grid))