from collections import deque

def min_seconds_to_meet(N):

    alice_queue = deque([(1, 0)])  
    bob_queue = deque([(N, 0)])

    alice_visited = set([1])
    bob_visited = set([N])
    
    while alice_queue and bob_queue:

        a_pos, a_time = alice_queue.popleft()
        for next_pos in (a_pos + 2, a_pos + 3):
            if next_pos <= N and next_pos not in alice_visited:
                alice_visited.add(next_pos)
                alice_queue.append((next_pos, a_time + 1))
                if next_pos in bob_visited:
                    return a_time + 1

        b_pos, b_time = bob_queue.popleft()
        for next_pos in (b_pos - 1, b_pos - 2):
            if next_pos >= 1 and next_pos not in bob_visited:
                bob_visited.add(next_pos)
                bob_queue.append((next_pos, b_time + 1))
                if next_pos in alice_visited:
                    return b_time + 1
    
    return -1

print(min_seconds_to_meet(5))  
