def find_stamps(n, m):
    S = n * (n + 1) // 2  # Максимальна сума чисел від 1 до N
    if m > S:
        return [0]  # Якщо сума більша за максимально можливу

    result = []
    current_sum = 0

    # Проходимо по числах від найбільшого до найменшого
    for i in range(n, 0, -1):
        if current_sum + i <= m:
            result.append(i)
            current_sum += i
        if current_sum == m:
            break

    # Якщо ми досягли потрібної суми, повертаємо результат
    if current_sum == m:
        return sorted(result)
    else:
        return [0]  # Якщо неможливо досягти суми M


# Введення даних
n = int(input("Кількість марок: "))
m = int(input("Загальна вартість: "))

# Виведення результату
result = find_stamps(n, m)
print(*result)