def find_stamps(n: int, m: int) -> str:
    if m <= n:
        return " ".join(str(i) for i in range(1, m + 1))
    remainders = {}
    for i in range(1, n + 1):
        remainder = m % i
        if remainder == 0:
            return str(i)
        if remainder not in remainders:
            remainders[remainder] = i
    for i in range(1, n + 1):
        for j in range(i + 1, n + 1):
            if (m - i) % j == 0 or (m - j) % i == 0:
                return f"{i} {j}"

    return "0"
n = int(input())
m = int(input())

result = find_stamps(n, m)
print(result)