def count_uniform_color_squares(N, matrix):
    count = 0
    for size in range(1, N):
        for i in range(N - size):
            for j in range(N - size):
                top_left = matrix[i][j]
                top_right = matrix[i][j + size]
                bottom_left = matrix[i + size][j]
                bottom_right = matrix[i + size][j + size]
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1
    return count

N = int(input())
matrix = [list(map(int, input().split())) for _ in range(N)]

print(count_uniform_color_squares(N, matrix))