def solve():
    import sys
    input = sys.stdin.read
    data = input().splitlines()

    t = int(data[0])  # кількість тестових блоків
    results = []
    idx = 1

    for _ in range(t):
        N = int(data[idx])
        idx += 1

        blue_points = []
        red_points = []

        for i in range(N):
            x, y = map(int, data[idx].split())
            blue_points.append((x, y, i + 1))  # зберігаємо також індекс точки
            idx += 1

        for i in range(N):
            x, y = map(int, data[idx].split())
            red_points.append((x, y, i + 1))  # зберігаємо також індекс точки
            idx += 1

        # Сортуємо точки за координатою x
        blue_points.sort()
        red_points.sort()

        # З'єднуємо точки жадібно
        pairs = []
        used_red = set()

        for bx, by, b_idx in blue_points:
            for rx, ry, r_idx in red_points:
                if r_idx not in used_red:
                    pairs.append((b_idx, r_idx))
                    used_red.add(r_idx)
                    break

        if len(pairs) == N:
            results.append("\n".join(f"{b} {r}" for b, r in pairs))
        else:
            results.append("0")

    sys.stdout.write("\n\n".join(results) + "\n")

# Цей код треба запускати в середовищі, де можна подавати вхідні дані через stdin.
# Наприклад, запустивши програму і передавши тестові дані через файл або термінал.

