def possible_positions_alice(N):
    # Початкова позиція Аліси
    alice_positions = [1]
    # Список для зберігання тюплетів (ходів і позицій)
    moves_alice = [(0, alice_positions)]

    for move in range(1, N):
        new_positions = []
        for pos in alice_positions:
            if pos + 2 <= N:
                new_positions.append(pos + 2)
            if pos + 3 <= N:
                new_positions.append(pos + 3)
        # Уникнути дублювання позицій
        alice_positions = list(set(new_positions))
        moves_alice.append((move, alice_positions))

    return moves_alice

def possible_positions_bob(N):
    # Початкова позиція Боба
    bob_positions = [N]
    # Список для зберігання тюплетів (ходів і позицій)
    moves_bob = [(0, bob_positions)]

    for move in range(1, N):
        new_positions = []
        for pos in bob_positions:
            if pos - 1 >= 1:
                new_positions.append(pos - 1)
            if pos - 2 >= 1:
                new_positions.append(pos - 2)
        # Уникнути дублювання позицій
        bob_positions = list(set(new_positions))
        moves_bob.append((move, bob_positions))

    return moves_bob

def find_meeting_time(N):
    moves_alice = possible_positions_alice(N)
    moves_bob = possible_positions_bob(N)

    # Шукаємо спільні позиції на кожному кроці
    for move in range(min(len(moves_alice), len(moves_bob))):
        positions_alice = set(moves_alice[move][1])
        positions_bob = set(moves_bob[move][1])
        if positions_alice & positions_bob:
            return move

    return -1

# Приклад використання
N = int(input())
print(find_meeting_time(N))
