def find_meeting_time(N):
    alice_positions = {1}
    bob_positions = {N}

    for move in range(1, N):
        # Оновлення можливих позицій для Аліси
        new_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= N:
                new_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                new_alice_positions.add(pos + 3)
        alice_positions = new_alice_positions

        # Оновлення можливих позицій для Боба
        new_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                new_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_positions.add(pos - 2)
        bob_positions = new_bob_positions

        # Перевірка на спільні позиції
        if alice_positions & bob_positions:
            return move

        # Якщо жодних можливих позицій більше немає
        if not alice_positions or not bob_positions:
            break

    return -1

# Приклад використання
N = int(input())
print(find_meeting_time(N))
