from collections import deque

def count(n):
    a = 1
    b = n
    c = 1
    while a < b:
        a += 3
        b -= 2
        c += 1
    return c

def func(n):
    if n <= 1:
        return -1

    ppa = deque([1])
    ppb = deque([n])
    visited_alice = {1}
    visited_bob = {n}

    for i in range(1, count(n) + 1):
        # Оновлення позицій для Аліси
        for _ in range(len(ppa)):
            pos = ppa.popleft()
            if pos + 2 <= n:
                if pos + 2 in visited_bob:
                    return i
                if pos + 2 not in visited_alice:
                    ppa.append(pos + 2)
                    visited_alice.add(pos + 2)
            if pos + 3 <= n:
                if pos + 3 in visited_bob:
                    return i
                if pos + 3 not in visited_alice:
                    ppa.append(pos + 3)
                    visited_alice.add(pos + 3)
        
        # Оновлення позицій для Боба
        for _ in range(len(ppb)):
            pos = ppb.popleft()
            if pos - 1 >= 1:
                if pos - 1 in visited_alice:
                    return i
                if pos - 1 not in visited_bob:
                    ppb.append(pos - 1)
                    visited_bob.add(pos - 1)
            if pos - 2 >= 1:
                if pos - 2 in visited_alice:
                    return i
                if pos - 2 not in visited_bob:
                    ppb.append(pos - 2)
                    visited_bob.add(pos - 2)
        
        # Якщо жодних можливих позицій більше немає
        if not ppa or not ppb:
            break

    return -1

# Приклад використання
N = int(input())
print(func(N))
