from collections import deque

def func(n):
    # Початкові позиції
    ppa = deque([3, 4])  # Можливі позиції Аліси
    ppb = deque([n - 1, n - 2])  # Можливі позиції Боба
    visited_alice = set(ppa)  # Відвідані позиції Аліси
    visited_bob = set(ppb)  # Відвідані позиції Боба

    # Ітерації
    for steps in range(1, n):  # Максимум n ітерацій
        # Перетин позицій
        if visited_alice & visited_bob:
            return steps
        
        # Оновлення позицій Аліси
        new_ppa = deque()
        for pos in ppa:
            for move in [2, 3]:  # Аліса рухається на +2 або +3
                new_pos = pos + move
                if new_pos <= n and new_pos not in visited_alice:
                    new_ppa.append(new_pos)
                    visited_alice.add(new_pos)
        ppa = new_ppa

        # Оновлення позицій Боба
        new_ppb = deque()
        for pos in ppb:
            for move in [-1, -2]:  # Боб рухається на -1 або -2
                new_pos = pos + move
                if new_pos >= 1 and new_pos not in visited_bob:
                    new_ppb.append(new_pos)
                    visited_bob.add(new_pos)
        ppb = new_ppb

        # Якщо позиції вичерпано, виходимо
        if not ppa or not ppb:
            break

    return -1  # Якщо немає перетину

# Приклад використання
N = int(input())
print(func(N))
