def find_stamps(N, M):
    # Обчислюємо максимальну можливу суму марок
    max_sum = N * (N + 1) // 2
    
    # Якщо M більша за максимальну суму, то такого набору немає
    if M > max_sum:
        return [0]
    
    result = []
    
    # Перебираємо марки від найбільших до найменших
    for i in range(N, 0, -1):
        if i <= M:
            result.append(i)
            M -= i
        
        # Якщо сума досягла 0, повертаємо результат
        if M == 0:
            break
    
    # Якщо сума не стала 0, значить такого набору немає
    if M > 0:
        return [0]
    
    return result

def main():
    N = int(input())  # Кількість марок
    M = int(input())  # Загальна сума для витрачання
    
    result = find_stamps(N, M)
    
    # Виведемо результат
    if result == [0]:
        print(0)
    else:
        print(*result)

if __name__ == "__main__":
    main()
