n = int(input())
arr = []

for _ in range(n):
    row = list(map(int, input().split()))
    arr.append(row)

def find_other_points(x1, y1, x2, y2):
    mx = (x1 + x2) / 2
    my = (y1 + y2) / 2
    
    dx = (x2 - x1)/2
    dy = (y2 - y1)/2
    
    x3 = mx + dy
    y3 = my - dx
    
    x4 = mx - dy
    y4 = my + dx
    #print(x3,y3,"   ",x4,y4)
    if all(v.is_integer() for v in [x3, x4, y3, y4]):
        if 0 <= x3 < n and 0 <= y3 < n and 0 <= x4 < n and 0 <= y4 < n:
            return arr[int(x3)][int(y3)], arr[int(x4)][int(y4)]
    return -1,-1

squares = 0
for i1 in range(n-1):
    for j1 in range(n-1):
        color = arr[i1][j1]
        for i2 in range(i1,n):
            for j2 in range(j1+1,n):
                if arr[i2][j2] == color:
                    p3,p4 = find_other_points(i1, j1, i2, j2)
                    if p3 == p4 == color:
                        squares +=1

print(squares)
