using System;
using System.Collections.Generic;

class Solution {
    public static void Main(string[] args) {
       
        int N = int.Parse(Console.ReadLine());
        
        
        int result = FindMeetingTime(N);
        
        
        Console.WriteLine(result);
    }

    static int FindMeetingTime(int N) {
        
        if (N < 2) return -1;

       
        HashSet<int> alicePositions = new HashSet<int> { 1 };
        HashSet<int> bobPositions = new HashSet<int> { N };

        
        int steps = 0;

        
        while (alicePositions.Count > 0 && bobPositions.Count > 0) {
            steps++;

          
            HashSet<int> nextAlicePositions = new HashSet<int>();
            foreach (int position in alicePositions) {
                if (position + 2 <= N) nextAlicePositions.Add(position + 2);
                if (position + 3 <= N) nextAlicePositions.Add(position + 3);
            }

           
            foreach (int pos in nextAlicePositions) {
                if (bobPositions.Contains(pos)) return steps;
            }

            alicePositions = nextAlicePositions;

            
            HashSet<int> nextBobPositions = new HashSet<int>();
            foreach (int position in bobPositions) {
                if (position - 1 > 0) nextBobPositions.Add(position - 1);
                if (position - 2 > 0) nextBobPositions.Add(position - 2);
            }

           
            foreach (int pos in nextBobPositions) {
                if (alicePositions.Contains(pos)) return steps;
            }

            bobPositions = nextBobPositions;
        }

        
        return -1;
    }
}

