#include <iostream>
#include <vector>
#include <unordered_map>
#include <climits>
using namespace std;

int findPresident(int N, vector<int>& a) {
    
    unordered_map<int, int> count;

    
    for (int num : a) {
        count[num]++;
    }

    
    int min_unique = INT_MAX;

   
    for (auto& entry : count) {
        if (entry.second == 1) {  
            min_unique = min(min_unique, entry.first);
        }
    }

   
    if (min_unique == INT_MAX) {
        return -1;
    }
    return min_unique;
}

int main() {
    int N;
    cin >> N;
    vector<int> a(N);

   
    for (int i = 0; i < N; i++) {
        cin >> a[i];
    }

   
    cout << findPresident(N, a) << endl;

    return 0;
}