#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N;
    cin >> N;

    // Зчитуємо матрицю
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int count = 0;
    for (int size = 1; size < N; ++size) { 
        for (int i = 0; i + size < N; ++i) { 
            for (int j = 0; j + size < N; ++j) {
            
                int topLeft = grid[i][j];
                int topRight = grid[i][j + size];
                int bottomLeft = grid[i + size][j];
                int bottomRight = grid[i + size][j + size];

        
                if (topLeft == topRight && topRight == bottomLeft && bottomLeft == bottomRight) {
                    ++count;
                }
            }
        }
    }

    cout << count << endl;
    return 0;
}
