#include <iostream>
#include <vector>
using namespace std;

int main() {
    long long totalMarks, targetSum;
    cin >> totalMarks >> targetSum;

    long long maxPossibleSum = totalMarks * (totalMarks + 1) / 2;
    
    if (targetSum > maxPossibleSum) 
    {
        cout << 0 << endl;
        return 0;
    }

    vector<int> selectedMarks; 
    for (int i = totalMarks; i >= 1; i--) 
    {
        if (targetSum >= i) 
        {
            selectedMarks.push_back(i);
            targetSum -= i;
        }
        if (targetSum == 0)
        {
            break;
        }
    }

    if (targetSum != 0) 
    {
        cout << 0 << endl; 
    } 
    else 
    {
        for (int stamp : selectedMarks) 
        {
            cout << stamp << " ";
        }
        cout << endl;
    }

    return 0;
}
