import java.io.*;
import java.util.*;

public class Main6 {
    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        int N = Integer.parseInt(br.readLine());
        String[] input = br.readLine().split(" ");

        Map<Long, Integer> frequencyMap = new HashMap<>();
        long[] numbers = new long[N];

        for (int i = 0; i < N; i++) {
            numbers[i] = Long.parseLong(input[i]);
            frequencyMap.put(numbers[i], frequencyMap.getOrDefault(numbers[i], 0) + 1);
        }

        long minUniqueNumber = Long.MAX_VALUE;
        int minIndex = -1;

        for (int i = 0; i < N; i++) {
            long num = numbers[i];
            if (frequencyMap.get(num) == 1 && num < minUniqueNumber) {
                minUniqueNumber = num;
                minIndex = i;
            }
        }

        if (minIndex != -1) {
            System.out.println(minIndex);
        } else {
            System.out.println(-1);
        }
    }
}
