import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class Main5 {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        
        int N = sc.nextInt();
        
        int[] numbers = new int[N];
        
        Map<Integer, Integer> frequency = new HashMap<>();
        
        for (int i = 0; i < N; ++i) {
            numbers[i] = sc.nextInt();
            frequency.put(numbers[i], frequency.getOrDefault(numbers[i], 0) + 1);
        }
        
        int uniqueMin = Integer.MAX_VALUE;
        boolean found = false;
        
        for (Map.Entry<Integer, Integer> entry : frequency.entrySet()) {
            if (entry.getValue() == 1) {
                uniqueMin = Math.min(uniqueMin, entry.getKey());
                found = true;
            }
        }
        
        if (found) {
            System.out.println(uniqueMin);
        } else {
            System.out.println(-1);
        }
        
        sc.close();
    }
}
