import java.util.Scanner;

public class Main {

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);

        int N = sc.nextInt();

        int[] numbers = new int[N];

        for (int i = 0; i < N; ++i) {
            numbers[i] = sc.nextInt();
        }

        int uniqueMin = Integer.MAX_VALUE;

        int[] freq = new int[1000001];

        for (int i = 0; i < N; ++i) {
            freq[numbers[i]]++;
        }

        for (int i = 0; i < N; ++i) {
            if (freq[numbers[i]] == 1) {
                uniqueMin = Math.min(uniqueMin, numbers[i]);
            }
        }

        if (uniqueMin == Integer.MAX_VALUE) {
            System.out.println(-1);
        } else {
            System.out.println(uniqueMin);
        }

        sc.close();
    }
}