import java.util.Scanner;

public class Main {

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);

        // Зчитуємо кількість елементів
        int N = sc.nextInt();

        // Масив для зберігання чисел
        int[] numbers = new int[N];

        // Зчитуємо елементи масиву
        for (int i = 0; i < N; ++i) {
            numbers[i] = sc.nextInt();
        }

        // Мапа для підрахунку частот елементів
        int[] freq = new int[1000001]; // Можливі числа від 1 до 10^6

        // Підраховуємо частоти елементів
        for (int i = 0; i < N; ++i) {
            freq[numbers[i]]++;
        }

        // Мінімальне число з частотою 1
        int uniqueMin = Integer.MAX_VALUE;
        for (int i = 0; i < N; ++i) {
            if (freq[numbers[i]] == 1) {
                uniqueMin = Math.min(uniqueMin, numbers[i]);
            }
        }

        // Якщо унікальне число знайдено, вивести його, інакше -1
        if (uniqueMin == Integer.MAX_VALUE) {
            System.out.println(-1);
        } else {
            System.out.println(uniqueMin);
        }

        sc.close();
    }
}
