#include <iostream>
#include <vector>
#include <unordered_map>
#include <limits>
using namespace std;

int main() {
    int array_size;
    cin >> array_size;

    vector<int> numbers(array_size);
    unordered_map<int, int> frequency_map;
    
    for (int i = 0; i < array_size; ++i) 
    {
        cin >> numbers[i];
        frequency_map[numbers[i]]++;
    }

    int smallest_unique = numeric_limits<int>::max();
    bool unique_found = false;
    
    for (const auto& entry : frequency_map)
    {
        if (entry.second == 1) 
        { 
            smallest_unique = min(smallest_unique, entry.first);
            unique_found = true;
        }
    }

    if (unique_found) 
    {
        cout << smallest_unique << endl;
    } 
    else 
    {
        cout << -1 << endl;
    }

    return 0;
}
