import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);

        // Вхід: розмір сітки
        int N = sc.nextInt();
        
        // Сітка для зберігання кольорів точок (0 - синій, 1 - червоний)
        int[][] grid = new int[N][N];

        // Читання кольорів точок
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                grid[i][j] = sc.nextInt();
            }
        }

        // Лічильник квадратів одного кольору
        int count = 0;

        // Перебір всіх можливих квадратів
        for (int x1 = 0; x1 < N; x1++) {
            for (int y1 = 0; y1 < N; y1++) {
                for (int x2 = x1 + 1; x2 < N; x2++) {
                    for (int y2 = y1 + 1; y2 < N; y2++) {
                        // Перевіряємо чи утворюється квадрат з точок (x1, y1) і (x2, y2)
                        if (x2 - x1 == y2 - y1) {
                            // Якщо всі чотири вершини одного кольору
                            if (grid[x1][y1] == grid[x2][y2] &&
                                grid[x1][y1] == grid[x1][y2] &&
                                grid[x1][y1] == grid[x2][y1]) {
                                count++;
                            }
                        }
                    }
                }
            }
        }

        // Виводимо результат
        System.out.println(count+1);
    }
}
