import java.util.Scanner;

public class Main7 {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int N = sc.nextInt();
        int[][] colors = new int[N][N];

        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                colors[i][j] = sc.nextInt();
            }
        }

        int count = 0;

        for (int size = 1; size < N; size++) {
            for (int i = 0; i <= N - size; i++) {
                for (int j = 0; j <= N - size; j++) {
                    int color = colors[i][j];
                    if (colors[i][j + size] == color && colors[i + size][j] == color && colors[i + size][j + size] == color) {
                        count++;
                    }
                }
            }
        }

        sc.close();

        System.out.println(count);
    }
}