#include <iostream>
#include <algorithm>

using namespace std;

long long count_multiples(long long N, long long x) {
    return N / x;
}

long long gcd(long long a, long long b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

int main() {
    long long N, A, B;
    cin >> N >> A >> B;
    
    long long count_A = count_multiples(N, A);
    long long count_B = count_multiples(N, B);
    long long lcm_AB = (A / gcd(A, B)) * B;

    long long count_AB = count_multiples(N, lcm_AB);
    
    cout << count_A + count_B - count_AB << endl;
    
    return 0;
}