#include <bits/stdc++.h>
#include <vector>
#include <algorithm>

using namespace std;

struct Point {
    int x, y, index;
    bool isBlue; // Чи це синя точка (true - синя, false - червона)

    bool operator<(const Point& other) const {
        // Сортуємо за x, потім за y
        if (x == other.x) return y < other.y;
        return x < other.x;
    }
};

int main() {
    int t;
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<Point> points;
        
        // Зчитуємо сині точки
        for (int i = 0; i < N; ++i) {
            int x, y;
            cin >> x >> y;
            points.push_back({x, y, i + 1, true});  // true - синя точка
        }

        // Зчитуємо червоні точки
        for (int i = 0; i < N; ++i) {
            int x, y;
            cin >> x >> y;
            points.push_back({x, y, i + 1, false});  // false - червона точка
        }

        // Сортуємо всі точки по x, потім по y
        sort(points.begin(), points.end());

        // Виводимо пари
        bool possible = true;
        for (int i = 0; i < N; ++i) {
            if (points[i].isBlue) {
                cout << points[i].index << " " << points[i + N].index << endl;
                i++; // Пропускаємо пару
            }
        }

        // Якщо не можемо зв'язати точки коректно, виводимо 0
        if (!possible) {
            cout << 0 << endl;
        }
    }

    return 0;
}
