#include <iostream>
#include <algorithm>
using namespace std;

long long solve(long long n) {
    for (long long t = 0; t <= n; ++t) {
        long long alicePos1 = 1 + 2 * t; // Аліса рухається на 2 клітинки
        long long alicePos2 = 1 + 3 * t; // Аліса рухається на 3 клітинки
        long long bobPos1 = n - t;       // Боб рухається на 1 клітинку назад
        long long bobPos2 = n - 2 * t;   // Боб рухається на 2 клітинки назад
        
        if (alicePos1 == bobPos1 || alicePos1 == bobPos2 || alicePos2 == bobPos1 || alicePos2 == bobPos2) {
            return t;
        }
    }
    return -1;
}

int main() {
    long long n;
    cin >> n;
    cout << solve(n) << endl;
    return 0;
}
