def can_meet(N):
    alice_positions = {1}  
    bob_positions = {N}    
    time = 0
    
    while True:
        if alice_positions & bob_positions:
            return True, time
        
        new_alice = set()
        for pos in alice_positions:
            if pos + 2 <= N:
                new_alice.add(pos + 2)
            if pos + 3 <= N:
                new_alice.add(pos + 3)
        
        new_bob = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                new_bob.add(pos - 1)
            if pos - 2 >= 1:
                new_bob.add(pos - 2)
        
        if not new_alice and not new_bob:
            return False, -1
        
        alice_positions = new_alice
        bob_positions = new_bob
        time += 1

N = int(input())
can_meet, time = can_meet(N)
if can_meet:
    print(time)
else:
    print(-1)
