#include <iostream>
#include <vector>
#include <unordered_map>
#include <limits>
using namespace std;

int main() {
    int N;
    cin >> N;

    vector<int> numbers(N);
    unordered_map<int, int> frequency;
    for (int i = 0; i < N; ++i) 
    {
        cin >> numbers[i];
        frequency[numbers[i]]++;
    }

    
    int unique_min = numeric_limits<int>::max();
    bool found = false;
    for (const auto& pair : frequency)
    {
        if (pair.second == 1) 
        { 
            unique_min = min(unique_min, pair.first);
            found = true;
        }
    }

    if (found) 
    {
        cout << unique_min << endl;
    } 
    else 
    {
        cout << -1 << endl;
    }

    return 0;
}
