#include <iostream>
#include <vector>
using namespace std;


int countSquareWithSameColor(int N, const vector<vector<int>>& grid) {
    int count = 0;

    
    for (int k = 2; k <= N; ++k) {
        for (int i = 0; i <= N - k; ++i) { 
            for (int j = 0; j <= N - k; ++j) {
                
                int topLeft = grid[i][j];
                int topRight = grid[i][j + k - 1];
                int botLeft = grid[i + k - 1][j];
                int botRight = grid[i + k - 1][j + k - 1];
                if (topLeft == topRight && topLeft == botLeft && topLeft == botRight) {
                    ++count;
                }
            }
        }
    }

    return count;
}

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int result = countSquareWithSameColor(N, grid);
    cout << result << endl;

    return 0;
}
