#include <bits/stdc++.h>
using namespace std;

struct P {
    int x, y, index, type;
};

bool cP(const P &a, const P &b) {
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        int N;
        cin >> N;

        vector<P> p(2 * N);
        for (int i = 0; i < N; i+=1) {
            cin >> p[i].x >> p[i].y;
            p[i].index = i + 1;
            p[i].type = 0;
        }
        for (int i = 0; i < N; i+=1) {
            cin >> p[N + i].x >> p[N + i].y;
            p[N + i].index = i + 1;
            p[N + i].type = 1; 
        }

        sort(p.begin(), p.end(), cP);

        set<pair<int, int>> aS; 
        vector<pair<int, int>> r;

        for (const auto &p : p) {
            if (p.type == 0) {
                aS.insert({p.y, p.index});
            } else {
                auto it = aS.lower_bound({p.y, -1});
                if (it == aS.end()) it = prev(aS.end());
                r.emplace_back(it->second, p.index);
                aS.erase(it);
            }
        }

        if ((int)r.size() != N) {
            cout << 0 << endl;
        } else {
            for (const auto &pr : r) {
                cout << pr.first << " " << pr.second << endl;
            }
        }
    }

    return 0;
}