#include <bits/stdc++.h>
using namespace std;
struct P {
    int x, y, index;
};

bool cP(const P& a, const P& b) {
    return atan2(a.y, a.x) < atan2(b.y, b.x);
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<P> b(N), r(N);

        for (int i = 0; i < N; i+=1) {
            cin >> b[i].x >> b[i].y;
            b[i].index = i + 1;
        }

        for (int i = 0; i < N; i+=1) {
            cin >> r[i].x >> r[i].y;
            r[i].index = i + 1;
        }

        sort(b.begin(), b.end(), cP);
        sort(r.begin(), r.end(), cP);

        vector<pair<int, int>> pairs(N);
        for (int i = 0; i < N; ++i) {
            pairs[i] = {b[i].index, r[i].index};
        }

        for (auto& pair : pairs) {
            cout << pair.first << " " << pair.second << endl;
        }
    }

    return 0;
}