#include <bits/stdc++.h>
using namespace std;
struct P {
    int x, y, index;
};

bool cY(const P& a, const P& b) {
    return a.y < b.y || (a.y == b.y && a.x < b.x);
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<P> b(N), r(N);

        for (int i = 0; i < N; i++) {
            cin >> b[i].x >> b[i].y;
            b[i].index = i + 1;
        }

        for (int i = 0; i < N; i++) {
            cin >> r[i].x >> r[i].y;
            r[i].index = i + 1;
        }

        sort(b.begin(), b.end(), cY);
        sort(r.begin(), r.end(), cY);

        bool possible = true;
        vector<pair<int, int>> pairs;
        
        for (int i = 0; i < N; i++) {
            pairs.push_back({b[i].index, r[i].index});
        }

        for (int i = 0; i < N - 1; i++) {
            if ((b[i].y - b[i + 1].y) * (r[i].y - r[i + 1].y) < 0) {
                possible = false;
                break;
            }
        }

        if (!possible) {
            cout << 0 << endl;
        } else {
            for (auto& pair : pairs) {
                cout << pair.first << " " << pair.second << endl;
            }
        }
    }

    return 0;
}