#include <bits/stdc++.h>
using namespace std;
struct P {
    int x, y, index;
};

bool cX(const P& a, const P& b) {
    return a.x < b.x;
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<P> b(N), r(N);

        for (int i = 0; i < N; i+=1) {
            cin >> b[i].x >> b[i].y;
            b[i].index = i + 1;
        }

        for (int i = 0; i < N; i+=1) {
            cin >> r[i].x >> r[i].y;
            r[i].index = i + 1;
        }

        sort(b.begin(), b.end(), cX);
        sort(r.begin(), r.end(), cX);

        vector<pair<int, int>> pairs;
        bool possible = true;

        for (int i = 0; i < N; i++) {
            pairs.push_back({b[i].index, r[i].index});
        }

        for (int i = 0; i < N - 1; i++) {
            if ((b[i].x < r[i].x && b[i+1].x >= r[i+1].x) ||
                (b[i].x > r[i].x && b[i+1].x <= r[i+1].x)) {
                possible = false;
                break;
            }
        }

        if (!possible) {
            cout << 0 << endl;
        } else {
            for (auto& pair : pairs) {
                cout << pair.first << " " << pair.second << endl;
            }
        }
    }

    return 0;
}