def find_meeting_time(N):
    # Початкові позиції
    alice_pos = 1  # Аліса стартує з 1
    bob_pos = N    # Боб стартує з N
    
    # Максимальна кількість ітерацій не перевищує N
    t = 0
    while alice_pos <= N and bob_pos >= 1:
        # Якщо Аліса і Боб зустрілися
        if alice_pos == bob_pos:
            return t
        
        # Оновлюємо позиції
        t += 1
        alice_pos += 2  # Аліса рухається вперед на 2
        if t % 3 == 0:
            alice_pos += 1  # Кожна третя секунда дає +1
        
        bob_pos -= 1  # Боб рухається назад на 1
        if t % 2 == 0:
            bob_pos -= 1  # Кожна друга секунда дає -1

    return -1  # Якщо зустріч неможлива

# Зчитуємо вхід
N = int(input())
print(find_meeting_time(N))
