n = int(input())
m = int(input())

# Calculate the total sum of the first `n` natural numbers.
total_sum = n * (n + 1) // 2

# If the total sum is less than `m`, it's impossible to select numbers.
if total_sum < m:
    print(0)
else:
    results = []
    remaining_sum = m

    # Start from the largest number and work backward.
    for current_num in range(n, 0, -1):
        if remaining_sum <= 0:
            break  # Stop early if we reach the required sum.
        if remaining_sum >= current_num:
            results.append(current_num)
            remaining_sum -= current_num

    print("\n".join(map(str, results)) if results else 0)
