n = int(input())
m = int(input())

# Calculate the total sum of the first `n` natural numbers.
total_sum = n * (n + 1) // 2

# If `m` is greater than the total sum, directly return 0.
if total_sum < m:
    print(0)
else:
    results = []
    remaining_sum = m

    # Start iterating from `n` and decrement.
    for current_num in range(n, 0, -1):
        if remaining_sum <= 0:
            break
        if remaining_sum >= current_num:
            results.append(current_num)
            remaining_sum -= current_num

    # Directly join and print the results.
    print("\n".join(map(str, results)))
