def solve():
    import sys
    input = sys.stdin.read
    data = input().split()
    
    t = int(data[0])  # Кількість тестових блоків
    idx = 1
    results = []
    
    for _ in range(t):
        n = int(data[idx])  # Кількість точок одного кольору
        idx += 1
        
        blue_points = []
        red_points = []
        
        # Зчитуємо координати синіх точок
        for _ in range(n):
            x, y = map(int, data[idx:idx+2])
            blue_points.append((x, y))
            idx += 2
        
        # Зчитуємо координати червоних точок
        for _ in range(n):
            x, y = map(int, data[idx:idx+2])
            red_points.append((x, y))
            idx += 2
        
        # Сортуємо сині та червоні точки за x (можна змінити на інший критерій)
        blue_points = sorted(enumerate(blue_points, start=1), key=lambda p: (p[1][0], p[1][1]))
        red_points = sorted(enumerate(red_points, start=1), key=lambda p: (p[1][0], p[1][1]))
        
        # Формуємо пари
        pairs = []
        for b, r in zip(blue_points, red_points):
            pairs.append((b[0], r[0]))
        
        # Зберігаємо результат
        results.append("\n".join(f"{b} {r}" for b, r in pairs))
    
    # Виводимо всі результати
    sys.stdout.write("\n\n".join(results) + "\n")

