#include <iostream>
#include <unordered_set>
using namespace std;

int teleportationMeeting(int N) {
    if (N % 2 != 1) {
        return -1;
    }

    unordered_set<int> alice_positions = {1};
    unordered_set<int> bob_positions = {N};
    int time = 0;

    while (true) {
        for (int pos : alice_positions) {
            if (bob_positions.count(pos)) {
                return time;
            }
        }

        unordered_set<int> next_alice_positions;
        for (int pos : alice_positions) {
            if (pos + 2 <= N) next_alice_positions.insert(pos + 2);
            if (pos + 3 <= N) next_alice_positions.insert(pos + 3);
        }

        unordered_set<int> next_bob_positions;
        for (int pos : bob_positions) {
            if (pos - 1 > 0) next_bob_positions.insert(pos - 1);
            if (pos - 2 > 0) next_bob_positions.insert(pos - 2);
        }

        alice_positions = next_alice_positions;
        bob_positions = next_bob_positions;

        time++;
    }
}

int main() {
    int N;
    cin >> N;

    int result = teleportationMeeting(N);
    cout << result << endl;

    return 0;
}