#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N;
    cin >> N;
    
    vector<vector<int>> grid(N, vector<int>(N));
    
    // Вводимо матрицю
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }
    
    int count = 0;

    // Перевіряємо всі можливі квадрати розміру 2x2
    for (int i = 0; i < N - 1; ++i) {
        for (int j = 0; j < N - 1; ++j) {
            // Перевірка квадрата, побудованого на точках (i,j), (i,j+1), (i+1,j), (i+1,j+1)
            if (grid[i][j] == grid[i][j+1] && grid[i][j] == grid[i+1][j] && grid[i][j] == grid[i+1][j+1]) {
                count++;
            }
        }
    }
    
    cout << count << endl;
    
    return 0;
}