import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        long N = scanner.nextLong();
        scanner.close();

        long[] times = new long[4];
        times[0] = (N - 1) % 3 == 0 ? (N - 1) / 3 : -1;
        times[1] = (N - 1) % 4 == 0 ? (N - 1) / 4 : -1;
        times[2] = (N - 1) % 5 == 0 ? (N - 1) / 5 : -1;

        long minTime = Long.MAX_VALUE;

        for (long t : times) {
            if (t >= 0) {
                minTime = Math.min(minTime, t);
            }
        }

        System.out.println(minTime == Long.MAX_VALUE ? -1 : minTime);
    }
}
