import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        long N = scanner.nextLong();

        long result = findMinSeconds(N);
        System.out.println(result);
    }

    private static long findMinSeconds(long N) {
        for (long t = 0; t <= N; t++) {
            long alice1 = 1 + 2 * t;
            long alice2 = 1 + 3 * t;

            long bob1 = N - t;
            long bob2 = N - 2 * t;

            if (alice1 == bob1 || alice1 == bob2 || alice2 == bob1 || alice2 == bob2) {
                return t;
            }
        }
        return -1;
    }
}
