import java.util.*;

public class Main {
    static List<Integer> result = null;

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int N = scanner.nextInt();
        int M = scanner.nextInt();

        int[] stamps = new int[N];
        for (int i = 0; i < N; i++) {
            stamps[i] = i + 1;
        }

        findMinimumStamps(stamps, M, new ArrayList<>(), 0, 0);

        if (result != null) {
            for (int stamp : result) {
                System.out.println(stamp);
            }
        } else {
            System.out.println(0);
        }

        scanner.close();
    }

    static void findMinimumStamps(int[] stamps, int target, List<Integer> current, int sum, int index) {
        if (sum == target) {
            if (result == null || current.size() < result.size()) {
                result = new ArrayList<>(current);
            }
            return;
        }

        if (sum > target || index >= stamps.length) {
            return;
        }

        current.add(stamps[index]);
        findMinimumStamps(stamps, target, current, sum + stamps[index], index + 1);

        current.removeLast();
        findMinimumStamps(stamps, target, current, sum, index + 1);
    }
}
