import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int N = scanner.nextInt();
        if (N <= 0) {
            System.out.println(-1);
            scanner.close();
            return;
        }

        int[] numbers = new int[N];

        for (int i = 0; i < N; i++) {
            numbers[i] = scanner.nextInt();
        }

        Map<Integer, Integer> countMap = new HashMap<>();
        for (int num : numbers) {
            countMap.put(num, countMap.getOrDefault(num, 0) + 1);
        }
        
        int min = Integer.MAX_VALUE;
        for (int num : countMap.keySet()) {
            if (countMap.get(num) == 1 && num < min) {
                min = num;
            }
        }

        System.out.println(min == Integer.MAX_VALUE ? -1 : min);

        scanner.close();
    }
}
