import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int N = scanner.nextInt();
        if (N <= 0) {
            System.out.println(-1);
            scanner.close();
            return;
        }

        int[] numbers = new int[N];
        for (int i = 0; i < N; i++) {
            numbers[i] = scanner.nextInt();
        }

        Map<Integer, Integer> countMap = new HashMap<>();
        for (int num : numbers) {
            countMap.put(num, countMap.getOrDefault(num, 0) + 1);
        }

        int minUnique = Integer.MAX_VALUE;
        for (Map.Entry<Integer, Integer> entry : countMap.entrySet()) {
            if (entry.getValue() == 1 && entry.getKey() < minUnique) {
                minUnique = entry.getKey();
            }
        }

        System.out.println(minUnique == Integer.MAX_VALUE ? -1 : minUnique);

        scanner.close();
    }
}
