import java.io.*;
import java.util.*;

public class Main {
    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        int N = Integer.parseInt(reader.readLine());
        StringTokenizer tokenizer = new StringTokenizer(reader.readLine());

        Map<Integer, Integer> countMap = new HashMap<>();
        int[] numbers = new int[N];

        for (int i = 0; i < N; i++) {
            int num = Integer.parseInt(tokenizer.nextToken());
            numbers[i] = num;
            countMap.put(num, countMap.getOrDefault(num, 0) + 1);
        }

        int minUnique = Integer.MAX_VALUE;
        for (int num : numbers) {
            if (countMap.get(num) == 1 && num < minUnique) {
                minUnique = num;
            }
        }

        System.out.println(minUnique == Integer.MAX_VALUE ? -1 : minUnique);
    }
}
