import java.util.Scanner;

public class Main {

    private static int gcd(int a, int b) {
        while (b != 0) {
            int temp = b;
            b = a % b;
            a = temp;
        }
        return a;
    }

    private static long lcm(int a, int b) {
        return (long) a * (b / gcd(a, b));
    }

    public static int countOnes(int n, int a, int b) {
        int countA = n / a;
        int countB = n / b;
        long lcmAB = lcm(a, b);
        int countBoth = (lcmAB > n) ? 0 : (int) (n / lcmAB);
        return countA + countB - countBoth;
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int n = scanner.nextInt();
        int a = scanner.nextInt();
        int b = scanner.nextInt();

        System.out.println(countOnes(n, a, b));

        scanner.close();
    }
}
