import java.util.Scanner;

public class Main {

    public static int countUniformColorSquares(int n, int[][] grid) {
        int count = 0;

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                for (int size = 1; size < n - Math.max(i, j); size++) {
                    int topLeft = grid[i][j];
                    int topRight = grid[i][j + size];
                    int bottomLeft = grid[i + size][j];
                    int bottomRight = grid[i + size][j + size];

                    if (topLeft == topRight && topLeft == bottomLeft && topLeft == bottomRight) {
                        count++;
                    }
                }
            }
        }

        return count;
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int n = scanner.nextInt();
        int[][] grid = new int[n][n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                grid[i][j] = scanner.nextInt();
            }
        }

        System.out.println(countUniformColorSquares(n, grid)+1);

        scanner.close();
    }
}