import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int N = scanner.nextInt();
        int[][] grid = new int[N][N];

        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                grid[i][j] = scanner.nextInt();
            }
        }

        int count = 0;

        for (int size = 1; size < N; size++) {
            for (int i = 0; i + size < N; i++) {
                for (int j = 0; j + size < N; j++) {
                    int topLeft = grid[i][j];
                    int topRight = grid[i][j + size];
                    int bottomLeft = grid[i + size][j];
                    int bottomRight = grid[i + size][j + size];

                    if (topLeft == topRight && topRight == bottomLeft && bottomLeft == bottomRight) {
                        count++;
                    }
                }
            }
        }

        System.out.println(count+1);
    }
}