from collections import deque

N = int(input())
alice_dist = [-1] * (N + 1)
bob_dist = [-1] * (N + 1)

queue = deque([1])
alice_dist[1] = 0
while queue:
    k = queue.popleft()
    for move in [2, 3]:
        new_pos = k + move
        if new_pos <= N and alice_dist[new_pos] == -1:
            alice_dist[new_pos] = alice_dist[k] + 1
            queue.append(new_pos)

queue = deque([N])
bob_dist[N] = 0
while queue:
    k = queue.popleft()
    for move in [1, 2]:
        new_pos = k - move
        if new_pos >= 1 and bob_dist[new_pos] == -1:
            bob_dist[new_pos] = bob_dist[k] + 1
            queue.append(new_pos)

min_time = float('inf')
for i in range(1, N + 1):
    if alice_dist[i] != -1 and bob_dist[i] != -1:
        min_time = min(min_time, max(alice_dist[i], bob_dist[i]))

print(min_time if min_time != float('inf') else -1)
