from collections import deque

def teleport(N):
    a_q = deque([(1, 0)])
    b_q = deque([(N, 0)])
    a_visited = set([1])
    b_visited = set([N])
    
    while a_q and b_q:
        for _ in range(len(a_q)):
            a_pos, a_time = a_q.popleft()
            for m in [2, 3]:
                new_pos = a_pos + m
                if new_pos <= N and new_pos not in a_visited:
                    a_visited.add(new_pos)
                    a_q.append((new_pos, a_time + 1))
        
        for _ in range(len(b_q)):
            b_pos, b_time = b_q.popleft()
            for m in [1, 2]:
                new_pos = b_pos - m
                if new_pos >= 1 and new_pos not in b_visited:
                    b_visited.add(new_pos)
                    b_q.append((new_pos, b_time + 1))
        
        if a_visited & b_visited:
            return min(a_time, b_time) + 1
    
    return -1

N = int(input())
print(teleport(N))
