def find_stamps(N, M):
    stamps = list(range(1, N + 1))
    dp = [float('inf')] * (M + 1)
    dp[0] = 0
    
    for i in range(1, M + 1):
        for stamp in stamps:
            if i >= stamp:
                dp[i] = min(dp[i], dp[i - stamp] + 1)
    
    if dp[M] == float('inf'):
        return 0
    
    result = []
    while M > 0:
        for stamp in stamps:
            if M >= stamp and dp[M - stamp] == dp[M] - 1:
                result.append(stamp)
                M -= stamp
                break
    
    return result

N = int(input())
M = int(input())

result = find_stamps(N, M)

if result == 0:
    print(0)
else:
    print(" ".join(map(str, result)))
