def find_stamps(N, M):
    total_sum = N * (N + 1) // 2
    if total_sum < M:
        return 0  
    selected_stamps = []
    current_sum = 0
    for i in range(N, 0, -1):
        if current_sum + i <= M:
            selected_stamps.append(i)
            current_sum += i
        if current_sum == M:
            break
    return selected_stamps if current_sum == M else 0
N = int(input())
M = int(input())
result = find_stamps(N, M)
if result == 0:
    print(0)
else:
    print(" ".join(map(str, sorted(result))))


