from collections import deque

def solve(N):
    alice = deque([1])
    bob = deque([N])
    
    time = 0
    
    alice_visited = set([1])
    bob_visited = set([N])
    
    while alice and bob:
        time += 1
        
        new_alice = set()
        for pos in alice:
            for move in [2, 3]:
                new_pos = pos + move
                if new_pos <= N and new_pos not in alice_visited:
                    new_alice.add(new_pos)
                    alice_visited.add(new_pos)
        
        new_bob = set()
        for pos in bob:
            for move in [-1, -2]:
                new_pos = pos + move
                if new_pos >= 1 and new_pos not in bob_visited:
                    new_bob.add(new_pos)
                    bob_visited.add(new_pos)
        
        if new_alice & new_bob:
            return time
        
        alice = deque(new_alice)
        bob = deque(new_bob)
    
    return -1

N = int(input())
print(solve(N))
