def find_stamps(N, M):
    solutions = []
    
    for mask in range(1, 1 << N): 
        total = 0
        stamps = []
        for i in range(N):
            if mask & (1 << i):
                total += i + 1  
                stamps.append(i + 1)  
        
        if total == M:
            solutions.append(stamps)
    if solutions:
        for solution in solutions:
            print(" ".join(map(str, solution)))
    else:
        print(0)

N = int(input())
M = int(input())

find_stamps(N, M)