def find_stamps(N, M):
    # Максимальна сума, яку можна отримати з усіх марок 1 до N
    total_sum = N * (N + 1) // 2
    
    # Якщо сума всіх марок менша за M, то неможливо досягти такої суми
    if total_sum < M:
        print(0)
        return
    
    result = []
    # Почнемо з найбільших марок і будемо їх додавати, поки сума не стане рівною M
    for i in range(N, 0, -1):
        if M >= i:
            result.append(i)
            M -= i
        if M == 0:
            break
    
    # Якщо ми знайшли підмножину, виводимо її
    if M == 0:
        print(" ".join(map(str, result)))
    else:
        print(0)

# Вхідні дані
N = int(input())  # кількість марок
M = int(input())  # загальна вартість марок, які Єва вибере

find_stamps(N, M)