from collections import deque

def teleportation(N):
    alice_start = 1
    bob_start = N

    queue = deque([(alice_start, bob_start, 0)])
    
    visited = set()
    visited.add((alice_start, bob_start))

    while queue:
        alice_pos, bob_pos, time = queue.popleft()

        if alice_pos == bob_pos:
            return time

        for alice_move in [2, 3]:
            new_alice_pos = alice_pos + alice_move
            if new_alice_pos <= N:
                for bob_move in [1, 2]:
                    new_bob_pos = bob_pos - bob_move
                    if new_bob_pos >= 1:
                        if (new_alice_pos, new_bob_pos) not in visited:
                            visited.add((new_alice_pos, new_bob_pos))
                            queue.append((new_alice_pos, new_bob_pos, time + 1))

    return -1

N = int(input())

print(teleportation(N))