def count_uniform_squares(N, grid):
    count = 0

    for i in range(N):
        for j in range(N):
            for size in range(1, min(N - i, N - j) + 1):
                if (grid[i][j] == grid[i + size - 1][j] == 
                    grid[i][j + size - 1] == grid[i + size - 1][j + size - 1]):
                    count += 1

    return count

N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

result = count_uniform_squares(N, grid)

print(result)
