def count_uniform_color_squares(N, grid):
    count = 0
    
    for side in range(1, N):
        for i in range(N - side):  
            for j in range(N - side):
                color = grid[i][j]
                if (grid[i][j] == grid[i+side][j] == grid[i][j+side] == grid[i+side][j+side]):
                    count += 1
    return count

N = int(input()) 
grid = [list(map(int, input().split())) for _ in range(N)]

print(count_uniform_color_squares(N, grid))
