import random

def solve():
    t = int(input())  
    for _ in range(t):
        N = int(input()) 
        blue_points = []
        red_points = []
        
        for i in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y, i + 1)) 
        
        for i in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y, i + 1)) 
        
        blue_points.sort() 
        red_points.sort() 
        
        blue_indices = [blue_points[i][2] for i in range(N)]
        red_indices = [red_points[i][2] for i in range(N)]
        
        random.shuffle(blue_indices)
        random.shuffle(red_indices)
        
        result = []
        for i in range(N):
            result.append(f"{blue_indices[i]} {red_indices[i]}")
        
        print("\n".join(result))

solve()
