def solve(test_cases):
    results = []
    
    for case in test_cases:
        N, blue_points, red_points = case
        blue_points_sorted = sorted(enumerate(blue_points), key=lambda x: (x[1][0], x[1][1]))
        red_points_sorted = sorted(enumerate(red_points), key=lambda x: (x[1][0], x[1][1]))

        solution = []
        for i in range(N):
            blue_index = blue_points_sorted[i][0] + 1  
            red_index = red_points_sorted[i][0] + 1 
            solution.append(f"{blue_index} {red_index}")
        
        results.append("\n".join(solution))
    
    return "\n\n".join(results)

def main():
    t = int(input())
    
    test_cases = []
    
    for _ in range(t):
        N = int(input())
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().split())) for _ in range(N)]
        
        test_cases.append((N, blue_points, red_points))
    
    print(solve(test_cases))

