#include <chrono>
#include <thread>
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"

struct point {
  ll x;
  ll y;
  ll ind;
  bool red;
};

ll dist(point first, point second) {
  return (first.x - second.x) * (first.x - second.x) +
         (first.y - second.y) * (first.y - second.y);
}

ll orient_(point first, point second, point third) {
  ll s = first.x * (second.y - third.y) + second.x * (third.y - first.y) +
         third.x * (first.y - second.y);
  if (s == 0) {
    return 0;
  } else if (s < 0) {
    return -1;
  } else {
    return 1;
  }
}

void cpu_sleep(ll tm) {
  auto a = chrono::high_resolution_clock::now().time_since_epoch();
  while (std::chrono::duration_cast<std::chrono::milliseconds>(
             chrono::high_resolution_clock::now().time_since_epoch() - a)
             .count() < tm) {
  }
}


int main() {
  ios_base::sync_with_stdio();
  cin.tie(0);
  cout.tie(0);
  ll n, t, a, b, c, d, e, f, g;
  bool bl, bl2;
  cin >> t;
  // this_thread::sleep_for(chrono::milliseconds(t));
  cpu_sleep(t);
  assert(false);
  while (t--) {
    cin >> n;
    vector<point> points;
    vector<pair<ll, ll>> ans;
    for (ll i = 0; i < n; i++) {
      cin >> a >> b;
      points.push_back({a, b, i + 1, false});
    }
    for (ll i = 0; i < n; i++) {
      cin >> a >> b;
      points.push_back({a, b, i + 1, true});
    }
    ll mn_point = 0;
    for (ll i = 1; i < 2 * n; i++) {
      if (points[mn_point].y > points[i].y ||
          (points[mn_point].y == points[i].y &&
           points[mn_point].x > points[i].x)) {
        mn_point = i;
      }
    }
    point mn_pt = points[mn_point];
    sort(all(points), [&mn_pt](const point &first, const point &second) {
      ll o = orient_(mn_pt, first, second);
      if (o == 0) {
        return dist(mn_pt, first) < dist(mn_pt, second);
      }
      return o < 0;
    });
    bl2 = true;
    while (points.size() > 0) {
      bool bl = false;
      for (ll i = 0; i < n; i++) {
        ll nxt = (i + 1) % n;
        if (points[i].red != points[nxt].red) {
          ans.push_back({points[i].ind, points[nxt].ind});
          if (points[i].red) {
            swap(ans.back().first, ans.back().second);
          }
          points.erase(points.begin() + i);
          if (nxt != 0) {
            points.erase(points.begin() + i);
          } else {
            points.erase(points.begin());
          }
          bl = true;
          break;
        }
      }
      if (!bl) {
        bl2 = false;
        break;
      }
    }
    if (!bl2) {
      cout << 0 << nl;
      continue;
    }
    for (auto i : ans) {
      cout << i.first << " " << i.second << nl;
    }
  }
}
