def min_teleportation_time(N):
    # Позиція Аліси (1) та Боба (N)
    a_pos = 1
    b_pos = N
    
    # Якщо різниця між позиціями менша або рівна 3, вони можуть зустрітись за 1 крок
    if abs(a_pos - b_pos) <= 3:
        return 1
    
    # Якщо різниця між позиціями більша, перевіримо скільки кроків потрібно
    # Аліса може рухатися на 2 або 3, Боб на -1 або -2
    # Якщо (N - 1) % 2 == 0, це означає, що вони можуть зустрітися на парних кроках
    if (N - 1) % 2 == 0:
        return 2
    
    # Якщо ж ні, то повертаємо -1
    return -1

# Вхідні дані
N = int(input().strip())

# Вивести результат
print(min_teleportation_time(N))
