def teleport(N):
    # Початкові позиції Аліси і Боба
    alice_positions = {1}  # Аліса починає з 1-го боксу
    bob_positions = {N}  # Боб починає з N-го боксу
    seconds = 0
    
    # Обходимо кожну секунду
    while seconds < N:
        seconds += 1
        
        # Нові позиції для Аліси
        new_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= N:
                new_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                new_alice_positions.add(pos + 3)
        
        # Нові позиції для Боба
        new_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                new_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_positions.add(pos - 2)
        
        # Перевіряємо, чи є спільні позиції
        if new_alice_positions & new_bob_positions:
            return seconds
        
        # Оновлюємо позиції для наступної секунди
        alice_positions = new_alice_positions
        bob_positions = new_bob_positions
    
    # Якщо не знайшли спільної позиції
    return -1

# Вхідні дані
N = int(input())

# Викликаємо функцію та виводимо результат
print(teleport(N))
