def min_teleportation_time(N):
    # Якщо є лише два бокси, то зустріч може статися миттєво
    if N == 2:
        return 1
    
    # Початкові позиції
    alice_position = 1
    bob_position = N
    
    # Лічильник часу
    time = 0
    
    # Поки Аліса не зустрічається з Бобом
    while alice_position < bob_position:
        time += 1
        # Аліса телепортується в бокс на k+2 або k+3
        alice_position += 3 if alice_position + 3 <= N else 2
        # Боб телепортується в бокс на k-1 або k-2
        bob_position -= 1 if bob_position - 1 >= 1 else 2
        
        # Якщо позиції Аліси та Боба співпали, повертаємо час
        if alice_position == bob_position:
            return time
    
    # Якщо вони не можуть зустрітися
    return -1

# Вхідні дані
N = int(input().strip())

# Вивести результат
print(min_teleportation_time(N))
