def min_teleportation_time(N):
    # Якщо N == 2, зустріч відбудеться миттєво
    if N == 2:
        return 0

    # Початкові позиції для Аліси та Боба
    alice_pos = 1
    bob_pos = N
    time = 0
    
    # Продовжуємо рухатись поки не знайдемо спільну позицію
    while alice_pos < bob_pos:
        time += 1
        
        # Рухаємо Алісу
        if alice_pos + 2 <= N:
            alice_pos += 2
        elif alice_pos + 3 <= N:
            alice_pos += 3
        
        # Рухаємо Боба
        if bob_pos - 1 >= 1:
            bob_pos -= 1
        elif bob_pos - 2 >= 1:
            bob_pos -= 2
        
        # Перевіряємо, чи вони на тій самій позиції
        if alice_pos == bob_pos:
            return time
    
    # Якщо не знайшли спільної позиції
    return -1

# Вхідні дані
N = int(input().strip())

# Вивести результат
print(min_teleportation_time(N))