from collections import Counter

def find_president(N, nums):
    # Підраховуємо кількість кожного числа
    count = Counter(nums)
    
    # Збираємо всі числа, які зустрічаються тільки один раз
    unique_numbers = [num for num, cnt in count.items() if cnt == 1]
    
    if not unique_numbers:
        print(-1)  # Якщо немає унікальних чисел
    else:
        # Якщо є унікальні числа, виводимо найменше
        print(min(unique_numbers))

# Вхідні дані
N = int(input())  # Кількість роботів
nums = list(map(int, input().split()))  # Список згенерованих чисел

# Викликаємо функцію
find_president(N, nums)
