#include <iostream>
#include <set>

using namespace std;

int teleportation_meeting(int N) {
    // Створюємо множину для можливих позицій Аліси та Боба
    set<int> alice_positions = {1};
    set<int> bob_positions = {N};
    
    int seconds = 0;
    
    while (seconds < N) {
        seconds++;
        
        // Створюємо нові множини для наступної секунди
        set<int> new_alice_positions;
        set<int> new_bob_positions;
        
        // Телепортуємо Алісу: 1 -> 3, 1 -> 4
        for (int pos : alice_positions) {
            if (pos + 2 <= N) new_alice_positions.insert(pos + 2);
            if (pos + 3 <= N) new_alice_positions.insert(pos + 3);
        }
        
        // Телепортуємо Боба: N -> N-1, N -> N-2
        for (int pos : bob_positions) {
            if (pos - 1 >= 1) new_bob_positions.insert(pos - 1);
            if (pos - 2 >= 1) new_bob_positions.insert(pos - 2);
        }
        
        // Перевіряємо на перетин
        for (int pos : new_alice_positions) {
            if (new_bob_positions.find(pos) != new_bob_positions.end()) {
                return seconds;
            }
        }
        
        // Оновлюємо множини
        alice_positions = new_alice_positions;
        bob_positions = new_bob_positions;
    }
    
    return -1;
}

int main() {
    int N;
    cin >> N;
    
    // Викликаємо функцію і виводимо результат
    cout << teleportation_meeting(N) << endl;
    
    return 0;
}


   



