def choose_stamps(N, M):
    # Визначення максимальної суми
    max_sum = N * (N + 1) // 2
    if M > max_sum:
        return [0]  # Неприпустимо, якщо M перевищує максимальну суму

    # Список для зберігання вибраних марок
    chosen_stamps = []

    # Проходимо від N до 1
    for i in range(N, 0, -1):
        if M >= i:  # Якщо можемо взяти цю марку
            chosen_stamps.append(i)
            M -= i  # Віднімемо вартість марки від M

        if M == 0:  # Якщо досягли необхідної суми
            break

    # Якщо M не дорівнює 0, значить неможливо вибрати марки
    if M > 0:
        return [0]

    return chosen_stamps

# Читання вхідних даних
N = int(input())
M = int(input())

# Виклик функції та виведення результату
result = choose_stamps(N, M)
print(" ".join(map(str, result)))