import math

def count_multiples(N, x):
    return N // x

def lcm(a, b):
    return a * b // math.gcd(a, b)

def test_memory(N, A, B):
    # Кількість чисел, кратних A
    count_A = count_multiples(N, A)
    
    # Кількість чисел, кратних B
    count_B = count_multiples(N, B)
    
    # Кількість чисел, кратних LCM(A, B)
    lcm_AB = lcm(A, B)
    count_AB = count_multiples(N, lcm_AB)
    
    # Враховуємо принцип включення-виключення
    return count_A + count_B - count_AB

# Читання вхідних даних
N = int(input())  # кількість комірок в пам'яті
A, B = map(int, input().split())  # числа A та B

# Виведення результату
print(test_memory(N, A, B))
