def solve_case(N, blue_points, red_points):
    # Сортуємо сині та червоні точки за їх координатами (спочатку по x, потім по y)
    sorted_blue = sorted(enumerate(blue_points, 1), key=lambda x: (x[1][0], x[1][1]))
    sorted_red = sorted(enumerate(red_points, 1), key=lambda x: (x[1][0], x[1][1]))
    
    # Параметри для з'єднання
    result = []
    
    # З'єднуємо точки
    for i in range(N):
        blue_index = sorted_blue[i][0]
        red_index = sorted_red[i][0]
        result.append((blue_index, red_index))
    
    return result

def main():
    t = int(input())  # Кількість тестових блоків
    for _ in range(t):
        N = int(input())  # Кількість точок одного кольору
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().split())) for _ in range(N)]
        
        result = solve_case(N, blue_points, red_points)
        
        # Вивести відповідь
        for blue_index, red_index in result:
            print(blue_index, red_index)

# Виклик основної функції
main()

