def get_squares(N, grid):
    squares = 0

    for x1 in range(N):
        for y1 in range(N):
            for x2 in range(x1 + 1, N):
                for y2 in range(y1, N):
                    x3 = x2 - (y2 - y1)
                    y3 = y2 + (x2 - x1)
                    x4 = x1 - (y2 - y1)
                    y4 = y1 + (x2 - x1)

                    if 0 <= x3 < N and 0 <= y3 < N and 0 <= x4 < N and 0 <= y4 < N:
                        if grid[x1][y1] == grid[x2][y2] == grid[x3][y3] == grid[x4][y4]:
                            squares += 1
    return squares

n = int(input())
grid = [list(map(int, input().split())) for _ in range(n)]

print(get_squares(n, grid))
