def count_squares(N, grid):
    squares = 0
    for x1 in range(N):
        for y1 in range(N):
            for side_length in range(1, min(N - x1, N - y1)):
                x2, y2 = x1, y1 + side_length
                x3, y3 = x1 + side_length, y1
                x4, y4 = x1 + side_length, y1 + side_length
                if grid[x1][y1] == grid[x2][y2] == grid[x3][y3] == grid[x4][y4]:
                    squares += 1
    return squares

N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]
print(count_squares(N, grid))