import sys

def main():
    import sys
    import sys
    import sys
    def input():
        return sys.stdin.read()

    data = sys.stdin.read().split()
    ptr = 0
    N = int(data[ptr]); ptr +=1
    grid = []
    for _ in range(N):
        row = [int(x) for x in data[ptr:ptr+N]]
        grid.append(row)
        ptr +=N

    # Create a set for quick lookup
    point_set = set()
    for x in range(N):
        for y in range(N):
            point_set.add( (x, y) )

    # Create a list of points
    points = []
    colors = []
    for x in range(N):
        for y in range(N):
            points.append( (x, y) )
            colors.append( grid[x][y] )

    count = 0
    total_points = len(points)
    # Precompute a dictionary for color access
    # To speed up, convert grid to a list of lists
    grid_list = grid

    for i in range(total_points):
        x1, y1 = points[i]
        color1 = grid_list[x1][y1]
        for j in range(i+1, total_points):
            x2, y2 = points[j]
            color2 = grid_list[x2][y2]
            dx = x2 - x1
            dy = y2 - y1

            # First possible square
            x3 = x1 - dy
            y3 = y1 + dx
            x4 = x2 - dy
            y4 = y2 + dx
            if 0 <= x3 < N and 0 <= y3 < N and 0 <= x4 < N and 0 <= y4 < N:
                color3 = grid_list[x3][y3]
                color4 = grid_list[x4][y4]
                if color1 == color2 == color3 == color4:
                    count +=1

            # Second possible square
            x3 = x1 + dy
            y3 = y1 - dx
            x4 = x2 + dy
            y4 = y2 - dx
            if 0 <= x3 < N and 0 <= y3 < N and 0 <= x4 < N and 0 <= y4 < N:
                color3 = grid_list[x3][y3]
                color4 = grid_list[x4][y4]
                if color1 == color2 == color3 == color4:
                    count +=1

    # Each square is counted four times
    print(count //4)

if __name__ == "__main__":
    main()