#include <bits/stdc++.h>
using namespace std;

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    
    int N;
    cin >> N;
    vector<vector<int>> grid(N, vector<int>(N));
    for(int i=0;i<N;i++) {
        for(int j=0; j<N; j++) {
            cin >> grid[i][j];
        }
    }
    
    long long count =0;
    
    for(int x1=0; x1<N; x1++){
        for(int y1=0; y1<N; y1++){
            int c = grid[x1][y1];
            for(int dx = -N+1; dx < N; dx++){
                for(int dy = -N+1; dy < N; dy++){
                    if(dx ==0 && dy ==0) continue;
                    int x2 = x1 + dx;
                    int y2 = y1 + dy;
                    if(x2 <0 || x2 >=N || y2 <0 || y2 >=N) continue;
                    
                    int x3 = x1 - dy;
                    int y3 = y1 + dx;
                    if(x3 <0 || x3 >=N || y3 <0 || y3 >=N) continue;
                    
                    int x4 = x2 - dy;
                    int y4 = y2 + dx;
                    if(x4 <0 || x4 >=N || y4 <0 || y4 >=N) continue;
                    
                    if(grid[x2][y2] == c && grid[x3][y3] == c && grid[x4][y4] == c){
                        count++;
                    }
                }
            }
        }
    }
    
    cout << (count / 4) << "\n";
}