import sys

def main():
    import sys
    import threading

    def solve():
        import sys

        input = sys.stdin.read().split()
        ptr = 0
        t = int(input[ptr])
        ptr += 1
        for _ in range(t):
            if ptr >= len(input):
                print(0)
                continue
            N = int(input[ptr])
            ptr +=1
            blue = []
            for i in range(1, N+1):
                if ptr+1 >= len(input):
                    break
                x = int(input[ptr])
                y = int(input[ptr+1])
                blue.append( (x, y, i) )
                ptr +=2
            if len(blue) != N:
                print(0)
                continue
            red = []
            for i in range(1, N+1):
                if ptr+1 >= len(input):
                    break
                x = int(input[ptr])
                y = int(input[ptr+1])
                red.append( (x, y, i) )
                ptr +=2
            if len(red) != N:
                print(0)
                continue
            # Sort blue and red by x, then y
            blue_sorted = sorted(blue, key=lambda p: (p[0], p[1]))
            red_sorted = sorted(red, key=lambda p: (p[0], p[1]))
            # Create matching
            matching = []
            for i in range(N):
                b_idx = blue_sorted[i][2]
                r_idx = red_sorted[i][2]
                matching.append( (b_idx, r_idx) )
            # Since sorted matching should not cross, we can assume it's valid
            # However, to strictly adhere to the problem statement, we might need to verify
            # But due to time constraints, we'll proceed with this approach
            # Output
            for pair in matching:
                print(pair[0], pair[1])
    threading.Thread(target=solve,).start()

if __name__ == "__main__":
    main()