import sys
import threading

def main():
    def solve():
        import sys

        data = sys.stdin.read().split()
        ptr = 0
        t = int(data[ptr]); ptr +=1

        for _ in range(t):
            if ptr >= len(data):
                print(0)
                continue
            N = int(data[ptr]); ptr +=1
            blue = []
            for i in range(1, N+1):
                if ptr+1 >= len(data):
                    break
                x = int(data[ptr]); ptr +=1
                y = int(data[ptr]); ptr +=1
                blue.append( (x, y, i) )
            if len(blue) != N:
                print(0)
                # Skip remaining inputs for this test case
                ptr += 2*N
                continue
            red = []
            for i in range(1, N+1):
                if ptr+1 >= len(data):
                    break
                x = int(data[ptr]); ptr +=1
                y = int(data[ptr]); ptr +=1
                red.append( (x, y, i) )
            if len(red) != N:
                print(0)
                continue
            # Sort blue and red points by x, then y
            blue_sorted = sorted(blue, key=lambda p: (p[0], p[1]))
            red_sorted = sorted(red, key=lambda p: (p[0], p[1]))
            # Match sorted blue to sorted red
            matching = []
            for b, r in zip(blue_sorted, red_sorted):
                matching.append( (b[2], r[2]) )
            # Output matching in sorted blue order
            for pair in matching:
                print(pair[0], pair[1])
    threading.Thread(target=solve).start()

if __name__ == "__main__":
    main()