#include <iostream>
#include <vector>

using namespace std;

vector<int> find_stamps(int N, int M) {
    vector<int> result;

    // Перебираємо марки від N до 1
    for (int i = N; i > 0; --i) {
        if (M <= 0) {
            break;
        }
        if (M >= i) {
            result.push_back(i);
            M -= i;
        }
    }

    // Якщо залишок M більше 0, значить не вдалося зібрати суму
    if (M > 0) {
        return {0};
    }

    return result;
}

int main() {
    int N, M;
    cin >> N >> M;

    vector<int> result = find_stamps(N, M);

    if (result[0] == 0) {
        cout << "0\n";
    } else {
        for (size_t i = 0; i < result.size(); ++i) {
            cout << result[i];
            if (i < result.size() - 1) {
                cout << " ";
            }
        }
        cout << "\n";
    }

    return 0;
}