def count_same_color_squares(n, grid):
    count = 0
    for size in range(1, n):
        for i in range(n - size):
            for j in range(n - size):
                if grid[i][j] == grid[i][j + size] == grid[i + size][j] == grid[i + size][j + size]:
                    count += 1
    return count

def main():
    import sys
    input = sys.stdin.read
    data = input().splitlines()
    n = int(data[0])
    grid = [list(map(int, row.split())) for row in data[1:]]
    print(count_same_color_squares(n, grid))

if __name__ == "__main__":
    main()
