var scanf = require('scanf');
var n = scanf('%d');

function minTeleportationTime(N) {  
    let t = 0;
    let alicePositions = new Set([1]);
    let bobPositions = new Set([N]);

    while (true) {
        for (let pos of alicePositions) {
            if (bobPositions.has(pos)) return t;
        }
        const newAlicePositions = new Set();
        for (let pos of alicePositions) {
            if (pos + 2 <= N) newAlicePositions.add(pos + 2);
            if (pos + 3 <= N) newAlicePositions.add(pos + 3);
        }

        const newBobPositions = new Set();
        for (let pos of bobPositions) {
            if (pos - 1 >= 1) newBobPositions.add(pos - 1);
            if (pos - 2 >= 1) newBobPositions.add(pos - 2);
        }

        alicePositions = newAlicePositions;
        bobPositions = newBobPositions;

        t++;
    }
}

console.log(minTeleportationTime(n));
