#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N;
    cin >> N;
    
    vector<vector<int>> grid(N, vector<int>(N));
    for(int i = 0; i < N-1; i++) {
        for(int j = 0; j < N; j++) {
            cin >> grid[i][j];
        }
    }
    for(int j = 0; j < N; j++) {
        cin >> grid[N-1][j];
    }
    
    int count = 0;
    
    //top-left corner of square
    for(int i = 0; i < N-1; i++) {
        for(int j = 0; j < N-1; j++) {
            // For each possible square size
            for(int size = 1; i + size < N && j + size < N; size++) {
                // all corners coords
                int bottomRow = i + size;
                int rightCol = j + size;
                
                if(grid[i][j] == grid[i][rightCol] && 
                   grid[i][j] == grid[bottomRow][j] && 
                   grid[i][j] == grid[bottomRow][rightCol]) {
                    count++;
                }
            }
        }
    }
    
    cout << count + 1 << endl;
    return 0;
}