#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>

using namespace std;

int main() {
    int t;
    cin >> t;
    while (t--) {
        int N;
        cin >> N;
        vector<tuple<int, int, int>> blue(N), red(N);
        
        for (int i = 0; i < N; ++i) {
            int x, y;
            cin >> x >> y;
            blue[i] = make_tuple(x, y, i + 1);
        }
        
        for (int i = 0; i < N; ++i) {
            int x, y;
            cin >> x >> y;
            red[i] = make_tuple(x, y, i + 1);
        }
        
        sort(blue.begin(), blue.end());
        sort(red.begin(), red.end());
        
        for (int i = 0; i < N; ++i) {
            cout << get<2>(blue[i]) << " " << get<2>(red[i]) << endl;
        }
    }
    return 0;
}