#include <bits/stdc++.h>
using namespace std;

static long long distSq(int x1,int y1, int x2,int y2){
    long long dx = x2-x1;
    long long dy = y2 - y1;
    return dx*dx + dy*dy;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    vector<vector<int>> color(n+1,vector<int>(n+1));
    for(int row = 1;row<=n;++row){
        for(int x =1;x<=n;++x){
            int val;cin>>val;
            int y=n-row+1;
            color[x][y]=val;
        }
    }
    vector<pair<int,int>> points;
    points.reserve(n*n);
    for(int x=1; x<=n;++x){
        for(int y=1;y<=n;++y){
            points.push_back({x,y});
        }
    }
    long long countSquares = 0;
    int totalPoints = (int)points.size();

    for(int p1 = 0;p1<totalPoints;++p1){
        int x1 = points[p1].first;
        int y1 = points[p1].second;
        for(int p2 = p1+1;p2<totalPoints;++p2){
            int x2 = points[p2].first;
            int y2 = points[p2].second;
            int dx = x2-x1;
            int dy = y2-y1;
            if ((dx % 2) != 0 || (dy % 2) != 0) continue;
            int midX = (x1+x2)/2;
            int midY = (y1+y2)/2;
            int x3 = midX-dy/2;
            int y3 = midY+dx/2;
            int x4 = midX + dy/2;
            int y4 = midY - dx/2;
            if (x3 < 1 || x3 > n || y3 < 1 || y3 > n) continue;
            if (x4 < 1 || x4 > n || y4 < 1 || y4 > n) continue;
            int c = color[x1][y1];
            if (color[x2][y2] != c || color[x3][y3] != c || color[x4][y4] != c) continue;
            long long d13 = distSq(x1,y1,x3,y3);
            long long d32 = distSq(x3,y3,x2,y2);
            long long d24 = distSq(x2,y2,x4,y4);
            long long d41 = distSq(x4,y4,x1,y1);
            if (d13 == 0 || d13 != d32 || d32 != d24 || d24 != d41) continue;
            long long d12 = distSq(x1,y1,x2,y2);
            long long d34 = distSq(x3,y3,x4,y4);
            if(d12!=d34 || d12 <= d13) continue;
            ++countSquares;
        }
    }
    cout<<countSquares/2;
    return 0;
}
