#include <bits/stdc++.h>
using namespace std;

inline bool isInt(double x) {
    return fabs(x-(int)x)<1e-9;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int N; cin >> N;
    vector<vector<int>> color(N, vector<int>(N));
    for (int i = 0;i < N;++i) {
        for (int j = 0;j < N;++j) {
            cin>>color[i][j];
        }
    }

    long long ans=0;
    for (int x1 = 0;x1 < N;++x1) {
        for (int y1 = 0;y1 < N;++y1) {
            for (int x2 = x1;x2 < N;++x2) {
                int startY =(x2==x1)?y1+1:0;
                for (int y2 = startY; y2 < N; ++y2) {
                    if (color[x1][y1] != color[x2][y2]) continue;
                    double mx = (x1 + x2) / 2.0; 
                    double my = (y1 + y2) / 2.0;
                    int dx = x2 - x1;
                    int dy = y2 - y1;
                    double x3 = mx + dy / 2.0;
                    double y3 = my - dx / 2.0;
                    double x4 = mx - dy / 2.0;
                    double y4 = my + dx / 2.0;
                    if (!isInt(x3) || !isInt(y3) || !isInt(x4) || !isInt(y4)) continue;
                    int ix3 = (int)round(x3), iy3 = (int)round(y3);
                    int ix4 = (int)round(x4), iy4 = (int)round(y4);
                    if (ix3 < 0 || ix3 >= N || iy3 < 0 || iy3 >= N) continue;
                    if (ix4 < 0 || ix4 >= N || iy4 < 0 || iy4 >= N) continue;
                    if (color[ix3][iy3] == color[x1][y1] && color[ix4][iy4] == color[x1][y1]) ans++;
                }
            }
        }
    }

    cout << ans / 2 << "\n";
    return 0;
}