#include <bits/stdc++.h>
using namespace std;

struct Point {
    int idx; 
    long long x,y;
    double angle;
};
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t; cin >> t;
    while(t--){
        int N; cin >> N;
        vector<Point> blue(N), red(N);

        for (int i = 0; i < N; i++) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].idx = i+1; 
        }
        for (int j = 0; j < N; j++) {
            cin >> red[j].x >> red[j].y;
            red[j].idx = j+1;
        }
        long long sumX=0, sumY=0;
        for (auto &b : blue) { sumX += b.x; sumY += b.y; }
        for (auto &r : red) { sumX += r.x; sumY += r.y; }
        double cx = (double)sumX/(2*N);
        double cy = (double)sumY/(2*N);
         for (auto &b : blue) {
            double dx = b.x - cx;
            double dy = b.y - cy;
            b.angle = atan2(dy,dx);
        }
        for (auto &r : red) {
            double dx = r.x - cx;
            double dy = r.y - cy;
            r.angle = atan2(dy,dx);
        }
        sort(blue.begin(), blue.end(), [](const Point&a, const Point&b){
            return a.angle < b.angle;
        });
        sort(red.begin(), red.end(), [](const Point&a, const Point&b){
            return a.angle < b.angle;
        });
        for (int i = 0; i < N; i++){
            cout << blue[i].idx << " " << red[i].idx << "\n";
        }
    }
}
