#include<bits/stdc++.h>
using namespace std;

struct Point {
    int x, y, index;
};

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin>>t;
    while(t--){
        int N;
        cin>>N;
        vector<Point> blue(N);
        for(int i=0;i<N;i++){
            cin>>blue[i].x>>blue[i].y;
            blue[i].index = i+1;
        }
        vector<Point> red(N);
        for(int i=0;i<N;i++){
            cin>>red[i].x>>red[i].y;
            red[i].index = i+1;
        }
        sort(blue.begin(), blue.end(), [&](const Point&a,const Point&b)->bool{
            if(a.x != b.x) return a.x < b.x;
            return a.y < b.y;
        });
        sort(red.begin(), red.end(), [&](const Point&a,const Point&b)->bool{
            if(a.x != b.x) return a.x < b.x;
            return a.y < b.y;
        });
        bool ok=true;
        for(int i=1;i<N;i++) {
            if(red[i].x < red[i-1].x){
                ok=false;
                break;
            }
        }
        if(ok){
            for(int i=0;i<N;i++) cout<<blue[i].index<<" "<<red[i].index<<"\n";
        }
        else{
            cout<<0<<"\n";
        }
    }
}
