from collections import deque

def min_meeting_time(N):
    alice_queue = deque([1])
    bob_queue = deque([N])
    alice_visited = set([1])
    bob_visited = set([N])
    time = 0
    
    while alice_queue and bob_queue:
        time += 1
        for _ in range(len(alice_queue)):
            pos = alice_queue.popleft()
            for new_pos in [pos + 2, pos + 3]:
                if 1 <= new_pos <= N and new_pos not in alice_visited:
                    alice_visited.add(new_pos)
                    alice_queue.append(new_pos)
                    if new_pos in bob_visited:
                        return time
        for _ in range(len(bob_queue)):
            pos = bob_queue.popleft()
            for new_pos in [pos - 1, pos - 2]:
                if 1 <= new_pos <= N and new_pos not in bob_visited:
                    bob_visited.add(new_pos)
                    bob_queue.append(new_pos)
                    if new_pos in alice_visited:
                        return time
    
    return -1
N = int(input())
print(min_meeting_time(N))