#include <iostream>
#include <vector>
#include <climits> 
using namespace std;

int main() {
    int N, M;
    cin >> N >> M;

    vector<int> dp(M + 1, INT_MAX);
    dp[0] = 0;  

    vector<int> last(M + 1, -1);

 
    for (int i = 1; i <= N; ++i) {
        for (int j = M; j >= i; --j) {
            if (dp[j - i] != INT_MAX && dp[j - i] + 1 < dp[j]) {
                dp[j] = dp[j - i] + 1;
                last[j] = i;
            }
        }
    }

    if (dp[M] == INT_MAX) {
        cout << 0 << endl;
    } else {
        vector<int> result;
        int sum = M;
        while (sum > 0) {
            result.push_back(last[sum]);
            sum -= last[sum];
        }

    
        for (int i = 0; i < result.size(); ++i) {
            cout << result[i] << " ";
        }
        cout << endl;
    }

    return 0;
}