#include <iostream>
#include <unordered_map>
#include <vector>
#include <climits>
using namespace std;

int main() {
    int N;
    cin >> N;
    
    vector<int> numbers(N);
    unordered_map<int, int> freq_map;  

    for (int i = 0; i < N; ++i) {
        cin >> numbers[i];
        freq_map[numbers[i]]++;
    }
    
    int min_unique = INT_MAX;
    
  
    for (int num : numbers) {
        if (freq_map[num] == 1 && num < min_unique) {
            min_unique = num;
        }
    }
    
    
    if (min_unique == INT_MAX) {
        cout << -1 << endl;
    } else {
        cout << min_unique << endl;
    }
    
    return 0;
}