#include <iostream>
#include <vector>
using namespace std;


int countUniformSquares(int N, const vector<vector<int>>& grid) {
    int count = 0;


    for (int size = 1; size < N; ++size) { 
        for (int i = 0; i + size < N; ++i) { 
            for (int j = 0; j + size < N; ++j) { 
                
                int top_left = grid[i][j];
                int top_right = grid[i][j + size];
                int bottom_left = grid[i + size][j];
                int bottom_right = grid[i + size][j + size];

                
                if (top_left == top_right && top_left == bottom_left && top_left == bottom_right) {
                    ++count;
                }
            }
        }
    }

    return count;
}

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));


    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }


    cout << countUniformSquares(N, grid) << endl;

    return 0;
}