def solve_eva_problem():
    import sys
    input = sys.stdin.read
    data = input().splitlines()
    
    t = int(data[0]) 
    results = []
    index = 1
    
    for _ in range(t):
        N = int(data[index]) 
        index += 1
        
        blue_points = []
        red_points = []
        
        for i in range(N):
            x, y = map(int, data[index + i].split())
            blue_points.append((x, y, i + 1)) 
        index += N
        
        for i in range(N):
            x, y = map(int, data[index + i].split())
            red_points.append((x, y, i + 1))
        index += N
        
        blue_points.sort(key=lambda p: p[0])
        red_points.sort(key=lambda p: p[0])
        
        pairs = []
        is_possible = True
        
        for i in range(N):
            bx, by, b_index = blue_points[i]
            rx, ry, r_index = red_points[i]
            if bx > rx:
                is_possible = False
                break
            pairs.append((b_index, r_index))
        
        if is_possible:
            results.append("\n".join(f"{b} {r}" for b, r in pairs))
        else:
            results.append("0")
    
    print("\n".join(results))