def count_uniform_squares(N, grid):
    count = 0
    
    # Перебір усіх можливих розмірів квадратів
    for size in range(1, N + 1):  # Розмір квадратів: 1x1, 2x2, ..., NxN
        for i in range(N - size + 1):  # Верхній лівий кут по y
            for j in range(N - size + 1):  # Верхній лівий кут по x
                # Перевіряємо всі вершини квадрата
                uniform = True
                color = grid[i][j]
                for x in range(size):
                    for y in range(size):
                        if grid[i + x][j + y] != color:
                            uniform = False
                            break
                    if not uniform:
                        break
                
                if uniform:
                    count += 1
    
    return count

# Ввід
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Вивід
print(count_uniform_squares(N, grid))
