def find_min_time_to_meet(n):
    # Початкові умови
    a_positions = {1}
    b_positions = {n}
    
    # Ітерації
    time = 0
    while True:
        time += 1
        
        # Можливі позиції для Аліси
        next_a_positions = set()
        for pos in a_positions:
            next_a_positions.add(pos + 2)
            next_a_positions.add(pos + 3)
        
        # Можливі позиції для Боба
        next_b_positions = set()
        for pos in b_positions:
            next_b_positions.add(pos - 1)
            next_b_positions.add(pos - 2)
        
        # Перевірка на перехрестя
        if next_a_positions & next_b_positions:
            return time
        
        # Оновлюємо позиції для наступної секунди
        a_positions = next_a_positions
        b_positions = next_b_positions
        
        # Якщо Аліса і Боб вже можуть опинитися на однаковій клітинці, повертаємо час
        if a_positions & b_positions:
            return time
        
        # Якщо ми не знайшли спільної клітинки, припиняємо
        if not a_positions or not b_positions:
            break
    
    return -1

# Вхід
n = int(input())

# Виклик функції
print(find_min_time_to_meet(n))
