from collections import deque

def find_min_time_to_meet(n):
    # Початкові умови
    alice_positions = {1}
    bob_positions = {n}
    
    time = 0
    
    while True:
        time += 1
        
        # Створюємо нові множини для наступних можливих клітинок
        next_alice_positions = set()
        next_bob_positions = set()
        
        for pos in alice_positions:
            if pos + 2 <= n:
                next_alice_positions.add(pos + 2)
            if pos + 3 <= n:
                next_alice_positions.add(pos + 3)
        
        for pos in bob_positions:
            if pos - 1 >= 1:
                next_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                next_bob_positions.add(pos - 2)
        
        # Перевіряємо, чи є спільні клітинки
        if next_alice_positions & next_bob_positions:
            return time
        
        # Оновлюємо множини
        alice_positions = next_alice_positions
        bob_positions = next_bob_positions
        
        # Якщо позицій Аліси чи Боба більше немає, повертаємо -1
        if not alice_positions or not bob_positions:
            return -1

# Вхід
n = int(input())

# Виклик функції
print(find_min_time_to_meet(n))
