def find_min_time_to_meet(n):
    # Якщо n == 2, то неможливо зустрітися
    if n == 2:
        return -1

    # Можливі кроки для Аліси (переміщається на +2 або +3)
    alice_moves = [2, 3]

    # Можливі кроки для Боба (переміщається на -1 або -2)
    bob_moves = [-1, -2]

    # Перевіряємо можливість зустрічі
    for t in range(1, 100):  # Перевіряємо можливість зустрічі до 100 секунд
        # Для кожної секунди перевіряємо можливість зустрічі
        for alice_pos in range(1, n + 1):
            if any(alice_pos + move == n for move in alice_moves):
                return t
        
    return -1  # Якщо не знайшли зустріч
