from collections import deque

def can_meet(n):
    # BFS для поиска минимального времени
    alice_positions = set([1])  # Начальная позиция Алисы
    bob_positions = set([n])  # Начальная позиция Боба
    
    time = 0
    while alice_positions and bob_positions:
        time += 1
        
        # Новые позиции Алисы
        new_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= n:
                new_alice_positions.add(pos + 2)
            if pos + 3 <= n:
                new_alice_positions.add(pos + 3)
        
        # Новые позиции Боба
        new_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                new_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_positions.add(pos - 2)
        
        # Проверка на пересечение позиций
        if new_alice_positions & new_bob_positions:
            return time
        
        # Обновление текущих позиций
        alice_positions = new_alice_positions
        bob_positions = new_bob_positions
    
    return -1

# Ввод
n = int(input())
# Вывод
print(can_meet(n))
