function can_meet(n)
    -- Инициализация позиций Алисы и Боба
    local alice_positions = {1}
    local bob_positions = {n}
    local time = 0
    
    -- Пока есть позиции для поиска
    while #alice_positions > 0 and #bob_positions > 0 do
        time = time + 1
        
        -- Множества для новых позиций Алисы и Боба
        local new_alice_positions = {}
        local new_bob_positions = {}
        
        -- Новые позиции Алисы
        for i = 1, #alice_positions do
            local pos = alice_positions[i]
            if pos + 2 <= n then
                table.insert(new_alice_positions, pos + 2)
            end
            if pos + 3 <= n then
                table.insert(new_alice_positions, pos + 3)
            end
        end
        
        -- Новые позиции Боба
        for i = 1, #bob_positions do
            local pos = bob_positions[i]
            if pos - 1 >= 1 then
                table.insert(new_bob_positions, pos - 1)
            end
            if pos - 2 >= 1 then
                table.insert(new_bob_positions, pos - 2)
            end
        end
        
        -- Проверяем пересечение позиций
        for _, alice_pos in ipairs(new_alice_positions) do
            for _, bob_pos in ipairs(new_bob_positions) do
                if alice_pos == bob_pos then
                    return time
                end
            end
        end
        
        -- Обновляем позиции
        alice_positions = new_alice_positions
        bob_positions = new_bob_positions
    end
    
    return -1
end

-- Ввод
n = tonumber(io.read())
-- Вывод
print(can_meet(n))
