function can_meet(n)
    -- Возможности для Алисы и Боба
    local alice_steps = {2, 3}
    local bob_steps = {-1, -2}

    -- Проверка на возможность пересечения
    for time = 0, math.floor(n / 2) do
        -- Проверяем позиции Алисы и Боба на каждом шаге
        for _, alice in ipairs(alice_steps) do
            local alice_pos = 1 + alice * time
            for _, bob in ipairs(bob_steps) do
                local bob_pos = n + bob * time
                if alice_pos == bob_pos then
                    return time
                end
            end
        end
    end
    return -1
end

-- Ввод
n = tonumber(io.read())
-- Вывод
print(can_meet(n))
