#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N, M;
    cin >> N >> M;

    vector<int> result;

    // Починаємо з найбільшої марки
    for (int i = N; i >= 1; --i) {
        // Якщо поточна марка може бути використана для досягнення суми M
        if (M >= i) {
            result.push_back(i);
            M -= i;  // Віднімаємо вартість цієї марки від залишкової суми
        }
    }

    // Якщо сума стала 0, значить ми знайшли правильні марки
    if (M == 0) {
        // Якщо є кілька можливих варіантів, вибираємо будь-який
        for (int mark : result) {
            cout << mark << " ";  // Виводимо вибрані марки
        }
        cout << endl;
    } else {
        cout << 0 << endl;  // Якщо не вдалося досягти суми M, виводимо 0
    }

    return 0;
}
