#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N, M;
    cin >> N >> M;

    // Якщо максимальна вартість усіх марок менша за M, то рішення неможливе
    if ((N * (N + 1)) / 2 < M) {
        cout << 0 << endl;
        return 0;
    }

    // Вектор для збереження вибраних марок
    vector<int> result;

    // Жадібний підхід: відбираємо марки з максимальною вартістю
    for (int i = N; i >= 1; --i) {
        if (M >= i) {
            result.push_back(i);
            M -= i;
        }
        if (M == 0) break;
    }

    // Якщо сума не нульова, вивести 0, якщо це не вдалося
    if (M == 0) {
        for (int mark : result) {
            cout << mark << " ";
        }
        cout << endl;
    } else {
        cout << 0 << endl;
    }

    return 0;
}
