import java.util.*;

public class Philately {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        
        // Вхідні дані
        int N = scanner.nextInt();  // Кількість марок
        int M = scanner.nextInt();  // Загальна вартість
        
        // Список для збереження вибраних марок
        List<Integer> selectedStamps = new ArrayList<>();
        
        // Починаємо з найвищої марки і йдемо вниз
        for (int i = N; i >= 1; i--) {
            if (M >= i) {
                M -= i;
                selectedStamps.add(i);
            }
            if (M == 0) {
                break;
            }
        }

        // Якщо залишилася сума, яку не можемо покрити, вивести 0
        if (M > 0) {
            System.out.println(0);
        } else {
            // Вивести вибрані марки в порядку зростання без сортування
            StringBuilder result = new StringBuilder();
            for (int i = selectedStamps.size() - 1; i >= 0; i--) {
                result.append(selectedStamps.get(i)).append(" ");
            }
            System.out.println(result.toString().trim());
        }
    }
}
