#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N, M;
    cin >> N >> M;

    // Максимальна можливу суму
    int max_sum = N * (N + 1) / 2;
    
    // Якщо неможливо отримати точну суму
    if (M > max_sum) {
        cout << 0 << endl;
        return 0;
    }

    vector<int> result;
    int current_sum = 0;

    // Перевіряємо з найбільших марок
    for (int i = N; i >= 1; --i) {
        if (current_sum + i <= M) {
            result.push_back(i);
            current_sum += i;
        }
        if (current_sum == M) {
            break;
        }
    }

    // Якщо сума дорівнює M, виводимо марки
    if (current_sum == M) {
        for (int i = 0; i < result.size(); ++i) {
            cout << result[i] << " ";
        }
        cout << endl;
    } else {
        cout << 0 << endl;
    }

    return 0;
}
