#include <iostream>
#include <numeric> // Для функції std::gcd
using namespace std;

// Функція для обчислення кількості чисел, кратних X
long long countMultiples(long long N, long long X) {
    return N / X;
}

// Функція для обчислення НСК (найменше спільне кратне)
long long lcm(long long A, long long B) {
    return (A * B) / gcd(A, B);
}

int main() {
    long long N, A, B;
    cin >> N >> A >> B;
    
    // Кількість чисел, кратних A
    long long countA = countMultiples(N, A);
    
    // Кількість чисел, кратних B
    long long countB = countMultiples(N, B);
    
    // Кількість чисел, кратних обом A і B (тобто, кратних НСК(A, B))
    long long lcmAB = lcm(A, B);
    long long countAB = (lcmAB <= N) ? countMultiples(N, lcmAB) : 0;
    
    // Кількість одиниць в пам'яті
    long long result = countA + countB - countAB;
    
    cout << result << endl;
    
    return 0;
}
