#include <bits/stdc++.h>
using namespace std;

struct Point {
    int x, y, index;
};

bool compareBlue(Point a, Point b) {
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

bool compareRed(Point a, Point b) {
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    
    int t;
    cin >> t;
    
    while (t--) {
        int N;
        cin >> N;
        
        vector<Point> blue(N), red(N);
        
        // Зчитуємо сині точки
        for (int i = 0; i < N; ++i) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1;
        }
        
        // Зчитуємо червоні точки
        for (int i = 0; i < N; ++i) {
            cin >> red[i].x >> red[i].y;
            red[i].index = i + 1;
        }
        
        // Сортуємо сині та червоні точки
        sort(blue.begin(), blue.end(), compareBlue);
        sort(red.begin(), red.end(), compareRed);
        
        // Виводимо пари індексів синіх і червоних точок
        for (int i = 0; i < N; ++i) {
            cout << blue[i].index << " " << red[i].index << "\n";
        }
    }
    
    return 0;
}
