def solve_case(N, blue_points, red_points):
    # Індексуємо точки, щоб потім вивести їх відповідно до порядку
    indexed_blue = [(x, y, i + 1) for i, (x, y) in enumerate(blue_points)]
    indexed_red = [(x, y, i + 1) for i, (x, y) in enumerate(red_points)]
    
    # Сортуємо точки за координатами (перш за все по x, потім по y)
    indexed_blue.sort()  # сортуємо за (x, y)
    indexed_red.sort()   # сортуємо за (x, y)
    
    # Виводимо відповідні пари індексів
    result = []
    for i in range(N):
        blue_index = indexed_blue[i][2]
        red_index = indexed_red[i][2]
        result.append(f"{blue_index} {red_index}")
    
    return result

def main():
    t = int(input())  # кількість тестових блоків
    for _ in range(t):
        N = int(input())  # кількість точок одного кольору
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().split())) for _ in range(N)]
        
        result = solve_case(N, blue_points, red_points)
        
        if result:
            print("\n".join(result))

if __name__ == "__main__":
    main()
