#include <iostream>
using namespace std;

// Функція для визначення мінімальної кількості секунд
int findMeetingTime(int N) {
    if (N < 2) return -1; // Неприпустимі випадки
    
    int alice = 1; // Початкова позиція Аліси
    int bob = N;   // Початкова позиція Боба
    int time = 0;  // Лічильник секунд
    
    // Знаходимо момент зустрічі
    while (alice < bob) {
        time++;
        alice += (time % 2 == 1) ? 2 : 3; // Чергування: +2 або +3
        bob -= (time % 2 == 1) ? 1 : 2;   // Чергування: -1 або -2
        if (alice == bob) return time;   // Зустріч
    }
    
    return -1; // Зустріч неможлива
}

int main() {
    int N;
    cin >> N;
    cout << findMeetingTime(N) << endl;
    return 0;
}
