#include <iostream>
#include <unordered_set>
using namespace std;

int main() {
    long long N;
    cin >> N;

    if (N == 2) {
        cout << -1 << endl;
        return 0;
    }

    for (long long k = 0; k <= N; ++k) {
        unordered_set<long long> alice_positions;
        long long alice_pos1 = 1 + 2 * k;
        long long alice_pos2 = 1 + 3 * k;
        if (alice_pos1 <= N) alice_positions.insert(alice_pos1);
        if (alice_pos2 <= N) alice_positions.insert(alice_pos2);

        long long bob_pos1 = N - k;
        long long bob_pos2 = N - 2 * k;
        if (alice_positions.count(bob_pos1) || alice_positions.count(bob_pos2)) {
            cout << k << endl;
            return 0;
        }
    }

    cout << -1 << endl;
    return 0;
}