#include <iostream>
#include <cmath>
using namespace std;

long long findMeetingTime(long long N) {
    for (long long t = 0; t <= N; ++t) {
        // Аліса може бути у 1 + 2t або 1 + 3t
        long long alice1 = 1 + 2 * t;
        long long alice2 = 1 + 3 * t;

        // Боб може бути у N - t або N - 2t
        long long bob1 = N - t;
        long long bob2 = N - 2 * t;

        // Перевірка чи позиції збігаються
        if (alice1 == bob1 || alice1 == bob2 || alice2 == bob1 || alice2 == bob2) {
            return t;
        }

        // Якщо Аліса вийшла за межі, можна завершити раніше
        if (alice1 > N && alice2 > N) {
            break;
        }
    }
    return -1;
}

int main() {
    long long N;
    cin >> N;

    cout << findMeetingTime(N) << endl;

    return 0;
}
