using System;
using System.Collections.Generic;

class Program
{
    static void Main()
    {
        // Зчитування вхідних даних
        string[] input = Console.ReadLine().Split();
        long N = long.Parse(input[0]);
        long M = long.Parse(input[1]);

        // Список для збереження результату
        List<long> result = new List<long>();

        // Жадібний підхід: починаємо з найбільшої марки
        for (long i = N; i >= 1; i--)
        {
            if (M >= i)
            {
                result.Add(i);
                M -= i;
            }

            // Якщо сума досягнута, виходимо
            if (M == 0)
                break;
        }

        // Якщо неможливо скласти суму M, виводимо 0
        if (M > 0)
        {
            Console.WriteLine(0);
        }
        else
        {
            // Виводимо номери марок
            result.Reverse(); // Для виведення у зростаючому порядку
            Console.WriteLine(string.Join(" ", result));
        }
    }
}
