def find_stamps(N, M):

    stamps = list(range(1, N + 1))


    dp = {0: []}

    for stamp in stamps:
        new_dp = dp.copy()  # Temporary DP update
        for total, subset in dp.items():
            new_total = total + stamp
            if new_total <= M:
                new_dp[new_total] = subset + [stamp]

        dp = new_dp 

        # Stop early if we find a solution
        if M in dp:
            return dp[M]


    return 0


N = 12
M = 7


result = find_stamps(N, M)
print(result if result != 0 else 0)