#include <iostream>
#include <map>
#include <limits>
using namespace std;

int main() {
    int N;
    cin >> N;

    map<int, int> countMap; 
    int number;


    for (int i = 0; i < N; ++i) {
        cin >> number;
        countMap[number]++;
    }

    int minUnique = numeric_limits<int>::max();
    bool found = false;


    for (const auto& entry : countMap) {
        if (entry.second == 1) { 
            minUnique = min(minUnique, entry.first);
            found = true;
        }
    }


    if (found) {
        cout << minUnique << endl;
    } else {
        cout << -1 << endl; 
    }

    return 0;
}
