#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N;
    cin >> N;
    vector<vector<int>> grid(N, vector<int>(N));

    // Читання матриці
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int count = 0;

    // Перебір всіх можливих квадратів
    for (int size = 1; size < N; ++size) { // розмір квадрата (від 1 до N-1)
        for (int i = 0; i + size < N; ++i) { // верхня ліва вершина квадрата
            for (int j = 0; j + size < N; ++j) {
                // Перевірка кольорів вершин квадрата
                int color = grid[i][j];
                if (grid[i][j] == color &&
                    grid[i + size][j] == color &&
                    grid[i][j + size] == color &&
                    grid[i + size][j + size] == color) {
                    ++count;
                }
            }
        }
    }

    cout << count << endl;

    return 0;
}