#include <bits/stdc++.h>

using namespace std;

#define endl '\n'
#define pll pair<long long, long long>
#define fi first
#define se second

const long long DIM=1e2+7;
const long long INF=1e9+7;

long long n;
long long a[DIM][DIM];

bool checkSquare(int x1, int y1, int x2, int y2){
    int oX = x2-x1;
    int oY = y2-y1;

    int x3 = x2+oY;
    int y3 = y2-oX;

    if(x3<0 || x3>=n || y3<0 || y3>=n) return false;

    int x4 = x3-oX;
    int y4 = y3-oY;

    if(x4<0 || x4>=n || y4<0 || y4>=n) return false;


    if(a[y1][x1]==a[y2][x2] &&
       a[y2][x2]==a[y3][x3] &&
       a[y3][x3]==a[y4][x4]) return true;

    return false;
}

int checkBoard(int x, int y){
    int sum = 0;
    for(int i=0; i<n; i++){
        for(int j=0; j<n; j++){
            if(i==y && j==x) continue;
            if(checkSquare(x, y, j, i)==true){
                sum++;
            }
        }
    }
    return sum;
}

int main()
{
    cin >> n;
    for(int i=0; i<n; i++){
        for(int j=0; j<n; j++){
            cin >> a[i][j];
        }
    }

    int ans=0;
    for(int i=0; i<n; i++){
        for(int j=0; j<n; j++){
            ans+=checkBoard(j, i);
        }
    }

    cout << ans/4;

    return 0;
}