var scanf = require('scanf');

var n = scanf('%d');
let numbers = [];

for (let i = 0; i < +n; i++) {
    numbers.push(scanf('%d'));
}

const countMap = new Map();

for (let number of numbers) {
    if (countMap.has(number)) {
        countMap.set(number, countMap.get(number) + 1);
    } else {
        countMap.set(number, 1);
    }
}

let minUnique = -1;
for (let [number, count] of countMap.entries()) {
    if (count === 1) {
        if (minUnique === -1 || number < minUnique) {
            minUnique = number;
        }
    }
}
console.log(minUnique);


