def solve(points):
    points.sort(key=lambda x: (x[0], x[1]))

    n = len(points) // 2
    pairs = [-1] * n

    def find_pair(i):
        for j in range(n, 2*n):
            if pairs[j] == -1 and (points[i][0] != points[j][0] or points[i][1] != points[j][1]):
                pairs[i] = j - n
                pairs[j] = i
                return True
        return False

    for i in range(n):
        if not find_pair(i):
            return False

    return pairs

t = int(input())
for _ in range(t):
    n = int(input())
    points = []
    for _ in range(n):
        x, y = map(int, input().split())
        points.append((x, y))
    for _ in range(n):
        x, y = map(int, input().split())
        points.append((x, y))

    result = solve(points)

    if result:
        for i, j in enumerate(result):
            print(i+1, j+1)
    else:
        print(0)