import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int number = in.nextInt();
        System.out.printf("%d %d\n", number/10, number%10);
    }
}
import java.io.*;
import java.util.*;

public class Main {
    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter out = new PrintWriter(System.out);
        
        int t = Integer.parseInt(br.readLine()); // Кількість тестів
        
        for (int test = 0; test < t; test++) {
            int n = Integer.parseInt(br.readLine()); // Кількість точок одного кольору
            
            // Зчитування синіх точок
            Point[] blue = new Point[n];
            for (int i = 0; i < n; i++) {
                String[] line = br.readLine().split(" ");
                int x = Integer.parseInt(line[0]);
                int y = Integer.parseInt(line[1]);
                blue[i] = new Point(x, y, i + 1);
            }
            
            // Зчитування червоних точок
            Point[] red = new Point[n];
            for (int i = 0; i < n; i++) {
                String[] line = br.readLine().split(" ");
                int x = Integer.parseInt(line[0]);
                int y = Integer.parseInt(line[1]);
                red[i] = new Point(x, y, i + 1);
            }
            
            // Сортуємо обидва масиви точок
            Arrays.sort(blue, Comparator.comparingInt(p -> p.x));
            Arrays.sort(red, Comparator.comparingInt(p -> p.x));
            
            // Виводимо пари
            for (int i = 0; i < n; i++) {
                out.println(blue[i].index + " " + red[i].index);
            }
        }
        
        out.flush();
        out.close();
    }

    // Клас для зберігання координат точки та її індексу
    static class Point {
        int x, y, index;

        Point(int x, int y, int index) {
            this.x = x;
            this.y = y;
            this.index = index;
        }
    }
}
