#include <iostream>
#include <cmath>
using namespace std;

int min_time_to_meet(int N) {
    // Тіло задачі: перебір значень t, від 1 до максимального можливого часу
    for (int t = 1; t <= N; t++) {
        // Перевірка всіх можливих комбінацій кроків для Аліси (a, b) та Боба (c, d)
        for (int a = 0; a <= t; a++) {
            int b = t - a;  // кількість кроків на 3 для Аліси
            int alice_pos = 1 + 2 * a + 3 * b;  // позиція Аліси через t секунд

            for (int c = 0; c <= t; c++) {
                int d = t - c;  // кількість кроків на 2 для Боба
                int bob_pos = N - c - 2 * d;  // позиція Боба через t секунд

                // Перевірка на зустріч
                if (alice_pos == bob_pos) {
                    return t;
                }
            }
        }
    }
    return -1;  // Якщо зустріч неможлива
}

int main() {
    int N;
    cin >> N;  // Вхідне значення N
    int result = min_time_to_meet(N);
    cout << result << endl;  // Вивести результат
    return 0;
}
