#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

vector<int> result; 
vector<int> current; 

void findCombination(int index, int sum, int M, const vector<int>& stamps) {
    if (sum == M) {
        if (result.empty() || current.size() < result.size()) {
            result = current;
        }
        return;
    }
    if (sum > M || index == stamps.size()) {
        return;
    }
    current.push_back(stamps[index]);
    findCombination(index + 1, sum + stamps[index], M, stamps);

    current.pop_back();
    findCombination(index + 1, sum, M, stamps);
}

int main() {
    int N, M;
    cin >> N >> M;

    vector<int> stamps;
    for (int i = 1; i <= N; ++i) {
        stamps.push_back(i); 
    }
    findCombination(0, 0, M, stamps);

    if (result.empty()) {
        cout << 0 << endl; 
    } else {
        for (int mark : result) {
            cout << mark << " ";
        }
        cout << endl;
    }

    return 0;
}
