#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N, M;
    cin >> N >> M;
    
    // Сума всіх марок: сума чисел від 1 до N
    int total_sum = N * (N + 1) / 2;
    
    // Якщо сума всіх марок менша за M, неможливо вибрати марки
    if (total_sum < M) {
        cout << 0 << endl;
        return 0;
    }
    
    vector<int> selected_stamps;
    
    // Починаємо вибір з найбільших марок
    for (int i = N; i >= 1; --i) {
        if (M >= i) {
            selected_stamps.push_back(i);
            M -= i;
        }
        if (M == 0) break;
    }
    
    // Якщо M не дорівнює нулю, то не вдалося скласти потрібну суму
    if (M != 0) {
        cout << 0 << endl;
    } else {
        // Вивести обрані марки
        for (int stamp : selected_stamps) {
            cout << stamp << " ";
        }
        cout << endl;
    }

    return 0;
}
