#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N;
    cin >> N;

    // Вхідна матриця N x N
    vector<vector<int>> matrix(N, vector<int>(N));

    // Зчитуємо матрицю
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> matrix[i][j];
        }
    }

    int count = 0;

    // Перебираємо всі можливі квадрати
    for (int k = 1; k <= N; ++k) {  // Розміри квадратів від 1x1 до NxN
        for (int i = 0; i <= N - k; ++i) {  // Верхній лівий кут по вертикалі
            for (int j = 0; j <= N - k; ++j) {  // Верхній лівий кут по горизонталі

                // Перевіряємо, чи всі кути однакового кольору
                int top_left = matrix[i][j];
                int top_right = matrix[i][j + k - 1];
                int bottom_left = matrix[i + k - 1][j];
                int bottom_right = matrix[i + k - 1][j + k - 1];

                if (top_left == top_right && top_left == bottom_left && top_left == bottom_right) {
                    count++;
                }
            }
        }
    }

    // Виводимо результат
    cout << count << endl;

    return 0;
}
