#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N;
    cin >> N;

    // Вхідна матриця N x N
    vector<vector<int>> grid(N, vector<int>(N));

    // Зчитуємо матрицю
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int count = 0;

    // Перебираємо всі можливі квадрати від 1x1 до NxN
    for (int k = 1; k < N; ++k) {  // Розмір квадрату
        for (int i = 0; i <= N - k; ++i) {  // Верхній лівий кут по вертикалі
            for (int j = 0; j <= N - k; ++j) {  // Верхній лівий кут по горизонталі

                // Перевіряємо, чи всі кути однакові
                int color = grid[i][j];
                if (grid[i + k - 1][j] == color &&
                    grid[i][j + k - 1] == color &&
                    grid[i + k - 1][j + k - 1] == color) {
                    count++;
                }
            }
        }
    }

    // Виводимо результат
    cout << count << endl;

    return 0;
}

