#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct Point {
    int x, y, index;
    bool isBlue;
};

bool compare(Point a, Point b) {
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

int main() {
    int t;
    cin >> t; // Кількість тестових блоків
    
    while (t--) {
        int N;
        cin >> N;
        vector<Point> bluePoints(N), redPoints(N);

        // Зчитуємо сині точки
        for (int i = 0; i < N; ++i) {
            cin >> bluePoints[i].x >> bluePoints[i].y;
            bluePoints[i].index = i + 1;
            bluePoints[i].isBlue = true;
        }
        
        // Зчитуємо червоні точки
        for (int i = 0; i < N; ++i) {
            cin >> redPoints[i].x >> redPoints[i].y;
            redPoints[i].index = i + 1;
            redPoints[i].isBlue = false;
        }

        // Сортуємо обидва масиви точок по координатах
        sort(bluePoints.begin(), bluePoints.end(), compare);
        sort(redPoints.begin(), redPoints.end(), compare);

        // Виводимо пари точок
        for (int i = 0; i < N; ++i) {
            cout << bluePoints[i].index << " " << redPoints[i].index << endl;
        }
    }

    return 0;
}

