#include <bits/stdc++.h>
using namespace std;

struct point {
    int x, y, col, num;
    double coef; 
};

vector<point> a;
vector<int> res;
vector<pair<int,int>> ans;
int k = 1;
int fl = 0;

bool comp(pair<double,int> a, pair<double,int> b) {
    return a.first > b.first;
}

stack<vector<int>> st;

void dnc(vector<int> pts) {
    int n = pts.size();
    //for (auto i : pts) cout << a[i].x << " " << a[i].y << endl;
    //cout << endl;
    if (pts.size()==2) {
        res[pts[0]] = k;
        res[pts[1]] = k;
        ans.push_back({pts[0],pts[1]});
        k++;
        return;
    }
    vector<int> x_cords(n);
    vector<int> y_cords(n);
    for (int i = 0; i < n; i++) {
        x_cords[i] = a[pts[i]].x;
        y_cords[i] = a[pts[i]].y;
    }
    sort(x_cords.begin(),x_cords.end());
    sort(y_cords.begin(),y_cords.end());
    double cx = (x_cords[n/2-1]+x_cords[n/2])/2+0.3;
    double cy = (y_cords[n/2-1]+y_cords[n/2])/2+0.7;
    //for (int i = 0; i < n; i++) cout << x_cords[i] << " ";
    //cout << cx << " " << cy;
    vector<pair<double,int>> upd(n);
    int cnt_left = 0, cnt_right = 0, sm_left = 0, sm_right = 0;
    for (int i = 0; i < n; i++) {
        double slope = (a[pts[i]].y-cy)/(a[pts[i]].x-cx);
        upd[i] = {slope,pts[i]};
        if (a[pts[i]].x < cx) {
            if (a[pts[i]].col == 1) cnt_left++;
            else cnt_left--;
            sm_left++;
        }
        else {
            if (a[pts[i]].col == 1) cnt_right++;
            else cnt_right--;
            sm_right++;
        }
    }
    //cout << cnt_left << " " << cnt_right << endl;
    int flip_i = -1;
    if (cnt_left == 0 && cnt_right == 0 && sm_left > 0 && sm_right > 0) {
        flip_i = -1;
    }
    else {
        sort(upd.begin(),upd.end(),comp);
        for (int i = 0; i < n; i++) {
            //cout << a[upd[i].second].x << " " << a[upd[i].second].y << " " << upd[i].first <<endl;
            int ind = upd[i].second;
            if (a[ind].x < cx) {
                if (a[ind].col == 1) cnt_left--;
                else cnt_left++;
                if (a[ind].col == 1) cnt_right++;
                else cnt_right--;
                sm_left--;
                sm_right++;
            }
            else {
                if (a[ind].col == 1) cnt_left++;
                else cnt_left--;
                if (a[ind].col == 1) cnt_right--;
                else cnt_right++;
                sm_left++;
                sm_right--;
            }
            //cout << cnt_left << " " << cnt_right << endl;
            if (cnt_left == 0 && cnt_right == 0 && sm_left > 0 && sm_right > 0) {
                flip_i = i;
                break;
            }
            
        }
    }
    //cout << flip_i << endl;
    vector<int> ll, rr;
    for (int i = 0; i <= flip_i; i++) {
        int ind = upd[i].second;
        if (a[ind].x < cx) rr.push_back(ind);
        else ll.push_back(ind); 
    }
    for (int i = flip_i+1; i < n; i++ ){
        int ind = upd[i].second;
        if (a[ind].x < cx) ll.push_back(ind);
        else rr.push_back(ind); 
    }
    // cout << "ll:" << endl;
    // for (auto i : ll) cout << a[i].x << " " << a[i].y << endl;
    // cout << "rr:" << endl;
    // for (auto i : rr) cout << a[i].x << " " << a[i].y << endl;
    //dnc(ll);
    //dnc(rr);
    st.push(ll);
    st.push(rr);
    fl=1;
}

void solve() {
    int n;
    cin>>n;
    a.resize(2*n);
    res.resize(2*n);
    ans.clear();
    vector<int> v;
    for (int i = 0; i < 2*n; i++) {
        cin >> a[i].x >> a[i].y;
        a[i].col = i/n;
        a[i].num = i%n+1;
        v.push_back(i);
    }
    st.push(v);
    while(!st.empty()) {
        auto x = st.top();
        st.pop();
        dnc(x);
    }

    for (int i = 0; i < n; i++) {
        if (a[ans[i].first].col > a[ans[i].second].col) swap(ans[i].first,ans[i].second);
        //cout << a[ans[i].first].x << " " <<a[ans[i].first].y << "    " << a[ans[i].second].x << " " <<a[ans[i].second].y << endl;
        cout << a[ans[i].first].num << " " << a[ans[i].second].num << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    cin >> t;
    while(t--) {
        solve();
    }
}
