def select_stamps(N, M):
    dp = [float('inf')] * (M + 1)
    dp[0] = 0
    stamp_choice = [-1] * (M + 1)
    for i in range(1, N + 1):
        for j in range(M, i - 1, -1):
            if dp[j - i] + 1 < dp[j]:
                dp[j] = dp[j - i] + 1
                stamp_choice[j] = i
    if dp[M] == float('inf'):
        return [0]
    result = []
    while M > 0:
        result.append(stamp_choice[M])
        M -= stamp_choice[M]
    return result
N = int(input())
M = int(input())
result = select_stamps(N, M)
if result == [0]:
    print(0)
else:
    print(" ".join(map(str, sorted(result))))
