def solve_connecting_points(t, test_cases):
    results = []
    for case in test_cases:
        N, blue_points, red_points = case
        blue_points = sorted(blue_points)
        red_points = sorted(red_points)
        result = []
        for i in range(N):
            result.append((blue_points[i][2], red_points[i][2]))
        results.append(result)
    return results
t = int(input())
test_cases = []
for _ in range(t):
    N = int(input())
    blue_points = [tuple(map(int, input().split())) + (i + 1,) for i in range(N)]
    red_points = [tuple(map(int, input().split())) + (i + 1,) for i in range(N)]
    test_cases.append((N, blue_points, red_points))
results = solve_connecting_points(t, test_cases)
for result in results:
    for pair in result:
        print(pair[0], pair[1])
