n = int(input())
print ("%d %d\n" % (n/10, n%10))
def solve_case(N, blue_points, red_points):
    # Сортуємо точки по x (для кожного кольору)
    blue_points_sorted = sorted(blue_points)
    red_points_sorted = sorted(red_points)
    
    # Вивести результати
    result = []
    for i in range(N):
        blue_index = blue_points.index(blue_points_sorted[i]) + 1  # індекси з 1
        red_index = red_points.index(red_points_sorted[i]) + 1
        result.append(f"{blue_index} {red_index}")
    
    return result

def main():
    t = int(input())  # кількість тестів
    for _ in range(t):
        N = int(input())  # кількість точок одного кольору
        blue_points = []
        red_points = []
        
        # Читання синіх точок
        for _ in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y))
        
        # Читання червоних точок
        for _ in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y))
        
        # Розв'язання для цього тесту
        result = solve_case(N, blue_points, red_points)
        if result:
            print("\n".join(result))
        else:
            print(0)

# Викликаємо основну функцію
main()
