from collections import deque

N = int(input())
if N <= 1:
    print(-1)
else:
    alice_queue = deque([1])
    bob_queue = deque([N])
    visited_alice = set([1])
    visited_bob = set([N])
    seconds = 0

    while alice_queue and bob_queue:
        if visited_alice & visited_bob:
            print(seconds)
            break

        for _ in range(len(alice_queue)):
            pos = alice_queue.popleft()
            for next_pos in (pos + 2, pos + 3):
                if next_pos <= N and next_pos not in visited_alice:
                    visited_alice.add(next_pos)
                    alice_queue.append(next_pos)

        for _ in range(len(bob_queue)):
            pos = bob_queue.popleft()
            for next_pos in (pos - 1, pos - 2):
                if next_pos >= 1 and next_pos not in visited_bob:
                    visited_bob.add(next_pos)
                    bob_queue.append(next_pos)

        seconds += 1
    else:
        print(-1)