from collections import Counter

# Введення даних
N = int(input())
a = list(map(int, input().split()))

# Підрахунок кількості кожного числа
count = Counter(a)

# Пошук мінімального унікального числа
unique_min = float('inf')
for number, freq in count.items():
    if freq == 1 and number < unique_min:
        unique_min = number

# Виведення результату
print(unique_min if unique_min != float('inf') else -1)
