def solve():
    t = int(input())
    for _ in range(t):
        N = int(input())
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().split())) for _ in range(N)]
        
        blue_points = sorted(blue_points)
        red_points = sorted(red_points)
        
        pairs = []
        for i in range(N):
            pairs.append((i + 1, i + 1))
        
        is_possible = True
        for i in range(N):
            for j in range(i + 1, N):
                if (blue_points[i][0] - red_points[i][0]) * (blue_points[j][1] - red_points[j][1]) < (blue_points[j][0] - red_points[j][0]) * (blue_points[i][1] - red_points[i][1]):
                    is_possible = False
                    break
            if not is_possible:
                break
        
        if is_possible:
            for pair in pairs:
                print(pair[0], pair[1])
        else:
            print(0)

solve()
