def decompose_number(M, N):
    if M <= 0 or N <= 0:
        return None

    total_sum = N * (N + 1) // 2
    if M > total_sum:
        return None

    result = []
    for num in range(N, 0, -1):
        if M >= num:
            result.append(num)
            M -= num
        if M == 0:
            return result

    return None
N = int(input())
M = int(input())
result = decompose_number(M, N)
if result:
    for i in result:
        print(i)
else:
  print(0)