def decompose_number(M, N):
    if M <= 0 or N <= 0 or M > N * (N + 1) // 2:
        return None

    result = []
    total = M
    for num in range(N, 0, -1):
        if total >= num:
            result.append(num)
            total -= num
        if total == 0:
            return result

    return None

N = int(input())
M = int(input())
result = decompose_number(M, N)
if result:
    for i in result:
        print(i)
else:
  print(0)