def decompose_number(M, N):
    if N * (N + 1) // 2 < M:  
        return 0

    if M == 0:
        return ""  
    if M >= N:
        return f"{N} " + decompose_number(M - N, N - 1) 
    else:
        return decompose_number(M, N - 1)

N = int(input())
M = int(input())
result = decompose_number(M, N)

if result == 0:
    print(0)
else:
    print(result.strip())  
