def find_smallest_unique(nums):
    num_counts = {}
    
    for num in nums:
        num_counts[num] = num_counts.get(num, 0) + 1
    
    unique_nums = [num for num, count in num_counts.items() if count == 1]
    
    if unique_nums:
        return min(unique_nums)
    else:
        return -1

# Example usage
n = int(input())
nums = list(map(int, input().split()))  # Enter a list of numbers
result = find_smallest_unique(nums)
print(result)
