def count_squares(N, grid):
    count = 0
    for i1 in range(N):
        for j1 in range(N):
            for i2 in range(i1 + 1, N):
                for j2 in range(j1 + 1, N):
                    if grid[i1][j1] == grid[i2][j2]:
                        x3 = i2 + (j2 - j1)
                        y3 = j2 - (i2 - i1)
                        x4 = i1 + (j2 - j1)
                        y4 = j1 - (i2 - i1)
                        if 0 <= x3 < N and 0 <= y3 < N and 0 <= x4 < N and 0 <= y4 < N:
                            if grid[x3][y3] == grid[x4][y4] == grid[i1][j1]:
                                count += 1
    return count

N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

print(count_squares(N, grid))
