using System;

class Solution {
    public static void Main() {
        int n = int.Parse(Console.ReadLine());

        if (n < 2 || n > 1000000000) {
            Console.WriteLine("-1");
            return;
        }

        int result = FindMinimumTime(n);
        Console.WriteLine(result);
    }

    public static int FindMinimumTime(int N) {
        for (int seconds = 0; ; seconds++) {
            int aliceStart = 1 + 2 * seconds;
            int aliceEnd = 1 + 3 * seconds;
            int bobStart = N - seconds;
            int bobEnd = N - 2 * seconds;

            if (aliceStart > N || bobEnd < 1) break;

            if ((bobStart >= aliceStart && bobStart <= aliceEnd) || 
                (bobEnd >= aliceStart && bobEnd <= aliceEnd)) {
                return seconds;
            }
        }

        return -1;
    }
}
