using System;

class Solution {
    public static void Main() {
        int n = int.Parse(Console.ReadLine());

        // Перевірка на допустимість значення N
        if (n < 2 || n > 1000000000) {
            Console.WriteLine("-1");
            return;
        }

        int result = FindMinimumTime(n);
        Console.WriteLine(result);
    }

    public static int FindMinimumTime(int N) {
        // Початкові умови
        int aliceStart = 1;
        int bobStart = N;

        for (int seconds = 0; seconds <= N; seconds++) {
            // Перевіряємо можливі бокси Аліси та Боба
            int alicePos1 = aliceStart + 2 * seconds;
            int alicePos2 = aliceStart + 3 * seconds;
            int bobPos1 = bobStart - seconds;
            int bobPos2 = bobStart - 2 * seconds;

            // Перевіряємо, чи є спільний бокс
            if ((alicePos1 >= 1 && alicePos1 <= N && (alicePos1 == bobPos1 || alicePos1 == bobPos2)) || 
                (alicePos2 >= 1 && alicePos2 <= N && (alicePos2 == bobPos1 || alicePos2 == bobPos2))) {
                return seconds;
            }
        }

        // Якщо не знайшли спільного боксного номера
        return -1;
    }
}
