using System;

class Solution {
    public static void Main() {
        int n = int.Parse(Console.ReadLine());

        if (n < 2 || n > 1000000000) {
            Console.WriteLine("-1");
            return;
        }

        int result = FindMinimumTime(n);
        Console.WriteLine(result);
    }

    public static int FindMinimumTime(int N) {
        for (int seconds = 0; seconds <= N; seconds++) {
            int alice1 = 1 + 2 * seconds;  // 1 + 2 * t
            int alice2 = 1 + 3 * seconds;  // 1 + 3 * t

            int bob1 = N - seconds;         // N - t
            int bob2 = N - 2 * seconds;     // N - 2 * t

            if ((alice1 == bob1) || (alice1 == bob2) || 
                (alice2 == bob1) || (alice2 == bob2)) {
                return seconds;
            }

            if (alice1 > N && alice2 > N) {
                break;
            }
        }

        return -1; // Якщо не знайдено
    }
}