using System;

class Solution {
    public static void Main() {
        int N = int.Parse(Console.ReadLine());
        
        if (N < 2 || N > 1000000000) {
            Console.WriteLine("-1");
            return;
        }

        int seconds = FindMinimumTime(N);
        Console.WriteLine(seconds);
    }

    public static int FindMinimumTime(int N) {
        if (N == 2) return 1; 

        for (int seconds = 1; seconds <= N / 2; seconds++) {
            if ((seconds * 2 + 1 >= N - seconds * 2)) {
                return seconds;
            }
        }

        // Якщо не знайшли можливості зустрічі
        return -1;
    }
}