# Функція для перевірки, чи число міститься в вказаному діапазоні
def get_input_from_user(min_val, max_val):
    while True:
        try:
            number = int(input())
            
            if min_val <= number <= max_val:
                return number
            else:
                print("Введіть число в діапазоні від 1 до 1 000 000 000 включно!")
        except ValueError:
            print("Це не ціле число. Спробуйте ще раз!")

# Функція для обчислення висоти вежі
def calculate_height(N, K):
    # Кількість непарних кубиків
    odd_count = (N + 1) // 2
    
    # Якщо K непарне
    if K % 2 == 1:
        return (K + 1) // 2  # Висота для непарних кубиків
    else:
        # Якщо K парне
        return odd_count + (K // 2)  # Висота для парних кубиків

# Вхідні дані
N = get_input_from_user(1, 1000000000)
K = get_input_from_user(1, N)

# Виведення результату
print(calculate_height(N, K))
