# Функція для перевірки, чи число міститься в вказаному діапазоні
def get_input_from_user(min_val, max_val):
    while True:
        try:
            number = int(input())
            
            if min_val <= number <= max_val:
                return number
            else:
                print("Введіть число в діапазоні від 1 до 1 000 000 000 включно!")
        except Error:
            print("Це не ціле число. Спробуйте ще раз!")

def select_stamps(N, M):
    # Перевіримо, чи можна досягти суми M
    stamp_sum = N * (N + 1) // 2
    if M > stamp_sum:
        return [0]
    
    selected_stamps = []
    for i in range(N, 0, -1):
        if M >= i:
            M -= i
            selected_stamps.append(i)
        if M == 0:
            break

    if M == 0:
        return selected_stamps
    else:
        return 0

# Введення даних
N = get_input_from_user(1, 10**9)
M = get_input_from_user(1, 10**9)

result = select_stamps(N, M)
for stamp in result:
    print(stamp)