
# Функція для перевірки, чи число міститься в вказаному діапазоні
def get_input_from_user():
    while True:
        try:
            number = int(input())
            if 1 <= number <= 10**9:
                return number
            else:
                print("Введіть число в діапазоні від 1 до 1 000 000 000 включно!")
        except ValueError:
            print("Це не ціле число. Спробуйте ще раз!")

def select_stamps(N, M):
    # Максимальна сума всіх чисел від 1 до N
    stamp_sum = N * (N + 1) // 2

    if M > stamp_sum:
        return [0]

    selected_stamps = []
    current = N

    while M > 0 and current > 0:
        if M >= current:
            selected_stamps.append(current)
            M -= current
        current -= 1

    if M == 0:
        return selected_stamps
    else:
        return [0]

# Введення даних
N = get_input_from_user()
M = get_input_from_user()

# Отримуємо результат
result = select_stamps(N, M)

# Вивід результату
print("\n".join(map(str, result)) + "\n")
