from collections import Counter

# Функція для перевірки, чи число міститься в вказаному діапазоні
def get_input_from_user(min_val, max_val):
    while True:
        try:
            number = int(input())
            
            if min_val <= number <= max_val:
                return number
            else:
                print("Введіть число в діапазоні від 1 до 1 000 000 000 включно!")
        except Error:
            print("Це не ціле число. Спробуйте ще раз!")

N = get_input_from_user(1, 10**5)
a = list(map(int, input().split()))

# Обчислюємо частоту кожного числа
counter = Counter(a)

min_unique = -1
for number in counter:
    if counter[number] == 1:
        # якщо число зустрічається один раз
        if min_unique == -1 or number < min_unique:
            # якщо ми поки не знайшли унік. числа
            # або якщо це число є меншим за унік. число
            min_unique = number

# Виводимо результат
print(min_unique)
