# Функція для перевірки, чи число міститься в вказаному діапазоні
def get_input_from_user(min_val, max_val):
    while True:
        try:
            number = int(input())
            
            if min_val <= number <= max_val:
                return number
            else:
                print(f"Введіть число в діапазоні від {min_val} до {max_val} включно!")
        except ValueError:
            print("Це не ціле число. Спробуйте ще раз!")

# Функція для вибору чисел, які діляться на A або B
def chooseNumbers(a, b, n):
    chosenNumbers = set()  

    # Вибір чисел, які діляться на A
    for i in range(a, n + 1, a):
        chosenNumbers.add(i)

    # Вибір чисел, які діляться на B
    for i in range(b, n + 1, b):
        chosenNumbers.add(i)
    
    # Повертаємо відсортований список чисел, які діляться на A або B
    return len(chosenNumbers)

# Вхідні дані
N = int(input())  # кількість комірок
A, B = map(int, input().split())  # числа A та B

chosenNumbers = chooseNumbers(A, B, N)

print(chosenNumbers)