using System;

class Program
{
    static void Main()
    {
        // Зчитуємо кількість тестових блоків
        int t = int.Parse(Console.ReadLine());
        
        for (int test = 0; test < t; test++)
        {
            int N = int.Parse(Console.ReadLine()); // Кількість точок одного кольору

            // Масиви для зберігання координат синіх та червоних точок
            int[][] bluePoints = new int[N][];
            int[][] redPoints = new int[N][];

            // Зчитуємо координати синіх точок
            for (int i = 0; i < N; i++)
            {
                var coords = Console.ReadLine().Split();
                bluePoints[i] = new int[] { int.Parse(coords[0]), int.Parse(coords[1]), i + 1 }; // Додаємо індекс
            }

            // Зчитуємо координати червоних точок
            for (int i = 0; i < N; i++)
            {
                var coords = Console.ReadLine().Split();
                redPoints[i] = new int[] { int.Parse(coords[0]), int.Parse(coords[1]), i + 1 }; // Додаємо індекс
            }

            // Сортуємо точки за координатами
            Array.Sort(bluePoints, (a, b) => a[0] != b[0] ? a[0].CompareTo(b[0]) : a[1].CompareTo(b[1]));
            Array.Sort(redPoints, (a, b) => a[0] != b[0] ? a[0].CompareTo(b[0]) : a[1].CompareTo(b[1]));

            // Виводимо індекси з'єднаних точок
            for (int i = 0; i < N; i++)
            {
                Console.WriteLine($"{bluePoints[i][2]} {redPoints[i][2]}");
            }
        }
    }
}
