#include <bits/stdc++.h>
using namespace std;

vector<int> choose_stamps(int N, int M) {
    vector<int> result;
    int remaining_sum = M;
    int left = 1, right = N;
    while (left <= right) {
        int mid = left + (right - left) / 2;
        if (mid <= remaining_sum) {
            left = mid + 1;
            result.push_back(mid);
            remaining_sum -= mid;
        } else {
            right = mid - 1;
        }
    }
    return result;
}

int main() {
    int N, M;
    cin >> N >> M;

    vector<int> selected_stamps = choose_stamps(N, M);

    if (!selected_stamps.empty()) {
        for (int stamp : selected_stamps) {
            cout << stamp << " ";
        }
    } else {
        cout << 0;
    }

    return 0;
}