#include <iostream>
#include <unordered_map>
#include <vector>
#include <climits>  
#include <bits/stdc++.h>

using namespace std;

int main() {
    int N;
    cin >> N; 
    vector<int> a(N);
    for (int i = 0; i < N; ++i) {
        cin >> a[i];
    }
    unordered_map<int, int> count;
    for (int num : a) {
        count[num]++;
    }
    int result = INT_MAX; 
    for (auto& pair : count) {
        if (pair.second == 1 && pair.first < result) {
            result = pair.first;
        }
    }
    if (result == INT_MAX) {
        cout << -1 << endl;
    } else {
        cout << result << endl;
    }

    return 0;
}
