#include <bits/stdc++.h>

using namespace std;

struct Point {
    int x, y, index;
};

bool compare(const Point &a, const Point &b) {
    return a.x < b.x;
}

// Перевірка на перетин двох відрізків (i-й і j-й)
bool isIntersecting(int i, int j, const vector<Point>& blue, const vector<Point>& red) {
    return (blue[i].x < blue[j].x && red[i].x > red[j].x) || (blue[i].x > blue[j].x && red[i].x < red[j].x);
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<Point> blue(N), red(N);

        for (int i = 0; i < N; i++) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1;
        }

        for (int i = 0; i < N; i++) {
            cin >> red[i].x >> red[i].y;
            red[i].index = i + 1;
        }

        sort(blue.begin(), blue.end(), compare);
        sort(red.begin(), red.end(), compare);

        bool possible = true;
        for (int i = 0; i < N; i++) {
            for (int j = i + 1; j < N; j++) {
                if (isIntersecting(i, j, blue, red)) {
                    possible = false;
                    break;
                }
            }
            if (!possible) break;
        }

        if (possible) {
            for (int i = 0; i < N; i++) {
                cout << blue[i].index << " " << red[i].index << endl;
            }
        } else {
            cout << 0 << endl;
        }
    }

    return 0;
}