def min_time_to_meet(N):
    if N == 2:
        return -1
    
    alice_pos = {1}
    bob_positions = {N}
    time = 0
    
    while alice_pos and bob_positions:
        time += 1
        new_alice_pos = set()
        for pos in alice_pos:
            if pos + 2 <= N:
                new_alice_pos.add(pos + 2)
            if pos + 3 <= N:
                new_alice_pos.add(pos + 3)
        alice_pos = new_alice_pos
        
        new_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                new_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_positions.add(pos - 2)
        bob_positions = new_bob_positions
        
        intersection = alice_pos & bob_positions
        if intersection:
            return time
    return -1

N = int(input())
result = min_time_to_meet(N)
print(result)