from collections import deque

def min_seconds_to_meet(N):
    alice_positions = {1}
    bob_positions = {N}
    
    if 1 == N:
        return 0
    
    seconds = 0
    while alice_positions and bob_positions:
        seconds += 1
        
        next_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= N:
                next_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                next_alice_positions.add(pos + 3)
        
        next_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                next_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                next_bob_positions.add(pos - 2)
        
        if next_alice_positions & next_bob_positions:
            return seconds
        
        alice_positions = next_alice_positions
        bob_positions = next_bob_positions
    return -1

N = int(input())
print(min_seconds_to_meet(N))