#include <iostream>
#include <algorithm> 
using namespace std;

#include <iostream>
using namespace std;

// Функція для обчислення GCD (найбільший спільний дільник)
long long gcd(long long a, long long b) {
    while (b != 0) {
        long long temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

// Функція для обчислення LCM (найменше спільне кратне)
long long lcm(long long a, long long b) {
    return (a * b) / gcd(a, b);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long N, A, B;
    cin >> N >> A >> B;
    
    // Підраховуємо кількість елементів, які діляться на A, B і LCM(A, B)
    long long countA = N / A;
    long long countB = N / B;
    long long countLCM = N / lcm(A, B);
    
    // Використовуємо принцип включень та виключень
    long long result = countA + countB - countLCM;
    
    cout << result << endl;
    
    return 0;
}
