#include <iostream>
#include <algorithm> 
using namespace std;


int gcd(int a, int b) {
    while (b != 0) {
        a %= b;
        swap(a, b);
    }
    return a;
}

// Функція для знаходження найменшого спільного кратного
int lcm(int a, int b) {
    return a / gcd(a, b) * b;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    // Вхідні дані
    int N, A, B;
    cin >> N >> A >> B;

    // Кількість чисел, кратних A
    int countA = N / A;
    // Кількість чисел, кратних B
    int countB = N / B;
    // Кількість чисел, кратних обом A і B
    int countCommon = N / lcm(A, B);

    // Загальна кількість унікальних чисел, кратних A або B
    int result = countA + countB - countCommon;

    // Виведення результату
    cout << result << endl;

    return 0;
}
