from collections import Counter

def solve(N, numbers):
 
    count = Counter(numbers)
    

    min_unique = float('inf')
    for num, freq in count.items():
        if freq == 1 and num < min_unique:
            min_unique = num
    

    if min_unique == float('inf'):
        print(-1)
    else:
        print(min_unique)


N = int(input())
numbers = list(map(int, input().split()))
solve(N, numbers)
