def count_same_color_squares(N, grid):
    count = 0

    for size in range(1, N):
        for i in range(N - size):
            for j in range(N - size):
            
                all_same = True
                for x in range(i, i + size + 1):
                    for y in range(j, j + size + 1):
                        if grid[i][j] != grid[x][y]:
                            all_same = False
                            break
                    if not all_same:
                        break
                if all_same:
                    count += 1

    return count

def main():
    import sys
    input = sys.stdin.read
    data = input().split()
    
    N = int(data[0])
    grid = []
    
    index = 1
    for i in range(N):
        grid.append([int(data[index + j]) for j in range(N)])
        index += N
    
    result = count_same_color_squares(N, grid)
    print(result)

if __name__ == "__main__":
    main()
