def count_colored_squares(N, grid):
    count = 0
    for size in range(1, N):
        for i in range(N - size):
            for j in range(N - size):
                color = grid[i][j]
                if all(grid[i+di][j+dj] == color for di in range(size + 1) for dj in range(size + 1)):
                    count += 1
    return count

N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

print(count_colored_squares(N, grid))
