def count_colored_squares(N, grid):
    count = 0
    for i1 in range(N):
        for j1 in range(N):
            for i2 in range(i1 + 1, N):
                for j2 in range(j1 + 1, N):
                    if (i2 - i1) == (j2 - j1):
                        color = grid[i1][j1]
                        if (grid[i1][j1] == grid[i2][j1] == grid[i1][j2] == grid[i2][j2] == color):
                            count += 1
    return count

N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

print(count_colored_squares(N, grid))
