def count_colored_squares(N, grid):
    count = 0
    for i in range(N):
        for j in range(N):
            for size in range(1, N - max(i, j)):
                if (grid[i][j] == grid[i + size][j] == grid[i][j + size] == grid[i + size][j + size]):
                    count += 1
    return count

N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

print(count_colored_squares(N, grid))
