def solve(test_cases):
    for case in test_cases:
        N, blue_points, red_points = case
        

        sorted_blue = sorted(enumerate(blue_points, 1), key=lambda x: (x[1][0], x[1][1]))

        sorted_red = sorted(enumerate(red_points, 1), key=lambda x: (x[1][0], x[1][1]))
        
        result = []
        for i in range(N):
            blue_index = sorted_blue[i][0]
            red_index = sorted_red[i][0]
            result.append(f"{blue_index} {red_index}")
        
       
        print("\n".join(result))


t = int(input())
test_cases = []

for _ in range(t):
    N = int(input()) 
    blue_points = [tuple(map(int, input().split())) for _ in range(N)]
    red_points = [tuple(map(int, input().split())) for _ in range(N)] 
    test_cases.append((N, blue_points, red_points))


solve(test_cases)
