def find_meeting_time(N):
    if (N - 1) % 2 != 0:
        return -1

    alice_position = 1
    bob_position = N
    time = 0

    while alice_position < bob_position:
        if (bob_position - alice_position) % 3 == 0:
            alice_position += 3
        else:
            alice_position += 2
        if (bob_position - alice_position) % 2 == 0:
            bob_position -= 2
        else:
            bob_position -= 1
        time += 1
        if alice_position == bob_position:
            return time

    return -1

N = int(input())
result = find_meeting_time(N)
print(result)