#include <iostream>
#include <vector>
#include <climits>
using namespace std;
void findStamps(int N, int M) {
    vector<int> dp(M + 1, INT_MAX); 
    dp[0] = 0; 
    vector<int> parent(M + 1, -1);
    for (int i = 1; i <= N; ++i) {
        for (int j = M; j >= i; --j) {
            if (dp[j - i] != INT_MAX && dp[j - i] + 1 < dp[j]) {
                dp[j] = dp[j - i] + 1;
                parent[j] = i;
            }
        }
    }
    if (dp[M] == INT_MAX) {
        cout << 0 << endl;
    } else {
        int sum = M;
        while (sum > 0) {
            cout << parent[sum] << " ";
            sum -= parent[sum];
        }
        cout << endl;
    }
}
int main() {
    int N, M;
    cin >> N;
    cin >> M;
    findStamps(N, M);
    return 0;
}
