#include <iostream>
#include <vector>
using namespace std;

vector<long long> findStamps(long long N, long long M) {
    vector<long long> result;
    for (long long i = N; i >= 1; --i) {
        if (M >= i) {
            result.push_back(i);
            M -= i;
        }
    }
    if (M == 0) {
        return result;
    } else {
        return {};
    }
}

int main() {
    long long N, M;
    cin >> N >> M;

    vector<long long> result = findStamps(N, M);

    if (result.empty()) {
        cout << 0 << endl;
    } else {
        for (long long stamp : result) {
            cout << stamp << " ";
        }
        cout << endl;
    }

    return 0;
}
