#include <iostream>
#include <vector>
using namespace std;
vector<long long> findStamps(long long N, long long M) {
    vector<long long> result;
    while (M > 0 && N > 0) {
        long long sum = N * (N + 1) / 2;
        if (sum < M) {
            return {};
        }
        if (M >= N) {
            result.push_back(N);
            M -= N;
        }
        --N;
    }
    if (M == 0) {
        return result;
    } else {
        return {};
    }
}
int main() {
    long long N, M;
    cin >> N >> M;
    vector<long long> result = findStamps(N, M);
    if (result.empty()) {
        cout << 0 << endl;
    } else {
        for (long long stamp : result) {
            cout << stamp << " ";
        }
        cout << endl;
    }
    return 0;
}