#include <iostream>
#include <vector>
#include <unordered_map>
#include <limits>
using namespace std;

string findPresident(const vector<int>& numbers) {
    unordered_map<int, int> count;
    for (int num : numbers) {
        count[num]++;
    }
    long long minUnique = numeric_limits<int>::max(); 
    int minIndex = -1;
    for (size_t i = 0; i < numbers.size(); ++i) {
        if (count[numbers[i]] == 1 && numbers[i] < minUnique) {
            minUnique = numbers[i];
            minIndex = i; 
        }
    }
    if (minIndex == -1) {
        return "-1";
    }
    return to_string(minIndex);
}
int main() {
    int N;
    cin >> N;
    vector<int> numbers(N);
    for (int i = 0; i < N; ++i) {
        cin >> numbers[i];
    }
     cout << findPresident(numbers) << endl;
    return 0;
}

