#include <iostream>
#include <vector>
#include <unordered_map>
#include <limits>

using namespace std;

void findPresident(int N, const vector<int>& numbers) {
    unordered_map<int, int> frequency; 
    int minUniqueNumber = numeric_limits<int>::max();
    int presidentIndex = -1;
    for (int i = 0; i < N; ++i) {
        frequency[numbers[i]]++;
    }
    for (int i = 0; i < N; ++i) {
        if (frequency[numbers[i]] == 1 && numbers[i] < minUniqueNumber) {
            minUniqueNumber = numbers[i];
            presidentIndex = i + 1;
        }
    }
    if (presidentIndex == -1) {
        cout << -1<< endl;
    } else {
        cout << presidentIndex << endl;
    }
}
int main() {
    int N;
    cin >> N;
    vector<int> numbers(N);
    for (int i = 0; i < N; ++i) {
        cin >> numbers[i];
    }
    findPresident(N, numbers);
    return 0;
}
