def robot_meeting(n):
    
    Обчислює мінімальну кількість секунд до зустрічі роботів.

    Args:
        n: Кількість боксів.

    Returns:
        Мінімальна кількість секунд або -1, якщо зустріч неможлива.


    alice, bob = 1, n
    time = 0

    while alice < bob:
        time += 1
        alice = min(n, alice + 3)  # Переміщуємо Алісу на максимально можливу відстань
        bob = max(1, bob - 2)    # Переміщуємо Боба на максимально можливу відстань

    return time if alice == bob else -1

# Приклад використання
n = int(input("Введіть кількість боксів: "))
result = robot_meeting(n)

if result == -1:
    print("Роботи не зустрінуться.")
else:
    print("Роботи зустрінуться через", result, "секунд.")