def select_stamps(N, M):  
    total_value = N * (N + 1) // 2  # Сума від 1 до N  
    if M > total_value:  # Якщо запитувана сума більше, ніж максимально можлива  
        return [0]  

    selected_stamps = []  
    
    # Перебираємо марки від максимальної до мінімальної  
    for stamp_value in range(N, 0, -1):  
        if M >= stamp_value:  
            selected_stamps.append(stamp_value)  # Додаємо марку  
            M -= stamp_value  # Віднімаємо її вартість  
            
            if M == 0:  
                break  

    if M == 0:  # Якщо вартість досягнута  
        selected_stamps.sort()  # Сортуємо для організації результату  
        return selected_stamps  
    else:  
        return [0]  

# Зчитування вхідних даних  
N = int(input())  
M = int(input())  

# Вигляд результату  
result = select_stamps(N, M)  
print(' '.join(map(str, result)) if result[0] != 0 else 0)   