def select_stamps(N, M):  
    # Сума всіх марок від 1 до N  
    total_value = (N * (N + 1)) // 2  
    if M > total_value:  # якщо M перевищує можливу максимальну суму  
        return [0]  

    selected_stamps = []  
    
    # Перебір від максимальної марки до мінімальної  
    for stamp_value in range(N, 0, -1):  
        if M >= stamp_value:  # якщо марка може бути включена  
            selected_stamps.append(stamp_value)  # додаємо марку до результату  
            M -= stamp_value  # зменшуємо необхідну суму  

        if M == 0:  # Якщо досягли точної суми  
            break  

    if M == 0:  # Якщо сума дорівнює 0, ми знайшли марки  
        selected_stamps.sort()  # Сортуємо для кращого вигляду  
        return selected_stamps  
    else:  
        return [0]  

# Зчитування вхідних даних  
N = int(input().strip())  
M = int(input().strip())  

# Вигляд результату  
result = select_stamps(N, M)  
print(' '.join(map(str, result)) if result != [0] else 0)     