def select_stamps(N, M):  
    # Максимальна можлива сума марок  
    total_value = (N * (N + 1)) // 2  
    
    if M > total_value:  # Якщо M більше максимальної можливої суми  
        return [0]  

    selected_stamps = []  
    
    # Перебираємо марки з максимальної до мінімальної  
    for stamp_value in range(N, 0, -1):  
        if M >= stamp_value:  # Якщо марка може бути включена  
            selected_stamps.append(stamp_value)  
            M -= stamp_value  # Віднімаємо суму марки  

            if M == 0:  # Якщо досягли потрібної суми  
                break  

    if M == 0:  # Якщо вартість стала нульовою  
        selected_stamps.sort()  # Сортуємо для організації результату  
        return selected_stamps  
    else:  
        return [0]  

# Зчитування вхідних даних  
N = int(input().strip())  
M = int(input().strip())  

# Виведення результату  
result = select_stamps(N, M)  
print(' '.join(map(str, result)) if result != [0] else 0)      