def select_stamps(N, M):  
    # Максимальна можлива сума марок  
    total_value = (N * (N + 1)) // 2  
    
    # Якщо M більше максимальної суми, повертаємо 0  
    if M > total_value:  
        return [0]  

    selected_stamps = []  
    
    # Перебираємо марки з максимальної до мінімальної  
    for stamp_value in range(N, 0, -1):  
        if M <= 0:  
            break  # Вихід з циклу, якщо сума досягнута  
        
        if stamp_value <= M:  # Вибираємо марку, якщо її значення менше або дорівнює M  
            selected_stamps.append(stamp_value)  
            M -= stamp_value  # Зменшуємо залишок M  

    # Якщо M безпосередньо дорівнює 0, ми знайшли вірні марки  
    if M == 0:  
        return sorted(selected_stamps)  # Повертаємо відсортовані значення  

    # Якщо залишилося M, можливо, це означає, що ви не можете дійти до 0  
    return [0]  

# Зчитування вхідних даних  
N = int(input().strip())  
M = int(input().strip())  

# Вигляд результату  
result = select_stamps(N, M)  
print(' '.join(map(str, result)) if result != [0] else 0)  