#include <iostream>  
#include <vector>  

using namespace std;  

int main() {  
    int N;  
    cin >> N;  
    
    // Зчитування матриці кольорів  
    vector<vector<int>> color(N, vector<int>(N));  
    for (int i = 0; i < N; ++i) {  
        for (int j = 0; j < N; ++j) {  
            cin >> color[i][j];  
        }  
    }  

    int count = 0;  

    // Перебір можливих квадратів  
    for (int size = 1; size < N; ++size) { // розмір квадрату (1 до N-1)  
        for (int i = 0; i <= N - size; ++i) { // верхня координата квадрата  
            for (int j = 0; j <= N - size; ++j) { // ліва координата квадрата  
                // Перевіряєм всі 4 вершини  
                int a = color[i][j];                   // (i, j)  
                int b = color[i][j + size];           // (i, j + size)  
                int c = color[i + size][j];           // (i + size, j)  
                int d = color[i + size][j + size];    // (i + size, j + size)  

                // Якщо усі вершини однакові, збільшуємо лічильник  
                if (a == b && b == c && c == d) {  
                    count++;  
                }  
            }  
        }  
    }  

    // Виведення результату  
    cout << count << endl;  

    return 0;  
}  

# Читання даних  
N = int(input())  
grid = [list(map(int, input().split())) for _ in range(N)]  

# Отримання результату  
result = count_uniform_squares(N, grid)  

# Вивід результату  
print(result)  