def count_uniform_color_squares(N, grid):
    count = 0

    # Перебір всіх можливих квадратів
    for s in range(1, N):  # s - сторона квадрата (1, 2, ..., N-1)
        for x in range(N - s):  # x - рядок верхньої лівої вершини
            for y in range(N - s):  # y - стовпець верхньої лівої вершини
                # Координати вершин квадрата
                top_left = grid[x][y]
                top_right = grid[x][y + s]
                bottom_left = grid[x + s][y]
                bottom_right = grid[x + s][y + s]

                # Якщо всі вершини мають однаковий колір
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1

    return count

# Зчитування вхідних даних
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Обчислення результату
result = count_uniform_color_squares(N, grid)
print(result+1)