def find_matching_points(t, test_cases):  
    results = []  
    
    for case in test_cases:  
        N, blue_points, red_points = case  
        # Сортуємо точки за x, а потім за y  
        blue_points_sorted = sorted((x, y, i + 1) for i, (x, y) in enumerate(blue_points))  
        red_points_sorted = sorted((x, y, i + 1) for i, (x, y) in enumerate(red_points))  
        
        pairs = []  

        # Поєднуємо точки  
        for i in range(N):  
            blue_index = blue_points_sorted[i][2]  
            red_index = red_points_sorted[i][2]  
            pairs.append((blue_index, red_index))  
        
        results.append(pairs)  

    return results  

# Читання даних  
t = int(input())  
test_cases = []  

for _ in range(t):  
    N = int(input())  
    blue_points = [tuple(map(int, input().split())) for _ in range(N)]  
    red_points = [tuple(map(int, input().split())) for _ in range(N)]  
    test_cases.append((N, blue_points, red_points))  

results = find_matching_points(t, test_cases)  

# Вивід результатів  
for res in results:  
    if isinstance(res, list):  
        for pair in res:  
            print(f"{pair[0]} {pair[1]}")  
    else:  
        print(res)  