#include <bits/stdc++.h>
using namespace std;
#include <vector>

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long N, M;
    cin >> N;
    cin >> M;
    vector<int> cost(N);
    for (int i = 0; i < N; ++i) cost[i] = i + 1;
    vector<int> dp(M + 1, INT_MAX);
    vector<int> last_stamp(M + 1, -1);
    dp[0] = 0;
    for (int i = 1; i <= M; ++i){
        for (int j = 0; j < N; ++j){
            if (cost[j] <= i && dp[i - cost[j]] != INT_MAX && dp[i] > dp[i - cost[j]] + 1){
                dp[i] = dp[i - cost[j]] + 1;
                last_stamp[i] = cost[j];
            }
        }
    }
    if (dp[M] == INT_MAX){
        cout << 0 << std::endl;
    }
    else{
        vector<int> result;
        for (int i = M; i > 0; i -= last_stamp[i]){
            result.push_back(last_stamp[i]);
        }
        for (int stamp : result) { 
            cout << stamp;
        }
    }
    
}
