from itertools import combinations
def dis_sq(p1, p2):
    return (p1[0] - p2[0])**2 + (p1[1] - p2[1])**2

def is_square(p1, p2, p3, p4):
    distances = [
        dis_sq(p1, p2),
        dis_sq(p1, p3),
        dis_sq(p1, p4),
        dis_sq(p2, p3),
        dis_sq(p2, p4),
        dis_sq(p3, p4)
    ]
    distances.sort()


    return (distances[0] > 0 and
            distances[0] == distances[1] == distances[2] == distances[3] and
            distances[4] == distances[5] and
            distances[4] == 2 * distances[0])

def count_squares(points):
    square_count = 0


    for p1, p2, p3, p4 in combinations(points, 4):
        if is_square(p1, p2, p3, p4):
            square_count += 1

    return square_count


n=int(input())
a=""
for i in range(n):
  a=a+input()+" "
k=list(map(int, a.split()))
points = []
points2 = []
for i in range(n):
  for j in range(n):
    if k[j+i*n]==1:
      points.append((i,j))
    else:
      points2.append((i,j))

f_rs=count_squares(points)+count_squares(points2)
print(f_rs)
