using System;

class Solution {
  public static void Main(string[] args) {
        long N = long.Parse(Console.ReadLine());

        long difference = N - 1;

        if (difference % 1 != 0)
        {
            Console.WriteLine("-1");
            return;
        }

        long result = Solve(N, difference);
        Console.WriteLine(result);
    }

    static long Solve(long N, long difference)
    {
        long t = 0;
        while (true)
        {
            long alice1 = 1 + 2 * t;
            long alice2 = 1 + 3 * t;

            long bob1 = N - t;
            long bob2 = N - 2 * t;

            if (alice1 == bob1 || alice1 == bob2 || alice2 == bob1 || alice2 == bob2)
                return t;

            if (alice1 > N || bob1 < 1)
                break;

            t++;
        }

        return -1;
    }
}
