using System;

class Solution {
  public static void Main(string[] args) {
        long N = long.Parse(Console.ReadLine());

        long result = FindMinTime(N);

        Console.WriteLine(result);
    }

    static long FindMinTime(long N)
    {
        long difference = N - 1;

        foreach (var step in new int[] { 2, 3 })
        {
            foreach (var k in new int[] { 1, 2 })
            {
                long denominator = step + k;
                if (difference % denominator == 0)
                {
                    long t = difference / denominator;
                    if (t >= 0)
                    {
                        return t;
                    }
                }
            }
        }

        return -1;
    }
}
