using System;

class Solution {
  public static void Main(string[] args) {
       long N = long.Parse(Console.ReadLine());

       long result = FindMinTime(N);

       Console.WriteLine(result);
   }

   static long FindMinTime(long N)
   {
       long difference = N - 1;

       long minTime = long.MaxValue;

       CheckAndUpdate(ref minTime, difference, 3); // 1 + 2t = N - t
       CheckAndUpdate(ref minTime, difference, 4); // 1 + 2t = N - 2t
       CheckAndUpdate(ref minTime, difference, 4); // 1 + 3t = N - t
       CheckAndUpdate(ref minTime, difference, 5); // 1 + 3t = N - 2t

       return minTime == long.MaxValue ? -1 : minTime;
   }

   static void CheckAndUpdate(ref long minTime, long difference, long coefficient)
   {
       if (difference % coefficient == 0)
       {
           long t = difference / coefficient;
           if (t >= 0)
           {
               minTime = Math.Min(minTime, t);
           }
       }
   }
}
