using System;
using System.Linq;

class Solution {
  public static void Main(string[] args) {
      int N = int.Parse(Console.ReadLine());
        var numbers = Console.ReadLine().Split().Select(int.Parse).ToArray();
        
        var frequency = new System.Collections.Generic.Dictionary<int, int>();
        
        foreach (var num in numbers)
        {
            if (frequency.ContainsKey(num))
                frequency[num]++;
            else
                frequency[num] = 1;
        }
        
        int president = -1;
        
        foreach (var kvp in frequency)
        {
            if (kvp.Value == 1)
            {
                if (president == -1 || kvp.Key < president)
                {
                    president = kvp.Key;
                }
            }
        }
        
        Console.WriteLine(president);
    }
}
