using System;

class Solution {

     static int CountSquares(int N, int[,] grid)
    {
        int count = 0;

        for (int x1 = 0; x1 < N; x1++)
        {
            for (int y1 = 0; y1 < N; y1++)
            {
                for (int x2 = x1 + 1; x2 < N; x2++)
                {
                    for (int y2 = y1 + 1; y2 < N; y2++)
                    {
                        if (grid[x1, y1] == grid[x1, y2] && grid[x1, y1] == grid[x2, y1] && grid[x1, y1] == grid[x2, y2])
                        {
                            count++;
                        }
                    }
                }
            }
        }

        return count;
    }
  public static void Main(string[] args) {
      int N = int.Parse(Console.ReadLine());
        int[,] grid = new int[N, N];

        for (int i = 0; i < N; i++)
        {
            var row = Console.ReadLine().Split(' ');
            for (int j = 0; j < N; j++)
            {
                grid[i, j] = int.Parse(row[j]);
            }
        }

        Console.WriteLine(CountSquares(N, grid));
    }
}
