using System;
using System.Linq;

class Solution {
  public static void Main(string[] args) {
        int t = int.Parse(Console.ReadLine()); 
        for (int testCase = 0; testCase < t; testCase++)
        {
            int N = int.Parse(Console.ReadLine()); 

            var bluePoints = new (int x, int y, int index)[N];
            var redPoints = new (int x, int y, int index)[N];

            for (int i = 0; i < N; i++)
            {
                var point = Console.ReadLine().Split().Select(int.Parse).ToArray();
                bluePoints[i] = (point[0], point[1], i + 1);
            }

            for (int i = 0; i < N; i++)
            {
                var point = Console.ReadLine().Split().Select(int.Parse).ToArray();
                redPoints[i] = (point[0], point[1], i + 1);
            }

            var sortedBlue = bluePoints.OrderBy(p => p.x).ThenBy(p => p.y).ToArray();
            var sortedRed = redPoints.OrderBy(p => p.x).ThenBy(p => p.y).ToArray();

            for (int i = 0; i < N; i++)
            {
                Console.WriteLine($"{sortedBlue[i].index} {sortedRed[i].index}");
            }
        }
    }
}
