def solve_case(N, blue_points, red_points):
    # Сортуємо обидві групи точок за x, потім за y (для стабільності сортування)
    sorted_blue = sorted(enumerate(blue_points, 1), key=lambda x: (x[1][0], x[1][1]))
    sorted_red = sorted(enumerate(red_points, 1), key=lambda x: (x[1][0], x[1][1]))
    
    # Підготовимо відповідь
    result = []
    for i in range(N):
        blue_idx, blue_point = sorted_blue[i]
        red_idx, red_point = sorted_red[i]
        result.append((blue_idx, red_idx))
    
    # Вивести пари індексів
    for pair in result:
        print(pair[0], pair[1])

def main():
    t = int(input())  # Кількість тестових блоків
    for _ in range(t):
        N = int(input())  # Кількість точок одного кольору
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().split())) for _ in range(N)]
        
        solve_case(N, blue_points, red_points)

# Запуск програми
if __name__ == "__main__":
    main()
