def can_connect(points_blue, points_red):
    # Сортуємо точки за x, а потім за y
    points_blue.sort()
    points_red.sort()

    connections = []
    for i in range(len(points_blue)):
        connections.append((i + 1, i + 1))  # Номери точок починаються з 1

    return connections

def main():
    import sys
    input = sys.stdin.read
    data = input().strip().splitlines()
    
    index = 0
    t = int(data[index])
    index += 1
    results = []
    
    for _ in range(t):
        N = int(data[index])
        index += 1
        
        points_blue = []
        points_red = []
        
        for i in range(N):
            x, y = map(int, data[index].split())
            points_blue.append((x, y))
            index += 1
            
        for i in range(N):
            x, y = map(int, data[index].split())
            points_red.append((x, y))
            index += 1
        
        # Виконуємо перевірку на можливість з'єднання
        connections = can_connect(points_blue, points_red)
        
        if connections:
            results.append('\n'.join(f"{b} {r}" for b, r in connections))
        else:
            results.append("0")
    
    print('\n\n'.join(results))

if __name__ == "__main__":
    main()