#include <bits/stdc++.h>
using namespace std;

#define MAX_N 100

int dp[MAX_N + 1];
int prev[MAX_N + 1];

void find_min_stamps(int N, int M) {
    for (int i = 0; i <= M; i++) {
        dp[i] = INT_MAX;
        prev[i] = -1;
    }
    dp[0] = 0;

    for (int i = 1; i <= N; i++) {
        for (int j = i; j <= M; j++) {
            if (dp[j - i] != INT_MAX && dp[j - i] + 1 < dp[j]) {
                dp[j] = dp[j - i] + 1;
                prev[j] = i;
            }
        }
    }

    if (dp[M] == INT_MAX) {
        printf("0\n");
    } else {
        int sum = M;
        while (sum > 0) {
            printf("%d ", prev[sum]);
            sum -= prev[sum];
        }
        printf("\n");
    }
}

int main() {
    int N, M;
    scanf("%d %d", &N, &M);

    find_min_stamps(N, M);

    return 0;
}