def solve_case(n, blue_points, red_points):
    blue_points = sorted((x, y, i + 1) for i, (x, y) in enumerate(blue_points))
    red_points = sorted((x, y, i + 1) for i, (x, y) in enumerate(red_points))

    pairs = []
    for i in range(n):
        pairs.append((blue_points[i][2], red_points[i][2]))
    

    return pairs
    
def main():
    t = int(input())
    results = []

    for i in range(t):
        n = int(input())
        blue_points = [tuple(map(int, input().split())) for _ in range(n)]
        red_points = [tuple(map(int, input().split())) for _ in range(n)]

        result = solve_case(n, blue_points, red_points)
        results.append(result)

    for result in results:
        for pair in result:
            print(pair[0], pair[1])

if __name__ == "__main__":
    main()
