import java.util.Scanner;
import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);

        int N = (int) in.nextLong();
        int[] num = new int[N];

        for (int i = 0; i < N; i++) {
            num[i] = in.nextInt();
        }

        Map<Integer, Integer> fm = new HashMap<>();

        for (int number : num) {
            fm.put(number, fm.getOrDefault(number, 0) + 1);
        }

        int uniqueMin = Integer.MAX_VALUE;
        for (int number : num) {
            if (fm.get(number) == 1) {
                uniqueMin = Math.min(uniqueMin, number);
            }
        }

        if (uniqueMin == Integer.MAX_VALUE) {
            System.out.println(-1);
        } else {
            System.out.println(uniqueMin);
        }
    }
}
