def test(n, blue_points, red_points):
    if len(blue_points) != n or len(red_points) != n:
        return [0]

   
    blue_p = sorted(enumerate(blue_p, 1), key=lambda p: p[1][0] + p[1][1])
    red_p = sorted(enumerate(red_p, 1), key=lambda p: p[1][0] + p[1][1])

    
    result = []
    for i in range(n):
        result.append((blue_p[i][0], red_p[i][0]))

    return result



def main():
    
    t = int(input())
    results = []

    for i in range(t):
        n = int(input())
        blue_p = []
        red_p = []

        for i in range(n):
            x, y = map(int, input().split())
            blue_p.append((x, y))

        for i in range(n):
            x, y = map(int, input().split())
            red_p.append((x, y))

      
        result = test(n, blue_p, red_p)
        results.append(result)

 
    for result in results:
        if result == [0]:
            print(0)
        else:
            for p in result:
                print(p[0], p[1])

main()
