from collections import Counter

def elect_president(N, a):
    # Підраховуємо кількість появ кожного числа
    count = Counter(a)
    
    # Знайдемо мінімальне число, яке з'являється лише один раз
    min_number = float('inf')
    for num, freq in count.items():
        if freq == 1 and num < min_number:
            min_number = num
    
    # Якщо мінімальне число знайдено, виводимо його, інакше виводимо -1
    if min_number == float('inf'):
        print(-1)
    else:
        print(min_number)

# Вхідні дані
N = int(input())  # кількість роботів
a = list(map(int, input().split()))  # числа, згенеровані роботами

# Викликаємо функцію для визначення президента
elect_president(N, a)
