def count_squares(N, grid):
    count = 0
    
    # Перебираємо всі можливі квадрати (від 2x2 до NxN)
    for size in range(1, N):  # size — це розмір квадрату (починаємо з 2x2)
        for i in range(N - size):  # рядок верхньої лівої точки квадрата
            for j in range(N - size):  # стовпець верхньої лівої точки квадрата
                # Перевіряємо, чи всі чотири вершини цього квадрата мають однаковий колір
                color = grid[i][j]
                if (grid[i][j] == grid[i + size][j] == grid[i][j + size] == grid[i + size][j + size]):
                    count += 1
    return count

# Вхідні дані
N = int(input())  # сторона квадрата
grid = [list(map(int, input().split())) for _ in range(N)]  # матриця кольорів

# Виведення результату
print(count_squares(N, grid))
