def count_squares(N, grid):
    count = 0
    
    # Перебираємо всі квадрати розміру 2x2 і більше
    for size in range(1, N):  # розмір квадрата (починаючи з 2x2)
        for i in range(N - size):  # верхній лівий кут квадрата
            for j in range(N - size):  # верхній лівий кут квадрата
                # Перевіряємо, чи всі чотири вершини цього квадрата мають однаковий колір
                color = grid[i][j]
                if (grid[i][j] == grid[i + size][j] == grid[i][j + size] == grid[i + size][j + size]):
                    count += 1
    return count

# Вхідні дані
N = int(input())  # сторона квадрата
grid = [list(map(int, input().split())) for _ in range(N)]  # матриця кольорів

# Викликаємо функцію та виводимо результат
print(count_squares(N, grid))
