def solve():
    t = int(input())  # Читаємо кількість тестових випадків
    for _ in range(t):
        N = int(input())  # Читаємо кількість точок одного кольору
        
        blue_points = []
        red_points = []
        
        # Зчитуємо координати синіх точок
        for i in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y, i + 1))  # зберігаємо точку і її індекс
        
        # Зчитуємо координати червоних точок
        for i in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y, i + 1))  # зберігаємо точку і її індекс
        
        # Тепер, оскільки жодні три точки не лежать на одній прямій, сортуємо тільки за порядком введення
        # Потрібно з'єднати точки в порядку їх введення, оскільки це гарантує, що відрізки не перетинатимуться
        result = []
        for i in range(N):
            result.append((blue_points[i][2], red_points[i][2]))  # додаємо пари індексів
        
        # Виводимо відповідь
        for pair in result:
            print(pair[0], pair[1])

# Запуск програми
solve()
