N = int(input())

def minimum_time(N, steps_A={1}, steps_B={N}, time=0):
    if steps_A & steps_B:
        return time
    
    if not steps_A or not steps_B:
        return -1
    
    time += 1
    new_A = set()
    new_B = set()
    
    for a in steps_A:
        if a + 2 <= N:
            new_A.add(a + 2)
        if a + 3 <= N:
            new_A.add(a + 3)
    
    for b in steps_B:
        if b - 1 >= 1:
            new_B.add(b - 1)
        if b - 2 >= 1:
            new_B.add(b - 2)
    
    return minimum_time(N, new_A, new_B, time)

print(minimum_time(N))
