def min_seconds_to_meet(n: int) -> int:
    """
    Обчислює мінімальну кількість секунд для зустрічі Аліси та Боба
    або повертає -1, якщо це неможливо.

    :param n: Кількість боксів (2 ≤ N ≤ 1_000_000_000)
    :return: Мінімальна кількість секунд або -1
    """
    # Якщо різниця між позиціями Аліси та Боба парна, зустріч можлива
    if (n - 1) % 2 == 0:
        # Обчислюємо мінімальний час для зустрічі
        return (n - 1) // 2
    else:
        # Якщо різниця непарна, зустріч неможлива
        return -1


# Приклад використання
n = int(input("Введіть кількість боксів (N): "))
print(min_seconds_to_meet(n))
