import math

def count_ones(n: int, a: int, b: int) -> int:
    """
    Підрахунок кількості одиниць, записаних у пам'ять робота.
    
    :param n: Кількість комірок у пам'яті
    :param a: Перше число
    :param b: Друге число
    :return: Кількість одиниць
    """
    # Найменше спільне кратне (lcm) для чисел A і B
    lcm_ab = (a * b) // math.gcd(a, b)

    # Формула включення-виключення
    count = (n // a) + (n // b) - (n // lcm_ab)
    return count


if __name__ == "__main__":
    # Зчитування даних
    n = int(input("Введіть кількість комірок N: "))
    a, b = map(int, input("Введіть числа A та B: ").split())
    
    # Обчислення результату
    print(count_ones(n, a, b))

