def can_connect(blue, red):
    for i in range(len(blue)):
        for j in range(i + 1, len(blue)):
            for k in range(len(red)):
                for l in range(k + 1, len(red)):
                    if (blue[i][0] < blue[j][0] and red[k][0] > red[l][0]) or \
                       (blue[i][0] > blue[j][0] and red[k][0] < red[l][0]):
                        return False
    return True

def solve(t, test_cases):
    results = []
    for i in range(t):
        N, blue_points, red_points = test_cases[i]
        pairs = []
        blue_points_sorted = sorted([(x, y, idx + 1) for idx, (x, y) in enumerate(blue_points)])
        red_points_sorted = sorted([(x, y, idx + 1) for idx, (x, y) in enumerate(red_points)])
        for i in range(N):
            pairs.append((blue_points_sorted[i][2], red_points_sorted[i][2]))
        results.append(pairs)
    return results

t = int(input())
test_cases = []
for _ in range(t):
    N = int(input())
    blue_points = [tuple(map(int, input().split())) for _ in range(N)]
    red_points = [tuple(map(int, input().split())) for _ in range(N)]
    test_cases.append((N, blue_points, red_points))

results = solve(t, test_cases)
for result in results:
    if result:
        for pair in result:
            print(pair[0], pair[1])
    else:
        print(0)
