#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Point {
    int x, y, index;
};

bool cmp(const Point& a, const Point& b) {
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

bool isConvex(const Point& a, const Point& b, const Point& c, const Point& d) {
    // Перевірка на опуклість чотирикутника
    // Реалізація цього методу може бути різною
    // Наприклад, можна використовувати векторний добуток
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        int n;
        cin >> n;

        vector<Point> points(2 * n);
        for (int i = 0; i < n; ++i) {
            cin >> points[i].x >> points[i].y;
            points[i].index = i + 1;
        }
        for (int i = n; i < 2 * n; ++i) {
            cin >> points[i].x >> points[i].y;
            points[i].index = i + 1 - n;
        }

        sort(points.begin(), points.end(), cmp);

        vector<int> pairs(n);
        // Реалізація алгоритму з'єднання точок з перевіркою на перетин
        // ...

        bool possible = true;
        // Перевірка, чи всі точки були спаровані
        for (int i = 0; i < n; ++i) {
            if (pairs[i] == 0) {
                possible = false;
                break;
            }
        }

        if (!possible) {
            cout << 0 << endl;
        } else {
            for (int i = 0; i < n; ++i) {
                cout << pairs[i] << " " << i + 1 << endl;
            }
        }
    }

    return 0;
}