#include <iostream>
#include <vector>

int main() {
    int n, m;
    std::cin >> n;
    std::cin >> m;

    if ((n * (n + 1)) / 2 < m) {
        std::cout << 0 << std::endl;
    } else {
        int currentMoney = m;
        std::vector<int> l;
        for (int i = n; i > 0; --i) {
            double fn = static_cast<double>(currentMoney) / i;
            bool valid = fn >= 1;
            if (valid) {
                l.push_back(i);
                currentMoney -= i;
            }
        }

        for (size_t i = 0; i < l.size(); ++i) {
            std::cout << l[i] << std::endl;
        }
    }

    return 0;
}