#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

int main() {
    int n;
    std::cin >> n;
    std::vector<int> l(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> l[i];
    }
    
    std::sort(l.begin(), l.end());
    
    std::unordered_map<int, int> count;
    for (int i = 0; i < n; ++i) {
        count[l[i]]++;
    }
    
    bool printed = false;
    for (int i = 0; i < n; ++i) {
        if (count[l[i]] == 1) {
            std::cout << l[i] << std::endl;
            printed = true;
            break;
        }
    }
    
    if (!printed) {
        std::cout << -1 << std::endl;
    }
    
    return 0;
}
