#include <iostream>
#include <unordered_map>
#include <climits>

using namespace std;

int main() {
    int N;
    cin >> N;
    
    unordered_map<int, int> freq;
    int num;
    
    // Зчитуємо числа і підраховуємо їх кількість
    for (int i = 0; i < N; i++) {
        cin >> num;
        freq[num]++;
    }
    
    int minUnique = INT_MAX;
    
    // Перевіряємо, яке з чисел є унікальним і мінімальним
    for (auto& entry : freq) {
        if (entry.second == 1 && entry.first < minUnique) {
            minUnique = entry.first;
        }
    }
    
    // Якщо знайшли таке число, виводимо його, інакше виводимо -1
    if (minUnique == INT_MAX) {
        cout << -1 << endl;
    } else {
        cout << minUnique << endl;
    }

    return 0;
}