#include <iostream>
#include <algorithm>

// Функція для знаходження НСК (найменшого спільного кратного)
long long lcm(long long a, long long b) {
    return a * b / std::gcd(a, b);  // Використовуємо стандартну функцію для знаходження НСД
}

int main() {
    long long N, A, B;
    std::cin >> N >> A >> B;
    
    // Підраховуємо скільки чисел діляться на A, B, і на їх LCM
    long long countA = N / A;
    long long countB = N / B;
    long long countLCM = N / lcm(A, B);
    
    // Кількість одиничних значень в пам'яті
    long long result = countA + countB - countLCM;
    
    std::cout << result << std::endl;
    
    return 0;
}