#include <iostream>

// Функція для знаходження НСД за допомогою алгоритму Евкліда
long long gcd(long long a, long long b) {
    while (b != 0) {
        long long temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

// Функція для обчислення НСК
long long lcm(long long a, long long b) {
    return a * b / gcd(a, b);  // Використовуємо власну функцію для знаходження НСД
}

int main() {
    long long a = 12, b = 15;
    std::cout << "LCM of " << a << " and " << b << " is " << lcm(a, b) << std::endl;
    return 0;
}