#include <iostream>
#include <numeric> // Для std::gcd

// Функція для обчислення LCM (найменше спільне кратне)
long long lcm(long long a, long long b) {
    return a * b / std::gcd(a, b);
}

int main() {
    // Вхідні дані
    long long N, A, B;
    std::cin >> N >> A >> B;

    // Кількість чисел, що діляться на A
    long long countA = N / A;
    
    // Кількість чисел, що діляться на B
    long long countB = N / B;

    // Кількість чисел, що діляться на LCM(A, B)
    long long lcmAB = lcm(A, B);
    long long countAB = N / lcmAB;

    // Загальна кількість одиниць в пам'яті робота
    long long result = countA + countB - countAB;

    // Вивести результат
    std::cout << result << std::endl;

    return 0;
}