#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N;
    cin >> N;
    
    vector<vector<int>> grid(N, vector<int>(N));

    // Читання сітки
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int count = 0;

    // Перебір всіх можливих квадратів
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            // Розмір квадрата
            for (int size = 1; i + size < N && j + size < N; ++size) {
                // Перевірка чотирьох вершин
                int color = grid[i][j];
                if (grid[i][j] == grid[i + size][j] &&   // ліва верхня та ліва нижня
                    grid[i][j] == grid[i][j + size] &&   // ліва верхня та права верхня
                    grid[i][j] == grid[i + size][j + size]) { // ліва верхня та права нижня
                    ++count;  // Збільшуємо лічильник квадратів
                }
            }
        }
    }

    cout << count << endl;
    return 0;
}