#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Point {
    int x, y, index; // координати та індекс точки
    bool isRed; // якщо true, точка червона, якщо false - синя
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

// Структура для збереження точки
struct Point {
    int x, y, index; // координати та індекс точки
    bool isRed; // true якщо червона точка, false якщо синя
    
    // Оператор для сортування точок: спочатку по x, потім по y
    bool operator<(const Point& other) const {
        if (x == other.x) return y < other.y;
        return x < other.x;
    }
};

int main() {
    int t;  // кількість тестів
    cin >> t;

    while (t--) {
        int N;
        cin >> N;
        
        vector<Point> bluePoints(N), redPoints(N);
        
        // Зчитуємо координати синіх точок
        for (int i = 0; i < N; ++i) {
            cin >> bluePoints[i].x >> bluePoints[i].y;
            bluePoints[i].index = i + 1;  // індекс синьої точки
            bluePoints[i].isRed = false;  // синя точка
        }
        
        // Зчитуємо координати червоних точок
        for (int i = 0; i < N; ++i) {
            cin >> redPoints[i].x >> redPoints[i].y;
            redPoints[i].index = i + 1;  // індекс червоної точки
            redPoints[i].isRed = true;   // червона точка
        }
        
        // Сортуємо сині та червоні точки
        sort(bluePoints.begin(), bluePoints.end());
        sort(redPoints.begin(), redPoints.end());
        
        // Виводимо пари точок, якщо вони можуть бути з'єднані
        for (int i = 0; i < N; ++i) {
            cout << bluePoints[i].index << " " << redPoints[i].index << endl;
        }
    }

    return 0;
}
