def min_time_to_meet(N):
    alice_positions = {1}
    bob_positions = {N}
    seconds = 0
    alice_queue = [1]
    bob_queue = [N]

    while alice_queue and bob_queue:
        seconds += 1

        new_alice_positions = []
        for a in alice_queue:
            if a in bob_positions:
                return seconds
            if a + 2 <= N:
                new_alice_positions.append(a + 2)
            if a + 3 <= N:
                new_alice_positions.append(a + 3)
        alice_positions.update(new_alice_positions)
        alice_queue = new_alice_positions


        new_bob_positions = []
        for b in bob_queue:
            if b in alice_positions:
                return seconds
            if b - 1 > 0:
                new_bob_positions.append(b - 1)
            if b - 2 > 0:
                new_bob_positions.append(b - 2)
        bob_positions.update(new_bob_positions)
        bob_queue = new_bob_positions

    return -1

N = int(input())
print(min_time_to_meet(N))
