def count_same_color_squares(N, grid):
    count = 0
    
    for i in range(N):
        for j in range(N):
            for size in range(1, min(N - i, N - j)):
                # Перевіряємо чи всі чотири вершини квадрата одного кольору
                if (grid[i][j] == grid[i + size][j] == 
                    grid[i][j + size] == grid[i + size][j + size]):
                    count += 1

    return count

def main():
    import sys
    input = sys.stdin.read
    data = input().strip().split()
    
    idx = 0
    N = int(data[idx])
    idx += 1
    
    grid = []
    for i in range(N):
        row = list(map(int, data[idx:idx + N]))
        grid.append(row)
        idx += N

    result = count_same_color_squares(N, grid)
    print(result)

if name == "main":
    main()