def read_input():
    import sys
    input = sys.stdin.read
    data = input().strip().split()
    
    idx = 0
    t = int(data[idx])
    idx += 1
    test_cases = []
    
    for _ in range(t):
        N = int(data[idx])
        idx += 1
        blue_points = []
        red_points = []
        
        for _ in range(N):
            x, y = int(data[idx]), int(data[idx + 1])
            blue_points.append((x, y))
            idx += 2
        
        for _ in range(N):
            x, y = int(data[idx]), int(data[idx + 1])
            red_points.append((x, y))
            idx += 2
        
        test_cases.append((N, blue_points, red_points))
    
    return test_cases

def solve_case(N, blue_points, red_points):
    # Sort points to avoid intersections
    blue_points.sort()
    red_points.sort()
    
    # Pair points by their order
    pairs = []
    for i in range(N):
        pairs.append((i + 1, i + 1))
    
    return pairs

def main():
    test_cases = read_input()
    results = []
    
    for N, blue_points, red_points in test_cases:
        pairs = solve_case(N, blue_points, red_points)
        results.append(pairs)
    
    for pairs in results:
        for blue_idx, red_idx in pairs:
            print(blue_idx, red_idx)

if name == "main":
    main()