#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int N;
    cin >> N;
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            cin >> grid[i][j];
        }
    }

    int totalSquares = 0;
    for (int size = 1; size < N; size++) {
        for (int x = 0; x + size < N; x++) {
            for (int y = 0; y + size < N; y++) {
                int color = grid[x][y];
                if (grid[x][y + size] == color &&
                    grid[x + size][y] == color &&
                    grid[x + size][y + size] == color) {
                    totalSquares++;
                }
            }
        }
    }

    cout << totalSquares << endl;
    return 0;
}
