def select_stamps(N, M):
    selected_stamps = []
    current_sum = 0
    
    # Проходимо марки з найдорожчої до найдешевшої
    for i in range(N, 0, -1):
        if current_sum + i <= M:
            selected_stamps.append(i)
            current_sum += i
            if current_sum == M:
                return sorted(selected_stamps)  # Сортуємо у порядку зростання
            
    # Якщо сума M не була досягнута
    return [0]

# Зчитування даних
N = int(input())
M = int(input())

# Виведення результату
result = select_stamps(N, M)
print("\n".join(map(str, result)))