from collections import Counter

def find_president(N, numbers):
    
    count = Counter(numbers)
    
    
    min_number = float('inf')
    
    for num, cnt in count.items():
        if cnt == 1:
            min_number = min(min_number, num)
    
    
    return min_number if min_number != float('inf') else -1


N = int(input())
numbers = list(map(int, input().split()))


print(find_president(N, numbers))