function min_seconds(N)
    if N == 1 then return 0 end


    local alice_set = {[1] = true}
    local bob_set = {[N] = true}
    local seconds = 0


    local alice_moves = {2, 3}
    local bob_moves = {-1, -2}

    while true do
        seconds = seconds + 1
        local new_alice_set = {}
        local new_bob_set = {}

        for pos, _ in pairs(alice_set) do
            for _, move in ipairs(alice_moves) do
                local new_pos = pos + move
                if new_pos <= N then
                    new_alice_set[new_pos] = true
                end
            end
        end

        for pos, _ in pairs(bob_set) do
            for _, move in ipairs(bob_moves) do
                local new_pos = pos + move
                if new_pos >= 1 then
                    new_bob_set[new_pos] = true
                end
            end
        end

        for pos, _ in pairs(new_alice_set) do
            if new_bob_set[pos] then
                return seconds
            end
        end

        alice_set = new_alice_set
        bob_set = new_bob_set


        if next(alice_set) == nil or next(bob_set) == nil then
            return -1
        end
    end
end

local N = tonumber(io.read())
print(min_seconds(N))
