function find_stamps(N, M)
  
    local dp = {}
    local used = {}

    dp[0] = 0 
    for i = 1, M do
        dp[i] = math.huge 
    end


    for stamp = 1, N do
        for sum = M, stamp, -1 do
            if dp[sum - stamp] + 1 < dp[sum] then
                dp[sum] = dp[sum - stamp] + 1
                used[sum] = stamp
            end
        end
    end


    if dp[M] == math.huge then
        print(0)
        return
    end


    local result = {}
    local sum = M
    while sum > 0 do
        table.insert(result, used[sum])
        sum = sum - used[sum]
    end

 
    for _, value in ipairs(result) do
        print(value)
    end
end

local N = tonumber(io.read())
local M = tonumber(io.read())

find_stamps(N, M)
