function find_stamps(N, M)
    local dp = {}
    local used = {}
    
    dp[0] = 0
    for i = 1, M do
        dp[i] = math.huge
    end

    for stamp = 1, math.min(N, M) do
        for sum = M, stamp, -1 do
            local prev = dp[sum - stamp]
            if prev + 1 < dp[sum] then
                dp[sum] = prev + 1
                used[sum] = stamp
            end
        end
    end

    if dp[M] == math.huge then
        print(0)
        return
    end

    local sum = M
    while sum > 0 do
        local stamp = used[sum]
        print(stamp)
        sum = sum - stamp
    end
end

local N = tonumber(io.read())
local M = tonumber(io.read())

find_stamps(N, M)
