function customSplit(input, delimiter)
    local result = {}
    local pattern = "(.-)" .. delimiter
    local lastEnd = 1

    for part, pos in input:gmatch(pattern .. "()") do
        table.insert(result, part)
        lastEnd = pos
    end
    if lastEnd <= #input then
        table.insert(result, input:sub(lastEnd))
    end
    return result
end

local N = tonumber(io.read())
local AB = customSplit(io.read()," ")

for i, num in ipairs(AB) do
    AB[i] = tonumber(num)
end

local A = AB[1]
local B = AB[2]

local amount = 0
local index = 0

while N > 0 do
	index = index +1
	N = N -1
	if index % A == 0 or index % B == 0 then
		amount = amount +1
	end
	
end

print(amount)