def count_same_color_squares(N, grid):
    count = 0
    for size in range(2, N + 1):
        for i in range(N - size + 1):
            for j in range(N - size + 1):
                color = grid[i][j]
                all_same = True
                for x in range(i, i + size):
                    for y in range(j, j + size):
                        if grid[x][y] != color:
                            all_same = False
                            break
                    if not all_same:
                        break
                if all_same:
                    count += 1
    return count
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]
print(count_same_color_squares(N, grid))
