#include <iostream>
#include <vector>
using namespace std;

int countUniformSquares(int N, const vector<vector<int>>& grid) {
    int count = 0;
    for (int i = 0; i < N - 1; ++i) {
        for (int j = 0; j < N - 1; ++j) {
            if (grid[i][j] == grid[i][j + 1] &&
                grid[i][j] == grid[i + 1][j] &&
                grid[i][j] == grid[i + 1][j + 1]) {
                ++count;
            }
        }
    }
    return count;
}

int main() {
    int N;
    cin >> N;
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }
    cout << countUniformSquares(N, grid) << endl;
    return 0;
}
