#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int t;
    cin >> t;
    
    while (t--) {
        int N;
        cin >> N;
        
        vector<pair<int, pair<int, int>>> blue(N), red(N);
        
        for (int i = 0; i < N; ++i) {
            cin >> blue[i].second.first >> blue[i].second.second;
            blue[i].first = i + 1;
        }
        
        for (int i = 0; i < N; ++i) {
            cin >> red[i].second.first >> red[i].second.second;
            red[i].first = i + 1;
        }
        
        sort(blue.begin(), blue.end(), [](auto& a, auto& b) {
            return a.second < b.second;
        });
        
        sort(red.begin(), red.end(), [](auto& a, auto& b) {
            return a.second < b.second;
        });
        
        for (int i = 0; i < N; ++i) {
            cout << blue[i].first << " " << red[i].first << endl;
        }
    }

    return 0;
}
