from typing import List, Sequence, Tuple


n = int(input())
m = int(input())

def calculate_sum_from_a_to_b(a:int, b:int):
    return (b-a+1) * (a + b)/2

def find_closest_sum_to_m(n, goal) -> Tuple[int, int, Sequence[int]]:
    s = 0
    for i in range(n):
        new_number = (n-i)
        s += new_number
        if s == goal:
            return new_number-1, goal - s, range(new_number, n+1)
        if s > goal:
            return new_number, goal - (s - new_number) , range(new_number+1, n+1)
    raise Exception("oops")


def solve(n, m):
    ans = []
    if m > calculate_sum_from_a_to_b(1, n):
        return None
    if m < n:
        return [m]

    n, m, ans = find_closest_sum_to_m(n, m)
    if m != 0:
        ans = list(ans)
        ans.append(m)
    return ans
ans = solve(n,m)
# print("ans")
if ans is None:
    print(0)
else:
    for a in ans:
        print(a)

