from typing import List, Tuple
from math import sqrt

def solve(blue_points: List[Tuple[int, int]], red_points: List[Tuple[int, int]], amount_of_points):
    connected = {}
    closest = {}

    # ks = {}
    # bs = {}
    #
    # def calc_formula(p1, p2)-> None:
    #     if p1[0] == p2[0]:
    #         k = 9999999999
    #     else:
    #         k = abs(p2[0]-p1[0]) / abs(p1[0]-p2[0])
    #     ks[id(p1), id(p2)] = k, p1[1] - p1[0]*k


    def calc_dist(p1: Tuple[int, int], p2: Tuple[int, int])-> float:
        return sqrt((p2[0] - p1[0])**2 + (p1[1]-p2[1])**2)

    def find_closest(point, points) -> None:
        closest[point] = sorted(points, key=lambda p2: calc_dist(p2, point))


    for i in range(amount_of_points):
        find_closest(red_points[i], blue_points)
        find_closest(blue_points[i], red_points)

    def connect_point(point, points):
        for p2 in points:
            if connected.get(p2) is not None:
                continue
            connected[point] = p2
            connected[p2] = point
            return

    for i in range(amount_of_points):
        connect_point(red_points[i], blue_points)
    return connected



t = int(input())
for _ in range(t):
    amount_of_points =int(input())
    blue_points=[]
    red_points=[]
    for i in range(amount_of_points):
        a =list(map(int, input().split()) )
        blue_points.append((a[0], a[1], i))
    for i in range(amount_of_points):
        b= list(map(int, input().split()))
        red_points.append((b[0], b[1], i))

    for fr, to in solve(blue_points, red_points, amount_of_points).items():
        if fr in blue_points:
            print(fr[2]+1, to[2]+1)


