from itertools import combinations

def minimal_numbers(m, n):
    min_combination = None
    min_length = float('inf')
    
    # Generate all possible combinations of numbers from 1 to m
    for i in range(1, m+1):
        for comb in combinations(range(1, m+1), i):
            if sum(comb) == n:
               
                if len(comb) < min_length:
                    min_length = len(comb)
                    min_combination = comb
    
    return list(min_combination)


m =  int(input())
n = int(input())
fin = minimal_numbers(m, n)
print(fin[0])
print(fin[1]) 
