-- Read input
local N = tonumber(io.read())
local M = tonumber(io.read())

-- To store the selected stamp numbers
local selected_stamps = {}

-- Greedy approach: start from the highest value and move downwards
for i = N, 1, -1 do
    while M >= i do
        M = M - i
        table.insert(selected_stamps, i)
    end
end

-- Output the selected stamps or 0 if not possible
if #selected_stamps > 0 then
    for _, v in ipairs(selected_stamps) do
        print(v)
    end
else
    print(0)
end
