def solve():
    import sys
    input = sys.stdin.read
    data = input().splitlines()
    
    t = int(data[0])  # кількість тестів
    index = 1
    results = []
    
    for _ in range(t):
        N = int(data[index])  # кількість точок одного кольору
        index += 1
        
        blue_points = []
        for i in range(N):
            x, y = map(int, data[index + i].split())
            blue_points.append((x, y, i + 1))  # координати та номер точки
        index += N
        
        red_points = []
        for i in range(N):
            x, y = map(int, data[index + i].split())
            red_points.append((x, y, i + 1))  # координати та номер точки
        index += N
        
        # Сортуємо точки за координатами x, а у випадку рівності за y
        blue_points.sort(key=lambda p: (p[0], p[1]))
        red_points.sort(key=lambda p: (p[0], p[1]))
        
        # Паруємо точки
        result = []
        for i in range(N):
            b_idx = blue_points[i][2]
            r_idx = red_points[i][2]
            result.append(f"{b_idx} {r_idx}")
        
        # Додаємо результат
        results.append("\n".join(result))
    
    # Вивід результату
    sys.stdout.write("\n\n".join(results) + "\n")