#include <bits/stdc++.h>
using namespace std;

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    
    int N;
    cin >> N;
    vector<vector<int>> a(N, vector<int>(N));
    for(int y=0; y<N; y++){
        for(int x=0; x<N; x++) cin >> a[y][x];
    }
        vector<vector<pair<int, int>>> points_by_color(2, vector<pair<int, int>>());
    vector<vector<vector<bool>>> presence(2, vector<vector<bool>>(N, vector<bool>(N, false)));
    
    for(int y=0; y<N; y++){
        for(int x=0; x<N; x++){
            int color = a[y][x];
            points_by_color[color].emplace_back(x, y);
            presence[color][y][x] = true;
        }
    }
    
    long long res = 0;
    for(int color=0; color<=1; color++){
        const vector<pair<int, int>> &points = points_by_color[color];
        int M = points.size();
        for(int i=0; i<M; i++){
            int x1 = points[i].first;
            int y1 = points[i].second;
            for(int j=i+1; j<M; j++){
                int x2 = points[j].first;
                int y2 = points[j].second;
                int dx = x2 - x1;
                int dy = y2 - y1;
                int x3 = x1 - dy;
                int y3 = y1 + dx;
                int x4 = x2 - dy;
                int y4 = y2 + dx;
                if(x3 >=0 && x3 < N && y3 >=0 && y3 < N &&
                   x4 >=0 && x4 < N && y4 >=0 && y4 < N){
                    if(presence[color][y3][x3] && presence[color][y4][x4]){
                        res++;
                    }
                }
            }
        }
    }
    
    cout << res / 2;
}
