using System;

class Solution {
    static void Main(string[] args) {
        
        long N = long.Parse(Console.ReadLine());

        
        long steps = Solve(N);

        
        Console.WriteLine(steps); 
    }

    static long Solve(long N) {
        long alice = 1; 
        long bob = N;   
        
        for (long t = 0; t <= N; t++) {
            
            long alicePosition = 1 + 2 * t; 
            long bobPosition1 = N - t;       
            long bobPosition2 = N - 2 * t;  

            if (alicePosition > N)
                break;

           
            if (alicePosition == bobPosition1 || alicePosition == bobPosition2) {
                return t; 
            }
        }

        
        return -1;
    }
}
