using System;

class Solution {
    static void Main(string[] args) {

        long N = long.Parse(Console.ReadLine());
        long steps = Solve(N);
        Console.WriteLine(steps);
    }

    static long Solve(long N)
    {
        for (long t = 0; ; t++)
        {
            long alicePosition = 1 + 2 * t;
            if (alicePosition > N) break;
            long remaining = N - alicePosition;
            if (remaining >= 0 && remaining % 3 == 0)
            {
                return t;
            }
        }
        return -1;
    }
}

