using System;

class Solution
{
    
    static long GCD(long a, long b)
    {
        while (b != 0)
        {
            long temp = b;
            b = a % b;
            a = temp;
        }
        return a;
    }

    
    static long LCM(long a, long b)
    {
        return a / GCD(a, b) * b;
    }

    static void Main()
    {
        
        long N = long.Parse(Console.ReadLine()); 
        string[] input = Console.ReadLine().Split();
        long A = long.Parse(input[0]);
        long B = long.Parse(input[1]);

       
        long countA = N / A;
        long countB = N / B;
        long lcmAB = LCM(A, B);
        long countAB = N / lcmAB;

        
        long result = countA + countB - countAB;

        Console.WriteLine(result);
    }
}
