using System;

class Solution {
  public static void Main(string[] args) {
       
        int N = int.Parse(Console.ReadLine());

        
        int[,] grid = new int[N, N];
        for (int i = 0; i < N; i++)
        {
            var row = Console.ReadLine().Split();
            for (int j = 0; j < N; j++)
            {
                grid[i, j] = int.Parse(row[j]);
            }
        }

        int count = 0;

       
        for (int size = 1; size < N; size++)
        {
            for (int i = 0; i < N - size; i++) 
            {
                for (int j = 0; j < N - size; j++) 
                {
                   
                    if (grid[i, j] == grid[i + size, j] && 
                        grid[i, j] == grid[i, j + size] && 
                        grid[i, j] == grid[i + size, j + size])
                    {
                        count++;
                    }
                }
            }
        }

       
        Console.WriteLine(count);
    }
}
