using System;

class Solution
{
    static void Main()
    {
        int N = int.Parse(Console.ReadLine()); 
        int[,] grid = new int[N, N];

        
        for (int i = 0; i < N; i++)
        {
            string[] row = Console.ReadLine().Split();
            for (int j = 0; j < N; j++)
            {
                grid[i, j] = int.Parse(row[j]);
            }
        }

        int squareCount = 1;

        for (int size = 1; size < N; size++)  
        {
            for (int i = 0; i + size < N; i++) 
            {
                for (int j = 0; j + size < N; j++)  // По осі y
                {
                    int color = grid[i, j];  // Колір верхнього лівого кута
                    // Перевірка всіх чотирьох вершин квадрата
                    bool allEqual = (grid[i, j] == grid[i + size, j] &&  // (i,j) та (i+size,j)
                                      grid[i, j] == grid[i, j + size] &&  // (i,j) та (i,j+size)
                                      grid[i, j] == grid[i + size, j + size]);  // (i,j) та (i+size,j+size)
                    if (allEqual)
                    {
                        squareCount++;
                    }
                }
            }
        }

        Console.WriteLine(squareCount);
    }
}
