using System;
using System.Linq;

class Solution {
    public static void Main(string[] args) {
        
        int t = int.Parse(Console.ReadLine());

        for (int block = 0; block < t; block++) {
           
            int N = int.Parse(Console.ReadLine());

          
            (int x, int y, int index)[] bluePoints = new (int, int, int)[N];
            (int x, int y, int index)[] redPoints = new (int, int, int)[N];

          
            for (int i = 0; i < N; i++) {
                var coordinates = Console.ReadLine().Split();
                bluePoints[i] = (int.Parse(coordinates[0]), int.Parse(coordinates[1]), i + 1);
            }

           
            for (int i = 0; i < N; i++) {
                var coordinates = Console.ReadLine().Split();
                redPoints[i] = (int.Parse(coordinates[0]), int.Parse(coordinates[1]), i + 1);
            }

          
            var sortedBluePoints = bluePoints.OrderBy(p => p.x).ToArray();
            var sortedRedPoints = redPoints.OrderBy(p => p.x).ToArray();

         
            bool isPossible = true;
            for (int i = 0; i < N; i++) {
                if (sortedBluePoints[i].y == sortedRedPoints[i].y) {
                   
                    isPossible = false;
                    break;
                }
            }

            
            if (isPossible) {
                for (int i = 0; i < N; i++) {
                    Console.WriteLine($"{sortedBluePoints[i].index} {sortedRedPoints[i].index}");
                }
            } else {
                Console.WriteLine(0);
            }
        }
    }
}
