def find_president(N, numbers):
    from collections import Counter
    
    count = Counter(numbers)
    unique_min = float('inf')
    
    for num in numbers:
        if count[num] == 1 and num < unique_min:
            unique_min = num

    return unique_min if unique_min != float('inf') else -1

N = int(input())
numbers = list(map(int, input().split()))

print(find_president(N, numbers))