def solve_test_case(N, blue_points, red_points):
    blue_sorted = sorted([(x, y, i + 1) for i, (x, y) in enumerate(blue_points)], key=lambda p: (p[0], p[1]))
    red_sorted = sorted([(x, y, i + 1) for i, (x, y) in enumerate(red_points)], key=lambda p: (p[0], p[1]))

    result = []
    for i in range(N):
        result.append(f"{blue_sorted[i][2]} {red_sorted[i][2]}")

    return "\n".join(result)

def main():
    t = int(input())
    for _ in range(t):
        N = int(input())
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().split())) for _ in range(N)]

        result = solve_test_case(N, blue_points, red_points)
        print(result)

main()

