import java.util.Arrays;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int n = scanner.nextInt();
        int[] numbers = new int[n];

        for (int i = 0; i < n; i++) {
            int num = scanner.nextInt();
            numbers[i] = num;
        }
        scanner.close();

        Arrays.sort(numbers);

        int buffer = numbers[0];
        boolean isFind = false;
        for (int i = 1; i < n; i++) {
            if (numbers[i] == buffer) {
                isFind = true;
            } else {
                if (isFind) {
                    buffer = numbers[i];
                    isFind = false;
                } else {
                    break;
                }
            }
        }

        if (isFind) {
            System.out.println(-1);
        } else {
            System.out.println(buffer);
        }



    }
}