def solve(N, alice_pos=1, bob_pos=None, steps=0, alice_visited=None, bob_visited=None):
    if bob_pos is None:
        bob_pos = N
    if alice_visited is None:
        alice_visited = set([alice_pos])
    if bob_visited is None:
        bob_visited = set([bob_pos])

    if alice_pos == bob_pos:
        return steps

    # Шаги для Алисы и Боба
    alice_moves = [2, 3]
    bob_moves = [-1, -2]

    if alice_pos > N or bob_pos < 1:
        return -1

    min_steps = float('inf')
    for move in alice_moves:
        new_alice_pos = alice_pos + move
        if new_alice_pos not in alice_visited:
            alice_visited.add(new_alice_pos)
            result = solve(N, new_alice_pos, bob_pos, steps + 1, alice_visited, bob_visited)
            if result != -1:
                min_steps = min(min_steps, result)

    for move in bob_moves:
        new_bob_pos = bob_pos + move
        if new_bob_pos not in bob_visited:
            bob_visited.add(new_bob_pos)
            result = solve(N, alice_pos, new_bob_pos, steps + 1, alice_visited, bob_visited)
            if result != -1:
                min_steps = min(min_steps, result)

    return min_steps if min_steps != float('inf') else -1

n = int(input())
result = solve(n)
print(result/2)