def find_stamps(N, M):
    def recursive_find(n, m, stamps):
        if m == 0:
            return stamps
        if n == 0 or m < 0:
            return None

        if n <= m:
            result = recursive_find(n - 1, m - n, stamps + [n])
            if result:
                return result

        return recursive_find(n - 1, m, stamps)
    
    result = recursive_find(N, M, [])
    
    if result:
        return " ".join(map(str, result))
    else:
        return 0



n = int(input())
m = int(input())
print(find_stamps(n, m))