import math

def find_stamps(N, M):
    n = int((-1 + math.sqrt(1 + 8 * M)) // 2)

    sum_n = n * (n + 1) // 2
    if sum_n < M:
        n += 1
        sum_n = n * (n + 1) // 2

    if n > N:
        print(0)
        return

    stamps = list(range(1, n + 1))

    extra = sum_n - M
    if extra > 0:
        stamps.remove(extra)

    for stamp in stamps:
        print(stamp)

n = int(input())
m = int(input())
find_stamps(n, m)