from collections import Counter

# Вхідні дані
N = int(input())  # Кількість роботів
a = list(map(int, input().split()))  # Числа, згенеровані роботами

# Підрахунок кількості кожного числа
count = Counter(a)

# Пошук мінімального числа, яке зустрічається лише один раз
min_number = float('inf')
for num, cnt in count.items():
    if cnt == 1:
            min_number = min(min_number, num)

            # Якщо мінімальне число залишилось нескінченним, то вибори не відбудуться
            if min_number == float('inf'):
                print(-1)
                else:
                    print(min_number)
                    
