from collections import deque

def can_meet(N):
    alice_queue = deque([1])
    bob_queue = deque([N])
    alice_visited = {1}
    bob_visited = {N}
    
    time = 0
    
    while alice_queue and bob_queue:
        if alice_visited & bob_visited:
            return time

        for _ in range(len(alice_queue)):
            pos = alice_queue.popleft()
            for next_pos in (pos + 2, pos + 3):
                if next_pos <= N and next_pos not in alice_visited:
                    alice_visited.add(next_pos)
                    alice_queue.append(next_pos)

        for _ in range(len(bob_queue)):
            pos = bob_queue.popleft()
            for next_pos in (pos - 1, pos - 2):
                if next_pos >= 1 and next_pos not in bob_visited:
                    bob_visited.add(next_pos)
                    bob_queue.append(next_pos)

        time += 1
    return -1
N = int(input())
result = can_meet(N)
if result == -1:
    print(-1)
else:
    print(f"{result}")
