def min_stamps(n, m):
    dp = [float('inf')] * (m + 1)
    dp[0] = 0
    for i in range(1, n + 1):
        for j in range(i, m + 1):
            dp[j] = min(dp[j], dp[j - i] + 1)
    if dp[m] == float('inf'):
        return []
    result = []
    current_sum = m
    for i in range(n, 0, -1):
        while current_sum >= i and dp[current_sum] == dp[current_sum - i] + 1:
            result.append(i)
            current_sum -= i
    
    return result
n = int(input())  
m = int(input())  
result = min_stamps(n, m)
print(len(result))
print(result)
