def find_president_robot(numbers):
    from collections import Counter
    counts = Counter(numbers)
    unique_numbers = [num for num, count in counts.items() if count == 1]
    if not unique_numbers:
        return False, None
    min_unique = min(unique_numbers)
    president_index = numbers.index(min_unique) + 1
    return True, president_index
N = int(input())
A = list(map(int, input().split()))

election_happened, president = find_president_robot(A)

if election_happened:
    print(f"{president-1}")
else:
    print(-1)