def solve_test_case(N, blue_points, red_points):
    blue_points = sorted(enumerate(blue_points, 1), key=lambda p: (p[1][0], p[1][1]))
    red_points = sorted(enumerate(red_points, 1), key=lambda p: (p[1][0], p[1][1]))

    result = []
    for i in range(N):
        result.append((blue_points[i][0], red_points[i][0]))
    return result

def main():
    t = int(input())
    results = []

    for _ in range(t):
        N = int(input())
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().split())) for _ in range(N)]

        try:
            result = solve_test_case(N, blue_points, red_points)
            results.append(result)
        except Exception:
            results.append(0)

    for res in results:
        if res == 0:
            print(0)
        else:
            for blue_idx, red_idx in res:
                print(blue_idx, red_idx)

if __name__ == "__main__":
    main()
