#include <iostream>
#include <vector>
using namespace std;

void findStamps(int N, int M) {
    vector<int> result;
    int currentSum = 0;

    for (int i = N; i >= 1; --i) {
        if (currentSum + i <= M) {
            result.push_back(i);
            currentSum += i;
        }
        if (currentSum == M) break;
    }

    if (currentSum == M) {
        for (int stamp : result) {
            cout << stamp << " ";
        }
        cout << endl;
    } else {
        cout << 0 << endl;
    }
}

int main() {
    int N, M;
    cin >> N >> M;
    findStamps(N, M);
    return 0;
}
