def teleportation_time(N):
    alice_positions = {1}
    bob_positions = {N}
    
    time = 0
    
    while alice_positions and bob_positions:
        if alice_positions & bob_positions:
            return time
        
        new_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= N:
                new_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                new_alice_positions.add(pos + 3)
        
        new_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                new_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_positions.add(pos - 2)
        
        alice_positions = new_alice_positions
        bob_positions = new_bob_positions
        time += 1
    
    return -1

N = int(input())
print(teleportation_time(N))

