def find_min_stamps(N, M):
    # Результуючий список обраних марок
    selected_stamps = []
    
    # Перебираємо марки у зворотному порядку (від найдорожчої до найдешевшої)
    for stamp in range(N, 0, -1):
        # Поки вартість марки не перевищує залишок, додаємо її
        while M >= stamp:
            selected_stamps.append(stamp)
            M -= stamp
    
    return selected_stamps

# Зчитування вхідних даних
N = int(input("Введіть кількість марок N: "))
M = int(input("Введіть суму M: "))

# Виведення результату
result = find_min_stamps(N, M)
print("Обрані марки:", result)
print("Кількість марок:", len(result))
