def count_uniform_squares(n, grid):
    count = 0
    # Перебираємо всі можливі квадрати
    for size in range(1, n):  # Розмір квадрата від 1 до N-1
        for i in range(n - size):  # Верхня ліва координата по x
            for j in range(n - size):  # Верхня ліва координата по y
                # Вершини квадрата
                top_left = grid[i][j]
                top_right = grid[i][j + size]
                bottom_left = grid[i + size][j]
                bottom_right = grid[i + size][j + size]
                
                # Перевірка, чи всі вершини однакові
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1
    return count

# Введення даних
n = int(input())
grid = [list(map(int, input().split())) for _ in range(n)]

# Виведення результату
result = count_uniform_squares(n, grid)
print(result)
