def solve():
    t = int(input())  # Кількість тестових наборів
    results = []
    
    for _ in range(t):
        n = int(input())  # Кількість точок одного кольору
        
        blue_points = []
        red_points = []
        
        # Зчитуємо координати синіх точок
        for i in range(1, n + 1):
            x, y = map(int, input().split())
            blue_points.append((x, y, i))
        
        # Зчитуємо координати червоних точок
        for i in range(1, n + 1):
            x, y = map(int, input().split())
            red_points.append((x, y, i))
        
        # Сортуємо точки за координатами x
        blue_points.sort()
        red_points.sort()
        
        # З'єднуємо точки в парах
        pairs = []
        for b, r in zip(blue_points, red_points):
            pairs.append(f"{b[2]} {r[2]}")  # Зберігаємо номери точок
        
        results.append("\n".join(pairs))
    
    # Виводимо результати для всіх тестових наборів
    print("\n\n".join(results))

# Запуск програми
solve()