def solve():
    t = int(input())  # Кількість тестів
    for _ in range(t):
        N = int(input())  # Кількість точок одного кольору
        blue_points = []
        red_points = []
        
        # Читання координат синіх точок
        for i in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y, i + 1))  # зберігаємо точку з її індексом
        
        # Читання координат червоних точок
        for i in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y, i + 1))  # зберігаємо точку з її індексом
        
        # Сортуємо точки по x, потім по y
        blue_points.sort()
        red_points.sort()
        
        # Перевірка чи є вирішення:
        answer = []
        for i in range(N):
            # Для кожної пари синьої та червоної точки
            blue_index = blue_points[i][2]  # індекс синьої точки
            red_index = red_points[i][2]    # індекс червоної точки
            answer.append(f"{blue_index} {red_index}")
        
        # Виводимо відповіді
        print("\n".join(answer))

# Виклик функції для виконання програми
solve()
