from collections import deque

n = int(input())

def min_steps_to_meet(N):
    from collections import deque
    
    queue = deque([(1, N, 0)])
    visited = set([(1, N)])
    
    while queue:
        alice_pos, bob_pos, steps = queue.popleft()
        
        if alice_pos == bob_pos:
            return steps
        
        alice_moves = [alice_pos + 2, alice_pos + 3]
        
        bob_moves = [bob_pos - 1, bob_pos - 2]
        
        valid_alice_moves = [move for move in alice_moves if 1 <= move <= N]
        valid_bob_moves = [move for move in bob_moves if 1 <= move <= N]
        
        for new_alice in valid_alice_moves:
            for new_bob in valid_bob_moves:
                if (new_alice, new_bob) not in visited:
                    queue.append((new_alice, new_bob, steps + 1))
                    visited.add((new_alice, new_bob))
    
    return -1

result = min_steps_to_meet(n)

print(result)
