from collections import deque
n = int(input())
alice = 1 
bob = n 
queue = deque([(alice, bob, 0)]) 
visited = set([(alice, bob)]) 
while queue:
    a, b, time = queue.popleft()
    if a == b:
        print(time)
        break
    alice_moves = [a + 2, a + 3]
    bob_moves = [b - 1, b - 2]
    for new_a in alice_moves:
        for new_b in bob_moves:
            if 1 <= new_a <= n and 1 <= new_b <= n and (new_a, new_b) not in visited:
                visited.add((new_a, new_b))
                queue.append((new_a, new_b, time + 1))
else:
    print(-1)