def select_stamps(n, m):
    dp = [float('inf')] * (m + 1)
    dp[0] = 0
    prev = [-1] * (m + 1)
    for value in range(1, n + 1):
        for current_sum in range(m, value - 1, -1):
            if dp[current_sum - value] + 1 < dp[current_sum]:
                dp[current_sum] = dp[current_sum - value] + 1
                prev[current_sum] = value
    if dp[m] == float('inf'):
        return [0]
    result = []
    current = m
    while current > 0:
        result.append(prev[current])
        current -= prev[current]
    return result
n = int(input())
m = int(input())
result = select_stamps(n, m)
print(*result)