def solve():
    t = int(input())  # кількість тестів
    for _ in range(t):
        N = int(input())  # кількість точок одного кольору
        blue_points = []
        red_points = []
        
        # Зчитуємо сині точки
        for i in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y, i + 1))  # додаємо індекс для кожної точки

        # Зчитуємо червоні точки
        for i in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y, i + 1))  # додаємо індекс для кожної точки
        
        # Сортуємо точки (спочатку по x, потім по y)
        blue_points.sort(key=lambda p: (p[0], p[1]))
        red_points.sort(key=lambda p: (p[0], p[1]))

        # Виводимо відповіді
        for i in range(N):
            print(blue_points[i][2], red_points[i][2])

# викликаємо основну функцію
solve()