def solve_test_case(N, blue_points, red_points):
    # Сортируем точки по x-координате
    blue_points = sorted((x, y, i + 1) for i, (x, y) in enumerate(blue_points))
    red_points = sorted((x, y, i + 1) for i, (x, y) in enumerate(red_points))
    
    # Формируем пары
    pairs = []
    for i in range(N):
        b_index = blue_points[i][2]
        r_index = red_points[i][2]
        pairs.append((b_index, r_index))
    
    return pairs

# Ввод данных
t = int(input())
results = []

for _ in range(t):
    N = int(input())
    
    blue_points = [tuple(map(int, input().split())) for _ in range(N)]
    red_points = [tuple(map(int, input().split())) for _ in range(N)]
    
    # Решаем текущий тест
    pairs = solve_test_case(N, blue_points, red_points)
    results.append(pairs)

# Вывод результатов
for pairs in results:
    for b, r in pairs:
        print(b, r)