using System;
using System.Collections.Generic;
using System.Linq;

class Solution {
  public static void Main(string[] args) {
    int n = Convert.ToInt32(Console.ReadLine());
    string input;
    bool[,] square = new bool[n,n];
    for (int i = 0; i < n; i++)
    {
        input = Console.ReadLine();
        List<int> numbers = input.Split(' ').Select(int.Parse).ToList();
        for (int j = 0; j < n; j++)
        {
            if (numbers[j] == 1)
                square[i, j] = true;
            else
                square[i, j] = false;
        }
    }
    int count = 0;
    
    for (int x1 = 0; x1 < n; x1++)
    {
        for (int y1 = 0; y1 < n; y1++)
        {
            for (int x2 = 0; x2 < n; x2++)
            {
                for (int y2 = 0; y2 < n; y2++)
                {
                    if (square[x1, y1] == square[x2, y2] && !(x1 == x2 && y1 == y2))
                    {
                        int dX = x2 - x1;
                        int dY = y2 - y1;
                        if ((x2 + dY >= 0 && y2 - dX >= 0 && x2 + dY - dX >= 0 && y2 - dX - dY >= 0) && (x2 + dY < n && y2 - dX < n && x2 + dY - dX < n && y2 - dX - dY < n) && square[x1, y1] == square[x2 + dY, y2 - dX] && square[x1, y1] == square[x2 + dY - dX, y2 - dX - dY])
                            count++;
                    }
                }
            }
        }
    }

    Console.WriteLine(count / 4);
  }
}
