fun main() {
    val t = readLine()!!.toInt()
    repeat(t) {
        val n = readLine()!!.toInt()

        val bluePoints = mutableListOf<Pair<Int, Int>>()
        for (i in 1..n) {
            val (x, y) = readLine()!!.split(" ").map { it.toInt() }
            bluePoints.add(Pair(x, y))
        }

        val redPoints = mutableListOf<Pair<Int, Int>>()
        for (i in 1..n) {
            val (x, y) = readLine()!!.split(" ").map { it.toInt() }
            redPoints.add(Pair(x, y))
        }

        val sortedBlue = bluePoints.mapIndexed { index, point ->
            Pair(point.first, point.second to index + 1)
        }.sortedBy { it.first }

        val sortedRed = redPoints.mapIndexed { index, point ->
            Pair(point.first, point.second to index + 1)
        }.sortedBy { it.first }

        for (i in 0..n-1) {
            val blueIndex = sortedBlue[i].second.second
            val redIndex = sortedRed[i].second.second
            println("$blueIndex $redIndex")
        }
    }
}