from collections import deque

def min_steps(N):
    alice_queue = deque([(1, 0)])
    bob_queue = deque([(N, 0)])
    alice_visited = set([1])
    bob_visited = set([N])
    while alice_queue or bob_queue:
        if alice_queue:
            position, steps = alice_queue.popleft()
            for new_position in [position + 2, position + 3]:
                if 1 <= new_position <= N and new_position not in alice_visited:
                    alice_visited.add(new_position)
                    alice_queue.append((new_position, steps + 1))
                    if new_position in bob_visited:
                        return steps + 1
        if bob_queue:
            position, steps = bob_queue.popleft()
            for new_position in [position - 1, position - 2]:
                if 1 <= new_position <= N and new_position not in bob_visited:
                    bob_visited.add(new_position)
                    bob_queue.append((new_position, steps + 1))
                    if new_position in alice_visited:
                        return steps + 1
    return -1
n= int(input())
print(min_steps(n))
