def can_meet(N):

    alice_positions = {1}
    bob_positions = {N}
    

    alice_steps = [2, 3]
    bob_steps = [-1, -2]
    

    time = 0
    
    while alice_positions and bob_positions:
        time += 1
        

        alice_positions = {pos + step for pos in alice_positions for step in alice_steps if 1 <= pos + step <= N}
        

        bob_positions = {pos + step for pos in bob_positions for step in bob_steps if 1 <= pos + step <= N}
        

        if alice_positions & bob_positions:
            return time
    
    return -1


n = int(input())  
print(can_meet(n))

