def can_meet(N):
    alice_visited = [False] * (N + 1)
    bob_visited = [False] * (N + 1)

    alice_visited[1] = True
    bob_visited[N] = True

    alice_positions = [1]
    bob_positions = [N]

    time = 0

    while alice_positions and bob_positions:
        time += 1

        # Обробка Аліси
        next_alice_positions = []
        for pos in alice_positions:
            for move in [2, 3]:
                new_pos = pos + move
                if new_pos <= N and not alice_visited[new_pos]:
                    alice_visited[new_pos] = True
                    next_alice_positions.append(new_pos)
                    if bob_visited[new_pos]:
                        return time
        alice_positions = next_alice_positions

        # Обробка Боба
        next_bob_positions = []
        for pos in bob_positions:
            for move in [1, 2]:
                new_pos = pos - move
                if new_pos >= 1 and not bob_visited[new_pos]:
                    bob_visited[new_pos] = True
                    next_bob_positions.append(new_pos)
                    if alice_visited[new_pos]:
                        return time
        bob_positions = next_bob_positions

    return -1

n = int(input())  
print(can_meet(n))