def solve(N, M, result=None):
    # Якщо результат порожній, ініціалізуємо його на першому виклику
    if result is None:
        result = []
    
    # Базова умова: якщо сума M стала 0, виводимо результат
    if M == 0:
        print(*result)
        return
    
    # Якщо M більше за максимальну можливу суму, не можемо сформувати таку суму
    max_sum = (N * (N + 1)) // 2
    if M > max_sum:
        print(0)
        return
    
    # Базова умова: якщо N менше або рівне нулю, припиняємо
    if N == 0:
        print(0)
        return
    
    # Якщо поточне число можна додати до результату
    if M >= N:
        solve(N - 1, M - N, result + [N])  # Додаємо N до результату та рекурсивно викликаємо
    else:
        solve(N - 1, M, result)  # Не додаємо N, але рекурсивно викликаємо без змін у результаті

# Вхідні дані
solve(int(input()), int(input()))
