def count_colored_squares(N, grid):
    count = 0
    for size in range(1, N):  
        for i in range(N - size):
            for j in range(N - size):
                color = grid[i][j]
                if (grid[i+size][j] == color and
                    grid[i][j+size] == color and
                    grid[i+size][j+size] == color):
                    count += 1
    return count+1

N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]
print(count_colored_squares(N, grid))
