def count_squares(N, grid):
    count = 0
    
    # Iterate through all possible top-left corners of 2x2 squares
    for i in range(N - 1):
        for j in range(N - 1):
            # Check the four corners of the square
            if (grid[i][j] == grid[i][j + 1] == grid[i + 1][j] == grid[i + 1][j + 1]):
                count += 1
                
    return count

# Read input
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Get the result
result = count_squares(N, grid)

# Print the result
print(result+1)