def solve():
    t = int(input())  # Читаємо кількість тестових випадків
    
    for _ in range(t):
        N = int(input())  # Кількість точок одного кольору
        blue_points = []
        red_points = []
        
        # Зчитуємо координати синіх точок
        for i in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y, i + 1))  # Зберігаємо координати та індекс
        
        # Зчитуємо координати червоних точок
        for i in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y, i + 1))  # Зберігаємо координати та індекс
        
        # Сортуємо точки по x, якщо x однакові - по y
        blue_points.sort(key=lambda point: (point[0], point[1]))
        red_points.sort(key=lambda point: (point[0], point[1]))
        
        # Виводимо відповідь: для кожної пари синя і червона точка
        for i in range(N):
            print(blue_points[i][2], red_points[i][2])

# Викликаємо функцію для запуску
solve()
