def solve():
    t = int(input())  # Читаємо кількість тестових випадків
    
    for _ in range(t):
        N = int(input())  # Кількість точок одного кольору
        blue_points = []
        red_points = []
        
        # Зчитуємо координати синіх точок
        for i in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y, i + 1))  # Зберігаємо координати та індекс
        
        # Зчитуємо координати червоних точок
        for i in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y, i + 1))  # Зберігаємо координати та індекс
        
        # Сортуємо точки по x, якщо x однакові - по y
        blue_points.sort(key=lambda point: (point[0], point[1]))
        red_points.sort(key=lambda point: (point[0], point[1]))
        
        # Потрібно перевірити, чи відрізки не перетинаються.
        # У задачі зазначено, що точки не повинні перетинатися, якщо з'єднувати їх за сортуванням.
        # Якщо все правильно, то просто виводимо пари
        result = []
        for i in range(N):
            result.append(f"{blue_points[i][2]} {red_points[i][2]}")
        
        # Виводимо результат для поточного тесту
        print("\n".join(result))

# Викликаємо функцію для запуску
solve()
