def solve():
    t = int(input())  # Кількість тестів
    
    for _ in range(t):
        N = int(input())  # Кількість точок одного кольору
        
        blue_points = []
        red_points = []
        
        # Читання координат синіх точок
        for i in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y, i + 1))  # Додаємо індекс для синіх точок
        
        # Читання координат червоних точок
        for i in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y, i + 1))  # Додаємо індекс для червоних точок
        
        # Сортуємо сині точки за x, потім за y
        blue_points.sort()
        
        # Сортуємо червоні точки за x, потім за y
        red_points.sort()

        # Перевірка чи можна поєднати без перетину
        result = []
        for i in range(N):
            result.append((blue_points[i][2], red_points[i][2]))  # Додаємо пари (індекси)

        # Виводимо результат
        for b, r in result:
            print(b, r)

# Викликаємо основну функцію
solve()
