def solve():
    import sys
    input = sys.stdin.read
    data = input().splitlines()
    
    index = 0
    t = int(data[index])
    index += 1
    results = []
    
    for _ in range(t):
        N = int(data[index])
        index += 1
        
        blue_points = []
        red_points = []
        
        # Read blue points
        for i in range(N):
            x, y = map(int, data[index].split())
            blue_points.append((x, y, i + 1))  # Store (x, y, index)
            index += 1
        
        # Read red points
        for i in range(N):
            x, y = map(int, data[index].split())
            red_points.append((x, y, i + 1))  # Store (x, y, index)
            index += 1
        
        # Sort points by (x, y)
        blue_points.sort()
        red_points.sort()
        
        # Prepare the result for this test case
        case_result = []
        
        for i in range(N):
            blue_index = blue_points[i][2]
            red_index = red_points[i][2]
            case_result.append(f"{blue_index} {red_index}")
        
        results.append("\n".join(case_result))
    
    # Print all results for all test cases
    print("\n\n".join(results))
