def solve():
    N = int(input())
    if N == 2:
        print(1)
        return
    
    alice_positions = {1}
    bob_positions = {N}
    seconds = 0
    
    while alice_positions and bob_positions:
        seconds += 1
        
        new_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= N:
                new_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                new_alice_positions.add(pos + 3)
        
        new_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                new_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_positions.add(pos - 2)
        
        if new_alice_positions & new_bob_positions:
            print(seconds)
            return
        
        alice_positions = new_alice_positions
        bob_positions = new_bob_positions
    
    print(-1)

if __name__ == "__main__":
    solve()
