import math

def lcm(a, b):
    return a * b // math.gcd(a, b)

def count_ones_in_memory(N, A, B):
    count_a = N // A
    count_b = N // B
    count_ab = N // lcm(A, B)
    return count_a + count_b - count_ab

N = int(input())
A, B = map(int, input().split())

print(count_ones_in_memory(N, A, B))
