def solve():
    t = int(input())  # Кількість тестів
    for _ in range(t):
        N = int(input())  # Кількість точок одного кольору
        blue_points = []
        red_points = []
        
        # Читання синіх точок
        for i in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y, i + 1))  # додаємо індекс точки
        
        # Читання червоних точок
        for i in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y, i + 1))  # додаємо індекс точки
        
        # Сортуємо точки за координатами x (і, при рівності x, за y)
        blue_points.sort()  # Сортуємо по x і y
        red_points.sort()   # Сортуємо по x і y
        
        # Виведення відповідей
        for i in range(N):
            print(blue_points[i][2], red_points[i][2])  # виводимо індекси точок
        
if __name__ == "__main__":
    solve()
