<?php

function min_seconds_to_meet($N) {
    $alice_queue = [1];
    $bob_queue = [$N];
    
    $alice_visited = [1 => true];
    $bob_visited = [$N => true];
    
    $seconds = 0;
    
    while (!empty($alice_queue) && !empty($bob_queue)) {
        $alice_queue_size = count($alice_queue);
        for ($i = 0; $i < $alice_queue_size; $i++) {
            $current_alice = array_shift($alice_queue);
            foreach ([2, 3] as $move) {
                $new_pos = $current_alice + $move;
                if ($new_pos <= $N && !isset($alice_visited[$new_pos])) {
                    $alice_visited[$new_pos] = true;
                    $alice_queue[] = $new_pos;
                    if (isset($bob_visited[$new_pos])) {
                        return $seconds + 1;
                    }
                }
            }
        }
        
        $bob_queue_size = count($bob_queue);
        for ($i = 0; $i < $bob_queue_size; $i++) {
            $current_bob = array_shift($bob_queue);
            foreach ([1, 2] as $move) {
                $new_pos = $current_bob - $move;
                if ($new_pos >= 1 && !isset($bob_visited[$new_pos])) {
                    $bob_visited[$new_pos] = true;
                    $bob_queue[] = $new_pos;
                    if (isset($alice_visited[$new_pos])) {
                        return $seconds + 1;
                    }
                }
            }
        }
        
        $seconds++;
    }
    
    return -1;
}

$N = intval(trim(fgets(STDIN)));

echo min_seconds_to_meet($N) . "\n";

?>