def countUniformColorSquares(N, grid):
    count = 0
    
    # Перевіряємо квадрати різних розмірів
    for size in range(1, N):  # Розміри квадратів від 1x1 до (N-1)x(N-1)
        for i in range(N - size):  # Проходимо по всіх можливих координатах верхнього лівого кута
            for j in range(N - size):
                # Перевірка всіх чотирьох вершин квадрату
                # Чотири вершини: (i,j), (i+size,j), (i,j+size), (i+size,j+size)
                color = grid[i][j]
                if (grid[i + size][j] == color and
                    grid[i][j + size] == color and
                    grid[i + size][j + size] == color):
                    count += 1
    return count

# Вхідні дані
N = int(input())  # Розмір квадрата
grid = [list(map(int, input().split())) for _ in range(N)]  # Матриця кольорів

# Обчислення результату
result = countUniformColorSquares(N, grid)

# Виведення результату
print(result)