class Point:
    def __init__(self, x, y, index):
        self.x = x
        self.y = y
        self.index = index

def solve():
    t = int(input())  # кількість тестів

    for _ in range(t):
        N = int(input())  # кількість точок одного кольору
        
        blue = []
        red = []

        # Читання синіх точок
        for i in range(N):
            x, y = map(int, input().split())
            blue.append(Point(x, y, i + 1))  # Додаємо точку синього кольору разом з її індексом

        # Читання червоних точок
        for i in range(N):
            x, y = map(int, input().split())
            red.append(Point(x, y, i + 1))  # Додаємо точку червоного кольору разом з її індексом

        # Сортуємо обидва набори точок: спочатку за x, потім за y
        blue.sort(key=lambda p: (p.x, p.y))
        red.sort(key=lambda p: (p.x, p.y))

        # Виведення пар точок
        for i in range(N):
            print(blue[i].index, red[i].index)

        # Якщо є ще інші тести, виводимо порожній рядок для розділення
        if _ < t - 1:
            print()

if __name__ == "__main__":
    solve()