#include <iostream>
#include <unordered_set>
#include <queue>
using namespace std;

int min_seconds_to_meet(int N) {
    unordered_set<int> alice_positions, bob_positions;
    
    alice_positions.insert(1);
    bob_positions.insert(N);  

    int seconds = 0;
    
    while (true) {
        seconds++;
        unordered_set<int> new_alice_positions;
        for (int pos : alice_positions) {
            if (pos + 2 <= N) {
                new_alice_positions.insert(pos + 2);
            }
            if (pos + 3 <= N) {
                new_alice_positions.insert(pos + 3);
            }
        }
        unordered_set<int> new_bob_positions;
        for (int pos : bob_positions) {
            if (pos - 1 >= 1) {
                new_bob_positions.insert(pos - 1);
            }
            if (pos - 2 >= 1) {
                new_bob_positions.insert(pos - 2);
            }
        }
        for (int pos : new_alice_positions) {
            if (new_bob_positions.find(pos) != new_bob_positions.end()) {
                return seconds;
            }
        }
        alice_positions = move(new_alice_positions);
        bob_positions = move(new_bob_positions);
        if (alice_positions.empty() || bob_positions.empty()) {
            return -1;
        }
    }
}

int main() {
    int N;
    cin >> N;
    cout << min_seconds_to_meet(N) << endl;
    return 0;
}
