def solve(n, m):
    dp = [float("inf")] * (m + 1)
    dp[0] = 0
    
    last_stamp = [0] * (m + 1)
    
    for stamp in range(1, n + 1):
        for value in range(m, stamp - 1, -1):
            if dp[value - stamp] + 1 < dp[value]:
                dp[value] = dp[value - stamp] + 1
                last_stamp[value] = stamp
    
    if dp[m] == float("inf"):
        return 0
    
    selected_stamps = []
    current_value = m
    while current_value > 0:
        stamp = last_stamp[current_value]
        selected_stamps.append(stamp)
        current_value -= stamp
    
    return "\n".join(map(str, selected_stamps))

n = int(input())
m = int(input())

result = solve(n, m)
print(result)