def solve(n, m):
    max_possible_sum = n * (n + 1) // 2
    
    if m > max_possible_sum or m < 0:
        return 0
    
    stamps = []
    current_stamp = n
    
    while m > 0 and current_stamp > 0:
        if current_stamp <= m:
            stamps.append(current_stamp)
            m -= current_stamp
        current_stamp -= 1
    
    return "\n".join(map(str, stamps)) if m == 0 else 0

n = int(input())
m = int(input())

result = solve(n, m)
print(result)
