def solve(N, target_amount):
    possible = 1
    
    min_postcards = [float('inf')] * (target_amount + 1)
    min_postcards[0] = 0
    
    solution = [[] for _ in range(target_amount + 1)]
    
    for postcard in range(1, N + 1):
        for amount in range(target_amount, postcard - 1, -1):
            if min_postcards[amount - postcard] < float('inf'):
                if min_postcards[amount - postcard] + 1 < min_postcards[amount]:
                    min_postcards[amount] = min_postcards[amount - postcard] + 1
                    solution[amount] = solution[amount - postcard] + [postcard]
    
    return "\n".join(map(str, solution[target_amount])) if min_postcards[target_amount] < float('inf') else 0

n = int(input())
m = int(input())

result = solve(n, m)
print(result)