def count_uniform_squares(N, grid):
    count = 0

    for size in range(1, N):
        for i in range(N - size):
            for j in range(N - size):
                if grid[i][j] == grid[i][j + size] == grid[i + size][j] == grid[i + size][j + size]:
                    count += 1

    for i in range(1, N - 1):
        for j in range(1, N - 1):
            size = 1
            while i - size >= 0 and i + size < N and j - size >= 0 and j + size < N:
                if grid[i][j] == grid[i - size][j] == grid[i + size][j] == grid[i][j - size] == grid[i][j + size]:
                    count += 1
                size += 1

    return count


N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]
print(count_uniform_squares(N, grid))
