t = int(input())  
for _ in range(t):
    n = int(input())  
    blue = [tuple(map(int, input().split())) for _ in range(n)] 
    red = [tuple(map(int, input().split())) for _ in range(n)]  

    blue_sorted = sorted((x, y, i+1) for i, (x, y) in enumerate(blue))
    red_sorted = sorted((x, y, i+1) for i, (x, y) in enumerate(red))

    result = [(blue_sorted[i][2], red_sorted[i][2]) for i in range(n)]

    def is_crossed(p1, p2, p3, p4):
        def ccw(A, B, C):
            return (C[1] - A[1]) * (B[0] - A[0]) > (B[1] - A[1]) * (C[0] - A[0])
        return ccw(p1, p3, p4) != ccw(p2, p3, p4) and ccw(p1, p2, p3) != ccw(p1, p2, p4)

    valid = True
    for i in range(n):
        for j in range(i + 1, n):
            if is_crossed(blue_sorted[i], red_sorted[i], blue_sorted[j], red_sorted[j]):
                valid = False
                break
        if not valid:
            break

    if valid:
        for b, r in result:
            print(b,r)
    else:
        print(0)
