def solve(N, M):
    # Calculate the total sum of all marks from 1 to N
    total_sum = N * (N + 1) // 2
    
    # If the total sum is less than M, it's impossible to find such a set
    if total_sum < M:
        print(0)
        return
    
    marks = []
    
    # Try to find the solution starting from the largest number down
    for i in range(N, 0, -1):
        if M >= i:
            marks.append(i)
            M -= i
        if M == 0:
            break
    
    if M == 0:
        print(" ".join(map(str, marks)))
    else:
        print(0)

# Читання вхідних даних
N = int(input())  # Кількість марок
M = int(input())  # Необхідна сума

# Виклик функції для знаходження відповідних марок
solve(N, M)
