def solve(N, M):
    # Calculate the total sum of marks from 1 to N
    total_sum = N * (N + 1) // 2
    
    # If the total sum is less than M, it's impossible to form M
    if total_sum < M:
        print(0)
        return
    
    # Start from the largest mark and subtract from M
    result = []
    
    for i in range(N, 0, -1):
        if M >= i:
            result.append(i)
            M -= i
        if M == 0:
            break
    
    # Output the result as a space-separated string
    if M == 0:
        print(*result)  # Efficient output by unpacking the list
    else:
        print(0)

# Input reading and function call
N = int(input())  # Number of stamps
M = int(input())  # Total cost

solve(N, M)
