def solve():
    t = int(input())  # Кількість тестів
    for _ in range(t):
        N = int(input())  # Кількість точок одного кольору
        blue_points = []
        red_points = []
        
        # Зчитуємо координати синіх точок
        for i in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y, i + 1))  # (x, y, індекс точки)
        
        # Зчитуємо координати червоних точок
        for i in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y, i + 1))  # (x, y, індекс точки)
        
        # Сортуємо обидві групи точок за координатами (перший критерій - x, другий - y)
        blue_points.sort()  # Сортуємо за x, а потім за y
        red_points.sort()  # Сортуємо за x, а потім за y
        
        # Виводимо з'єднання між точками
        result = []
        for i in range(N):
            result.append(f"{blue_points[i][2]} {red_points[i][2]}")
        
        # Виводимо всі з'єднання для поточного тесту
        print("\n".join(result))

# Запуск програми
solve()
