function minimumSeconds(N) {

    if (N <= 2) return -1;


    const distance = N - 1;


    const gcd = (a, b) => (b === 0 ? a : gcd(b, a % b));


    if (distance % gcd(2, gcd(3, gcd(1, 2))) !== 0) {
        return -1;
    }


    let alicePositions = new Set(); 
    let bobPositions = new Set();   

    for (let time = 0; time <= N; time++) {
     
        let alicePos = 1 + 2 * Math.floor(time / 2) + 3 * (time % 2); 
        if (alicePos >= N) break; 
        alicePositions.add(alicePos);

      
        let bobPos = N - 1 * Math.floor(time / 2) - 2 * (time % 2); 
        if (bobPos <= 1) break; 
        bobPositions.add(bobPos);

        // Перетин множин
        for (let pos of alicePositions) {
            if (bobPositions.has(pos)) {
                return time; 
            }
        }
    }

    return -1;
}


console.log(minimumSeconds(5));  
console.log(minimumSeconds(8)); 
console.log(minimumSeconds(1000000000)); 
