#include <iostream>
using namespace std;

int main() {
    long long N, M;
    cin >> N >> M;
    long long max_sum = N * (N + 1) / 2;
    if (M > max_sum) {
        cout << 0 << endl;
        return 0;
    }

    long long current_sum = 0; 
    bool first = true; 
    for (long long i = N; i >= 1 && current_sum < M; --i) {
        if (current_sum + i <= M) {
            if (!first) {
                cout << " ";
            }
            cout << i;
            current_sum += i;
            first = false;
        }
    }

    if (current_sum != M) {
        cout << 0 << endl;
    } else {
        cout << endl;
    }

    return 0;
}