def can_meet(N):
    if N == 2:
        return 1
    
    alice_pos = 1
    bob_pos = N
    
    seconds = 0
    
    alice_moves = {alice_pos}  
    bob_moves = {bob_pos}      
    
    while alice_moves and bob_moves:
        seconds += 1
        
        next_alice_moves = set()
        next_bob_moves = set()
        
        for pos in alice_moves:
            if pos + 2 <= N: next_alice_moves.add(pos + 2)
            if pos + 3 <= N: next_alice_moves.add(pos + 3)
        
        for pos in bob_moves:
            if pos - 1 >= 1: next_bob_moves.add(pos - 1)
            if pos - 2 >= 1: next_bob_moves.add(pos - 2)
        
        if next_alice_moves & next_bob_moves:
            return seconds
        
        alice_moves = next_alice_moves
        bob_moves = next_bob_moves
    
    return -1

# Вхідні дані
N = int(input())

print(can_meet(N))
