def solve(N):
    # Якщо різниця між N і 1 не кратна 2 або 3, вони не можуть зустрітися
    if (N - 1) % 2 != 0 and (N - 1) % 3 != 0:
        return -1
    
    # Якщо різниця кратна 2 або 3, обчислюємо мінімальні кроки
    # Мінімізація кроків: беремо найбільший крок (3) для швидшого зменшення
    steps = 0
    while N > 1:
        if (N - 1) % 3 == 0:
            N -= 3
        elif (N - 1) % 2 == 0:
            N -= 2
        else:
            return -1  # Не можемо знайти можливий крок
        steps += 1
        
    return steps

# Вводимо число N
N = int(input())
# Виводимо результат
print(solve(N))
