def find_minimum_stamps(N, M):
    # Обчислюємо суму всіх можливих марок
    total_sum = N * (N + 1) // 2
    
    # Якщо сума більше ніж можливий максимум, то це неможливо
    if M > total_sum:
        return [0]
    
    # Результат для вибраних марок
    result = []
    
    # Починаємо з найбільшої марки і віднімаємо її від M, поки M не стане 0
    for i in range(N, 0, -1):
        if M >= i:
            result.append(i)
            M -= i
        if M == 0:
            break
    
    # Якщо сума M все ще не стала 0, це неможливо
    if M != 0:
        return [0]
    
    # Виводимо марки у зростаючому порядку
    return sorted(result)

# Вхідні дані
N = int(input())
M = int(input())

# Виведення результату
result = find_minimum_stamps(N, M)
print(*result)
