def solve(N, M):
    # Сума всіх марок від 1 до N
    total_sum = N * (N + 1) // 2
    
    # Якщо не можна отримати суму M
    if total_sum < M:
        print(0)
        return
    
    # Починаємо з найбільшої марки і пробуємо вибирати марки
    result = []
    for i in range(N, 0, -1):
        if M >= i:
            result.append(i)
            M -= i
        if M == 0:
            break
    
    # Якщо сума M дорівнює 0, то виводимо номери марок
    if M == 0:
        print(" ".join(map(str, result)))
    else:
        print(0)

# Читання вхідних даних
N = int(input())  # Кількість марок
M = int(input())  # Загальна сума

# Викликаємо функцію для вирішення задачі
solve(N, M)
