def count_squares(N, grid):
    count = 0
    
    # Перебираємо всі можливі розміри квадратів
    for size in range(2, N + 1):
        # Перебираємо всі можливі координати верхнього лівого кута квадрата
        for i in range(N - size + 1):
            for j in range(N - size + 1):
                # Перевіряємо чи всі чотири вершини мають однаковий колір
                color = grid[i][j]
                if (grid[i + size - 1][j] == color and
                    grid[i][j + size - 1] == color and
                    grid[i + size - 1][j + size - 1] == color):
                    count += 1

    return count

# Читання входу
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Виведення результату
print(count_squares(N, grid))
