def count_squares(N, grid):
    count = 0
    # Перебираємо всі пари точок (i, j) та (k, l)
    for i in range(N):
        for j in range(N):
            for k in range(i + 1, N):
                for l in range(j + 1, N):
                    # Перевіряємо, чи ці точки можуть бути діагоналями квадрата
                    # Для цього перевіримо чи їх відстань по вертикалі = відстань по горизонталі
                    if abs(i - k) == abs(j - l):
                        # Визначаємо координати всіх 4 точок квадрата
                        x1, y1 = i, j
                        x2, y2 = i, l
                        x3, y3 = k, j
                        x4, y4 = k, l
                        
                        # Перевіряємо, чи всі точки одного кольору
                        color = grid[x1][y1]
                        if (grid[x2][y2] == color and
                            grid[x3][y3] == color and
                            grid[x4][y4] == color):
                            count += 1
    return count

# Вхідні дані
N = int(input())  # розмір сітки
grid = [list(map(int, input().split())) for _ in range(N)]

# Виведення результату
print(count_squares(N, grid))
