def solve():
    t = int(input())  # кількість тестів
    for _ in range(t):
        N = int(input())  # кількість точок одного кольору
        blue_points = []
        red_points = []
        
        for i in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y, i + 1))  # зберігаємо координати та індекс (1-based)

        for i in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y, i + 1))  # зберігаємо координати та індекс (1-based)

        # Сортуємо обидва масиви точок за координатами
        blue_points.sort()
        red_points.sort()

        # Виводимо пари точок
        result = []
        for i in range(N):
            result.append(f"{blue_points[i][2]} {red_points[i][2]}")

        # Виводимо результат для поточного тесту
        print("\n".join(result))

# викликаємо основну функцію для виконання програми
solve()
