use std::io;

fn main() {
    let mut alice = String::new();
    let mut bob = String::new();
    let mut duration = String::new();

    for i in [&mut alice, &mut bob, &mut duration] {
        io::stdin()
            .read_line(i) 
            .expect("Failed to read line");
    }

    let mut alice: u32 = alice.trim().parse().expect("Input should be an integer");
    let mut bob: u32 = bob.trim().parse().expect("Input should be an integer");
    let duration: u32 = duration.trim().parse().expect("Input should be an integer");

    for i in 1..=duration {
        alice += 1;
        bob += 2;

        std::mem::swap(&mut alice, &mut bob);
    }

    println!("{}", alice + bob)
}
