def find_president(N, numbers):
    # Підрахунок кількостей
    count = {}
    for num in numbers:
        count[num] = count.get(num, 0) + 1
    
    # Знайти всі унікальні числа
    unique_numbers = [num for num in count if count[num] == 1]
    
    # Якщо немає унікальних чисел, вибори не відбулися
    if not unique_numbers:
        return -1
    
    # Знайти мінімальне серед унікальних
    return min(unique_numbers)

# Зчитування вхідних даних
N = int(input())
numbers = list(map(int, input().split()))

# Виведення результату
print(find_president(N, numbers))
