def count_monochrome_squares(N, grid):
    count = 0
    # Iterate over all possible square sizes
    for size in range(1, N):  # size is the side length of the square
        for i in range(N - size):  # row of the top-left corner
            for j in range(N - size):  # column of the top-left corner
                # Get the vertices of the square
                top_left = grid[i][j]
                top_right = grid[i][j + size]
                bottom_left = grid[i + size][j]
                bottom_right = grid[i + size][j + size]
                # Check if all vertices have the same color
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1
    return count

# Example test case 1
N1 = 4
grid1 = [
    [0, 1, 0, 0],
    [0, 0, 1, 1],
    [1, 0, 0, 0],
    [0, 1, 1, 1]
]
count1 = count_monochrome_squares(N1, grid1)

# Example test case 2
N2 = 4
grid2 = [
    [0, 1, 0, 0],
    [0, 0, 0, 1],
    [1, 0, 0, 0],
    [0, 1, 1, 1]
]
count2 = count_monochrome_squares(N2, grid2)

count1, count2
