def count_monochrome_squares(N, grid):
    count = 0

    # Перевіряємо всі можливі квадрати з розмірами від 1x1 до NxN
    for size in range(1, N + 1):  # Розмір сторони квадрата
        for i in range(N - size + 1):  # Рядок верхньої лівої вершини квадрата
            for j in range(N - size + 1):  # Стовпець верхньої лівої вершини квадрата
                # Отримуємо колір верхньої лівої вершини
                color = grid[i][j]
                is_monochrome = True

                # Перевіряємо всі вершини квадрата
                for x in range(i, i + size):
                    for y in range(j, j + size):
                        if grid[x][y] != color:
                            is_monochrome = False
                            break
                    if not is_monochrome:
                        break

                # Якщо всі вершини однакового кольору, збільшуємо лічильник
                if is_monochrome:
                    count += 1

    return count


# Зчитування вхідних даних
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Розв'язок
result = count_monochrome_squares(N, grid)
print(result)

