def count_monochrome_squares(N, grid):
    count = 0

    # Перебираємо всі можливі розміри квадратів
    for size in range(1, N):
        # Перебираємо всі верхні ліві кути квадратів
        for i in range(N - size):
            for j in range(N - size):
                # Координати вершин квадрата
                top_left = grid[i][j]
                top_right = grid[i][j + size]
                bottom_left = grid[i + size][j]
                bottom_right = grid[i + size][j + size]

                # Перевірка, чи всі вершини однакового кольору
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1

    return count


# Зчитування вхідних даних
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Розв'язок
result = count_monochrome_squares(N, grid)
print(result)
