def solve():
    n = int(input())
    grid = list(map(int, input().split()))

    count = 0
    for i in range(n):
        for j in range(n):
            for size in range(1, min(n - i, n - j) + 1):
                print(f"i: {i}, j: {j}, size: {size}") #Debugging print statement
                points = []
                try:
                    points.append(grid[i * n + j])
                    points.append(grid[i * n + j + size])
                    points.append(grid[(i + size) * n + j])
                    points.append(grid[(i + size) * n + j + size])
                    if all(p == points[0] for p in points):
                        count += 1
                except IndexError as e:
                    print(f"IndexError caught at i={i}, j={j}, size={size}: {e}")
                    #Handle the error appropriately, possibly continue or exit
                    continue #for now just skip the faulty square

    print(f"Total count: {count}")

solve()
