def count_squares(N, grid):
    count = 0
    
    # Проходимо по всіх можливих розмірах квадратів
    for x1 in range(N):
        for y1 in range(N):
            for x2 in range(x1 + 1, N):
                for y2 in range(y1 + 1, N):
                    # Перевіряємо, чи можна створити квадрат з діагоналями (x1, y1) і (x2, y2)
                    if (x2 - x1) == (y2 - y1):  # Це умова для квадратів, де сторони рівні
                        # Точки квадрата
                        p1 = grid[x1][y1]
                        p2 = grid[x1][y2]
                        p3 = grid[x2][y1]
                        p4 = grid[x2][y2]
                        # Якщо всі чотири точки однакові, збільшуємо лічильник
                        if p1 == p2 == p3 == p4:
                            count += 1
    return count

# Зчитування вхідних даних
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Виклик функції та виведення результату
print(count_squares(N, grid))
