def find_meeting_time(N):
    if (1 % 2) != (N % 2):
        return -1
    alice_positions = {1}
    bob_positions = {N}
    
    time = 0
    
    while alice_positions and bob_positions:
        if alice_positions & bob_positions:
            return time
        
        alice_positions = {x + 2 for x in alice_positions if x + 2 <= N} | \
                          {x + 3 for x in alice_positions if x + 3 <= N}
        
        bob_positions = {x - 1 for x in bob_positions if x - 1 >= 1} | \
                        {x - 2 for x in bob_positions if x - 2 >= 1}
        
        time += 1
    
    return -1

N = int(input())
print(find_meeting_time(N))
