def count_colored_squares(N, grid):
    count = 0

    for i in range(N):
        for j in range(N):
            for k in range(1, N - max(i, j)):
                if grid[i][j] == grid[i+k][j] == grid[i][j+k] == grid[i+k][j+k]:
                    count += 1

    return count

N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

result = count_colored_squares(N, grid)
print(result)
