def count_squares(matrix):
    n = len(matrix)
    count = 0
    
    for size in range(2, n+1):
        for i in range(n-size+1):
            for j in range(n-size+1):
                if all(matrix[i+k][j] == matrix[i][j] for k in range(size)) and \
                   all(matrix[i][j+k] == matrix[i][j] for k in range(size)) and \
                   all(matrix[i+size-1][j+k] == matrix[i][j] for k in range(size)) and \
                   all(matrix[i+k][j+size-1] == matrix[i][j] for k in range(size)):
                    count += 1

    return count

matrix = [
    [0, 1, 0, 0],
    [0, 0, 1, 1],
    [1, 0, 0, 0],
    [0, 1, 1, 1]
]

print(count_squares(matrix))
