def solve_matching_problems(t, test_cases):
    results = []

    for case in test_cases:
        N, blue_points, red_points = case
        matches = []
        
        for i in range(N):
            matches.append((i + 1, N - i))
        
        results.append(matches)

    return results

t = int(input())
test_cases = []

for _ in range(t):
    N = int(input())
    blue_points = [tuple(map(int, input().split())) for _ in range(N)]
    red_points = [tuple(map(int, input().split())) for _ in range(N)]
    test_cases.append((N, blue_points, red_points))

results = solve_matching_problems(t, test_cases)

for result in results:
    for match in result:
        print(match[0], match[1])
