def solve_matching_problems(t, test_cases):
    results = []

    for case in test_cases:
        N, blue_points, red_points = case
        blue_points = sorted(blue_points)
        red_points = sorted(red_points)
        matches = [(i + 1, i + 1) for i in range(N)]
        results.append(matches)

    return results

# Читання вхідних даних
t = int(input().strip())
test_cases = []

for _ in range(t):
    N = int(input().strip())
    blue_points = [tuple(map(int, input().strip().split())) for _ in range(N)]
    red_points = [tuple(map(int, input().strip().split())) for _ in range(N)]
    test_cases.append((N, blue_points, red_points))

# Обчислення
results = solve_matching_problems(t, test_cases)

# Виведення результатів
for result in results:
    for match in result:
        print(match[0], match[1])
