import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int N = scanner.nextInt();
        Queue<Integer> queueAlice = new LinkedList<>();
        Queue<Integer> queueBob = new LinkedList<>();
        Set<Integer> visitedAlice = new HashSet<>();
        Set<Integer> visitedBob = new HashSet<>();
        queueAlice.add(1);
        visitedAlice.add(1);
        queueBob.add(N);
        visitedBob.add(N);
        int seconds = 0;
        while (!queueAlice.isEmpty() && !queueBob.isEmpty()) {
            int sizeAlice = queueAlice.size();
            for (int i = 0; i < sizeAlice; i++) {
                int currentAlice = queueAlice.poll();
                if (visitedBob.contains(currentAlice)) {
                    System.out.println(seconds);
                    return;
                }
                if (currentAlice + 2 <= N && !visitedAlice.contains(currentAlice + 2)) {
                    visitedAlice.add(currentAlice + 2);
                    queueAlice.add(currentAlice + 2);
                }
                if (currentAlice + 3 <= N && !visitedAlice.contains(currentAlice + 3)) {
                    visitedAlice.add(currentAlice + 3);
                    queueAlice.add(currentAlice + 3);
                }
            }
            int sizeBob = queueBob.size();
            for (int i = 0; i < sizeBob; i++) {
                int currentBob = queueBob.poll();
                if (visitedAlice.contains(currentBob)) {
                    System.out.println(seconds);
                    return;
                }
                if (currentBob - 1 >= 1 && !visitedBob.contains(currentBob - 1)) {
                    visitedBob.add(currentBob - 1);
                    queueBob.add(currentBob - 1);
                }
                if (currentBob - 2 >= 1 && !visitedBob.contains(currentBob - 2)) {
                    visitedBob.add(currentBob - 2);
                    queueBob.add(currentBob - 2);
                }
            }
            seconds++;
        }
        System.out.println(-1);
    }
}
