import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int N = sc.nextInt();
        
        // Якщо кількість боксів 2, то зустріч відбудеться одразу
        if (N == 2) {
            System.out.println(0);
            return;
        }

        // Аліса стартує з 1, Боб з N
        int alice = 1, bob = N, time = 0;
        
        // По черзі рухаємо роботів
        while (alice < bob) {
            time++;
            // Аліса може рухатись на +2 або +3
            if (alice + 3 <= N) alice += 3;
            else if (alice + 2 <= N) alice += 2;
            
            // Боб може рухатись на -1 або -2
            if (bob - 2 >= 1) bob -= 2;
            else if (bob - 1 >= 1) bob -= 1;
            
            // Перевірка, чи зустрілись роботи
            if (alice == bob) {
                System.out.println(time);
                return;
            }
        }
        
        System.out.println(-1);
    }
}
