import java.util.*;

public class Teleportation {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        
        int N = scanner.nextInt();
        
        if (N < 2) {
            System.out.println(-1);
            return;
        }
        
        int distance = N - 1;
        
        if (distance % gcd(2, 3) == 0) {
            System.out.println(distance / gcd(2, 3));
        } else {
            System.out.println(-1);
        }
    }

    private static int gcd(int a, int b) {
        while (b != 0) {
            int temp = b;
            b = a % b;
            a = temp;
        }
        return a;
    }
}
