import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int N = sc.nextInt();
        Map<Integer, Integer> count = new HashMap<>();
        
        // Підрахунок кількості кожного числа
        for (int i = 0; i < N; i++) {
            int num = sc.nextInt();
            count.put(num, count.getOrDefault(num, 0) + 1);
        }
        
        // Пошук мінімального унікального числа
        int res = -1;
        for (Map.Entry<Integer, Integer> entry : count.entrySet()) {
            if (entry.getValue() == 1 && (res == -1 || entry.getKey() < res)) {
                res = entry.getKey();
            }
        }
        
        System.out.println(res);
    }
}
