import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int N = sc.nextInt();  // кількість роботів
        Map<Integer, Integer> countMap = new HashMap<>();
        
        // Читання згенерованих чисел і підрахунок їх кількості
        for (int i = 0; i < N; i++) {
            int num = sc.nextInt();
            countMap.put(num, countMap.getOrDefault(num, 0) + 1);
        }
        
        // Знаходимо мінімальне унікальне число
        int result = Integer.MAX_VALUE;
        for (int num : countMap.keySet()) {
            if (countMap.get(num) == 1) {
                result = Math.min(result, num);
            }
        }
        
        // Виводимо результат
        System.out.println(result == Integer.MAX_VALUE ? -1 : result);
    }
}
