import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int N = sc.nextInt();
        int[][] grid = new int[N][N];

        // Вводимо кольори точок на площині
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                grid[i][j] = sc.nextInt();
            }
        }

        int count = 0;

        // Перевіряємо всі квадрати різного розміру
        for (int size = 1; size < N; size++) {
            for (int i = 0; i + size < N; i++) {
                for (int j = 0; j + size < N; j++) {
                    // Перевіряємо квадрати з верхнім лівим кутом (i, j) і стороною size
                    int x1 = i, y1 = j; // Верхній лівий кут
                    int x2 = i + size, y2 = j; // Верхній правий кут
                    int x3 = i, y3 = j + size; // Нижній лівий кут
                    int x4 = i + size, y4 = j + size; // Нижній правий кут

                    // Перевіряємо, чи всі чотири вершини мають однаковий колір
                    if (grid[x1][y1] == grid[x2][y2] && grid[x2][y2] == grid[x3][y3] && grid[x3][y3] == grid[x4][y4]) {
                        count++;
                    }
                }
            }
        }

        System.out.println(count);
    }
}
