import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        
        int N = scanner.nextInt();
        int[][] grid = new int[N][N];

        // Зчитуємо кольори точок
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                grid[i][j] = scanner.nextInt();
            }
        }

        int count = 0;

        // Перевіряємо всі можливі квадрати
        for (int size = 1; size < N; size++) { // Квадрати від 1x1 до (N-1)x(N-1)
            for (int i = 0; i < N - size; i++) { // Індекс верхнього лівого кута
                for (int j = 0; j < N - size; j++) { // Індекс верхнього лівого кута
                    int color = grid[i][j]; // Колір верхнього лівого кута

                    // Перевіряємо всі чотири вершини квадрата
                    if (grid[i + size][j] == color &&
                        grid[i][j + size] == color &&
                        grid[i + size][j + size] == color) {
                        count++; // Якщо всі вершини однакового кольору, збільшуємо лічильник
                    }
                }
            }
        }

        System.out.println(count);
    }
}
