import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        
        // Читання розміру квадрата
        int N = scanner.nextInt();
        int[][] grid = new int[N][N];
        
        // Читання кольорів для кожної точки
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                grid[i][j] = scanner.nextInt();
            }
        }
        
        int count = 0;
        
        // Перевірка всіх можливих квадратів
        for (int size = 1; size < N; size++) {  // розмір квадрату від 1 до N-1
            for (int i = 0; i < N - size; i++) {  // верхній лівий кут
                for (int j = 0; j < N - size; j++) {  // верхній лівий кут
                    int color = grid[i][j]; // колір верхнього лівого кута квадрата
                    
                    // Перевірка чотирьох вершин квадрата
                    if (grid[i + size][j] == color && 
                        grid[i][j + size] == color && 
                        grid[i + size][j + size] == color) {
                        count++; // Якщо всі чотири вершини одного кольору
                    }
                }
            }
        }
        
        // Виведення результату
        System.out.println(count);
        scanner.close();
    }
}
