import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int t = sc.nextInt(); // кількість тестів
        
        while (t-- > 0) {
            int N = sc.nextInt(); // кількість точок одного кольору
            int[][] bluePoints = new int[N][3]; // [x, y, index]
            int[][] redPoints = new int[N][3];  // [x, y, index]
            
            // Зчитуємо координати синіх точок
            for (int i = 0; i < N; i++) {
                bluePoints[i][0] = sc.nextInt();
                bluePoints[i][1] = sc.nextInt();
                bluePoints[i][2] = i + 1; // індекс точки
            }
            
            // Зчитуємо координати червоних точок
            for (int i = 0; i < N; i++) {
                redPoints[i][0] = sc.nextInt();
                redPoints[i][1] = sc.nextInt();
                redPoints[i][2] = i + 1; // індекс точки
            }
            
            // Сортуємо обидві групи точок за координатами (перш за все по x, потім по y)
            Arrays.sort(bluePoints, (p1, p2) -> p1[0] != p2[0] ? Integer.compare(p1[0], p2[0]) : Integer.compare(p1[1], p2[1]));
            Arrays.sort(redPoints, (p1, p2) -> p1[0] != p2[0] ? Integer.compare(p1[0], p2[0]) : Integer.compare(p1[1], p2[1]));
            
            // Виводимо пари з'єднаних точок
            for (int i = 0; i < N; i++) {
                System.out.println(bluePoints[i][2] + " " + redPoints[i][2]);
            }
        }
    }
}
