import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int t = sc.nextInt();  // кількість тестових блоків
        
        while (t-- > 0) {
            int N = sc.nextInt();  // кількість точок одного кольору
            int[][] blue = new int[N][3];  // збережемо координати синіх точок: [x, y, індекс]
            int[][] red = new int[N][3];   // збережемо координати червоних точок: [x, y, індекс]

            // Зчитуємо координати синіх точок
            for (int i = 0; i < N; i++) {
                blue[i][0] = sc.nextInt();  // x
                blue[i][1] = sc.nextInt();  // y
                blue[i][2] = i + 1;         // індекс
            }

            // Зчитуємо координати червоних точок
            for (int i = 0; i < N; i++) {
                red[i][0] = sc.nextInt();  // x
                red[i][1] = sc.nextInt();  // y
                red[i][2] = i + 1;         // індекс
            }

            // Сортуємо точки синього і червоного кольору
            Arrays.sort(blue, (p1, p2) -> p1[0] != p2[0] ? Integer.compare(p1[0], p2[0]) : Integer.compare(p1[1], p2[1]));
            Arrays.sort(red, (p1, p2) -> p1[0] != p2[0] ? Integer.compare(p1[0], p2[0]) : Integer.compare(p1[1], p2[1]));

            // Виводимо пари точок
            for (int i = 0; i < N; i++) {
                System.out.println(blue[i][2] + " " + red[i][2]);
            }
        }
    }
}
