import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int t = sc.nextInt();
        
        for (int test = 0; test < t; test++) {
            int N = sc.nextInt();
            int[][] blue = new int[N][2];
            int[][] red = new int[N][2];
            
            for (int i = 0; i < N; i++) {
                blue[i][0] = sc.nextInt();
                blue[i][1] = sc.nextInt();
            }
            
            for (int i = 0; i < N; i++) {
                red[i][0] = sc.nextInt();
                red[i][1] = sc.nextInt();
            }
            
            List<int[]> result = new ArrayList<>();
            boolean possible = true;
            
            for (int i = 0; i < N; i++) {
                int minDist = Integer.MAX_VALUE;
                int redIdx = -1;
                
                for (int j = 0; j < N; j++) {
                    int dist = Math.abs(blue[i][0] - red[j][0]) + Math.abs(blue[i][1] - red[j][1]);
                    if (dist < minDist) {
                        minDist = dist;
                        redIdx = j;
                    }
                }
                
                result.add(new int[]{i + 1, redIdx + 1});
                red[redIdx][0] = Integer.MAX_VALUE;
                red[redIdx][1] = Integer.MAX_VALUE;
            }
            
            if (possible) {
                for (int[] pair : result) {
                    System.out.println(pair[0] + " " + pair[1]);
                }
            } else {
                System.out.println(0);
            }
        }
    }
}
