import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        Map<Integer, Integer> frequency = new HashMap<>();
        int[] numbers = new int[n];
        for (int i = 0; i < n; i++) {
            numbers[i] = scanner.nextInt();
            frequency.put(numbers[i], frequency.getOrDefault(numbers[i], 0) + 1);
        }
        int minUnique = Integer.MAX_VALUE;
        for (int num : numbers) {
            if (frequency.get(num) == 1 && num < minUnique) {
                minUnique = num;
            }
        }
        System.out.println(minUnique == Integer.MAX_VALUE ? -1 : minUnique);
    }
}
