import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        
        Map<Integer, Integer> frequency = new HashMap<>();
        
        for (int i = 0; i < n; i++) {
            int num = scanner.nextInt();
            frequency.put(num, frequency.getOrDefault(num, 0) + 1);
        }

        int result = -1;
        for (Map.Entry<Integer, Integer> entry : frequency.entrySet()) {
            if (entry.getValue() == 1) {
                if (result == -1 || entry.getKey() < result) {
                    result = entry.getKey();
                }
            }
        }

        System.out.println(result);
    }
}
