import java.util.Scanner;

public class Main {
  public static void main(String[] args) {
    Scanner scanner = new Scanner(System.in);
    
    long n = scanner.nextLong();
    long a = scanner.nextLong();
    long b = scanner.nextLong();
    
    long result = countDivisible(n, a) + countDivisible(n, b) - countDivisible(n, lcm(a, b));
    
    System.out.println(result);
  }
  
  private static long countDivisible(long n, long d) {
    return n / d;
  }
  
  private static long lcm(long a, long b) {
    return a / gcd(a, b) * b;
  }
  
  private static long gcd(long a, long b) {
    while (b != 0) {
      long temp = b;
      b = a % b;
      a = temp;
    }
    return a;
  }
}
