import java.util.*;

public class Main {
  
  static class Point {
    int x, y, index;
    
    Point(int x, int y, int index) {
      this.x = x;
      this.y = y;
      this.index = index;
    }
  }
  
  public static void main(String[] args) {
    Scanner scanner = new Scanner(System.in);
    int t = scanner.nextInt(); 
    
    while (t-- > 0) {
      int N = scanner.nextInt(); 
      
      List<Point> bluePoints = new ArrayList<>();
      List<Point> redPoints = new ArrayList<>();
      
      for (int i = 0; i < N; i++) {
        int x = scanner.nextInt();
        int y = scanner.nextInt();
        bluePoints.add(new Point(x, y, i + 1));
      }
      
      for (int i = 0; i < N; i++) {
        int x = scanner.nextInt();
        int y = scanner.nextInt();
        redPoints.add(new Point(x, y, i + 1));
      }
      
      bluePoints.sort(Comparator.comparingInt((Point p) -> p.x).thenComparingInt(p -> p.y));
      redPoints.sort(Comparator.comparingInt((Point p) -> p.x).thenComparingInt(p -> p.y));
      
      for (int i = 0; i < N; i++) {
        System.out.println(bluePoints.get(i).index + " " + redPoints.get(i).index);
      }
    }
    
    scanner.close();
  }
}
