def min_time_to_meet(N):
    # Початкові позиції
    alice_positions = [1]  # Поточні позиції Аліси
    bob_positions = [N]    # Поточні позиції Боба
    
    # Лічильник часу
    time = 0
    
    # Ітерація
    while alice_positions and bob_positions:
        # Перевірка на перетин шляхів
        for alice in alice_positions:
            if alice in bob_positions:
                return time
        
        # Оновлення позицій
        time += 1
        new_alice_positions = []
        new_bob_positions = []
        
        for pos in alice_positions:
            if pos + 2 <= N:
                new_alice_positions.append(pos + 2)
            if pos + 3 <= N:
                new_alice_positions.append(pos + 3)
        
        for pos in bob_positions:
            if pos - 1 >= 1:
                new_bob_positions.append(pos - 1)
            if pos - 2 >= 1:
                new_bob_positions.append(pos - 2)
        
        # Унікальні значення для нових позицій
        alice_positions = list(set(new_alice_positions))
        bob_positions = list(set(new_bob_positions))
    
    return -1  # Якщо зустріч неможлива

# Читання вхідного числа
N = int(input())
print(min_time_to_meet(N))
