#include <iostream>
using namespace std;

int min_time_to_meet(int N) {
    // Початкові позиції
    int alice = 1;
    int bob = N;
    int time = 0;

    while (alice <= N && bob >= 1) {
        // Перевірка на зустріч
        if (alice == bob) {
            return time;
        }

        // Оновлення позицій
        time++;
        // Аліса може перейти на +2 або +3
        if ((bob - alice) % 2 == 0) {
            alice += 2;
        } else {
            alice += 3;
        }
        // Боб може перейти на -1 або -2
        if ((bob - alice) % 2 != 0) {
            bob -= 1;
        } else {
            bob -= 2;
        }
    }

    return -1; // Якщо зустріч неможлива
}

int main() {
    int N;
    cin >> N;
    cout << min_time_to_meet(N) << endl;
    return 0;
}
