#include <iostream>
#include <unordered_set>
using namespace std;

int min_time_to_meet(int N) {
    // Початкові позиції
    unordered_set<int> alice_positions = {1};
    unordered_set<int> bob_positions = {N};
    
    // Лічильник часу
    int time = 0;
    
    // Ітерація
    while (!alice_positions.empty() && !bob_positions.empty()) {
        // Перевірка на перетин множин
        for (int pos : alice_positions) {
            if (bob_positions.count(pos)) {
                return time;
            }
        }
        
        // Оновлення позицій
        time++;
        unordered_set<int> new_alice_positions;
        unordered_set<int> new_bob_positions;
        
        for (int pos : alice_positions) {
            if (pos + 2 <= N) {
                new_alice_positions.insert(pos + 2);
            }
            if (pos + 3 <= N) {
                new_alice_positions.insert(pos + 3);
            }
        }
        
        for (int pos : bob_positions) {
            if (pos - 1 >= 1) {
                new_bob_positions.insert(pos - 1);
            }
            if (pos - 2 >= 1) {
                new_bob_positions.insert(pos - 2);
            }
        }
        
        alice_positions = move(new_alice_positions);
        bob_positions = move(new_bob_positions);
    }
    
    return -1;  // Якщо не знайдено
}

int main() {
    int N;
    cin >> N;
    cout << min_time_to_meet(N) << endl;
    return 0;
}