N = int(input())

# Перевіряємо всі можливі стани для Аліси та Боба
for t in range(1, N):
    # Перевіряємо, чи може Аліса в t секундах опинитися в боксі
    alice_positions = {1 + 2 * i for i in range(t + 1)} | {1 + 3 * i for i in range(t + 1)}
    
    # Перевіряємо, чи може Боб в t секундах опинитися в боксі
    bob_positions = {N - i for i in range(t + 1)} | {N - 2 * i for i in range(t + 1)}
    
    # Перевіряємо, чи є спільна позиція для Аліси і Боба
    if alice_positions & bob_positions:
        print(t)
        break
else:
    # Якщо не знайдено жодної спільної позиції
    print(-1)