def min_teleport_time(N):
    # Якщо N == 2, то Аліса і Боб одразу можуть зустрітися в боксі 2
    if N == 2:
        return 1

    # Початкові позиції
    alice_pos = 1
    bob_pos = N
    time = 0

    # Перевіряємо можливість досягти однакової клітинки
    while alice_pos <= bob_pos:
        time += 1
        # Аліса рухається на 2 або 3 клітинки вперед
        alice_pos += 2 if time % 2 == 1 else 3
        # Боб рухається на 1 або 2 клітинки назад
        bob_pos -= 1 if time % 2 == 1 else 2

        if alice_pos == bob_pos:
            return time
        
    return -1

# Читання вхідних даних
N = int(input())

# Виведення результату
print(min_teleport_time(N))