from collections import Counter

# Вхідні дані
N = int(input())  # Кількість роботів
numbers = list(map(int, input().split()))  # Числа, згенеровані роботами

# Підраховуємо кількість кожного числа
count = Counter(numbers)

# Знаходимо мінімальне унікальне число
min_unique = float('inf')

for num, cnt in count.items():
    if cnt == 1:
        min_unique = min(min_unique, num)

# Виводимо результат
if min_unique == float('inf'):
    print(-1)
else:
    print(min_unique)