from collections import Counter

_n = int(input())
xs = map(int, input().split())
freqs = Counter(xs)

def non_unique(freqs):
    return all(f >= 2 for f in freqs.values())

def rarest(freqs):
    return min(reversed(freqs.items()), key=lambda x: x[1])[0]

if not non_unique(freqs):
    print(rarest(freqs))
else:
    print(-1)