def count_squares(matrix):
    N = len(matrix)
    dp = [[0] * N for _ in range(N)]
    total_squares = 0
    
    for i in range(N):
        for j in range(N):
            dp[i][j] = 1
            total_squares += 1
    
    for i in range(1, N):
        for j in range(1, N):
            if matrix[i][j] == matrix[i-1][j] == matrix[i][j-1] == matrix[i-1][j-1]:
                dp[i][j] = min(dp[i-1][j], dp[i][j-1], dp[i-1][j-1]) + 1
                total_squares += dp[i][j] - 1
    
    return total_squares

import sys
import math

lines = sys.stdin.read().strip().split('\n')
N = int(lines[0].strip())
matrix = [list(map(int, line.strip().split())) for line in lines[1:N+1]]

print(math.ceil(count_squares(matrix)/16))