#include <bits/stdc++.h>
using namespace std;

int main() {
    long long N, M;
    cin >> N >> M;

    vector<long long> dp(M + 1, LLONG_MAX); 
    vector<long long> prev(M + 1, -1);

    dp[0] = 0;

    for (long long i = 1; i <= N; ++i) {
        for (long long j = M; j >= i; --j) {
            if (dp[j - i] != LLONG_MAX && dp[j - i] + 1 < dp[j]) {
                dp[j] = dp[j - i] + 1;
                prev[j] = i;
            }
        }
    }

    if (dp[M] == LLONG_MAX) {
        cout << 0 << endl;
        return 0;
    }

    vector<long long> result;
    long long sum = M;
    while (sum > 0) {
        result.push_back(prev[sum]);
        sum -= prev[sum];
    }

    sort(result.begin(), result.end());

    for (long long i = 0; i < result.size(); ++i) {
        cout << result[i] << " ";
    }
    cout << endl;

    return 0;
}