import math

n = int(input())
grid = []
for i in range(n):
    grid.append(list(map(int, input().split())))

count = 2

for x1 in range(n):
    for y1 in range(n):
        for x2 in range(x1 + 1, n):
            for y2 in range(y1 + 1, n):
                x3, y3 = x1 + (y2 - y1), y1 - (x2 - x1)
                x4, y4 = x2 + (y2 - y1), y2 - (x2 - x1)

                if 0 <= x3 < n and 0 <= y3 < n and 0 <= x4 < n and 0 <= y4 < n:
                    color = grid[x1][y1]
                    if (grid[x2][y2] == color and 
                        grid[x3][y3] == color and 
                        grid[x4][y4] == color):
                        
                        dist1 = math.sqrt((x2 - x1) ** 2 + (y2 - y1) ** 2)
                        dist2 = math.sqrt((x3 - x1) ** 2 + (y3 - y1) ** 2)
                        dist3 = math.sqrt((x4 - x2) ** 2 + (y4 - y2) ** 2)
                        dist4 = math.sqrt((x3 - x4) ** 2 + (y3 - y4) ** 2)
                        
                        if (dist1 == dist2 == dist3 == dist4):
                            v1x, v1y = x2 - x1, y2 - y1
                            v2x, v2y = x3 - x1, y3 - y1
                            v3x, v3y = x4 - x2, y4 - y2
                            v4x, v4y = x3 - x4, y3 - y4

                            dot_product_diag1_diag2 = v1x * v2x + v1y * v2y
                            dot_product_diag3_diag4 = v3x * v4x + v3y * v4y
                            
                            if dot_product_diag1_diag2 == 0 and dot_product_diag3_diag4 == 0:
                                count += 1

print(count-2)