#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>

using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int length;
    cin >> length;

    map<int, int> numbers{};

    for (int i = 0; i < length; i++) {
        int number;
        cin >> number;

        numbers[number] += 1;
    }

    for (auto [number, count] : numbers) {
        if (count == 1) {
            cout << number << "\n";
            return 0;
        }
    }

    cout << "-1\n";

    return 0;
}
