def find_stamps(N, M):
    dp = [float('inf')] * (M + 1)
    dp[0] = 0

    for i in range(1, N + 1):
        for j in range(M, i - 1, -1):
            if dp[j - i] + 1 < dp[j]:
                dp[j] = dp[j - i] + 1

    if dp[M] == float('inf'):
        print(0)
        return

    result = []
    remaining_sum = M
    for i in range(N, 0, -1):
        if remaining_sum >= i and dp[remaining_sum] == dp[remaining_sum - i] + 1:
            result.append(i)
            remaining_sum -= i

    print(*result)

N = int(input())
M = int(input())

find_stamps(N, M)
