def find_elements_sum(M, n):
    dp = [float('inf')] * (M + 1)
    dp[0] = 0
    elements = [-1] * (M + 1)
    
    for num in range(1, n + 1):
        for i in range(M, num - 1, -1):
            if dp[i - num] + 1 < dp[i]:
                dp[i] = dp[i - num] + 1
                elements[i] = num
    
    if dp[M] == float('inf'):
        return []
    
    result = []
    while M > 0:
        result.append(elements[M])
        M -= elements[M]
    
    return result

N = int(input())
M = int(input())
result = find_elements_sum(M, N)
print(result)
