def find_stamps(N, M):
    dp = [float('inf')] * (M + 1)
    dp[0] = 0
    prev = [-1] * (M + 1)

    # Динамічне програмування для знаходження мінімальної кількості марок
    for i in range(1, N + 1):
        for j in range(M, i - 1, -1):
            if dp[j - i] + 1 < dp[j]:
                dp[j] = dp[j - i] + 1
                prev[j] = i

    if dp[M] == float('inf'):
        return [0]
    
    # Відновлення вибраних марок
    result = []
    while M > 0:
        result.append(prev[M])
        M -= prev[M]
    
    return result

# Вхідні дані
N = int(input())
M = int(input())

# Виклик функції та виведення результату
result = find_stamps(N, M)
print(" ".join(map(str, result)))
