def count_squares(N, grid):
    count = 0
    for i in range(N):
        for j in range(N):
            for k in range(i+1, N):
                for l in range(j+1, N):
                    if abs(i - k) == abs(j - l):
                        color = grid[i][j]
                        if (grid[k][l] == color and 
                            grid[i][l] == color and 
                            grid[k][j] == color):
                            count += 1
    return count

def main():
    N = int(input())
    grid = [list(map(int, input().split())) for _ in range(N)]
    print(count_squares(N, grid))

if __name__ == "__main__":
    main()
