#include <bits/stdc++.h>
using namespace std;

int t, n;
array <array <short, 2>, 2510> red;
array <array <short, 3>, 2510> blue;
array <array <short, 4>, 2510> pairs;

array <short, 2510> ans;

bool intersect(short x1, short y1, short x2, short y2, short x3, short y3, short x4, short y4) {
    if (x1 == x2 || x3 == x4) {
        swap(x1, y1);
        swap(x2, y2);
        swap(x3, y3);
        swap(x4, y4);
    }

    if (x1 == x2 || x3 == x4) {
        if (x1 != x2) {
            swap(x1, x3);
            swap(y1, y3);
            swap(x2, x4);
            swap(y2, y4);
        }

        if (min(x3, x4) <= x1 && x1 <= max(x3, x4)) {
            if (min(y1, y2) <= y3 && y3 <= max(y1, y2)) return true;
            else return false;
        } else return false;
    }

    double a1 = (y1 - y2) / (x1 - x2);
    double a2 = (y3 - y4) / (x3 - x4);

    double b1 = y1 - a1 * x1;
    double b2 = y3 - a2 * x3;

    double x = (b2 - b1) / (a1 - a2);
    double y = a1 * x + b1;

    if (min(x1, x2) <= x && x <= max(x1, x2) && min(y1, y2) <= y && y <= max(y1, y2)) return true;
    if (min(x3, x4) <= x && x <= max(x3, x4) && min(y3, y4) <= y && y <= max(y3, y4)) return true;
    return false;
}

bool f(short red_idx, array <array <short, 3>, 2510> blue, array <array <short, 4>, 2510> pairs) {
    if (red_idx == n) return true;
    for (int i = 0; i < n; i++) {
        if (blue[i][2] == 0) {
            blue[i][2] = 1;

            for (int p = 0; p < red_idx; p++) {
                if (!intersect(red[red_idx][0], red[red_idx][1], blue[i][0], blue[i][1], pairs[p][0], pairs[p][1], pairs[p][2], pairs[p][3])) {
                    pairs[red_idx][0] = red[red_idx][0];
                    pairs[red_idx][1] = red[red_idx][1];
                    pairs[red_idx][2] = blue[i][0];
                    pairs[red_idx][3] = blue[i][1];

                    ans[red_idx] = i;

                    if (f(red_idx + 1, blue, pairs)) return true;
                }
            }
            if (red_idx == 0) {
                pairs[red_idx][0] = red[red_idx][0];
                pairs[red_idx][1] = red[red_idx][1];
                pairs[red_idx][2] = blue[i][0];
                pairs[red_idx][3] = blue[i][1];

                if (f(red_idx + 1, blue, pairs)) return true;
            }
            
            blue[i][2] = 0;
        }
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int x, y;
    map <int, bool> corrected;

    cin >> t;

    while (t--) {
        cin >> n;
        pair <int, int> input[n];

        for (int i = 0; i < n; i++) {
            cin >> input[i].first >> input[i].second;

            pairs[i][0] = 0;
            pairs[i][1] = 0;
            pairs[i][2] = 0;
            pairs[i][3] = 0;
        }

        sort(input, input + n);

        for (int i = 0; i < n; i++) {
            red[i][0] = input[i].first;
            red[i][1] = input[i].second;
        }
        
        for (int i = 0; i < n; i++) {
            cin >> input[i].first >> input[i].second;
        }
        
        sort(input, input + n);

        for (int i = 0; i < n; i++) {
            corrected[i + 1] = false;
            blue[i][0] = input[i].first;
            blue[i][1] = input[i].second;
            blue[i][2] = 0;
        }

        if (f(0, blue, pairs)) {
            for (int i = 0; i < n; i++) {
                while (corrected[ans[i] + 1]) ans[i]++;
                corrected[ans[i] + 1] = true;
                cout << i + 1 << " " << ans[i] + 1 << "\n";
            }
        } else cout << 0 << "\n";
    }
    
    return 0;
}
