def minimum_time_to_meet(N):
    # Починаємо з часу t = 1 і перевіряємо по черзі
    t = 0
    while t < N:  # Максимальна кількість секунд обмежена
        t += 1
        # Перебираємо всі можливі a і b (для Аліси)
        for a in range(t + 1):  # a + b = t, отже b = t - a
            b = t - a
            alice_position = 1 + 2 * a + 3 * b
            
            # Перебираємо всі можливі c і d (для Боба)
            for c in range(t + 1):  # c + d = t, отже d = t - c
                d = t - c
                bob_position = N - c - 2 * d
                
                # Перевіряємо, чи збігаються позиції
                if alice_position == bob_position:
                    return t
    
    # Якщо після перебору всіх можливих варіантів зустрічі немає
    return -1

# Зчитування вхідних даних
N = int(input())
print(minimum_time_to_meet(N))
