def find_min_meeting_time(N):
    alice_positions = {1}  # Початкова позиція Аліси
    bob_positions = {N}    # Початкова позиція Боба
    
    for t in range(1, N + 1):  # Максимальна кількість кроків — це N (у гіршому випадку)
        # Генеруємо нові позиції
        new_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= N:
                new_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                new_alice_positions.add(pos + 3)
        
        new_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                new_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_positions.add(pos - 2)
        
        # Перевіряємо, чи є перетин множин
        if new_alice_positions & new_bob_positions:
            return t  # Зустріч можлива, повертаємо мінімальний час
        
        # Оновлюємо позиції
        alice_positions = new_alice_positions
        bob_positions = new_bob_positions
    
    return -1  # Якщо після усіх ітерацій зустріч неможлива

# Зчитування вхідних даних
N = int(input())
print(find_min_meeting_time(N))
