def find_stamps(N, M):
    # Список для збереження вибраних марок
    selected_stamps = []
    
    # Починаємо з найвищої марки, що не перевищує M
    for i in range(N, 0, -1):
        # Якщо поточна марка може бути використана для досягнення M
        if M >= i:
            selected_stamps.append(i)  # Додаємо марку
            M -= i  # Зменшуємо M на вартість цієї марки
        
        # Якщо сума M дорівнює нулю, значить ми знайшли рішення
        if M == 0:
            return selected_stamps
    
    # Якщо ми не змогли досягти точної суми M
    return [0]

# Вхідні дані
N = int(input())  # Кількість марок
M = int(input())  # Загальна вартість марок

# Отримуємо результат
result = find_stamps(N, M)

# Виводимо результат
print(" ".join(map(str, result)))

