def find_stamps(N, M):
    # Починаємо з найбільших можливих марок і намагаємось зібрати точну суму M
    selected_stamps = []
    
    # Проходимо по маркам від найбільшої до найменшої
    for i in range(N, 0, -1):
        if M >= i:
            selected_stamps.append(i)  # Додаємо марку
            M -= i  # Зменшуємо M на вартість цієї марки
        
        if M == 0:
            break  # Якщо сума M дорівнює нулю, виходимо з циклу
    
    # Якщо після всіх операцій M не стало 0, значить розв'язку не існує
    if M == 0:
        return selected_stamps
    else:
        return [0]

# Вхідні дані
N = int(input())  # Кількість марок
M = int(input())  # Загальна вартість марок

# Отримуємо результат
result = find_stamps(N, M)

# Виводимо результат
print(" ".join(map(str, result)))
