def find_minimal_stamps(N, M):
    # Створимо список марок від 1 до N
    stamps = list(range(1, N + 1))
    
    # Підбираємо марки, починаючи з найменших
    selected_stamps = []
    current_sum = 0
    
    for stamp in stamps:
        if current_sum + stamp <= M:
            selected_stamps.append(stamp)
            current_sum += stamp
    
    # Якщо сума не дорівнює M, повертаємо 0
    if current_sum == M:
        return selected_stamps
    else:
        return [0]

# Вхідні дані
N = int(input())  # Кількість марок
M = int(input())  # Загальна вартість марок

# Отримуємо результат
result = find_minimal_stamps(N, M)

# Виводимо результат
print(" ".join(map(str, result)))
