def find_minimal_stamps(N, M):
    # Спочатку вибираємо найбільші марки
    result = []
    for i in range(N, 0, -1):  # йдемо від N до 1
        if M >= i:
            result.append(i)  # додаємо марку
            M -= i  # зменшуємо залишок

    # Якщо сума марок дорівнює M, то ми успішно підібрали марки
    if M == 0:
        return result[::-1]  # Повертаємо марки в порядку зростання
    else:
        return [0]  # Якщо не вийшло досягнути точної суми M

# Вхідні дані
N = int(input())  # Кількість марок
M = int(input())  # Загальна вартість марок

# Отримуємо результат
result = find_minimal_stamps(N, M)

# Виводимо результат
print(" ".join(map(str, result)))
