def find_minimal_stamps(N, M):
    result = []
    current_sum = 0
    
    # Ідемо по марках від найбільших до найменших, щоб мінімізувати кількість марок
    for i in range(N, 0, -1):
        if current_sum + i <= M:
            result.append(i)
            current_sum += i
        
        if current_sum == M:
            break
    
    # Якщо сума M не досягнута
    if current_sum != M:
        return [0]
    
    return sorted(result)  # Сортуємо результат за зростанням

# Вхідні дані
N = int(input())  # Кількість марок
M = int(input())  # Загальна вартість марок

# Отримуємо результат
result = find_minimal_stamps(N, M)

# Виводимо результат
print(" ".join(map(str, result)))
