# Вхідні дані
N = int(input())  # Кількість марок
M = int(input())  # Загальна вартість марок

# Сума всіх марок від 1 до N
total_sum = N * (N + 1) // 2

# Якщо сума всіх марок менша за M, вивести 0
if total_sum < M:
    print(0)
else:
    # Рішення будемо знаходити за допомогою жадібного підходу
    chosen_marks = []
    current_sum = 0
    
    # Перевіряємо від найбільших марок до найменших
    for i in range(N, 0, -1):
        if current_sum + i <= M:
            chosen_marks.append(i)
            current_sum += i
        if current_sum == M:
            break
    
    # Якщо вийшло набрати точну суму
    if current_sum == M:
        for mark in chosen_marks:
            print(mark)
    else:
        print(0)
