# Вхідні дані
N = int(input())  # Кількість марок
M = int(input())  # Необхідна сума

# Загальна сума всіх марок від 1 до N
total_sum = N * (N + 1) // 2

# Якщо загальна сума марок менша за M, то відповісти 0
if total_sum < M:
    print(0)
else:
    # Список для вибраних марок
    selected_marks = []
    remaining_sum = M
    
    # Проходимо через марки від найбільшої до найменшої
    for i in range(N, 0, -1):
        if remaining_sum >= i:
            selected_marks.append(i)
            remaining_sum -= i
            
        # Якщо залишкова сума 0, то ми вже знайшли правильний набір марок
        if remaining_sum == 0:
            break
    
    # Якщо залишкова сума не дорівнює нулю, значить таку суму не можна отримати
    if remaining_sum != 0:
        print(0)
    else:
        # Виводимо вибрані марки
        for mark in selected_marks:
            print(mark)
