def count_same_color_squares(N: int, grid: list[list[int]]) -> int:
    count = 0
    # Перебираємо всі можливі квадрати
    for i in range(N):  # Рядки
        for j in range(N):  # Стовпці
            # Розмір сторони квадрата
            for size in range(1, N - max(i, j) + 1):  # Від квадрата 1x1 до найбільшого
                # Отримуємо вершини квадрата
                top_left = grid[i][j]
                top_right = grid[i][j + size - 1]
                bottom_left = grid[i + size - 1][j]
                bottom_right = grid[i + size - 1][j + size - 1]
                # Перевірка, чи всі вершини одного кольору
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1
    return count


# Читання вхідних даних
N = int(input("Введіть розмір квадрата (N): "))
print("Введіть матрицю кольорів (рядки через Enter):")
grid = [list(map(int, input().split())) for _ in range(N)]

# Обчислення та вивід результату
result = count_same_color_squares(N, grid)
print("Кількість квадратів одного кольору:", result)
