def count_same_color_squares(N: int, grid: list[list[int]]) -> int:
    count = 0

    # Перебираємо всі можливі квадрати
    for size in range(1, N + 1):  # Розмір квадрата: 1x1, 2x2, ..., NxN
        for i in range(N - size + 1):  # Верхній лівий кут: рядки
            for j in range(N - size + 1):  # Верхній лівий кут: стовпці
                # Отримуємо кольори вершин квадрата
                top_left = grid[i][j]
                top_right = grid[i][j + size - 1]
                bottom_left = grid[i + size - 1][j]
                bottom_right = grid[i + size - 1][j + size - 1]
                # Перевіряємо, чи всі вершини одного кольору
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1

    return count


# Читання вхідних даних
N = int(input("Введіть розмір квадрата (N): "))
print("Введіть матрицю кольорів (рядки через Enter):")
grid = [list(map(int, input().split())) for _ in range(N)]

# Обчислення та вивід результату
result = count_same_color_squares(N, grid)
print("Кількість квадратів одного кольору:", result)
