def solve_eva_problem():
    t = int(input("Введіть кількість тестів: "))
    results = []
    
    for _ in range(t):
        N = int(input())
        
        # Зчитуємо координати синіх точок
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        
        # Зчитуємо координати червоних точок
        red_points = [tuple(map(int, input().split())) for _ in range(N)]
        
        # Відсортуємо точки для простого з'єднання без перетинів
        blue_sorted = sorted(enumerate(blue_points, start=1), key=lambda x: (x[1][0], x[1][1]))
        red_sorted = sorted(enumerate(red_points, start=1), key=lambda x: (x[1][0], x[1][1]))
        
        # Створюємо пари між точками
        pairs = [(blue_sorted[i][0], red_sorted[i][0]) for i in range(N)]
        results.append(pairs)
    
    # Виводимо результати
    for result in results:
        for pair in result:
            print(pair[0], pair[1])

# Запуск функції
solve_eva_problem()

