def solve_eva_problem():
    import sys
    input = sys.stdin.read
    data = input().splitlines()
    
    t = int(data[0])  # кількість тестів
    index = 1
    results = []
    
    for _ in range(t):
        N = int(data[index])  # кількість точок одного кольору
        index += 1
        
        blue_points = []
        red_points = []
        
        # Зчитуємо сині точки
        for i in range(N):
            x, y = map(int, data[index].split())
            blue_points.append((x, y, i + 1))  # координати + індекс
            index += 1
        
        # Зчитуємо червоні точки
        for i in range(N):
            x, y = map(int, data[index].split())
            red_points.append((x, y, i + 1))  # координати + індекс
            index += 1
        
        # Сортуємо точки за координатою x (і за y для стабільності)
        blue_points.sort(key=lambda p: (p[0], p[1]))
        red_points.sort(key=lambda p: (p[0], p[1]))
        
        # Формуємо пари
        pairs = []
        for i in range(N):
            blue_index = blue_points[i][2]
            red_index = red_points[i][2]
            pairs.append((blue_index, red_index))
        
        results.append(pairs)
    
    # Виводимо результати
    output = []
    for result in results:
        for pair in result:
            output.append(f"{pair[0]} {pair[1]}")
    print("\n".join(output))


# Виклик функції
solve_eva_problem()
