def solve_eva_problem():
    t = int(input())  # кількість тестів
    for _ in range(t):
        N = int(input())  # кількість точок одного кольору
        blue_points = []
        red_points = []
        
        # Зчитуємо сині точки
        for i in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y, i + 1))  # координати + індекс
        
        # Зчитуємо червоні точки
        for i in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y, i + 1))  # координати + індекс
        
        # Сортуємо точки за координатами x, а при рівних x - за y
        blue_points.sort(key=lambda p: (p[0], p[1]))
        red_points.sort(key=lambda p: (p[0], p[1]))
        
        # Перевірка на можливість побудови з'єднань
        result = []
        for i in range(N):
            blue_index = blue_points[i][2]
            red_index = red_points[i][2]
            result.append((blue_index, red_index))
        
        # Виведення результату
        if result:
            for blue_index, red_index in result:
                print(f"{blue_index} {red_index}")
        else:
            print(0)

# Виклик функції
solve_eva_problem()

