def solve_case(N, blue_points, red_points):
    # Сортуємо обидва набори точок за x і за y
    blue_points_sorted = sorted(blue_points)
    red_points_sorted = sorted(red_points)
    
    # Після сортування з'єднуємо пари за порядком
    result = []
    for i in range(N):
        # Збираємо індекси пар точок (синя та червона)
        result.append(f"{blue_points_sorted[i][2]} {red_points_sorted[i][2]}")
    
    return result

def main():
    t = int(input())  # Кількість блоків тестових даних
    for _ in range(t):
        N = int(input())  # Кількість точок одного кольору
        blue_points = [tuple(map(int, input().split())) + (i + 1,) for i in range(N)]
        red_points = [tuple(map(int, input().split())) + (i + 1,) for i in range(N)]
        
        # Розв'язок для кожного тесту
        result = solve_case(N, blue_points, red_points)
        
        # Виведення результату
        if result:
            print("\n".join(result))
        else:
            print(0)

# Викликаємо основну функцію
if __name__ == "__main__":
    main()
