def func(N):
    if N == 2:
        return -1
    
    alice_pos = 1
    bob_pos = N
    
    alice_visited = {alice_pos}
    bob_visited = {bob_pos}
    
    alice_queue = [(alice_pos, 0)]
    bob_queue = [(bob_pos, 0)]
    
    while alice_queue and bob_queue:
        alice_current, alice_time = alice_queue.pop(0)
        for next_pos in [alice_current + 2, alice_current + 3]:
            if next_pos in bob_visited:
                return alice_time + 1
            if next_pos <= N and next_pos not in alice_visited:
                alice_queue.append((next_pos, alice_time + 1))
                alice_visited.add(next_pos)

        bob_current, bob_time = bob_queue.pop(0)
        for next_pos in [bob_current - 1, bob_current - 2]:
            if next_pos in alice_visited:
                return bob_time + 1
            if next_pos >= 1 and next_pos not in bob_visited:
                bob_queue.append((next_pos, bob_time + 1))
                bob_visited.add(next_pos)
    
    return -1

print(func(int(input())))


