#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
using namespace std;

int main() {
    long long n, m;
    cin >> n >> m;
    vector<long long> a(m + 1, LLONG_MAX); 
    vector<long long> b(m + 1, -1);       
    a[0] = 0;                             

    for (long long i = 1; i <= n; ++i) {
        for (long long j = m; j >= i; --j) {
            if (a[j - i] != LLONG_MAX && a[j - i] + 1 < a[j]) {
                a[j] = a[j - i] + 1;
                b[j] = i;
            }
        }
    }

    if (a[m] == LLONG_MAX) {
        cout << 0 << endl;
    } else {
        vector<long long> r;
        long long k = m;
        while (k > 0) {
            r.push_back(b[k]);
            k -= b[k];
        }
        sort(r.begin(), r.end());
        for (size_t i = 0; i < r.size(); ++i) {
            cout << r[i] << endl;
        }
    }

    return 0;
}
