def find_president(N, numbers):
    # Підрахуємо кількість кожного числа
    count = {}
    for num in numbers:
        count[num] = count.get(num, 0) + 1
    
    # Знайдемо всі унікальні числа (які зустрічаються рівно один раз)
    unique_numbers = [num for num in count if count[num] == 1]
    
    # Якщо немає унікальних чисел, вибори не відбулися
    if not unique_numbers:
        return -1
    
    # Знайдемо мінімальне серед унікальних чисел
    return min(unique_numbers)

# Вхідні дані
N = int(input())
numbers = list(map(int, input().split()))

# Результат
print(find_president(N, numbers))
