from collections import deque
def find_meeting_time(N):
    alice_queue = deque([(1, 0)])
    bob_queue = deque([(N, 0)])
    alice_visited = {1}
    bob_visited = {N}
    meetings = {}
    while alice_queue and bob_queue:
        alice_pos, alice_time = alice_queue.popleft()
        alice_moves = [alice_pos + 2, alice_pos + 3]
        for new_pos in alice_moves:
            if 1 <= new_pos <= N and new_pos not in alice_visited:
                alice_visited.add(new_pos)
                alice_queue.append((new_pos, alice_time + 1))
                if new_pos in bob_visited:
                    for bob_pos, bob_time in bob_queue:
                        if bob_pos == new_pos:
                            meetings[new_pos] = max(alice_time + 1, bob_time)
        bob_pos, bob_time = bob_queue.popleft()
        bob_moves = [bob_pos - 1, bob_pos - 2]
        for new_pos in bob_moves:
            if 1 <= new_pos <= N and new_pos not in bob_visited:
                bob_visited.add(new_pos)
                bob_queue.append((new_pos, bob_time + 1))
                if new_pos in alice_visited:
                    for alice_pos, alice_time in alice_queue:
                        if alice_pos == new_pos:
                            meetings[new_pos] = max(alice_time, bob_time + 1)
        if meetings:
            return min(meetings.values())
    return -1
N = int(input())
print(find_meeting_time(N))