def count_color_squares(N, grid):
    count = 0
    for i in range(N):
        for j in range(N):
            for size in range(1, min(N - i, N - j)):
                x1, y1 = i, j
                x2, y2 = i + size, j
                x3, y3 = i, j + size
                x4, y4 = i + size, j + size
                if grid[x1][y1] == grid[x2][y2] == grid[x3][y3] == grid[x4][y4]:
                    count += 1
    return count
N = int(input()) 
grid = [list(map(int, input().split())) for _ in range(N)]
print(count_color_squares(N, grid))
