def solve(t, test_cases):
    results = []
    for case in test_cases:
        n, blue_points, red_points = case

        
        blue_points = [(x, y, i + 1) for i, (x, y) in enumerate(blue_points)]
        red_points = [(x, y, i + 1) for i, (x, y) in enumerate(red_points)]

        
        blue_points.sort()
        red_points.sort()

        
        matching = []
        for b, r in zip(blue_points, red_points):
            matching.append((b[2], r[2]))

        results.append(matching)
    return results



t = int(input())
test_cases = []
for _ in range(t):
    n = int(input())
    blue_points = [tuple(map(int, input().split())) for _ in range(n)]
    red_points = [tuple(map(int, input().split())) for _ in range(n)]
    test_cases.append((n, blue_points, red_points))


results = solve(t, test_cases)


for res in results:
    for b, r in res:
        print(b, r)

