from collections import deque

def min_time_to_meet(N):
    alice_queue = deque([1])
    bob_queue = deque([N]) 
    
    alice_visited = set([1])
    bob_visited = set([N])
    
    time = 0
    
    while alice_queue and bob_queue:
        time += 1
        
        for _ in range(len(alice_queue)):
            current_alice = alice_queue.popleft()
            for move in [2, 3]:
                next_alice = current_alice + move
                if next_alice <= N and next_alice not in alice_visited:
                    alice_visited.add(next_alice)
                    alice_queue.append(next_alice)
                    if next_alice in bob_visited:
                        return time
        
        for _ in range(len(bob_queue)):
            current_bob = bob_queue.popleft()
            for move in [1, 2]:
                next_bob = current_bob - move
                if next_bob >= 1 and next_bob not in bob_visited:
                    bob_visited.add(next_bob)
                    bob_queue.append(next_bob)
                    if next_bob in alice_visited:
                        return time
    
    return -1


N = int(input())
print(min_time_to_meet(N))
