from collections import Counter

def vote(N, numbers):
    counts = Counter(numbers)
    
    min_value = float('inf')
    for num, count in counts.items():
        if count == 1:
            min_value = min(min_value, num)
    
    return min_value if min_value != float('inf') else -1

N = int(input())
numbers = list(map(int, input().split())) 

print(vote(N, numbers))