def minimum_seconds_to_meet(n):
    if n < 2:
        return -1
    alice_positions = {1}
    bob_positions = {n}

    seconds = 0

    while alice_positions and bob_positions:
        seconds += 1

        new_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= n:
                new_alice_positions.add(pos + 2)
            if pos + 3 <= n:
                new_alice_positions.add(pos + 3)

        new_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                new_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_positions.add(pos - 2)

        if new_alice_positions & new_bob_positions:
            return seconds

        alice_positions = new_alice_positions
        bob_positions = new_bob_positions

    return -1

n = int(input())
print(minimum_seconds_to_meet(n))