def find_stamps(N, M):
    max_sum = N * (N + 1) // 2
    if M > max_sum:
        return [0]

    result = []
    current = N

    while M > 0:
        if M >= current:
            result.append(current)
            M -= current
        current -= 1

    if M > 0:
        return [0]

    return sorted(result)

N = int(input())
M = int(input())

result = find_stamps(N, M)

if result == [0]:
    print(0)
else:
    print(*result)