from collections import deque

n = int(input())

alice_queue = deque([1])
bob_queue = deque([n])
alice_visited = set([1])
bob_visited = set([n])
seconds = 0

while alice_queue and bob_queue:
    seconds += 1

    for _ in range(len(alice_queue)):
        pos = alice_queue.popleft()
        for step in (2, 3):
            new_pos = pos + step
            if new_pos > n:
                continue
            if new_pos in bob_visited: 
                print(seconds)
                exit()
            if new_pos not in alice_visited:
                alice_visited.add(new_pos)
                alice_queue.append(new_pos)

    for _ in range(len(bob_queue)):
        pos = bob_queue.popleft()
        for step in (1, 2):
            new_pos = pos - step
            if new_pos < 1:
                continue
            if new_pos in alice_visited:
                print(seconds)
                exit()
            if new_pos not in bob_visited:
                bob_visited.add(new_pos)
                bob_queue.append(new_pos)

print(-1)