from collections import deque

n = int(input())

alice_queue = deque([1])
bob_queue = deque([n])
alice_visited = [False] * (n + 1)
bob_visited = [False] * (n + 1)
alice_visited[1] = True
bob_visited[n] = True
seconds = 0

while alice_queue and bob_queue:
    seconds += 1

    for _ in range(len(alice_queue)):
        pos = alice_queue.popleft()
        for step in (2, 3):
            new_pos = pos + step
            if new_pos > n:
                continue
            if bob_visited[new_pos]: 
                print(seconds)
                exit()
            if not alice_visited[new_pos]:
                alice_visited[new_pos] = True
                alice_queue.append(new_pos)

    for _ in range(len(bob_queue)):
        pos = bob_queue.popleft()
        for step in (1, 2):
            new_pos = pos - step
            if new_pos < 1:
                continue
            if alice_visited[new_pos]: 
                print(seconds)
                exit()
            if not bob_visited[new_pos]:
                bob_visited[new_pos] = True
                bob_queue.append(new_pos)

print(-1)