def count_squares(N, grid):
    count = 0
    for i in range(N):
        for j in range(N):
            for size in range(1, N - max(i, j) + 1):
                if i + size < N and j + size < N:
                    color = grid[i][j]
                    if (grid[i][j] == grid[i + size - 1][j] == grid[i][j + size - 1] == grid[i + size - 1][j + size - 1]):
                        count += 1
    return count

N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

print(count_squares(N, grid))