def count_monochrome_squares(n, grid):
    count = 0
    for size in range(1, n):
        for i in range(n - size):
            for j in range(n - size):
                if (
                    grid[i][j] == grid[i + size][j] == grid[i][j + size] == grid[i + size][j + size]
                ):
                    count += 1
    return count

n = int(input())
grid = [list(map(int, input().split())) for _ in range(n)]
result = count_monochrome_squares(n, grid)
print(result)