def solve():
    t = int(input())
    results = []
    for _ in range(t):
        n = int(input())
        blue_points = []
        red_points = []
        for i in range(n):
            x, y = map(int, input().split())
            blue_points.append((x, y, i + 1))
        for i in range(n):
            x, y = map(int, input().split())
            red_points.append((x, y, i + 1))
        blue_points.sort()
        red_points.sort()
        pairs = []
        for i in range(n):
            pairs.append((blue_points[i][2], red_points[i][2]))
        can_connect = True
        for i in range(n):
            for j in range(i + 1, n):
                b1, r1 = pairs[i]
                b2, r2 = pairs[j]
                if (b1 < b2 and r1 > r2) or (b1 > b2 and r1 < r2):
                    can_connect = False
                    break
            if not can_connect:
                break
        if can_connect:
            results.append(pairs)
        else:
            results.append([0])
    for res in results:
        if res == [0]:
            print(0)
        else:
            for pair in res:
                print(pair[0], pair[1])
solve()
        