def count_squares(grid):
    n = len(grid)
    count = 0

    for size in range(2, n + 1):
        for i in range(n - size + 1):
            for j in range(n - size + 1):
                color = grid[i][j]
                if all(grid[x][y] == color for x in range(i, i + size) for y in range(j, j + size)):
                    count += 1

    return count

n = int(input())
grid = []
for _ in range(n):
    grid.append(list(map(int, input().split())))

result = count_squares(grid)
print(result)