def solve(t, test_cases):
    results = []
    for i in range(t):
        N = test_cases[i][0]
        blue_points = test_cases[i][1]
        red_points = test_cases[i][2]

        sorted_blue = sorted((x, y, idx + 1) for idx, (x, y) in enumerate(blue_points))
        sorted_red = sorted((x, y, idx + 1) for idx, (x, y) in enumerate(red_points))

        result = []
        for b, r in zip(sorted_blue, sorted_red):
            result.append(f"{b[2]} {r[2]}")

        results.append("\n".join(result))
    
    return "\n\n".join(results)

t = int(input())
test_cases = []

for _ in range(t):
    N = int(input())
    blue_points = [tuple(map(int, input().split())) for _ in range(N)]
    red_points = [tuple(map(int, input().split())) for _ in range(N)]
    test_cases.append((N, blue_points, red_points))

print(solve(t, test_cases))
