def find_president(N, numbers):
    # Підрахунок частоти кожного числа
    frequency = {}
    for number in numbers:
        frequency[number] = frequency.get(number, 0) + 1
    
    # Пошук мінімального унікального числа
    unique_min = float('inf')
    for number, count in frequency.items():
        if count == 1 and number < unique_min:
            unique_min = number
    
    # Повернення результату
    return unique_min if unique_min != float('inf') else -1

# Зчитування вхідних даних
N = int(input())
numbers = list(map(int, input().split()))

# Виведення результату
print(find_president(N, numbers))
