def count_squares(N, grid):
    count = 0
    
    for k in range(1, N):  
        for i in range(N - k):  
            for j in range(N - k):  
                
                top_left = grid[i][j]
                top_right = grid[i][j + k]
                bottom_left = grid[i + k][j]
                bottom_right = grid[i + k][j + k]
                
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1
    return count


N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]


print(count_squares(N, grid))
