from collections import deque

def min_seconds_to_meet(N):
    queue = deque([(1, N, 0)])  
    visited = set([(1, N)])
    
    while queue:
        alice, bob, seconds = queue.popleft()
        if alice == bob:
            return seconds
        
        for a in [alice + 2, alice + 3]:
            for b in [bob - 1, bob - 2]:
                if 1 <= a <= N and 1 <= b <= N and (a, b) not in visited:
                    visited.add((a, b))
                    queue.append((a, b, seconds + 1))
    
    return -1

print(min_seconds_to_meet(5))
