#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

// int main() {
//     int N;
//     cin >> N;

//     vector<vector<int>> ar(N + 1, vector<int>(N + 1, -1));
//     ar[1][N] = 0;

//     for(int i = 1; i <= N; ++i)
//     {
//         for(int j = N; j >= i; --j)
//         {
//             if(ar[i][j] != -1)
//             {
//                 if(i + 2 <= j -1)
//                 {
//                     ar[i + 2][j - 1] = min(ar[i + 2][j - 1] == -1 ? INT_MAX : ar[i + 2][j - 1], ar[i][j] + 1);
//                 }
//                 if (i + 3 <= j - 1) 
//                 {
//                     ar[i + 3][j - 1] = min(ar[i + 3][j - 1] == -1 ? INT_MAX : ar[i + 3][j - 1], ar[i][j] + 1);
//                 }
//                 if (i + 2 <= j - 2) 
//                 {
//                     ar[i + 2][j - 2] = min(ar[i + 2][j - 2] == -1 ? INT_MAX : ar[i + 2][j - 2], ar[i][j] + 1);
//                 }
//                 if (i + 3 <= j - 2) 
//                 {
//                     ar[i + 3][j - 2] = min(ar[i + 3][j - 2] == -1 ? INT_MAX : ar[i + 3][j - 2], ar[i][j] + 1);
//                 }
//             }
//         }
//     }

//     int mTime = -1;
//     int meetBox = -1;
//     for(int i = 1; i <= N; ++i)
//     {
//         if(ar[i][i] != -1 && (mTime == -1 || ar[i][i] < mTime))
//         {
//             mTime = ar[i][i];
//             meetBox = i;
//         }
//     }
//     if(mTime != -1)
//     {
//         cout << mTime;
//     }
//     else {return -1;}
// } 

// int main() {
//     int N;
//     cin >> N;

//     vector<vector<int>> ar(N + 1, vector<int>(N + 1, -1));
//     ar[1][N] = 0;

//     for (int i = 1; i <= N; ++i) {
//         for (int j = N; j >= i; --j) {
//             if (ar[i][j] != -1) {
//                 if (i + 2 <= N && j - 1 >= 1) {
//                     ar[i + 2][j - 1] = min(ar[i + 2][j - 1] == -1 ? INT_MAX : ar[i + 2][j - 1], ar[i][j] + 1);
//                 }
//                 if (i + 3 <= N && j - 1 >= 1) {
//                     ar[i + 3][j - 1] = min(ar[i + 3][j - 1] == -1 ? INT_MAX : ar[i + 3][j - 1], ar[i][j] + 1);
//                 }
               
//                 if (i + 2 <= N && j - 2 >= 1) {
//                     ar[i + 2][j - 2] = min(ar[i + 2][j - 2] == -1 ? INT_MAX : ar[i + 2][j - 2], ar[i][j] + 1);
//                 }
//                 if (i + 3 <= N && j - 2 >= 1) {
//                     ar[i + 3][j - 2] = min(ar[i + 3][j - 2] == -1 ? INT_MAX : ar[i + 3][j - 2], ar[i][j] + 1);
//                 }
//             }
//         }
//     }

//     int mTime = -1;
//     for (int i = 1; i <= N; ++i) {
//         if (ar[i][i] != -1) {
//             if (mTime == -1 || ar[i][i] < mTime) {
//                 mTime = ar[i][i];
//             }
//         }
//     }

//     if (mTime != -1) {
//         cout << mTime << endl;
//     }
//     else {
//         cout << -1 << endl;
//     }
// }

#include <iostream>
#include <vector>
#include <queue>
#include <climits>
using namespace std;

struct State {
    int alice, bob, time;
};

int main() {
    int N;
    cin >> N;

    if (N < 2) 
    {
        cout << -1 << endl;
        return 0;
    }

    queue<State> q;
    vector<vector<bool>> visited(N + 1, vector<bool>(N + 1, false));

    q.push({ 1, N, 0 });
    visited[1][N] = true;

    while (!q.empty()) 
    {
        State current = q.front();
        q.pop();

        int alice = current.alice;
        int bob = current.bob;
        int time = current.time;

        if (alice == bob) {
            cout << time << endl;
            return 0;
        }

        vector<int> alice_moves = { alice + 2, alice + 3 };
        vector<int> bob_moves = { bob - 1, bob - 2 };

        for (int a_move : alice_moves) 
        {
            for (int b_move : bob_moves) 
            {
                if (a_move >= 1 && a_move <= N && b_move >= 1 && b_move <= N && !visited[a_move][b_move]) {
                    visited[a_move][b_move] = true;
                    q.push({ a_move, b_move, time + 1 });
                }
            }
        }
    }
    cout << -1 << endl;
}
