var scanf = require('scanf');

// Зчитуємо кількість боксів
var N = scanf('%d');

// Функція для перевірки можливості та пошуку мінімального t
function findMeetingTime(N) {
    let alicePositions = new Set();
    let t = 0;

    while (true) {
        // Позиції Аліси
        let a1 = 1 + 2 * t;
        let a2 = 1 + 3 * t;

        // Позиції Боба
        let b1 = N - t;
        let b2 = N - 2 * t;

        // Додаємо всі можливі позиції Аліси
        alicePositions.add(a1);
        alicePositions.add(a2);

        // Перевіряємо, чи Боб досяг цих позицій
        if (alicePositions.has(b1) || alicePositions.has(b2)) {
            return t;
        }

        // Якщо телепортація неможлива
        if (a1 > N && a2 > N) break;

        t++;
    }

    return -1;
}

// Результат
console.log(findMeetingTime(N));