def find_min_stamps(N, M):
    result = []
    
    # Починаємо з найбільшої марки і рухаємося до найменших
    for i in range(N, 0, -1):
        if M >= i:  # Якщо поточна марка менша або дорівнює залишковій сумі
            result.append(i)
            M -= i  # Віднімаємо вартість цієї марки від суми
    
        if M == 0:  # Якщо сума досягнута
            break
    
    return result

# Вхідні дані
N = int(input())  # Кількість марок
M = int(input())  # Бюджет, який робот хоче витратити

# Знайдемо набір марок, який задовольняє умови
stamps = find_min_stamps(N, M)

# Вивести результат
print(len(stamps))
print(" ".join(map(str, sorted(stamps))))
