n = int(input())
print ("%d %d\n" % (n/10, n%10))
from collections import deque

def min_meeting_time(N):

    alice_start = 1
    bob_start = N

    
    alice_queue = deque([(alice_start, 0)])
    bob_queue = deque([(bob_start, 0)])

    
    alice_visited = set()
    bob_visited = set()

    while alice_queue or bob_queue:
        
        if alice_queue:
            a_pos, a_time = alice_queue.popleft()
            if a_pos in bob_visited:
                return a_time  
            if a_pos not in alice_visited:
                alice_visited.add(a_pos)
                if a_pos + 2 <= N:
                    alice_queue.append((a_pos + 2, a_time + 1))
                if a_pos + 3 <= N:
                    alice_queue.append((a_pos + 3, a_time + 1))

        
        if bob_queue:
            b_pos, b_time = bob_queue.popleft()
            if b_pos in alice_visited:
                return b_time  
            if b_pos not in bob_visited:
                bob_visited.add(b_pos)
                if b_pos - 1 >= 1:
                    bob_queue.append((b_pos - 1, b_time + 1))
                if b_pos - 2 >= 1:
                    bob_queue.append((b_pos - 2, b_time + 1))

    
    return -1

# Вхідні дані
N = int(input("Введіть кількість боксів (N): "))
result = min_meeting_time(N)
if result == -1:
    print("Аліса і Боб ніколи не зможуть зустрітися.")
else:
    print("Мінімальна кількість секунд для зустрічі:", result)
