#include <iostream>
#include <vector>
#include <unordered_map>
#include <limits>

using namespace std;

void find_president(int N, const vector<int>& a) {
    unordered_map<int, int> frequency;
    
    
    for (int num : a) {
        frequency[num]++;
    }

    
    int min_unique = numeric_limits<int>::max();
    bool found = false;

    for (int num : a) {
        if (frequency[num] == 1) {
            min_unique = min(min_unique, num);
            found = true;
        }
    }

    if (found) {
        cout << min_unique << endl;
    } else {
        cout << -1 << endl;
    }
}

int main() {
    int N;
    cin >> N;

    vector<int> a(N);
    for (int i = 0; i < N; ++i) {
        cin >> a[i];
    }

    find_president(N, a);
    return 0;
}
