#include <iostream>
#include <vector>

using namespace std;

int count_same_color_squares(int N, const vector<vector<int>>& grid) {
    int count = 0;

    
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
           
            for (int k = 1; i + k < N && j + k < N; ++k) {
              
                int top_left = grid[i][j];
                int top_right = grid[i][j + k];
                int bottom_left = grid[i + k][j];
                int bottom_right = grid[i + k][j + k];

                
                if (top_left == top_right && top_right == bottom_left && bottom_left == bottom_right) {
                    ++count;
                }
            }
        }
    }

    return count;
}

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    cout << count_same_color_squares(N, grid) << endl;
    return 0;
}
