from collections import deque

def min_time_to_meet(N):
    alice_start, bob_start = 1, N
    visited = set()
    queue = deque([(alice_start, bob_start, 0)])
    while queue:
        alice_pos, bob_pos, time = queue.popleft()
        if alice_pos == bob_pos:
            return time
        if (alice_pos, bob_pos) in visited:
            continue
        visited.add((alice_pos, bob_pos))
        alice_moves = [alice_pos + 2, alice_pos + 3]
        bob_moves = [bob_pos - 1, bob_pos - 2]
        for new_alice in alice_moves:
            for new_bob in bob_moves:
                if 1 <= new_alice <= N and 1 <= new_bob <= N:
                    queue.append((new_alice, new_bob, time + 1))
    return -1
N = 10
print(min_time_to_meet(N))