local function solve(N)
    if N <= 4 then
        return 1
    end
    
    local distance = N - 1
    
    local minMoves = math.ceil(distance / 5)
    local aliceMin = 1 + 2 * minMoves
    local aliceMax = 1 + 3 * minMoves
    local bobMin = N - 2 * minMoves
    local bobMax = N - minMoves
    
    if aliceMax >= bobMin and aliceMin <= bobMax then
        return minMoves
    end
    
    aliceMin = 1 + 2 * (minMoves + 1)
    aliceMax = 1 + 3 * (minMoves + 1)
    bobMin = N - 2 * (minMoves + 1)
    bobMax = N - (minMoves + 1)
    
    if aliceMax >= bobMin and aliceMin <= bobMax then
        return minMoves + 1
    end
    
    return -1
end


local N = tonumber(io.read())

print(solve(N))
