var scanf = require('scanf');

var N = scanf('%d');
var M = scanf('%d');

function solve(N, M) {
    let result = [];
    let remainingSum = M;
    
    let currentStamp = Math.min(N, remainingSum);
    
    while (remainingSum > 0 && currentStamp > 0) {
        if (currentStamp <= remainingSum) {
            result.push(currentStamp);
            remainingSum -= currentStamp;
        }
        currentStamp--;
    }
    
    if (remainingSum !== 0) {
        console.log(0);
        return;
    }
    
    result.forEach(stamp => {
        console.log(stamp);
    });
}

solve(N, M);
