var scanf = require('scanf');

var n = scanf('%d');
var arr = scanf('%d%d%d%d%d%d%d');

function findUniqueMin(n, arr) {
    let freq = new Map();
    for(let i = 0; i < n; i++) {
        freq.set(arr[i], (freq.get(arr[i]) || 0) + 1);
    }
    
    let uniqueMin = Infinity;
    for(let [num, count] of freq) {
        if(count === 1 && num < uniqueMin) {
            uniqueMin = num;
        }
    }
    
    return uniqueMin === Infinity ? -1 : uniqueMin;
}

console.log(findUniqueMin(n, arr));
