const scanf = require('scanf');

let N = scanf('%d'); 
let A = [];

for (let i = 0; i < N; i++) {
    A.push(scanf('%d')); 
}

const freq = {};

for (let i = 0; i < N; i++) {
    const num = A[i];
    if (freq[num] === undefined) {
        freq[num] = 1;
    } else {
        freq[num]++;
    }
}

let minUnique = -1;

for (const key in freq) {
    if (freq.hasOwnProperty(key) && freq[key] === 1) {
        const num = parseInt(key, 10);
        if (minUnique === -1 || num < minUnique) {
            minUnique = num;
        }
    }
}

console.log(minUnique);
