def fast_meeting_time(N):
    target = (N - 1) % 6  # Цільовий залишок
    
    # Множини досяжних залишків для Аліси та Боба
    alice_remainders = {1, 3, 4}  # (1 + 2a + 3b) % 6
    bob_remainders = {0, 4, 5}    # (N - 1 - a - 2b) % 6
    
    # Перевірка, чи можлива зустріч
    if target not in {((a + b) % 6) for a in alice_remainders for b in bob_remainders}:
        return -1
    
    # Пошук мінімального t
    for t in range(0, 6):  # Малий цикл для перевірки парності
        for a in range(t + 1):
            b = t - a
            alice_pos = 1 + 2 * a + 3 * b
            bob_pos = N - a - 2 * b
            if alice_pos == bob_pos:
                return t
    
    return -1  # Якщо зустріч неможлива

# Ввід
N = int(input())
print(fast_meeting_time(N))
