def find_stamps(N, M):
    # Обчислюємо максимальну можливу суму
    total_sum = N * (N + 1) // 2
    
    # Якщо сума M більша за максимальну можливу суму, то неможливо вибрати марки
    if M > total_sum:
        return [0]
    
    result = []
    # Починаємо з найбільшої марки і перевіряємо, чи можна відняти її від M
    for i in range(N, 0, -1):
        if M >= i:
            result.append(i)
            M -= i
        if M == 0:
            break
    
    # Якщо сума не дорівнює 0, повертаємо 0
    if M != 0:
        return [0]
    
    return result

# Читання вхідних даних
N = int(input())
M = int(input())

# Викликаємо функцію і виводимо результат
result = find_stamps(N, M)
print(" ".join(map(str, result)))
