def find_stamps(N, M):
    # Якщо M перевищує максимальну можливу суму
    total_sum = N * (N + 1) // 2
    if M > total_sum:
        return [0]
    
    # Спочатку створимо набір марок
    result = []
    current_sum = M
    for i in range(N, 0, -1):
        if current_sum >= i:
            result.append(i)
            current_sum -= i
        if current_sum == 0:
            break
    
    # Якщо залишок суми не дорівнює 0, повертаємо 0
    return result if current_sum == 0 else [0]

# Читання вхідних даних
N = int(input())
M = int(input())

# Викликаємо функцію і виводимо результат
result = find_stamps(N, M)
print(" ".join(map(str, result)))
