#include <iostream>
#include <vector>
using namespace std;

void find_stamps(int N, int M) {
    // Формула для перевірки максимально можливої суми
    int max_sum = (N * (N + 1)) / 2;
    if (M > max_sum) {
        cout << 0 << endl;
        return;
    }

    vector<int> result;

    // Починаємо з найбільшої марки і поступово зменшуємо M
    for (int i = N; i > 0; --i) {
        if (M >= i) {
            result.push_back(i);
            M -= i;
        }
        if (M == 0) break;  // Завершуємо, якщо M дорівнює нулю
    }

    // Якщо залишок суми не досягнуто, повертаємо 0
    if (M != 0) {
        cout << 0 << endl;
        return;
    }

    // Виводимо результат у порядку зростання
    for (int i = result.size() - 1; i >= 0; --i) {
        cout << result[i] << " ";
    }
    cout << endl;
}

int main() {
    int N, M;
    cin >> N >> M;
    find_stamps(N, M);
    return 0;
}
