#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

void find_stamps(int N, int M) {
    // Максимальна сума всіх чисел від 1 до N
    int max_sum = (N * (N + 1)) / 2;

    // Якщо M більша за max_sum, неможливо отримати суму
    if (M > max_sum) {
        cout << 0 << endl;
        return;
    }

    vector<int> result;

    // Жадібний підхід: додаємо найбільші можливі марки
    for (int i = N; i > 0; --i) {
        if (M >= i) {
            result.push_back(i);
            M -= i;
        }
        if (M == 0) break;  // Якщо досягнуто потрібну суму
    }

    // Якщо залишок не дорівнює 0, виводимо 0
    if (M != 0) {
        cout << 0 << endl;
        return;
    }

    // Сортуємо результат у порядку зростання
    sort(result.begin(), result.end());
    for (int stamp : result) {
        cout << stamp << " ";
    }
    cout << endl;
}

int main() {
    int N, M;
    cin >> N >> M;
    find_stamps(N, M);
    return 0;
}
