def find_president(N, numbers):
    # Створюємо словник для підрахунку частоти кожного числа
    frequency = {}
    for number in numbers:
        frequency[number] = frequency.get(number, 0) + 1
    
    # Знаходимо всі числа, які є унікальними (частота == 1)
    unique_numbers = [num for num, count in frequency.items() if count == 1]
    
    # Якщо немає унікальних чисел, вибори не відбулися
    if not unique_numbers:
        return -1
    
    # Повертаємо мінімальне унікальне число
    return min(unique_numbers)

# Зчитування даних
N = int(input())
numbers = list(map(int, input().split()))

# Результат
print(find_president(N, numbers))
