def votes(N, numbers):
    allvotes = {}
    for number in numbers:
        allvotes[number] = allvotes.get(number, 0) + 1
    
    unique_numbers = [num for num, count in allvotes.items() if count == 1]

    if not unique_numbers:
        return -1
    
    return min(unique_numbers)

N = int(input())
numbers = list(map(int, input().split()))

print(votes(N, numbers))
