def count_squares(N, grid):
    count = 0
    
    # Перевіряємо всі можливі квадрати розміру 2x2
    for i in range(N - 1):  # i - рядок верхньої лівої точки
        for j in range(N - 1):  # j - стовпець верхньої лівої точки
            # Перевіряємо квадрат з вершинами (i,j), (i,j+1), (i+1,j), (i+1,j+1)
            color = grid[i][j]  # Початковий колір (вибираємо верхній лівий кут)
            if (grid[i][j+1] == color and
                grid[i+1][j] == color and
                grid[i+1][j+1] == color):
                count += 1
    
    return count

# Читання вхідних даних
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Викликаємо функцію і виводимо результат
print(count_squares(N, grid) + 1)
