def count_squares(N, grid):
    count = 0
    
    # Перевіряємо всі можливі квадрати
    for size in range(1, N):  # розмір квадрата
        for i in range(N - size):  # верхня межа для i
            for j in range(N - size):  # верхня межа для j
                # Чотири вершини квадрата
                x1, y1 = i, j
                x2, y2 = i + size, j
                x3, y3 = i, j + size
                x4, y4 = i + size, j + size
                
                # Перевірка кольору для всіх 4-х точок
                color = grid[x1][y1]
                if (grid[x2][y2] == color and
                    grid[x3][y3] == color and
                    grid[x4][y4] == color):
                    count += 1
    
    return count

# Читання вхідних даних
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Викликаємо функцію і виводимо результат
print(count_squares(N, grid))
