def count_squares(N, grid):
    count = 0
    
    # Перевіряємо всі можливі квадрати розмірів 2x2, 3x3, ..., NxN
    for size in range(2, N + 1):  # Розміри квадратів від 2x2 до NxN
        for i in range(N - size + 1):  # Початок квадрата по рядках
            for j in range(N - size + 1):  # Початок квадрата по стовпцях
                # Чотири вершини квадрата
                color = grid[i][j]
                if (grid[i][j] == grid[i][j + size - 1] == 
                    grid[i + size - 1][j] == grid[i + size - 1][j + size - 1]):
                    count += 1
    
    return count

# Читання вхідних даних
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Викликаємо функцію і виводимо результат
print(count_squares(N, grid))
