# Файл: count_uniform_color_squares.py

def count_uniform_color_squares(grid, N):
    count = 0

    # Перебір розмірів квадратів
    for size in range(2, N + 1):  # Розмір квадрата (мінімальний - 2x2)
        for i in range(N - size + 1):  # Верхній лівий рядок
            for j in range(N - size + 1):  # Верхній лівий стовпець
                # Вершини квадрата
                top_left = grid[i][j]
                top_right = grid[i][j + size - 1]
                bottom_left = grid[i + size - 1][j]
                bottom_right = grid[i + size - 1][j + size - 1]

                # Перевіряємо, чи всі вершини однакові
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1

    return count


# Читання вхідних даних
if __name__ == "__main__":
    N = int(input())
    grid = [list(map(int, input().split())) for _ in range(N)]
    result = count_uniform_color_squares(grid, N)
    print(result)
