def count_squares(N, grid):
    count = 0
    
    # Перевіряємо всі пари точок, шукаючи квадрати
    for x1 in range(N):
        for y1 in range(N):
            for x2 in range(N):
                for y2 in range(N):
                    if (x1 != x2 or y1 != y2):  # Точки не однакові
                        # Обчислюємо вектори, що утворюють квадрат
                        dx, dy = x2 - x1, y2 - y1
                        # Перевіряємо чи квадрат
                        x3, y3 = x1 - dy, y1 + dx
                        x4, y4 = x2 - dy, y2 + dx
                        # Перевіряємо, чи всі точки квадрата на місці
                        if 0 <= x3 < N and 0 <= y3 < N and 0 <= x4 < N and 0 <= y4 < N:
                            if (grid[x1][y1] == grid[x2][y2] == grid[x3][y3] == grid[x4][y4]):
                                count += 1
    return count

# Вхідні дані
N = int(input())  # розмір квадрата
grid = [list(map(int, input().split())) for _ in range(N)]

# Виводимо результат
print(count_squares(N, grid))
