#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>

using namespace std;

#define LF '\n';
typedef long long lli;
typedef long double ld;


struct point
{
    lli x, y;
};

vector<point> r;
vector<point> c;

bool cross(lli a, lli b, lli a1, lli b1) {
    ld ax = r[a].x;
    ld ay = r[a].y;
    ld a1x = c[a1].x;
    ld a1y = c[a1].y;

    ld bx = r[b].x;
    ld by = r[b].y;
    ld b1x = c[b1].x;
    ld b1y = c[b1].y;


    ld ka = (ld)(ax - a1x) / (ld)(ay-a1y);
    ld ba = ay - ka * ax;


    ld kb = (ld)(bx - b1x) / (ld)(by - b1y);
    ld bb = by - kb * bx;

    if (ka==0 && kb==0){
        return 0;
    }
    else if (ka == 0) {
        ld x = ax;
        ld y = kb * x + bb;
        if (y >= min(ay, a1y) && y <= max(ay, a1y) && x >= min(bx, b1x) && x <= max(bx, b1x))return 1;
        else return 0;
    }
    else if (kb == 0) {
        ld x = bx;
        ld y = ka * x + ba;
        if (y >= min(by, b1y) && y <= max(by, b1y) && x >= min(ax, a1x) && x <= max(ax, a1x))return 1;
        else return 0;
    }

    ld x = (ba - bb) / (kb - ka);
    if (x >= min(ax, a1x) && x <= max(ax, a1x) && x>=min(bx,b1x) && x<=max(bx,b1x))return 1;
    return 0;
}

void solve()
{
    lli n;
    cin >> n;
    r.clear();
    c.clear();
    r.resize(n + 1);
    c.resize(n + 1);
    for (int i = 1; i <= n; i++)cin >> r[i].x >> r[i].y;
    for (int i = 1; i <= n; i++)cin >> c[i].x >> c[i].y;
    vector<lli> v;
    v.resize(n + 1);
    for (int i = 1; i <= n; i++)v[i] = i;
    lli cnt = 10;
    while (cnt--) {
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= n; j++) {
                if (i == j)continue;
                if (cross(i, j, v[i], v[j]))swap(v[i], v[j]);
            }
        }
    }
    for (int i = 1; i <= n; i++)cout << i << " " << v[i] << LF;

}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 

    lli t;
    cin >> t;
    while (t--)solve();
}

