from collections import deque

def can_meet(N):
    alice_positions = deque([1])
    bob_positions = deque([N])
    visited_alice = set([1])
    visited_bob = set([N])
    seconds = 0

    while alice_positions and bob_positions:
        seconds += 1

        for _ in range(len(alice_positions)):
            pos = alice_positions.popleft()
            for new_pos in (pos + 2, pos + 3):
                if new_pos <= N and new_pos not in visited_alice:
                    if new_pos in visited_bob:
                        return seconds
                    alice_positions.append(new_pos)
                    visited_alice.add(new_pos)

        for _ in range(len(bob_positions)):
            pos = bob_positions.popleft()
            for new_pos in (pos - 1, pos - 2):
                if new_pos >= 1 and new_pos not in visited_bob:
                    if new_pos in visited_alice:
                        return seconds
                    bob_positions.append(new_pos)
                    visited_bob.add(new_pos)

    return -1

if __name__ == "__main__":
    n = int(input())
    result = can_meet(n)
    print(result)
