#include <bits/stdc++.h>
using namespace std;
struct point
{
    int x;
    int y;
    int num;
};
struct answer
{
    int x1, x2, num1;
    int y1, y2, num2;
};
bool cmp(point a, point b)
{
    if(a.y > b.y) return true;
    if(a.y < b.y) return false;
    if(a.x > b.x) return true;
    return false;
}

int check(point p1, point p2, point p)
{
    long double d;
    d = (p2.x - p1.x)*(p.y - p1.y) - (p.x - p1.x)*(p2.y - p1.y);

    if(d==0) return 0;
    if(d<0) return -1;
    return 1;
}

bool intersect(int p1x, int p1y, int p2x, int p2y, int p3x, int p3y, int p4x, int p4y)
{
    point p1, p2, p3, p4;
    p1.x = p1x;
    p1.y = p1y;
    p2.x = p2x;
    p2.y = p2y;
    p3.x = p3x;
    p3.y = p3y;
    p4.x = p4x;
    p4.y = p4y;
    int z1, z2, z3, z4;

    z1 = check(p1, p2, p3);
    z2 = check(p1, p2, p4);

    if(z1*z2==1) return false;

    z3 = check(p3, p4, p1);
    z4 = check(p3, p4, p2);

    if(z3*z4==1) return false;

    return true;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    point blue[2507], red[2507];
    answer ans[2507];
    int n, t;
    cin >> t;
    for(int j=1; j<=t; j++)
    {
        cin>>n;
        for(int i=1; i<=n; i++)
        {
            cin >> blue[i].x >> blue[i].y;
            blue[i].num = i;
        }
        sort(blue+1, blue+1+n, cmp);
        for(int i=1; i<=n; i++) 
        {
            cin >> red[i].x >> red[i].y;
            red[i].num = i;
        }
        sort(red+1, red+1+n, cmp);
        for(int i=1; i<=n; i++) 
        {
            ans[i].num1 = blue[i].num;
            ans[i].num2 = red[i].num;
            ans[i].x1 = blue[i].x;
            ans[i].x2 = red[i].x;
            ans[i].y1 = blue[i].y;
            ans[i].y2 = red[i].y;
        }

        for(int i=1; i<=n; i++)
        {
            for(int j=i+1; j<=n; j++)
            {
                if(intersect(ans[i].x1, ans[i].y1, ans[i].x2, ans[i].y2, ans[j].x1, ans[j].y1, ans[j].x2, ans[j].y2))
                {
                    swap(ans[i].x1, ans[j].x1);
                    swap(ans[i].y1, ans[j].y1);
                }
            }
        }
        for(int i=1; i<=n; i++) cout << ans[i].num1 << " " << ans[i].num2<< "\n";
    }
}
