t = int(input())

def are_intersecting(p1, p2, q1, q2):
    def get_orientation(p1, p2, q):
        t = (p1[1] - p2[1]) * (q[0] - p1[0]) - (p1[0] - p2[0]) * (q[1] - p1[1])
        return t > 0

    o1 = get_orientation(p1, q1, p2)
    o2 = get_orientation(p1, q1, q2)
    o3 = get_orientation(p2, q2, p1)
    o4 = get_orientation(p2, q2, q1)

    # orientations difere
    if o1 != o2 and o3 != o4:
        return True
    return False


def solution():
    n = int(input())
    reds = []
    blues = []
    for j in range(n): reds.append([int(i) for i in input().split()])
    for j in range(n): blues.append([int(i) for i in input().split()])

    res = ''
    for i in range(n):
        for j in range(n):
            if are_intersecting(reds[i], reds[j], blues[i], blues[j]):
                return
            else:
                res += f'{i} {j}\n'
    print(res)


for i in range(t):
    solution()