def count_uniform_color_squares():
    import sys
    input = sys.stdin.read
    data = input().splitlines()
    
    # Розмір квадрата
    N = int(data[0])
    grid = [list(map(int, line.split())) for line in data[1:]]

    count = 0

    # Перебір верхнього лівого кута квадрата
    for i in range(N):
        for j in range(N):
            # Перебір розмірів квадратів
            for size in range(2, N - max(i, j) + 1):
                # Координати вершин
                x1, y1 = i, j
                x2, y2 = i, j + size - 1
                x3, y3 = i + size - 1, j
                x4, y4 = i + size - 1, j + size - 1
                
                # Перевірка однаковості кольору
                if grid[x1][y1] == grid[x2][y2] == grid[x3][y3] == grid[x4][y4]:
                    count += 1

    print(count)
