def min_seconds_to_meet(N):
    # Створюємо множину позицій Аліси та Боба
    alice_positions = {1}
    bob_positions = {N}

    # Підраховуємо кількість секунд
    seconds = 0

    # Виконуємо цикл поки не знайдемо спільну позицію або не вичерпаємо всі можливості
    while alice_positions and bob_positions:
        seconds += 1
        # Оновлюємо множини позицій Аліси та Боба на наступному кроці
        new_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= N:
                new_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                new_alice_positions.add(pos + 3)

        new_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                new_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_positions.add(pos - 2)

        # Перевіряємо, чи є спільні позиції між Алісою і Бобом
        if new_alice_positions & new_bob_positions:
            return seconds

        # Оновлюємо позиції для наступного кроку
        alice_positions = new_alice_positions
        bob_positions = new_bob_positions

    return -1