from collections import Counter

def find_president(robots):
    counts = Counter(robots)
    unique_min_values = []
    for key, value in counts.items():
        if value == 1:
            unique_min_values.append(key)
    
    if not unique_min_values:
        return -1
    
    min_unique_value = unique_min_values[0]
    for value in unique_min_values:
        if value < min_unique_value:
            min_unique_value = value
    
    return min_unique_value

N = int(input())
robots = list(map(int, input().split()))

result = find_president(robots)
output = "-1" if result == -1 else str(result)
print(output)
