def count_uniform_squares(N, grid):
    count = 0
    for i in range(N):
        for j in range(N):
            for k in range(1, N):
                if i + k < N and j + k < N:
                    vertices = [
                        grid[i][j],
                        grid[i + k][j],
                        grid[i][j + k],
                        grid[i + k][j + k]
                    ]
                    if len(set(vertices)) == 1:
                        count += 1
    return count

N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]
print(count_uniform_squares(N, grid))
