def solve_test_case(N, blue_points, red_points):
    # Сортуємо точки за координатами для кожного кольору
    sorted_blue = sorted((x, y, i+1) for i, (x, y) in enumerate(blue_points))
    sorted_red = sorted((x, y, i+1) for i, (x, y) in enumerate(red_points))
    
    # Створюємо пари індексів
    pairs = [(blue[2], red[2]) for blue, red in zip(sorted_blue, sorted_red)]
    
    return pairs

def main():
    t = int(input())  # Кількість тестових блоків
    for _ in range(t):
        N = int(input())  # Кількість точок одного кольору
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().split())) for _ in range(N)]
        
        # Розв'язуємо задачу для поточного блоку
        result = solve_test_case(N, blue_points, red_points)
        
        # Виводимо результат
        for blue_idx, red_idx in result:
            print(blue_idx, red_idx)

if __name__ == "__main__":
    main()
