def solve_case(N, blue_points, red_points):
    sorted_blue = sorted(enumerate(blue_points, 1), key=lambda x: (x[1][0], x[1][1]))
    sorted_red = sorted(enumerate(red_points, 1), key=lambda x: (x[1][0], x[1][1]))
    
    result = []
    for i in range(N):
        result.append((sorted_blue[i][0], sorted_red[i][0]))
    
    return result

def main():
    t = int(input())
    for _ in range(t):
        N = int(input())
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().split())) for _ in range(N)]
        
        result = solve_case(N, blue_points, red_points)
        
        for pair in result:
            print(pair[0], pair[1])

if __name__ == "__main__":
    main()
