from collections import deque
def min_time_to_meet(N):
    queue = deque([(1, N, 0)])
    visited = set([(1, N)])
    while queue:
        alice, bob, time = queue.popleft()
        if alice == bob:
            return time
        for new_alice in [alice + 2, alice + 3]:
            if 1 <= new_alice <= N:
                for new_bob in [bob - 1, bob - 2]:
                    if 1 <= new_bob <= N:
                        if (new_alice, new_bob) not in visited:
                            visited.add((new_alice, new_bob))
                            queue.append((new_alice, new_bob, time + 1))
    return -1
N = int(input())
print(min_time_to_meet(N))
