def count_uniform_squares(N, grid):
    count = 0
    for size in range(1, N): 
        for a in range(N - size):  
            for b in range(N - size):  
                color = grid[a][b]
                if (grid[a][b] == color and 
                    grid[a][b + size] == color and 
                    grid[a + size][b] == color and 
                    grid[a + size][b + size] == color):
                    count += 1
    return count
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]
print(count_uniform_squares(N, grid))

