def solve():
    N = int(input())
    
    if N == 2:
        # Особливий випадок: Аліса залишається в 1, Боб телепортується до 1
        print(1)
    elif N == 3:
        # Особливий випадок: Аліса телепортується до 3, Боб до 1. Немає зустрічі
        print(-1)
    else:
        # Обчислюємо мінімальне t як округлення вгору (N-1)/5
        L = (N - 1 + 4) // 5  # Це еквівалентно ceil((N-1)/5)
        
        # Обчислюємо максимальне t як округлення вниз (N-1)/3
        R = (N - 1) // 3  # Це еквівалентно floor((N-1)/3)
        
        if L <= R:
            # Якщо існує t в діапазоні [L, R], то найменше t - це L
            print(L)
        else:
            # Інакше, зустріч неможлива
            print(-1)