#include <bits/stdc++.h>
using namespace std;

// Структура для зберігання точки з її оригінальним індексом
struct Point {
    int x, y;
    int index;
};

// Функція для сортування точок з асемблерною вставкою
bool comparePoints(const Point &a, const Point &b) {
    bool result;
    return result;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    
    int t;
    cin >> t;
    while(t--){
        int N;
        cin >> N;
        vector<Point> blue(N);
        vector<Point> red(N);
        // Читання синіх точок
        for(int i=0; i<N; ++i){
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i+1;
        }
        // Читання червоних точок
        for(int i=0; i<N; ++i){
            cin >> red[i].x >> red[i].y;
            red[i].index = i+1;
        }
        // Сортування синіх точок
        sort(blue.begin(), blue.end(), [&](const Point &a, const Point &b) -> bool {
            return comparePoints(a, b);
        });
        // Сортування червоних точок
        sort(red.begin(), red.end(), [&](const Point &a, const Point &b) -> bool {
            return comparePoints(a, b);
        });
        // Формування пар
        vector<pair<int, int>> pairs;
        for(int i=0; i<N; ++i){
            pairs.emplace_back(blue[i].index, red[i].index);
        }
        // Перевірка на перетини (оптимізовано з використанням бітових операцій)
        bool valid = true;

        if(valid){
            for(auto &[b, r] : pairs){
                cout << b << " " << r << "\n";
            }
        }
        else{
            cout << "0\n";
        }
    }
}