program MemoryTest;

var
  N, A, B: Int64;

// Функція для знаходження НСД (найбільшого спільного дільника)
function GCD(x, y: Int64): Int64;
begin
  while y <> 0 do
  begin
    GCD := y;
    y := x mod y;
    x := GCD;
  end;
  GCD := x;
end;

// Функція для знаходження НСК (найменшого спільного кратного)
function LCM(x, y: Int64): Int64;
begin
  LCM := (x div GCD(x, y)) * y;
end;

begin
  ReadLn(N);
  ReadLn(A, B);

  if (A > N) and (B > N) then
  begin
    WriteLn(0); // Немає комірок, що задовольняють умову
    Exit;
  end;

  // Підрахунок одиниць
  WriteLn((N div A) + (N div B) - (N div LCM(A, B)));
end.
