def is_between(a, b, c):
    return min(a, b) <= c <= max(a, b)

def checkOverlap(x0, y0, x1, y1, x2, y2, x3, y3):
    def area(x1, y1, x2, y2, x3, y3):
        return (x1 * (y2 - y3) + x2 * (y3 - y1) + x3 * (y1 - y2))
    
    if (area(x0, y0, x1, y1, x2, y2) == 0 and area(x0, y0, x1, y1, x3, y3) == 0):
        return (is_between(x0, x1, x2) or is_between(x0, x1, x3) or
                is_between(x2, x3, x0) or is_between(x2, x3, x1)) and (
                is_between(y0, y1, y2) or is_between(y0, y1, y3) or
                is_between(y2, y3, y0) or is_between(y2, y3, y1))
    return False 

numblocks = int(input())
for _ in range(numblocks):
    halfcolordots = int(input())
    blues = []
    reds = []
    drawn = []
    drawncoords = []
    for _ in range(halfcolordots):
        coords = input().split()
        blues.append([int(coords[0]), int(coords[1])])
    for _ in range(halfcolordots):
        coords = input().split()
        reds.append([int(coords[0]), int(coords[1])])
    
    redsused = []
    drawn = []
    blueIdx = -1
    for blueDot in blues:
        blueIdx += 1
        redIdx = -1
        for redDot in reds:
            redIdx += 1
            if redIdx not in redsused:
                owndrawn = [blueDot[0], blueDot[1], redDot[0], redDot[1]]
                overlaps = False
                for otherline in drawn:
                    if checkOverlap(blueDot[0], blueDot[1], redDot[0], redDot[1], otherline[0], otherline[1], otherline[2], otherline[3]):
                        overlaps = True
                if not overlaps:
                    redsused.append(redIdx)
                    drawn.append(owndrawn)
                    print(blueIdx + 1, redIdx + 1)
                    break
            
