def count_colored_squares(n, matrix):
    count = 0
    for x1 in range(n):
        for y1 in range(n):
            for side in range(1, n):
                x2, y2 = x1 + side, y1
                x3, y3 = x1, y1 + side
                x4, y4 = x1 + side, y1 + side
                if x2 < n and y3 < n and x4 < n and y4 < n:
                    if matrix[y1][x1] == matrix[y2][y2] == matrix[y3][x3] == matrix[y4][x4]:
                        count += 1
    return count
n = int(input())
matrix = [list(map(int, input().split())) for _ in range(n)]
print(count_colored_squares(n, matrix))