def solve_case(N, blue_points, red_points):
    # Сортуємо точки по координатах, зберігаючи індекси
    blue_sorted = sorted((x, y, i+1) for i, (x, y) in enumerate(blue_points))
    red_sorted = sorted((x, y, i+1) for i, (x, y) in enumerate(red_points))

    # Формуємо пари індексів для кожного з'єднання
    result = []
    for i in range(N):
        blue_x, blue_y, blue_index = blue_sorted[i]
        red_x, red_y, red_index = red_sorted[i]
        result.append((blue_index, red_index))

    # Вивести результат
    for blue_index, red_index in result:
        print(blue_index, red_index)

def main():
    t = int(input())
    for _ in range(t):
        N = int(input()) 
        blue_points = []
        red_points = []
        for _ in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y))
        for _ in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y))
        solve_case(N, blue_points, red_points)
main()

