#include <iostream>
#include <climits> 

using namespace std;

void find_min_combination(int len, int a, int b, int c) 
{
    int min_sum = INT_MAX, best_x = -1, best_y = -1, best_z = -1, remaining, sum, z;  
    for (int x = 0; x <= len / a; x++) 
    {
        for (int y = 0; y <= (len - x * a) / b; y++) 
        {
            remaining = len - x * a - y * b;
            if (remaining % c == 0) 
            {
                z = remaining / c;
                sum = x + y + z;
                if (sum < min_sum) 
                {
                    min_sum = sum;
                    best_x = x;
                    best_y = y;
                    best_z = z;
                }
            }
        }
    }
    if (best_x!=-1 and best_y!=-1 and best_z!=-1) 
    {
        cout << min_sum;
    } 
    else 
    {
        cout << "-1";
    }
}

int main() 
{
    int len;
    cin >> len;
    find_min_combination(len-1, 3, 4, 5);
    return 0;
}
