n = int(input())
print ("%d %d\n" % (n/10, n%10))
def min_time_to_meet(N):
    # Перевірка парності
    if (N - 1) % 2 != 0:
        return -1

    # Початкові позиції
    alice_positions = {1}  # Починаємо з позиції 1
    bob_positions = {N}    # Починаємо з позиції N

    t = 0  # Лічильник часу
    while True:
        # Перевірка перетину множин позицій
        if alice_positions & bob_positions:
            return t

        # Оновлення позицій Аліси
        next_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= N:
                next_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                next_alice_positions.add(pos + 3)

        # Оновлення позицій Боба
        next_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                next_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                next_bob_positions.add(pos - 2)

        # Оновлюємо множини для наступної ітерації
        alice_positions = next_alice_positions
        bob_positions = next_bob_positions

        t += 1  # Збільшуємо час

        # Захист від нескінченного циклу (теоретично не потрібен)
        if t > N:
            return -1

# Приклад виклику функції:
print(min_time_to_meet(9))  # Очікуваний результат: 2
print(min_time_to_meet(5))  # Очікуваний результат: 1
print(min_time_to_meet(8))  # Очікуваний результат: -1

