N = int(input())

def min_seconds_to_meet(N):
    # Вихідні умови
    if N < 2:
        return -1

    # Позиції Аліси та Боба
    alice_pos = [1]
    bob_pos = [N]

    seconds = 0

    while alice_pos and bob_pos:
        seconds += 1

        # Нові позиції на наступну секунду
        new_alice_pos = set()
        for pos in alice_pos:
            if pos + 2 <= N:
                new_alice_pos.add(pos + 2)
            if pos + 3 <= N:
                new_alice_pos.add(pos + 3)

        new_bob_pos = set()
        for pos in bob_pos:
            if pos - 1 >= 1:
                new_bob_pos.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_pos.add(pos - 2)

        # Перевірка на перетин
        if new_alice_pos & new_bob_pos:
            return seconds

        alice_pos = new_alice_pos
        bob_pos = new_bob_pos

    return -1

# Приклади
print(min_seconds_to_meet(N)) 
