N = int(input())

def min_seconds_to_meet(N):
    if N < 2:
        return -1

    from collections import deque

    # Ініціалізація черг для Аліси та Боба
    alice_queue = deque([1])
    bob_queue = deque([N])
    alice_visited = {1}
    bob_visited = {N}

    seconds = 0

    while alice_queue and bob_queue:
        seconds += 1

        # Рух Аліси
        for _ in range(len(alice_queue)):
            pos = alice_queue.popleft()
            for new_pos in [pos + 2, pos + 3]:
                if new_pos in bob_visited:
                    return seconds
                if new_pos <= N and new_pos not in alice_visited:
                    alice_visited.add(new_pos)
                    alice_queue.append(new_pos)

        # Рух Боба
        for _ in range(len(bob_queue)):
            pos = bob_queue.popleft()
            for new_pos in [pos - 1, pos - 2]:
                if new_pos in alice_visited:
                    return seconds
                if new_pos >= 1 and new_pos not in bob_visited:
                    bob_visited.add(new_pos)
                    bob_queue.append(new_pos)

    return -1

print(min_seconds_to_meet(N))