from collections import deque

N = int(input())

def min_seconds_to_meet(N):
    if N < 2:
        return -1

    queue = deque([(1, 0, 'alice'), (N, 0, 'bob')])
    alice_visited = {1}
    bob_visited = {N}

    while queue:
        pos, seconds, robot = queue.popleft()

        if robot == 'alice':
            for new_pos in [pos + 2, pos + 3]:
                if new_pos in bob_visited:
                    return seconds + 1
                if new_pos <= N and new_pos not in alice_visited:
                    alice_visited.add(new_pos)
                    queue.append((new_pos, seconds + 1, 'alice'))
        else:
            for new_pos in [pos - 1, pos - 2]:
                if new_pos in alice_visited:
                    return seconds + 1
                if new_pos >= 1 and new_pos not in bob_visited:
                    bob_visited.add(new_pos)
                    queue.append((new_pos, seconds + 1, 'bob'))

    return -1

print(min_seconds_to_meet(N))