N = int(input())

def min_seconds_to_meet(N):
    if N < 2:
        return -1

    alice_pos = {1}
    bob_pos = {N}

    seconds = 0

    while alice_pos and bob_pos:

        if len(alice_pos) > len(bob_pos):
            alice_pos, bob_pos = bob_pos, alice_pos

        seconds += 1

        new_alice_pos = set()
        for pos in alice_pos:
            if pos + 2 <= N:
                new_alice_pos.add(pos + 2)
            if pos + 3 <= N:
                new_alice_pos.add(pos + 3)

        if new_alice_pos & bob_pos:
            return seconds

        alice_pos = new_alice_pos

        new_bob_pos = set()
        for pos in bob_pos:
            if pos - 1 >= 1:
                new_bob_pos.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_pos.add(pos - 2)

        if new_bob_pos & alice_pos:
            return seconds

        bob_pos = new_bob_pos

    return -1

print(min_seconds_to_meet(N))