N = int(input())

def min_seconds_to_meet(N):
    # Вихідні умови
    if N < 2:
        return -1

    # Ініціалізація позицій та множин для перевірки відвіданих позицій
    alice_pos = {1}
    bob_pos = {N}
    alice_visited = {1}
    bob_visited = {N}
    
    seconds = 0

    while alice_pos and bob_pos:
        # Заміна позиції з меншою кількістю елементів, щоб мінімізувати обчислення
        if len(alice_pos) > len(bob_pos):
            alice_pos, bob_pos = bob_pos, alice_pos
            alice_visited, bob_visited = bob_visited, alice_visited

        seconds += 1

        # Нова позиція на наступну секунду
        new_alice_pos = set()
        for pos in alice_pos:
            for new_pos in [pos + 2, pos + 3]:
                if new_pos in bob_visited:
                    return seconds
                if new_pos <= N and new_pos not in alice_visited:
                    new_alice_pos.add(new_pos)
                    alice_visited.add(new_pos)
        
        alice_pos = new_alice_pos

        new_bob_pos = set()
        for pos in bob_pos:
            for new_pos in [pos - 1, pos - 2]:
                if new_pos in alice_visited:
                    return seconds
                if new_pos >= 1 and new_pos not in bob_visited:
                    new_bob_pos.add(new_pos)
                    bob_visited.add(new_pos)
        
        bob_pos = new_bob_pos

    return -1

print(min_seconds_to_meet(N))
