from collections import deque

N = int(input())

def min_seconds_to_meet(N):
    if N < 2:
        return -1

    alice_queue = deque([(1, 0)])
    bob_queue = deque([(N, 0)])
    alice_visited = {1}
    bob_visited = {N}
    
    while alice_queue and bob_queue:
        pos, sec = alice_queue.popleft()
        for new_pos in (pos + 2, pos + 3):
            if new_pos in bob_visited:
                return sec + 1
            if new_pos <= N and new_pos not in alice_visited:
                alice_visited.add(new_pos)
                alice_queue.append((new_pos, sec + 1))

        pos, sec = bob_queue.popleft()
        for new_pos in (pos - 1, pos - 2):
            if new_pos in alice_visited:
                return sec + 1
            if new_pos >= 1 and new_pos not in bob_visited:
                bob_visited.add(new_pos)
                bob_queue.append((new_pos, sec + 1))
    
    return -1

print(min_seconds_to_meet(N))