N = int(input())

def min_seconds_to_meet(N):
    if N < 2:
        return -1

    alice_pos = {1}
    bob_pos = {N}
    seconds = 0

    while alice_pos and bob_pos:
        seconds += 1
        
        # Нові позиції на наступну секунду для Аліси
        new_alice_pos = {pos + step for pos in alice_pos for step in [2, 3] if pos + step <= N}
        
        # Нові позиції на наступну секунду для Боба
        new_bob_pos = {pos - step for pos in bob_pos for step in [1, 2] if pos - step >= 1}

        # Перевірка на перетин
        if new_alice_pos & new_bob_pos:
            return seconds

        alice_pos, bob_pos = new_alice_pos, new_bob_pos

    return -1

print(min_seconds_to_meet(N))
