N = int(input().strip())
grid = [list(map(int, input().strip().split())) for _ in range(N)]

def count_uniform_squares(N, grid):
    count = 0
    
    for size in range(1, N):
        for i in range(N - size): 
            for j in range(N - size):

                top_left = grid[i][j]
                top_right = grid[i][j + size]
                bottom_left = grid[i + size][j]
                bottom_right = grid[i + size][j + size]
                
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1
                    
    return count

result = count_uniform_squares(N, grid) + 1
print(result)