def connect_points(test_cases):
    results = []
    
    for case in test_cases:
        N, blue_points, red_points = case
        
        sorted_blue = sorted((x, y, i + 1) for i, (x, y) in enumerate(blue_points))
        sorted_red = sorted((x, y, i + 1) for i, (x, y) in enumerate(red_points))
        
        current_result = []
        
        for i in range(N):
            blue_index = sorted_blue[i][2]
            red_index = sorted_red[i][2]
            current_result.append(f"{blue_index} {red_index}")
        
        results.append("\n".join(current_result))
    
    return results

t = int(input().strip())
test_cases = []

for _ in range(t):
    N = int(input().strip())
    blue_points = [tuple(map(int, input().strip().split())) for _ in range(N)]
    red_points = [tuple(map(int, input().strip().split())) for _ in range(N)]
    test_cases.append((N, blue_points, red_points))

results = connect_points(test_cases)
for result in results:
    print(result)