from collections import deque

n = int(input())

def teleport(n):   
    a_vis = set()
    b_vis = set()
    a_queue = deque([(1, 0)])
    b_queue = deque([(n, 0)])

    a_vis.add(1)
    b_vis(n)

    while a_queue or b_queue:

        if a_queue:
            a_pos, a_time = a_queue.popleft()
            for move in [2, 3]:
                next_pos = a_pos + move
                if next_pos <= n and next_pos not in a_vis:
                    return a_time + 1
                a_vis.add(next_pos)
                a_queue.append((next_pos, a_time + 1))

        if b_queue:
            b_pos, b_time = b_queue.popleft()
            for move in [1 , 2]:
                if next_pos >= 1 and next_pos not in b_vis:
                    return b_time + 1
                b_vis.add(next_pos)
                b_queue.append((next_pos, b_time + 1))

    return -1

print(teleport(n))