from collections import deque

n = int(input())

def teleport(n):   
    a_vis = set()
    b_vis = set()
    a_queue = deque([1])
    b_queue = deque([n])

    a_vis.add(1)
    b_vis.add(n)

    steps = 0

    while a_queue or b_queue:
        steps = steps + 1

        for a in range(len(a_queue)):
            a_pos = a_queue.popleft()

            for next_pos_a in [a_pos + 2, a_pos + 3]:
                if next_pos_a <= n and next_pos_a not in a_vis:
                    a_vis.add(next_pos_a)
                    a_queue.append(next_pos_a)
                    if next_pos_a in b_vis:
                        return steps

        for a in range(len(b_queue)):
            b_pos = b_queue.popleft()

            for next_pos_b in [b_pos - 1, b_pos - 2]:
                if next_pos_b <= n and next_pos_b not in b_vis:
                    b_vis.add(next_pos_b)
                    b_queue.append(next_pos_b)
                    if next_pos_b in a_vis:
                        return steps

    return -1

print(teleport(n))