#include <iostream>
#include <set>
using namespace std;

long long minMeetingTime(long long N) {
    if ((1 % 2) != (N % 2)) {
        return -1;
    }

    long long t = 0;
    while (true) {
        long long alice1 = 1 + 2 * t;
        long long alice2 = 1 + 3 * t;
        long long bob1 = N - t;
        long long bob2 = N - 2 * t;

        if ((alice1 == bob1 || alice1 == bob2) || 
            (alice2 == bob1 || alice2 == bob2)) {
            return t;
        }
        t++;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long N;
    cin >> N;
    cout << minMeetingTime(N) << endl;
    return 0;
}
