#include <iostream>
#include <vector>
#include <unordered_map>
#include <limits>

using namespace std;

int main() {
    int N;
    cin >> N;  
    vector<int> numbers(N);
    unordered_map<int, int> frequency;
    
    for (int i = 0; i < N; ++i) {
        cin >> numbers[i];
        frequency[numbers[i]]++;
    }
    
    int minUnique = numeric_limits<int>::max();
    
    for (int num : numbers) {
        if (frequency[num] == 1 && num < minUnique) {
            minUnique = num;
        }
    }
    
    if (minUnique == numeric_limits<int>::max()) {
        cout << -1 << "\n";
    } 
    else {
        cout << minUnique << "\n";
    }

    return 0;
}
