#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

int main() {
    int N;
    cin >> N;
    vector<vector<int>> grid(N, vector<int>(N));
    
    for (int y = 0; y < N; y++) {
        for (int x = 0; x < N; x++) {
            cin >> grid[y][x];
        }
    }
    
    int count = 0;

    for (int x1 = 0; x1 < N; x1++) {
        for (int y1 = 0; y1 < N; y1++) {
            for (int x2 = 0; x2 < N; x2++) {
                for (int y2 = 0; y2 < N; y2++) {
                    if (x1 == x2 && y1 == y2) continue;
                    int dx = x2 - x1;
                    int dy = y2 - y1;
                    if (abs(dx) != abs(dy)) continue;
                    if (grid[y1][x1] == grid[y2][x2] && grid[y1][x1] == grid[y1 + dy][x1 - dx] && grid[y1 + dy][x1 - dx] == grid[y2 - dy][x2 + dx]) {
                        count++;
                    }
                }
            }
        }
    }

    cout << count << "\n";
    return 0;
}
