#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Point {
    int x, y;
    int original_index;
};

bool compare(const Point &a, const Point &b) {
    if (a.x != b.x)
        return a.x < b.x;
    else
        return a.y < b.y;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int t;
    cin >> t;
    for (int test_case = 0; test_case < t; ++test_case) {
        int N;
        cin >> N;

        vector<Point> blue(N);
        for (int i = 0; i < N; ++i) {
            blue[i].original_index = i + 1;
            cin >> blue[i].x >> blue[i].y;
        }

        vector<Point> red(N);
        for (int i = 0; i < N; ++i) {
            red[i].original_index = i + 1;
            cin >> red[i].x >> red[i].y;
        }

        sort(blue.begin(), blue.end(), compare);
        sort(red.begin(), red.end(), compare);

        for (int i = 0; i < N; ++i) {
            cout << blue[i].original_index << " " << red[i].original_index << endl;
        }
    }
    return 0;
}