#include <iostream>
using namespace std;

int find_meeting_time(int N) {
    // Початкові позиції
    int alice_pos = 1;
    int bob_pos = N;
    int seconds = 0;

    // Перевіряємо можливість зустрічі
    while (alice_pos <= bob_pos) {
        seconds++;
        
        // Аліса може рухатись на +2 або +3
        if (alice_pos + 2 <= N) alice_pos += 2;
        else if (alice_pos + 3 <= N) alice_pos += 3;
        
        // Боб може рухатись на -1 або -2
        if (bob_pos - 1 >= 1) bob_pos -= 1;
        else if (bob_pos - 2 >= 1) bob_pos -= 2;
        
        // Якщо Аліса та Боб опиняються в одному боксі
        if (alice_pos == bob_pos) return seconds;
    }

    // Якщо немає можливості зустрітись
    return -1;
}

int main() {
    int N;
    cin >> N;
    cout << find_meeting_time(N) << endl;
    return 0;
}

