def teleportation(N):
    # Якщо кількість боксів менша за 2, то це неприпустимо
    if N < 2:
        return -1

    # Початкові клітинки Аліси та Боба
    a_position = 1
    b_position = N
    
    # Якщо N == 2, вони можуть зустрітись на клітинці 2 за 1 секунду
    if N == 2:
        return 1
    
    # Перевірка для кожної секунди
    for seconds in range(1, N+1):
        # Перевірка можливих позицій для Аліси на цю секунду
        a_positions = set()
        for i in range(0, seconds + 1):
            a_positions.add(1 + 2 * i + 3 * (seconds - i))

        # Перевірка можливих позицій для Боба
        b_positions = set()
        for i in range(0, seconds + 1):
            b_positions.add(N - (i + 2 * (seconds - i)))

        # Якщо є перетин, то повертаємо кількість секунд
        if not a_positions.isdisjoint(b_positions):
            return seconds

    # Якщо не знайшли
    return -1
