def teleportation(N):
    # Стартові позиції
    alice_positions = {1}  # Аліса починає з 1
    bob_positions = {N}  # Боб починає з N
    
    # Лічильник секунд
    seconds = 0
    
    while True:
        seconds += 1
        
        # Нові позиції для Аліси
        new_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= N:  # Аліса може телепортуватися на k+2
                new_alice_positions.add(pos + 2)
            if pos + 3 <= N:  # Аліса може телепортуватися на k+3
                new_alice_positions.add(pos + 3)
        
        # Нові позиції для Боба
        new_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:  # Боб може телепортуватися на k-1
                new_bob_positions.add(pos - 1)
            if pos - 2 >= 1:  # Боб може телепортуватися на k-2
                new_bob_positions.add(pos - 2)
        
        # Перевіряємо, чи є спільні позиції
        if not new_alice_positions.isdisjoint(new_bob_positions):
            return seconds  # Вони можуть зустрітися через `seconds` секунд
        
        # Оновлюємо множини позицій для наступного кроку
        alice_positions = new_alice_positions
        bob_positions = new_bob_positions
        
        # Якщо кількість позицій Аліси і Боба не змінюється, це означає, що вони не можуть зустрітися
        if not alice_positions or not bob_positions:
            break
    
    # Якщо вони не можуть зустрітися
    return -1
