def meet_in_one_box(N):
    # Початкові позиції
    alice_pos = {1}
    bob_pos = {N}
    
    # Перевіряємо на першій секунді
    if 1 == N:
        return 0
    
    # Для кожної секунди перевіряємо можливі позиції для Аліси та Боба
    for t in range(1, N):
        # Створимо нові множини для наступної секунди
        new_alice_pos = set()
        new_bob_pos = set()
        
        # Рух Аліси
        for pos in alice_pos:
            if pos + 2 <= N:
                new_alice_pos.add(pos + 2)
            if pos + 3 <= N:
                new_alice_pos.add(pos + 3)
        
        # Рух Боба
        for pos in bob_pos:
            if pos - 1 >= 1:
                new_bob_pos.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_pos.add(pos - 2)
        
        # Перевіряємо перетин множин
        if new_alice_pos & new_bob_pos:
            return t
        
        # Оновлюємо множини позицій
        alice_pos = new_alice_pos
        bob_pos = new_bob_pos
        
    return -1

# Зчитуємо вхідні дані
N = int(input())

# Викликаємо функцію для знаходження мінімального часу зустрічі
result = meet_in_one_box(N)

# Виводимо результат
print(result)
