#include <iostream>
#include <vector>
using namespace std;

void solve() {
    int N, M;
    cin >> N >> M;
    
    // Максимальна сума, яку можна отримати з перших N марок
    int max_sum = N * (N + 1) / 2;
    
    // Якщо M більше за максимальну можливу суму, вивести 0
    if (M > max_sum) {
        cout << 0 << endl;
        return;
    }
    
    // Вектор для збереження вибраних марок
    vector<int> result;
    
    // Починаємо з найбільшої марки і віднімаємо її від M
    for (int i = N; i >= 1; --i) {
        if (M >= i) {
            result.push_back(i);
            M -= i;
        }
        
        // Якщо сума стала 0, зупиняємося
        if (M == 0) {
            break;
        }
    }
    
    // Якщо залишкова сума M == 0, виводимо номери марок
    if (M == 0) {
        for (int i = 0; i < result.size(); ++i) {
            cout << result[i] << " ";
        }
        cout << endl;
    } else {
        cout << 0 << endl;
    }
}

int main() {
    solve();
    return 0;
}
