#include <iostream>
#include <vector>
using namespace std;

void solve() {
    int N, M;
    cin >> N >> M;
    
    // Максимальна можлива сума
    int max_sum = N * (N + 1) / 2;
    
    // Якщо сума M більша за максимальну можливу суму, вивести 0
    if (M > max_sum) {
        cout << 0 << endl;
        return;
    }
    
    vector<int> result;
    
    // Починаємо з найбільших марок і віднімаємо їх від M
    for (int i = N; i >= 1; --i) {
        if (M >= i) {
            result.push_back(i);
            M -= i;
        }
        // Якщо сума дорівнює нулю, зупиняємося
        if (M == 0) break;
    }
    
    // Якщо сума стала 0, виводимо результат
    if (M == 0) {
        for (int i = 0; i < result.size(); ++i) {
            cout << result[i] << " ";
        }
        cout << endl;
    } else {
        cout << 0 << endl;
    }
}

int main() {
    solve();
    return 0;
}
