import math

def count_ones_in_memory(N, A, B):
    # Функція для обчислення найменшого спільного кратного
    def lcm(x, y):
        return x * y // math.gcd(x, y)
    
    # Кількість чисел, які діляться на A
    count_A = N // A
    # Кількість чисел, які діляться на B
    count_B = N // B
    # Кількість чисел, які діляться на обидва A і B
    lcm_AB = lcm(A, B)
    count_AB = N // lcm_AB
    
    # За принципом включень і виключень
    result = count_A + count_B - count_AB
    return result

# Зчитуємо вхід
N = int(input())  # кількість комірок пам'яті
A, B = map(int, input().split())  # два числа A і B

# Обчислюємо і виводимо результат
print(count_ones_in_memory(N, A, B))
