import math

def count_ones_in_memory(N, A, B):
    def lcm(x, y):
        return x * y // math.gcd(x, y)
    
    count_A = N // A

    count_B = N // B

    lcm_AB = lcm(A, B)
    count_AB = N // lcm_AB
    
    result = count_A + count_B - count_AB
    return result


N = int(input())  
A, B = map(int, input().split()) 


print(count_ones_in_memory(N, A, B))
