def count_squares(N, grid):
    count = 0
    
    # Перебираємо всі можливі початкові точки (i, j)
    for i in range(N):
        for j in range(N):
            # Перебираємо всі можливі розміри квадратів
            for size in range(1, min(N-i, N-j)):
                # Перевіряємо чотири вершини квадрата з верхнім лівим кутом (i, j) і стороною size
                if (grid[i][j] == grid[i+size][j] == grid[i][j+size] == grid[i+size][j+size]):
                    count += 1
                    
    return count

# Читання вхідних даних
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Виклик функції та виведення результату
result = count_squares(N, grid)
print(result)
