def meet_in_one_box(N):
    # Початкові позиції
    alice_pos = {1}  # Аліса починає в боксі 1
    bob_pos = {N}    # Боб починає в боксі N
    
    # Перевіряємо на першій секунді
    if 1 == N:
        return 0
    
    t = 0  # Лічильник секунд
    
    while True:
        t += 1
        
        # Обчислюємо нові позиції для Аліси та Боба
        new_alice_pos = set()
        new_bob_pos = set()
        
        # Рух Аліси: можливі кроки 2 та 3
        for pos in alice_pos:
            if pos + 2 <= N:
                new_alice_pos.add(pos + 2)
            if pos + 3 <= N:
                new_alice_pos.add(pos + 3)
        
        # Рух Боба: можливі кроки -1 та -2
        for pos in bob_pos:
            if pos - 1 >= 1:
                new_bob_pos.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_pos.add(pos - 2)
        
        # Перевіряємо на перетин позицій
        if new_alice_pos & new_bob_pos:
            return t
        
        # Оновлюємо множини позицій
        alice_pos = new_alice_pos
        bob_pos = new_bob_pos
        
        # Якщо вже не можемо рухатись далі, то вони не зустрінуться
        if not alice_pos or not bob_pos:
            break
    
    return -1

# Зчитуємо вхідні дані
N = int(input())

# Викликаємо функцію для знаходження мінімального часу зустрічі
result = meet_in_one_box(N)

# Виводимо результат
print(result)
