type Tmas = array[1..10000] of longint;
procedure read_mas(var A:Tmas; var n:longint);
var i:longword;
begin
    read(n);
    for i := 1 to n do
        read(A[i]);
end;

procedure swap(var X,Y:longint);
var temp:longint;
begin
    temp := X;
    X := Y;
    Y := temp;
end;

procedure quick_sort(var mas: Tmas; low, high: longint);
var i, j, pivot: longint; 
begin 
    i := low; 
    j := high; 
    pivot := mas[(low + high) div 2]; 
    repeat 
        while mas[i] > pivot do 
            inc(i); 
        while mas[j] < pivot do dec(j); 
        if i <= j then 
            begin 
                swap(mas[i], mas[j]); 
                inc(i); 
                dec(j); 
            end; 
        until i > j; 
    if low < j then 
        quick_sort(mas, low, j); 
    if i < high then 
        quick_sort(mas, i, high); 
end;

function elections(var m:Tmas; n:longint):longint;
var i,temp_elect:longint;
begin
    temp_elect := -1;
    if (n > 1) and (m[1] <> m[2]) then
        temp_elect := m[1];
    if (n > 1) and (m[n] <> m[n - 1]) then
        temp_elect := m[n];
    for i := 2 to n - 1 do
        if ((m[i-1] <> m[i]) and (m[i] <> m[i+1])) then
            begin
                temp_elect := m[i];
                break;
            end;
    elections := temp_elect;
end;

var mas:Tmas; n:longint;
begin
    read_mas(mas,n);
    quick_sort(mas,1,n);
    writeln(elections(mas,n));
end.