def min_seconds_to_meet(N):
    if N < 2:
        return -1

    # Розв'язання рівнянь для t
    # t = (N - 1) / 3  (з рівняння 1 + 2 * t = N - t)
    t1 = (N - 1) / 3
    if t1 >= 1 and (1 + 2 * t1 == N - t1 or 1 + 3 * t1 == N - t1):
        return int(t1)
    
    # t = (N - 1) / 5  (з рівняння 1 + 3 * t = N - 2 * t)
    t2 = (N - 1) / 5
    if t2 >= 1 and (1 + 2 * t2 == N - 2 * t2 or 1 + 3 * t2 == N - 2 * t2):
        return int(t2)

    return -1

N = int(input().strip())
print(min_seconds_to_meet(N))