
from collections import defaultdict

def find_president():
    N = int(input().strip())
    numbers = list(map(int, input().split()))
    
    frequency = defaultdict(int)
    
    for num in numbers:
        frequency[num] += 1
    
    min_unique = float('inf')
    for num, count in frequency.items():
        if count == 1:
            min_unique = min(min_unique, num)
    
    if min_unique == float('inf'):
        print(-1)
    else:
        print(min_unique)

find_president()
