def count_colored_squares(N, grid):
    count = 0

    # Перебираємо всі можливі довжини сторони квадрата (від 1 до N-1)
    for side in range(1, N):
        # Перебираємо всі можливі верхні ліві вершини квадрата
        for i in range(N - side):
            for j in range(N - side):
                # Перевіряємо всі вершини квадрата
                is_uniform = True
                color = grid[i][j]
                for x in range(i, i + side + 1):
                    for y in range(j, j + side + 1):
                        if grid[x][y] != color:
                            is_uniform = False
                            break
                    if not is_uniform:
                        break

                if is_uniform:
                    count += 1

    return count

# Зчитування вхідних даних
N = int(input("Введіть розмір квадрата N: "))
grid = [list(map(int, input(f"Рядок {i + 1}: ").split())) for i in range(N)]

# Обчислення і виведення результату
result = count_colored_squares(N, grid)
print(f"Кількість квадратів одного кольору: {result}")