def count_same_color_squares(N, grid):
    count = 0
    
    # Перебір розмірів квадратів
    for size in range(1, N + 1):
        # Перебір верхнього лівого кута квадрата
        for x in range(N - size + 1):
            for y in range(N - size + 1):
                # Визначення координат вершин квадрата
                top_left = grid[x][y]
                top_right = grid[x][y + size - 1]
                bottom_left = grid[x + size - 1][y]
                bottom_right = grid[x + size - 1][y + size - 1]
                
                # Перевірка кольорів вершин
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1
                    
    return count

# Приклад використання
N1 = 4
grid1 = [
    [0, 1, 0, 0],
    [0, 0, 1, 1],
    [1, 0, 0, 0],
    [0, 1, 1, 1]
]
print(count_same_color_squares(N1, grid1))  # Виведе: 1

N2 = 4
grid2 = [
    [0, 1, 0, 0],
    [0, 0, 0, 1],
    [1, 0, 0, 0],
    [0, 1, 1, 1]
]
print(count_same_color_squares(N2, grid2))


