def solve_matching_problem(N, blue_points, red_points):
    # Сортуємо точки обох кольорів за координатами (x, y)
    blue_points.sort()
    red_points.sort()

    # Створюємо пари точок у відповідному порядку
    result = []
    for i in range(N):
        # Індекси точок у вихідних даних (з урахуванням, що індексація починається з 1)
        result.append((blue_points[i][2], red_points[i][2]))

    return result

# Зчитування кількості тестових блоків
t = int(input())
for _ in range(t):
    N = int(input())
    blue_points = []
    red_points = []

    # Зчитування координат синіх точок
    for i in range(N):
        x, y = map(int, input().split())
        blue_points.append((x, y, i + 1))  # Додаємо індекс точки (від 1 до N)

    # Зчитування координат червоних точок
    for i in range(N):
        x, y = map(int, input().split())
        red_points.append((x, y, i + 1))  # Додаємо індекс точки (від 1 до N)

    # Розв'язання задачі
    result = solve_matching_problem(N, blue_points, red_points)

    if result == 0:
        print(0)
    else:
        for pair in result:
            print(pair[0], pair[1])
