def solve(t, test_cases):
    results = []
    
    for case in test_cases:
        N, blue_points, red_points = case
        
        # Сортуємо сині та червоні точки за x, потім за y
        sorted_blues = sorted((x, y, i + 1) for i, (x, y) in enumerate(blue_points))
        sorted_reds = sorted((x, y, i + 1) for i, (x, y) in enumerate(red_points))
        
        # Після сортування з'єднуємо точки в порядку їхнього індексу
        result = []
        for i in range(N):
            blue_idx = sorted_blues[i][2]  # номер синьої точки
            red_idx = sorted_reds[i][2]  # номер червоної точки
            result.append((blue_idx, red_idx))
        
        results.append(result)
    
    # Виведення результатів
    for result in results:
        for pair in result:
            print(pair[0], pair[1])

# Читання вхідних даних
t = int(input())  # кількість блоків тестових даних
test_cases = []

for _ in range(t):
    N = int(input())  # кількість точок одного кольору
    blue_points = [tuple(map(int, input().split())) for _ in range(N)]
    red_points = [tuple(map(int, input().split())) for _ in range(N)]
    test_cases.append((N, blue_points, red_points))

solve(t, test_cases)