from collections import deque

def find_meeting_box(N):
    
    queue_alica = deque([(1, 0)]) 
    queue_bob = deque([(N, 0)])   
    
    
    visited_alica = set([1])       
    visited_bob = set([N])         
    
    while queue_alica and queue_bob:

        pos_a, time_a = queue_alica.popleft()
        if pos_a in visited_bob:  
            return time_a
        
        for next_pos_a in [pos_a + 2, pos_a + 3]:
            if next_pos_a <= N and next_pos_a not in visited_alica:  
                queue_alica.append((next_pos_a, time_a + 1))
                visited_alica.add(next_pos_a)
    
        pos_b, time_b = queue_bob.popleft()
        if pos_b in visited_alica:  
            return time_b
        
        for next_pos_b in [pos_b - 1, pos_b - 2]:
            if next_pos_b > 0 and next_pos_b not in visited_bob:  
                queue_bob.append((next_pos_b, time_b + 1))
                visited_bob.add(next_pos_b)
    return -1  
N = 10  
result = find_meeting_box(N)
if result != -1:
    print("Аліса та Боб можуть опинитися в одному боксі через {result} секунд.")
else:
    print("Аліса та Боб ніколи не опиняться в одному боксі.")