from typing import List, Tuple

def solve_eva_problem(N: int, red_points: List[Tuple[int, int]], blue_points: List[Tuple[int, int]]) -> List[Tuple[Tuple[int, int], Tuple[int, int]]]:
    red_points_sorted = sorted(red_points)
    blue_points_sorted = sorted(blue_points)
    connections = [(red_points_sorted[i], blue_points_sorted[i]) for i in range(N)]
    return connections
N = 4  
red_points = [(1, 5), (3, 2), (6, 8), (7, 1)]  
blue_points = [(2, 3), (4, 7), (5, 6), (8, 4)] 
connections = solve_eva_problem(N, red_points, blue_points)
print("З'єднані пари точок (червона - синя):")
for r, b in connections:
    print(f"Червона точка {r} з'єднана із синьою точкою {b}")
