from itertools import combinations

N = int(input())
points = []
for i in range(N):
  a = list(map(int, input().split()))
  for j in range(N):
            points.append((i, j, a[j]))
            
def square(points):
    dis = []
    for i in range(len(points)):
        for j in range(i + 1, len(points)):
            d = (points[i][0] - points[j][0]) ** 2 + (points[i][1] - points[j][1]) ** 2
            dis.append(d)
    dis.sort()

    return (
        len(dis) == 6 and
        dis[0] == dis[1] == dis[2] == dis[3] and
        dis[4] == dis[5] and
        dis[4] == 2 * dis[0] 
    )

def count(N, points):
    count = 0

    for c in combinations(points, 4):
        p1, p2, p3, p4 = c
        if square([(p1[0], p1[1]), (p2[0], p2[1]), (p3[0], p3[1]), (p4[0], p4[1])]):
            if p1[2] == p2[2] == p3[2] == p4[2]:
                count += 1
    return count

res = count(N, points)
print(res)