#include <bits/stdc++.h>
using namespace std;

struct Dot{
    int x, y, ind;
    void set_Dot (int tx, int ty, int i){
        x = tx; y = ty; ind = i;
    }
};

bool comp(Dot A, Dot B){
    return A.x < B.x;
}

Dot red[2500], blue[2500];
int n;

int check_side(Dot A, Dot B, Dot P){
    long long d = (B.x - A.x)*(P.y - A.y) - (P.x - A.x)*(B.y - A.y);
    
    if (d == 0) return 0;
    if (d > 0) return  1;
    if (d < 0) return -1;
}

bool segm_inters(Dot A, Dot B, Dot C, Dot D){
    int s_1, s_2, s_3, s_4;

    s_1 = check_side(A, B, C);
    s_2 = check_side(A, B, D);
    s_3 = check_side(C, D, A);
    s_4 = check_side(C, D, B);

    return !(s_1 * s_2 == 1 || s_3 * s_4 == 1);
}

void input(){
    cin >> n;
    for (int i = 0, x_i, y_i; i < n; ++i){
        cin >> x_i >> y_i;
        red[i].set_Dot(x_i, y_i, i + 1);
    }
    for (int i = 0, x_i, y_i; i < n; ++i){
        cin >> x_i >> y_i;
        blue[i].set_Dot(x_i, y_i, i + 1);
    }
}

void solve(){
    sort(red, red+n, comp);
    sort(blue, blue+n, comp);

    for (int i = 0; i < 2000; ++i)
        for (int j = 0; j < n-1; ++j)
            if (segm_inters(red[j], blue[j], red[j+1], blue[j+1])){
                if (rand() % 2 == 0)
                    swap(red[j+1], red[j]);
                else
                    swap(blue[j+1], blue[j]);
            }
}

void output(){
    for (int i = 0; i < n; ++i)
        cout << red[i].ind << ' ' << blue[i].ind << '\n';
}

int main() {
    srand(time(NULL));
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int q_test; cin >> q_test;
    for (int test = 0; test < q_test; ++test){
        input();
        solve();
        output();
    }
}
