N = int(input())  # Розмір квадрата
grid = [list(map(int, input().split())) for _ in range(N)]  # Введення квадрата

count = 0

# Перевіряємо всі можливі квадрати
for i in range(N + 1):  # Проходимо по всіх можливих координатах верхнього лівого кута квадрата
    for j in range(N + 1):
        for size in range(1, min(N - i, N - j)):  # Розмір квадрата від 1 до максимально можливого
            # Перевіряємо чи всі чотири вершини квадрата однакові
            if (grid[i][j] == grid[i+size][j] == grid[i][j+size] == grid[i+size][j+size]):
                count += 1

print(count)