def solve(t, test_cases):
    results = []
    
    for case in test_cases:
        N = case[0]
        blue_points = case[1]
        red_points = case[2]
        
        # Пара відповідностей точок
        result = []
        
        for i in range(N):
            result.append((i + 1, i + 1))
        
        results.append(result)
    
    return results

# Ввід вручну
t = int(input("Введіть кількість блоків тестових даних: "))
test_cases = []

for _ in range(t):
    N = int(input("\nВведіть кількість точок одного кольору: "))
    blue_points = []
    red_points = []
    
    print("Введіть координати синіх точок:")
    for _ in range(N):
        x, y = map(int, input().split())
        blue_points.append((x, y))
    
    print("Введіть координати червоних точок:")
    for _ in range(N):
        x, y = map(int, input().split())
        red_points.append((x, y))
    
    test_cases.append((N, blue_points, red_points))

# Розв'язання
results = solve(t, test_cases)

# Вивід результатів
for result in results:
    for pair in result:
        print(pair[0], pair[1])


