from collections import deque

def count(n):
    a = 1
    b = n
    c = 1
    while a < b:
        a += 3
        b -= 2
        c += 1
    return c

def func(n):
    ppa = deque([3, 4])
    ppb = deque([n - 1, n - 2])
    visited_alice = set(ppa)
    visited_bob = set(ppb)

    for i in range(1, count(n)):
        if visited_alice & visited_bob:
            return i

        new_ppa = deque()
        while ppa:
            pos = ppa.popleft()
            if pos + 2 <= n and pos + 2 not in visited_alice:
                new_ppa.append(pos + 2)
                visited_alice.add(pos + 2)
            if pos + 3 <= n and pos + 3 not in visited_alice:
                new_ppa.append(pos + 3)
                visited_alice.add(pos + 3)
        ppa = new_ppa

        new_ppb = deque()
        while ppb:
            pos = ppb.popleft()
            if pos - 1 >= 1 and pos - 1 not in visited_bob:
                new_ppb.append(pos - 1)
                visited_bob.add(pos - 1)
            if pos - 2 >= 1 and pos - 2 not in visited_bob:
                new_ppb.append(pos - 2)
                visited_bob.add(pos - 2)
        ppb = new_ppb

        if not ppa or not ppb:
            break

    return -1

n = int(input())
print(func(n))
