import multiprocessing as mp

def count(n):
    a = 1
    b = n
    c = 1
    while a < b:
        a += 3
        b -= 2
        c += 1
    return c

def update_positions(positions, delta1, delta2, n):
    new_positions = set()
    for pos in positions:
        if pos + delta1 <= n:
            new_positions.add(pos + delta1)
        if pos + delta2 <= n:
            new_positions.add(pos + delta2)
    return new_positions

def func(n):
    ppa = set([3, 4])
    ppb = set([n - 1, n - 2])
    pool = mp.Pool(processes=2)  # Створюємо пул процесів

    for i in range(1, count(n)):
        if ppa & ppb:
            pool.close()
            pool.join()
            return i

        ppa = pool.apply_async(update_positions, args=(ppa, 2, 3, n)).get()
        ppb = pool.apply_async(update_positions, args=(ppb, -1, -2, n)).get()

    pool.close()
    pool.join()
    return -1

n = int(input())
print(func(n))
