n = int(input())
nums = list(map(int, input().split()))

def find_president(N, nums):
    from collections import Counter

    count = Counter(nums)
    unique_minimum = float('inf')
    president_number = -1

    for number in nums:
        if count[number] == 1 and number < unique_minimum:
            unique_minimum = number
            president_number = number

    if unique_minimum == float('inf'):
        return -1
    else:
        return president_number


president = find_president(n, nums)
print(president)
