def solve_case(N, blue_points, red_points):
    # Відсортовуємо сині та червоні точки за x-координатою
    blue_sorted = sorted(enumerate(blue_points, start=1), key=lambda x: x[1][0])
    red_sorted = sorted(enumerate(red_points, start=1), key=lambda x: x[1][0])
    
    # З'єднуємо точки за індексами після сортування
    result = []
    for i in range(N):
        result.append((blue_sorted[i][0], red_sorted[i][0]))
    
    return result

def main():
    t = int(input())  # Кількість тестових блоків
    for _ in range(t):
        N = int(input())  # Кількість точок одного кольору
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().split())) for _ in range(N)]
        
        result = solve_case(N, blue_points, red_points)
        
        for pair in result:
            print(pair[0], pair[1])

if __name__ == "__main__":
    main()
