n = int(input())
arr = []

for _ in range(n):
    row = list(map(int, input().split()))
    arr.append(row)

points_map = {}

for i in range(n):
    for j in range(n):
        value = arr[i][j]
        if value not in points_map:
            points_map[value] = []
        points_map[value].append((i, j))

def find_other_points(x1, y1, x2, y2):
    mx = (x1 + x2) / 2
    my = (y1 + y2) / 2
    dx = (x2 - x1) / 2
    dy = (y2 - y1) / 2
    
    x3 = mx + dy
    y3 = my - dx
    x4 = mx - dy
    y4 = my + dx
    
    if all(isinstance(v, float) and v.is_integer() for v in [x3, x4, y3, y4]):
        x3, y3, x4, y4 = int(x3), int(y3), int(x4), int(y4)
        
        if 0 <= x3 < n and 0 <= y3 < n and 0 <= x4 < n and 0 <= y4 < n:
            return x3, y3, x4, y4
    return None

squares = 0

for value, points in points_map.items():
    for i in range(len(points)):
        x1, y1 = points[i]
        for j in range(i + 1, len(points)):
            x2, y2 = points[j]
            result = find_other_points(x1, y1, x2, y2)
            
            if result:
                x3, y3, x4, y4 = result
                if arr[x3][y3] == arr[x4][y4] == arr[x1][y1] == arr[x2][y2]:
                    squares += 1

print(squares)
