#include <iostream>
using namespace std;

long long findMeetingTime(long long N) {
    long long alice = 1;  // Позиція Аліси
    long long bob = N;    // Позиція Боба
    long long time = 0;

    while (alice < bob) {
        ++time;

        // Аліса може переміститися на +2 або +3
        alice += 2;

        // Боб може переміститися на -1 або -2
        bob -= 1;

        // Перевірка можливості зустрічі
        if (alice >= bob) return time;
    }

    return -1;  // Якщо зустріч неможлива
}

int main() {
    long long N;
    cin >> N;

    cout << findMeetingTime(N) << endl;

    return 0;
}
