#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main() {
    long long N, M;
    cin >> N >> M;

    vector<int> stamps;
    for (int i = N; i >= 1; --i) {
        stamps.push_back(i); 
    }

    vector<int> result;
    long long currentSum = 0;

    for (int stamp : stamps) {
        if (currentSum + stamp <= M) {
            result.push_back(stamp);
            currentSum += stamp;
            if (currentSum == M) break;
        }
    }

    if (currentSum != M) {
        cout << 0 << endl; 
    } else {
        for (int r : result) {
            cout << r << " "; 
        }
        cout << endl;
    }

    return 0;
}
