\#include <iostream>
#include <unordered_map>
#include <vector>
#include <limits>
using namespace std;

int main() {
    long long N;
    cin >> N;

    vector<long long> numbers(N);
    unordered_map<long long, int> frequency;

    // Зчитуємо числа та рахуємо частоту кожного
    for (int i = 0; i < N; ++i) {
        cin >> numbers[i];
        frequency[numbers[i]]++;
    }

    long long minUnique = numeric_limits<long long>::max(); // Мінімальне унікальне число
    int presidentIndex = -1; // Індекс робота-президента

    // Пошук унікального мінімального числа
    for (int i = 0; i < N; ++i) {
        if (frequency[numbers[i]] == 1 && numbers[i] < minUnique) {
            minUnique = numbers[i];
            presidentIndex = i + 1; // Зберігаємо номер робота
        }
    }

    // Вивід результату
    if (presidentIndex == -1) {
        cout << 0 << endl; // Вибори не відбулися
    } else {
        cout << presidentIndex << endl; // Номер робота-президента
    }

    return 0;
}
