def count_colored_squares(N, grid):
    count = 0
    
    for size in range(1, N):
        for i in range(N - size):
            for j in range(N - size):
                if grid[i][j] == grid[i][j + size] == grid[i + size][j] == grid[i + size][j + size]:
                    count += 1
    
    return count

# Приклад введення
N1 = 4
grid1 = [
    [0, 1, 0, 0],
    [0, 0, 1, 1],
    [1, 0, 0, 0],
    [0, 1, 1, 1]
]
print(count_colored_squares(N1, grid1))  # Виведе: 1

N2 = 4
grid2 = [
    [0, 1, 0, 0],
    [0, 0, 0, 1],
    [1, 0, 0, 0],
    [0, 1, 1, 1]
]
print(count_colored_squares(N2, grid2))  # Виведе: 2
