import java.util.*; 

public class Main6 {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);

        int N = sc.nextInt();
        long[] numbers = new long[N];

        for (int i = 0; i < N; i++) {
            numbers[i] = sc.nextLong();
        }

        Map<Long, Integer> frequencyMap = new HashMap<>();
        long minNumber = Long.MAX_VALUE;
        int minIndex = -1;

        for (int i = 0; i < N; i++) {
            long num = numbers[i];
            frequencyMap.put(num, frequencyMap.getOrDefault(num, 0) + 1);
        }

        for (int i = 0; i < N; i++) {
            long num = numbers[i];
            if (num < minNumber && frequencyMap.get(num) == 1) {
                minNumber = num;
                minIndex = i;
            }
        }

        // Виводимо результат
        if (minIndex != -1) {
            System.out.println(minIndex);
        } else {
            System.out.println("NO");
        }

        sc.close();
    }
}
