import java.util.*;

public class RobotPresident {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);

        int n = sc.nextInt();

        int[] numbers = new int[n];

        for (int i = 0; i < n; i++) {
            numbers[i] = sc.nextInt();
        }

        Map<Integer, Integer> countMap = new HashMap<>();

        for (int num : numbers) {
            countMap.put(num, countMap.getOrDefault(num, 0) + 1);
        }

        int min = Integer.MAX_VALUE;
        for (int num : numbers) {
            if (countMap.get(num) == 1 && num < min) {
                min = num;
            }
        }

        sc.close();

        System.out.println(min == Integer.MAX_VALUE ? -1 : min);
    }
}
