import java.util.*;

public class RobotPresident {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);

        int n = sc.nextInt();

        Map<Integer, Integer> countMap = new HashMap<>();

        for (int i = 0; i < n; i++) {
            int num = sc.nextInt();
            countMap.put(num, countMap.getOrDefault(num, 0) + 1);
        }

        int min = Integer.MAX_VALUE;
        for (Map.Entry<Integer, Integer> entry : countMap.entrySet()) {
            if (entry.getValue() == 1 && entry.getKey() < min) {
                min = entry.getKey();
            }
        }

        sc.close();

        System.out.println(min == Integer.MAX_VALUE ? -1 : min);
    }
}
