import java.util.HashMap;
import java.util.Scanner;

public class UniqueMinimum {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int N = scanner.nextInt();

        int[] numbers = new int[N];
        HashMap<Integer, Integer> frequency = new HashMap<>();

        for (int i = 0; i < N; i++) {
            numbers[i] = scanner.nextInt();
            frequency.put(numbers[i], frequency.getOrDefault(numbers[i], 0) + 1);
        }

        int uniqueMin = Integer.MAX_VALUE;
        boolean found = false;

        for (Integer number : frequency.keySet()) {
            if (frequency.get(number) == 1) {
                uniqueMin = Math.min(uniqueMin, number);
                found = true;
            }
        }

        if (found) {
            System.out.println(uniqueMin);
        } else {
            System.out.println(-1);
        }
    }
}