import java.util.Scanner;

public class Main {

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);

        int N = sc.nextInt();

        int[] numbers = new int[N];

        int[] frequency = new int[1000001]; // Маємо на увазі обмеження на числа (максимум 1000000)

        for (int i = 0; i < N; ++i) {
            numbers[i] = sc.nextInt();
            frequency[numbers[i]]++;
        }

        int uniqueMin = Integer.MAX_VALUE;
        boolean found = false;

        for (int num : numbers) {
            if (frequency[num] == 1) {
                uniqueMin = Math.min(uniqueMin, num);
                found = true;
            }
        }

        if (found) {
            System.out.println(uniqueMin);
        } else {
            System.out.println(-1);
        }

        sc.close();
    }
}
