import java.util.Scanner;
import java.util.HashMap;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);

        int N = sc.nextInt();
        HashMap<Integer, Integer> freq = new HashMap<>();

        for (int i = 0; i < N; i++) {
            int num = sc.nextInt();
            freq.put(num, freq.getOrDefault(num, 0) + 1);
        }

        int uniqueMin = Integer.MAX_VALUE;
        for (int num : freq.keySet()) {
            if (freq.get(num) == 1) {
                uniqueMin = Math.min(uniqueMin, num);
            }
        }

        System.out.println(uniqueMin == Integer.MAX_VALUE ? -1 : uniqueMin);
        sc.close();
    }
}
