import java.util.*;

public class Main8 {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);

        int t = sc.nextInt();

        for (int test = 0; test < t; test++) {
            int n = sc.nextInt();

            Point[] blue = new Point[n];
            for (int i = 0; i < n; i++) {
                int x = sc.nextInt();
                int y = sc.nextInt();
                blue[i] = new Point(x, y, i + 1);
            }

            Point[] red = new Point[n];
            for (int i = 0; i < n; i++) {
                int x = sc.nextInt();
                int y = sc.nextInt();
                red[i] = new Point(x, y, i + 1);
            }

            Arrays.sort(blue, Comparator.comparingInt(p -> p.x));
            Arrays.sort(red, Comparator.comparingInt(p -> p.x));

            StringBuilder result = new StringBuilder();
            for (int i = 0; i < n; i++) {
                result.append(blue[i].index).append(" ").append(red[i].index).append("\n");
            }

            sc.close();

            System.out.print(result);
        }
    }

    static class Point {
        int x, y, index;

        Point(int x, int y, int index) {
            this.x = x;
            this.y = y;
            this.index = index;
        }
    }
}
