#include <iostream>
#include <unordered_map>
using namespace std;

int main() {
    int N;
    cin >> N;

    unordered_map<int, int> freq;
    int num;

    for (int i = 0; i < N; ++i) {
        cin >> num;
        freq[num]++;
    }

    int min_num = -1;

    for (auto& p : freq) {
        if (p.second == 1) {
            if (min_num == -1 || p.first < min_num) {
                min_num = p.first;
            }
        }
    }

    cout << min_num << endl;

    return 0;
}
