#include <iostream>
#include <vector>

using namespace std;

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));

    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int result = 0;

    for (int size = 1; size < N; ++size) {
        for (int i = 0; i + size < N; i++) {
            for (int j = 0; j + size < N; j++) {
                if (grid[i][j] == grid[i][j + size] &&
                    grid[i][j] == grid[i + size][j] &&
                    grid[i][j] == grid[i + size][j + size]) {
                    ++result;
                }
            }
        }
    }

    cout << result << endl;

    return 0;
}