#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N;
    cin >> N;
    
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            cin >> grid[i][j];
        }
    }
    
    int count = 0;

    for (int size = 1; size < N; size++) {
        for (int i = 0; i < N - size; i++) {
            for (int j = 0; j < N - size; j++) {
                int x1 = i, y1 = j;
                int x2 = i + size, y2 = j;
                int x3 = i, y3 = j + size;
                int x4 = i + size, y4 = j + size;
                
                if (grid[x1][y1] == grid[x2][y2] && grid[x1][y1] == grid[x3][y3] && grid[x1][y1] == grid[x4][y4]) {
                    count++;
                }
            }
        }
    }

    cout << count << endl;
    return 0;
}
