#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

bool compare_x(const pair<int, int>& a, const pair<int, int>& b) {
    return a.first < b.first;
}

int main() {
    int t;
    cin >> t;
    
    while (t--) {
        int N;
        cin >> N;
        
        vector<pair<int, int>> blue(N), red(N);
        
        for (int i = 0; i < N; ++i) {
            cin >> blue[i].first >> blue[i].second;
            blue[i].first = i + 1;
        }
        
        for (int i = 0; i < N; ++i) {
            cin >> red[i].first >> red[i].second;
            red[i].first = i + 1;
        }
        
        sort(blue.begin(), blue.end(), [](const pair<int, int>& a, const pair<int, int>& b) {
            return a.second < b.second;
        });
        
        sort(red.begin(), red.end(), [](const pair<int, int>& a, const pair<int, int>& b) {
            return a.second < b.second;
        });
        
        for (int i = 0; i < N; ++i) {
            cout << blue[i].first << " " << red[i].first << endl;
        }
    }
    
    return 0;
}
