#include <iostream>
#include <algorithm>
using namespace std;

long long solve(long long n) {
    long long minimalTime = -1;

    // Проверка для остатка от деления на 3
    if ((n - 1) % 3 == 0) {
        long long t = (n - 1) / 3;
        long long alicePos = 1 + 2 * t;
        long long bobPos = n - t;
        if (t >= 0 && alicePos <= n && alicePos >= 1 && alicePos == bobPos) {
            minimalTime = (minimalTime == -1) ? t : min(minimalTime, t);
        }
    }

    // Проверка для остатка от деления на 4
    if ((n - 1) % 4 == 0) {
        long long t = (n - 1) / 4;
        long long alicePos = 1 + 2 * t;
        long long bobPos = n - 2 * t;
        if (t >= 0 && alicePos <= n && alicePos >= 1 && alicePos == bobPos) {
            minimalTime = (minimalTime == -1) ? t : min(minimalTime, t);
        }
    }

    // Проверка для остатка от деления на 5
    if ((n - 1) % 5 == 0) {
        long long t = (n - 1) / 5;
        long long alicePos = 1 + 3 * t;
        long long bobPos = n - 2 * t;
        if (t >= 0 && alicePos <= n && alicePos >= 1 && alicePos == bobPos) {
            minimalTime = (minimalTime == -1) ? t : min(minimalTime, t);
        }
    }

    return minimalTime;
}

int main() {
    long long n;
    cin >> n;
    cout << solve(n) << endl;
    return 0;
}
