#include <iostream>
#include <vector>
using namespace std;

int countSquaresWithSameColor(int N, const vector<vector<int>>& grid) {
    int count = 0;

    for (int size = 2; size <= N; ++size) {
        for (int i = 0; i <= N - size; ++i) {
            for (int j = 0; j <= N - size; ++j) {
                int color = grid[i][j];
                bool isSquare = true;
                for (int x = 0; x < size && isSquare; ++x) {
                    for (int y = 0; y < size && isSquare; ++y) {
                        if (grid[i + x][j + y] != color) {
                            isSquare = false;
                        }
                    }
                }
                if (isSquare) {
                    ++count;
                }
            }
        }
    }
    return count;
}

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int result = countSquaresWithSameColor
