#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct Point {
    int x, y, index;
    bool isBlue;
};

bool compare(const Point& p1, const Point& p2) {
    return p1.x < p2.x || (p1.x == p2.x && p1.y < p2.y);
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<Point> blue(N), red(N);

        for (int i = 0; i < N; ++i) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1;
            blue[i].isBlue = true;
        }

        for (int i = 0; i < N; ++i) {
            cin >> red[i].x >> red[i].y;
            red[i].index = i + 1;
            red[i].isBlue = false;
        }

        sort(blue.begin(), blue.end(), compare);
        sort(red.begin(), red.end(), compare);

        bool canSolve = true;

        for (int i = 0; i < N; ++i) {
            cout << blue[i].index << " " << red[i].index << endl;
        }
    }

    return 0;
}
