from itertools import combinations

def find_minimal_stamps(N, M):
    # Перебір розмірів підмножин від 1 до N
    for r in range(1, N + 1):
        for subset in combinations(range(1, N + 1), r):
            if sum(subset) == M:
                return subset
    return [0]  # Якщо розв'язку немає

# Вхідні дані
N = int(input())
M = int(input())

# Пошук рішення
result = find_minimal_stamps(N, M)

# Вивід результату
if result == [0]:
    print(0)
else:
    print("\n".join(map(str, result)))
