n = int(input())
m = int(input())

# Check if the sum of the first n natural numbers is less than m
if n * (n + 1) // 2 < m:
    print(0)
else:
    results = []
    remaining_sum = m

    # Iterate from n to 1 and subtract from remaining_sum
    for current_num in range(n, 0, -1):
        if remaining_sum >= current_num:
            results.append(current_num)
            remaining_sum -= current_num

    if results:
        # Convert each integer in results to string and join with newlines
        print("\n".join(map(str, results)))
    else:
        print(0)
