n = int(input())
m = int(input())

# The sum of the first n natural numbers is n*(n+1)//2
total_sum = n * (n + 1) // 2

# If the total sum is less than m, it's impossible to achieve the sum
if total_sum < m:
    print(0)
else:
    results = []
    remaining_sum = m

    # Start from n and try to subtract numbers as large as possible
    for current_num in range(n, 0, -1):
        if remaining_sum >= current_num:
            results.append(current_num)
            remaining_sum -= current_num

        if remaining_sum == 0:
            break

    # If we managed to match the sum, print the results
    if results:
        print("\n".join(map(str, results)))
    else:
        print(0)
