n = int(input())
m = int(input())

# The sum of the first n natural numbers
total_sum = n * (n + 1) // 2

# If total sum is less than m, it's impossible to achieve the sum
if total_sum < m:
    print(0)
else:
    results = []
    remaining_sum = m

    # Start from n and try to subtract numbers as large as possible
    for current_num in range(n, 0, -1):
        if remaining_sum >= current_num:
            results.append(current_num)
            remaining_sum -= current_num

        if remaining_sum == 0:
            break

    # Print results if the sum is matched
    print("\n".join(map(str, results)) if results else 0)
