#include <iostream>
#include <unordered_map>
#include <vector>
#include <climits>
using namespace std;

int main() {
    int N;
    cin >> N;
    
    vector<int> numbers(N);
    unordered_map<int, int> freq;
    
    // Зчитуємо числа та рахуємо їх частоти
    for (int i = 0; i < N; ++i) {
        cin >> numbers[i];
        freq[numbers[i]]++;
    }
    
    int min_unique = INT_MAX;  // Змінна для збереження мінімального унікального числа
    
    // Шукаємо найменше унікальне число
    for (int num : numbers) {
        if (freq[num] == 1 && num < min_unique) {
            min_unique = num;
        }
    }
    
    // Якщо таке число знайдено, виводимо його, якщо ні — виводимо -1
    if (min_unique == INT_MAX) {
        cout << -1 << endl;
    } else {
        cout << min_unique << endl;
    }
    
    return 0;
}