#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int t;
    cin >> t;
    
    while (t--) {
        int N;
        cin >> N;
        
        vector<pair<int, int>> blue_points(N);
        vector<pair<int, int>> red_points(N);
        
        for (int i = 0; i < N; ++i) {
            cin >> blue_points[i].first >> blue_points[i].second;
        }
        
        for (int i = 0; i < N; ++i) {
            cin >> red_points[i].first >> red_points[i].second;
        }
        
        // Сортуємо за координатами
        vector<pair<pair<int, int>, int>> blue_sorted(N);
        vector<pair<pair<int, int>, int>> red_sorted(N);
        
        for (int i = 0; i < N; ++i) {
            blue_sorted[i] = {blue_points[i], i + 1};
            red_sorted[i] = {red_points[i], i + 1};
        }
        
        sort(blue_sorted.begin(), blue_sorted.end());
        sort(red_sorted.begin(), red_sorted.end());
        
        // Виводимо пари
        for (int i = 0; i < N; ++i) {
            cout << blue_sorted[i].second << " " << red_sorted[i].second << endl;
        }
    }
    
    return 0;
}