#include <iostream>
#include <vector>
using namespace std;

int count(const vector<vector<int>>& grid, int N) {
    int squares = 0;

    for (int size = 1; size < N; size++) { 
        for (int i = 0; i + size < N; i++) {
            for (int j = 0; j + size < N; j++) {
                if (grid[i][j] == grid[i][j + size] &&
                    grid[i][j] == grid[i + size][j] &&
                    grid[i][j] == grid[i + size][j + size]) {
                    squares++;
                }
            }
        }
    }
    return squares;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int N;
    cin >> N;
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            cin >> grid[i][j];
        }
    }

    cout << count(grid, N) + 1<< endl;

    return 0;
}
