import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int N = scanner.nextInt();

        int[] divisors = {3, 4, 2, 5};

        int minTime = Integer.MAX_VALUE;

        for (int divisor : divisors) {
            if ((N - 1) % divisor == 0) {
                int t = (N - 1) / divisor;
                if (t >= 0) {
                    minTime = Math.min(minTime, t);
                }
            }
        }

        System.out.println(minTime == Integer.MAX_VALUE ? -1 : minTime);
    }
}
