import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        long N = sc.nextLong();
        long M = sc.nextLong();

        long sum = N * (N + 1) / 2;

        if (M > sum) {
            System.out.println(0);
            return;
        }

        long currentSum = 0;
        StringBuilder result = new StringBuilder();

        for (long i = N; i >= 1; i--) {
            if (currentSum + i <= M) {
                result.append(i).append("\n");
                currentSum += i;
            }
            if (currentSum == M) {
                break;
            }
        }

        if (currentSum == M) {
            System.out.println(result.toString().trim());
        } else {
            System.out.println(0);
        }
    }
}
