import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int N = scanner.nextInt();
        int[] numbers = new int[N];

        for (int i = 0; i < N; i++) {
            numbers[i] = scanner.nextInt();
        }

        Map<Integer, Integer> countMap = new HashMap<>();

        for (int num : numbers) {
            countMap.put(num, countMap.getOrDefault(num, 0) + 1);
        }

        int minNumber = Integer.MAX_VALUE;

        for (int num : numbers) {
            if (countMap.get(num) == 1 && num < minNumber) {
                minNumber = num;
            }
        }

        if (minNumber == Integer.MAX_VALUE) {
            System.out.println(-1);
        } else {
            System.out.println(minNumber);
        }

        scanner.close();
    }
}
