import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;

public class Main {
    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));

        int N = Integer.parseInt(reader.readLine());
        int[][] grid = new int[N][N];

        for (int i = 0; i < N; i++) {
            String[] line = reader.readLine().split(" ");
            for (int j = 0; j < N; j++) {
                grid[i][j] = Integer.parseInt(line[j]);
            }
        }

        int count = 0;

        for (int size = 1; size < N; size++) {
            for (int i = 0; i + size < N; i++) {
                for (int j = 0; j + size < N; j++) {
                    int topLeft = grid[i][j];
                    int topRight = grid[i][j + size];
                    int bottomLeft = grid[i + size][j];
                    int bottomRight = grid[i + size][j + size];

                    if (topLeft == topRight && topRight == bottomLeft && bottomLeft == bottomRight) {
                        count++;
                    }
                }
            }
        }

        System.out.println(count);
    }
}
