def min_seconds_to_meet(N):
    if 2 <= N <= 1000000000:
        alice_positions = {1}
        bob_positions = {N}
        seconds = 0
        
        while alice_positions and bob_positions:
            if alice_positions & bob_positions:
                return seconds
            
            alice_positions = {pos + 2 for pos in alice_positions if pos + 2 <= N} | {pos + 3 for pos in alice_positions if pos + 3 <= N}
            bob_positions = {pos - 1 for pos in bob_positions if pos - 1 >= 1} | {pos - 2 for pos in bob_positions if pos - 2 >= 1}
            seconds += 1
        
        return -1

N = int(input())
print(min_seconds_to_meet(N))
