import sys

def read_input():
    input = sys.stdin.read
    data = input().split()
    
    index = 0
    t = int(data[index])
    index += 1
    
    test_cases = []
    for _ in range(t):
        N = int(data[index])
        index += 1
        
        blue_points = []
        for _ in range(N):
            x = int(data[index])
            y = int(data[index + 1])
            blue_points.append((x, y))
            index += 2
        
        red_points = []
        for _ in range(N):
            x = int(data[index])
            y = int(data[index + 1])
            red_points.append((x, y))
            index += 2
        
        test_cases.append((N, blue_points, red_points))
    
    return test_cases

def solve_case(N, blue_points, red_points):
    pairs = []
    
    # Сортуємо точки за їх координатами
    blue_points.sort()
    red_points.sort()
    
    for i in range(N):
        pairs.append((blue_points[i], red_points[i]))
    
    # Перевіряємо, чи перетинаються відрізки
    for i in range(N):
        for j in range(i + 1, N):
            if intersect(pairs[i], pairs[j]):
                return 0
    
    result = []
    for i in range(N):
        blue_index = blue_points.index(pairs[i][0]) + 1
        red_index = red_points.index(pairs[i][1]) + 1
        result.append(f"{blue_index} {red_index}")
    
    return result

def intersect(pair1, pair2):
    # Тут можна реалізувати перевірку на перетин двох відрізків
    pass

def main():
    test_cases = read_input()
    results = []
    
    for N, blue_points, red_points in test_cases:
        result = solve_case(N, blue_points, red_points)
        if result == 0:
            results.append("0")
        else:
            results.extend(result)
            results.append("")
    
    for result in results:
        print(result)

if __name__ == "__main__":
    main()
