#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main() {
    int t;
    cin >> t;
    
    while (t--) {
        int N;
        cin >> N;
        
        vector<tuple<int, int, int>> blue_points, red_points;
        
        for (int i = 0; i < N; ++i) {
            int x, y;
            cin >> x >> y;
            blue_points.push_back(make_tuple(x, y, i + 1));
        }
        
        for (int i = 0; i < N; ++i) {
            int x, y;
            cin >> x >> y;
            red_points.push_back(make_tuple(x, y, i + 1));
        }
        
        sort(blue_points.begin(), blue_points.end());
        sort(red_points.begin(), red_points.end());
        
        for (int i = 0; i < N; ++i) {
            cout << get<2>(blue_points[i]) << " " << get<2>(red_points[i]) << endl;
        }
    }
    
    return 0;
}
