from collections import deque

def solve(N):
    alice_positions = {1}
    bob_positions = {N}
    
    time = 0
    while alice_positions and bob_positions:
        time += 1
        new_alice_positions = set()
        new_bob_positions = set()
        
        for pos in alice_positions:
            if pos + 2 <= N:
                new_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                new_alice_positions.add(pos + 3)
        
        for pos in bob_positions:
            if pos - 1 >= 1:
                new_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_positions.add(pos - 2)
        
        if new_alice_positions & new_bob_positions:
            return time
        
        alice_positions = new_alice_positions
        bob_positions = new_bob_positions
    
    return -1

N = int(input())
print(solve(N))
