def find_stamps(N, M):
    # Максимальна сума, яку можна отримати, використовуючи всі марки від 1 до N
    max_sum = N * (N + 1) // 2
    
    # Якщо M більша за максимальну суму, неможливо вибрати марки
    if M > max_sum:
        return [0]
    
    result = []
    # Починаємо з найбільших марок і йдемо вниз
    for i in range(N, 0, -1):
        if M >= i:
            result.append(i)
            M -= i
        if M == 0:
            break
    
    # Якщо ми не змогли досягти точної суми, виводимо 0
    if M != 0:
        return [0]
    
    return result

# Зчитування даних
N = int(input())  # Кількість марок
M = int(input())  # Загальна вартість

# Знаходимо марки, які потрібно продати
result = find_stamps(N, M)

# Виводимо результат
print(" ".join(map(str, result)))
