import random

def find_stamps(N, M):
    result = []
    
    # Починаємо з найбільших марок (від N) і пробуємо досягти суми M
    for i in range(N, 0, -1):
        if M >= i:
            result.append(i)
            M -= i
        
        if M == 0:
            break
    
    # Якщо сума M стала рівною 0, то ми знайшли відповідні марки
    if M == 0:
        return result
    
    # Якщо сума M не дорівнює 0, то такого вибору не існує
    return [0]

def randomize_answer(stamps):
    # Якщо відповідь не нульова, додаємо випадковість
    if stamps != [0]:
        random.shuffle(stamps)
    return stamps

# Зчитуємо вхід
N = int(input())  # Кількість марок
M = int(input())  # Загальна сума, яку хоче витратити Боб

# Знаходимо марки, які потрібно продати
result = find_stamps(N, M)

# Додаємо випадковість у відповідь
result = randomize_answer(result)

# Виводимо результат
print(" ".join(map(str, result)))
