import random

def solve():
    N = int(input()) 
    grid = [list(map(int, input().split())) for _ in range(N)] 
    squares = [] 

    for i1 in range(N):
        for j1 in range(N):
            if grid[i1][j1] == 1:
                for i2 in range(i1 + 1, N):
                    for j2 in range(j1 + 1, N):
                        if grid[i2][j2] == 1:
                            if grid[i1][j2] == 1 and grid[i2][j1] == 1:
                               
                                squares.append([(i1, j1), (i2, j2), (i1, j2), (i2, j1)])

    if squares:
        square = random.choice(squares)
        for (i, j) in square:
            print(i + 1, j + 1)
    else:
        print(0)

solve()
