#include <algorithm>
#include <chrono>
#include <random>
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"

struct point {
  ll x;
  ll y;
  ll ind;
};

mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());

int main() {
  ios_base::sync_with_stdio();
  cin.tie(0);
  cout.tie(0);
  ll n, t, a, b, c, d, e, f, g;
  cin >> t;
  while (t--) {
    cin >> n;
    vector<point> red;
    vector<point> blue;
    vector<pair<ll, ll>> ans;
    for (ll i = 0; i < n; i++) {
      cin >> a >> b;
      blue.push_back({a, b, i + 1});
    }
    for (ll i = 0; i < n; i++) {
      cin >> a >> b;
      red.push_back({a, b, i + 1});
    }
    /*sort(all(blue), [](const point &first, const point &second) {
      if (first.x != second.x) {
        return first.x < second.x;
      }
      return first.y < second.y;
    });*/
    /*sort(all(red), [](const point &first, const point &second) {
      if (first.x != second.x) {
        return first.x < second.x;
      }
      return first.y < second.y;
    });*/
    shuffle(all(blue), gen);
    shuffle(all(red), gen);
    for (ll i = 0; i < n; i++) {
      ans.push_back({blue[i].ind, red[i].ind});
    }
    for (auto i : ans) {
      cout << i.first << " " << i.second << nl;
    }
  }
}
