#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"

struct point {
  ll x;
  ll y;
  ll ind;
  bool red;
};

ll dist(point first, point second) {
  return (first.x - second.x) * (first.x - second.x) +
         (first.y - second.y) * (first.y - second.y);
}

ll ori(point first, point second, point third) {
  ll s = first.x * (second.y - third.y) + second.x * (third.y - first.y) +
         third.x * (third.y - first.y);
  if (s == 0) {
    return 0;
  } else if (s < 0) {
    return -1;
  } else {
    return 1;
  }
}

int main() {
  ios_base::sync_with_stdio();
  cin.tie(0);
  cout.tie(0);
  ll n, t, a, b, c, d, e, f, g;
  cin >> t;
  while (t--) {
    cin >> n;
    vector<point> red;
    vector<point> blue;
    vector<pair<ll, ll>> ans;
    for (ll i = 0; i < n; i++) {
      cin >> a >> b;
      blue.push_back({a, b, i + 1});
    }
    for (ll i = 0; i < n; i++) {
      cin >> a >> b;
      red.push_back({a, b, i + 1});
    }
    sort(all(blue), [](const point &first, const point &second) {
      if (first.x != second.x) {
        return first.x < second.x;
      }
      return first.y < second.y;
    });
    sort(all(red), [](const point &first, const point &second) {
      if (first.x != second.x) {
        return first.x < second.x;
      }
      return first.y < second.y;
    });
    if (red.size() == 0) {
      return 0;
    }
    point pt = red.front();
    sort(all(red), [pt](const point &first, const point &second) {
      return ori(pt, first, second) <= 0;
    });
    for (ll i = 0; i < n; i++) {
      ans.push_back({blue[i].ind, red[i].ind});
    }
    for (auto i : ans) {
      cout << i.first << " " << i.second << nl;
    }
  }
}
