def min_seconds_to_meet(N):
    if N % 2 != 0:
        return -1  
    

    alice_positions = {1}
    bob_positions = {N}
    t = 0
    
    while True:
        if alice_positions & bob_positions:
            return t
        
        t += 1
        next_alice_positions = set()
        next_bob_positions = set()
        
        for pos in alice_positions:
            if pos + 2 <= N:
                next_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                next_alice_positions.add(pos + 3)
        
        for pos in bob_positions:
            if pos - 1 >= 1:
                next_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                next_bob_positions.add(pos - 2)
        
        alice_positions = next_alice_positions
        bob_positions = next_bob_positions

N = int(input())
print(min_seconds_to_meet(N))
