def min_teleportation_time(N):
    # Перевірка для дуже маленьких значень
    if N == 2:
        return 1
    
    # Перевіряємо зменшення та збільшення на кожній секунді
    # Початкові позиції
    alice = 1
    bob = N
    time = 0
    
    # Поки Аліса не зустріне Боба
    while alice < bob:
        time += 1
        alice += 2  # Аліса може рухатись на 2 клітинки
        bob -= 2    # Боб може рухатись на 2 клітинки назад
        
        # Якщо вони вже зустрілися
        if alice == bob:
            return time
        if alice + 1 == bob or alice == bob + 1:
            return time + 1
    
    # Якщо неможливо зустрітися
    return -1

# Вхідні дані
N = int(input().strip())

# Вивести результат
print(min_teleportation_time(N))
