def min_teleportation_time(N):
    # Початкові позиції
    a_pos = 1  # Позиція Аліси
    b_pos = N  # Позиція Боба
    
    # Ми будемо перевіряти, за скільки секунд Аліса та Боб можуть зустрітись
    time = 0
    while a_pos <= b_pos:
        # Якщо Аліса і Боб на одній позиції, повертаємо час
        if a_pos == b_pos:
            return time
        # Аліса може рухатись на +2 або +3
        if (a_pos + 2) <= N:
            a_pos += 2
        else:
            a_pos += 3
        # Боб може рухатись на -1 або -2
        if (b_pos - 2) >= 1:
            b_pos -= 2
        else:
            b_pos -= 1
        time += 1
        
    return -1

# Вхідні дані
N = int(input().strip())

# Вивести результат
print(min_teleportation_time(N))
