def teleport(N):
    # Якщо N дуже маленьке, це тривіальний випадок
    if N == 2:
        return 1  # Аліса і Боб зустрічаються в одному боксі одразу
    
    # Стартові позиції для Аліси і Боба
    alice_pos = 1
    bob_pos = N
    seconds = 0
    
    # Ітерація поки Аліса і Боб можуть зустрітись
    while alice_pos <= bob_pos:
        seconds += 1
        
        # Позиції Аліси на поточну секунду
        alice_pos = 1 + 2 * seconds  # Аліса може рухатися на 2 одиниці за кожну секунду
        alice_pos_alt = 1 + 3 * seconds  # або на 3 одиниці
        
        # Позиції Боба на поточну секунду
        bob_pos = N - 1 * seconds  # Боб може рухатися на 1 одиницю назад за кожну секунду
        bob_pos_alt = N - 2 * seconds  # або на 2 одиниці назад

        # Якщо вони можуть зустрітись в одному боксі
        if alice_pos == bob_pos or alice_pos == bob_pos_alt or alice_pos_alt == bob_pos or alice_pos_alt == bob_pos_alt:
            return seconds
    
    # Якщо не можемо знайти спільну позицію
    return -1

# Вхідні дані
N = int(input())

# Викликаємо функцію та виводимо результат
print(teleport(N))
