from collections import deque

def знайти_час(N):
    if N % 2 == 0:
        return -1  # Якщо кількість боксів парна, зустріч неможлива

    черга_аліси = deque([1])  # Початкова позиція Аліси
    черга_боба = deque([N])   # Початкова позиція Боба

    відвідані_алісою = {1}  # Відвідані позиції Аліси
    відвідані_бобом = {N}   # Відвідані позиції Боба

    час = 0

    while черга_аліси and черга_боба:
        час += 1

        # Рух Аліси
        for _ in range(len(черга_аліси)):
            поточна = черга_аліси.popleft()
            for нова_позиція in (поточна + 2, поточна + 3):
                if нова_позиція > N:
                    continue
                if нова_позиція in відвідані_бобом:  # Якщо Аліса зустріла Боба
                    return час
                if нова_позиція not in відвідані_алісою:
                    відвідані_алісою.add(нова_позиція)
                    черга_аліси.append(нова_позиція)

        # Рух Боба
        for _ in range(len(черга_боба)):
            поточна = черга_боба.popleft()
            for нова_позиція in (поточна - 1, поточна - 2):
                if нова_позиція < 1:
                    continue
                if нова_позиція in відвідані_алісою:  # Якщо Боб зустрів Алісу
                    return час
                if нова_позиція not in відвідані_бобом:
                    відвідані_бобом.add(нова_позиція)
                    черга_боба.append(нова_позиція)

    return -1  # Якщо зустріч неможлива

# Основна програма
N = int(input().strip())  # Читаємо одне число з вводу
print(знайти_час(N))  # Виводимо результат