def find_stamps(N, M):
    dp = [[False] * (M + 1) for _ in range(N + 1)]
    dp[0][0] = True

    for i in range(1, N + 1):
        for j in range(1, M + 1):
            dp[i][j] = dp[i - 1][j]
            if j >= i:
                dp[i][j] = dp[i][j] or dp[i - 1][j - i]

    # Якщо неможливо зібрати суму M
    if not dp[N][M]:
        return [0]

    # Відновлення вибраних марок
    result = []
    i, j = N, M
    while i > 0 and j > 0:
        if dp[i - 1][j]:
            i -= 1
        else:
            result.append(i)
            j -= i
    return result[::-1]

# Введення даних
N = int(input())
M = int(input())

# Виклик функції та виведення результату
result = find_stamps(N, M)
print(*result)
