def find_stamps(N, M):
    stamps = list(range(1, N + 1))
    result = []

    # Сортуємо марки за спаданням вартості
    stamps.sort(reverse=True)

    while M > 0 and stamps:
        # Бінарний пошук для знаходження найбільшої підходящої марки
        left, right = 0, len(stamps) - 1
        while left <= right:
            mid = (left + right) // 2
            if stamps[mid] <= M:
                right = mid - 1
            else:
                left = mid + 1
        
        if left == len(stamps):
            break  # Немає більше підходящих марок

        result.append(stamps[left])
        M -= stamps[left]

    if M == 0:
        print(" ".join(map(str, result)))
    else:
        print(0)