def min_teleportation_time(N):
    # Початкові позиції Аліси і Боба
    alice_position = 1
    bob_position = N
    
    # Час
    time = 0

    # Поки Аліса не наздогнала Боба
    while alice_position <= bob_position:
        time += 1
        
        # Рух Аліси: Аліса може стрибнути на 2 або 3
        alice_position = max(alice_position + 2, alice_position + 3)
        
        # Рух Боба: Боб може стрибнути на -1 або -2
        bob_position = min(bob_position - 1, bob_position - 2)
        
        # Перевірка чи зустрілись
        if alice_position >= bob_position:
            return time
        
    # Якщо вони не зустрілися
    return -1

# Вхідні дані
N = int(input().strip())

# Вивести результат
print(min_teleportation_time(N))