import math

def count_ones_in_memory(N, A, B):
    # Кількість комірок, які діляться на A
    count_A = N // A
    # Кількість комірок, які діляться на B
    count_B = N // B
    # Кількість комірок, які діляться на обидва A і B (тобто на їх НСК)
    lcm_AB = (A * B) // math.gcd(A, B)
    count_AB = N // lcm_AB
    
    # Загальна кількість одиниць
    return count_A + count_B - count_AB

# Вхідні дані
N = int(input())  # Кількість комірок
A, B = map(int, input().split())  # Числа A і B

# Викликаємо функцію і виводимо результат
print(count_ones_in_memory(N, A, B))
