def count_squares(N, grid):
    count = 0
    
    # Перебираємо усі пари точок для двох протилежних вершин квадрата
    for i1 in range(N):
        for j1 in range(N):
            for i2 in range(i1 + 1, N):
                for j2 in range(j1 + 1, N):
                    # Перевірка, чи ці дві точки можуть бути діагоналями квадрата
                    if (i2 - i1) == (j2 - j1):
                        # Координати всіх чотирьох вершин квадрата
                        r1 = grid[i1][j1]
                        r2 = grid[i1][j2]
                        r3 = grid[i2][j1]
                        r4 = grid[i2][j2]
                        # Якщо всі чотири вершини мають однаковий колір
                        if r1 == r2 == r3 == r4:
                            count += 1
    return count


# Вхідні дані
N = int(input())  # Розмір квадрата
grid = [list(map(int, input().split())) for _ in range(N)]

# Виведення результату
print(count_squares(N, grid))
