def count_squares(matrix):
    N = len(matrix)
    count = 0

    # Перевірка всіх можливих квадратів
    for i in range(N):
        for j in range(N):
            # Перевіряємо квадрати різних розмірів
            for size in range(1, min(N - i, N - j)):  # Розмір квадрата
                # Вершини квадрата
                if matrix[i][j] == matrix[i + size][j] == matrix[i][j + size] == matrix[i + size][j + size]:
                    count += 1

    return count

# Вхідні дані
N = int(input())
matrix = [list(map(int, input().split())) for _ in range(N)]

# Виведення результату
print(count_squares(matrix))
