def count_uniform_color_squares(n, grid):
    count = 0
    
    # Перебір можливих квадратів
    for size in range(1, n):  # Розмір квадрата (1x1, 2x2, ..., NxN)
        for i in range(n - size):
            for j in range(n - size):
                # Координати вершин квадрата
                top_left = grid[i][j]
                top_right = grid[i][j + size]
                bottom_left = grid[i + size][j]
                bottom_right = grid[i + size][j + size]
                
                # Перевірка, чи всі вершини мають однаковий колір
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1

    return count

# Зчитування вхідних даних
n = int(input())
grid = [list(map(int, input().split())) for _ in range(n)]

# Розрахунок результату
result = count_uniform_color_squares(n, grid)

# Виведення результату
print(result)