def solve(N):
    # Початкові умови
    a_pos = 1  # Аліса знаходиться в клітинці 1
    b_pos = N  # Боб знаходиться в клітинці N
    seconds = 0  # Лічильник секунд
    
    # Покроковий підхід до пошуку мінімальних секунд
    while a_pos <= b_pos:
        seconds += 1
        a_pos += 2  # Аліса рухається на 2 клітинки вперед
        b_pos -= 1  # Боб рухається на 1 клітинку назад
        
        if a_pos == b_pos:  # Якщо вони зустрілися
            return seconds
        
        if a_pos + 1 == b_pos:  # Якщо на наступній секунді вони зустрічаються
            return seconds + 1
    
    # Якщо вони не можуть зустрітися
    return -1

# Вхідні дані
N = int(input())  # Кількість боксів

# Виведення результату
print(solve(N))