def solve_case(N, blue_points, red_points):
    # Сортуємо сині та червоні точки
    blue_points_sorted = sorted(enumerate(blue_points, start=1), key=lambda x: (x[1][0], x[1][1]))
    red_points_sorted = sorted(enumerate(red_points, start=1), key=lambda x: (x[1][0], x[1][1]))
    
    # Виводимо індекси з'єднаних точок
    result = []
    for i in range(N):
        blue_index = blue_points_sorted[i][0]
        red_index = red_points_sorted[i][0]
        result.append((blue_index, red_index))
    
    return result

def main():
    t = int(input())  # Кількість тестових випадків
    for _ in range(t):
        N = int(input())  # Кількість точок одного кольору
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().split())) for _ in range(N)]
        
        result = solve_case(N, blue_points, red_points)
        
        # Якщо результат порожній, вивести 0
        if not result:
            print(0)
        else:
            for blue_index, red_index in result:
                print(blue_index, red_index)

if __name__ == "__main__":
    main()
