def solve_case(N, blue_points, red_points):
    # Сортуємо сині точки за x (по зростанню)
    blue_points_sorted = sorted(blue_points)
    
    # Сортуємо червоні точки за x (по зростанню)
    red_points_sorted = sorted(red_points)
    
    # Створимо список пар індексів синіх і червоних точок
    result = []
    for i in range(N):
        # Потрібно вивести індекси після сортування
        blue_idx = blue_points_sorted[i][2]  # індекс синьої точки
        red_idx = red_points_sorted[i][2]    # індекс червоної точки
        result.append((blue_idx, red_idx))
    
    return result

def main():
    t = int(input())  # кількість тестових блоків
    for _ in range(t):
        N = int(input())  # кількість точок одного кольору
        blue_points = []
        red_points = []
        
        # Читаємо координати синіх точок, додаючи до списку з індексами
        for i in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y, i + 1))  # зберігаємо координати та індекс
        
        # Читаємо координати червоних точок, додаючи до списку з індексами
        for i in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y, i + 1))  # зберігаємо координати та індекс
        
        # Викликаємо функцію для розв'язку кожного тесту
        result = solve_case(N, blue_points, red_points)
        
        # Виводимо результат для цього тесту
        for blue_idx, red_idx in result:
            print(blue_idx, red_idx)

# Викликаємо головну функцію
main()
