def find_president(N, a):
    # Створення словника для підрахунку частоти чисел
    count = {}
    
    # Підрахунок частоти кожного числа
    for num in a:
        if num in count:
            count[num] += 1
        else:
            count[num] = 1
    
    # Знайдемо мінімальне число, яке зустрічається один раз
    min_value = float('inf')
    
    for num in count:
        if count[num] == 1:
            min_value = min(min_value, num)
    
    # Якщо мінімальне число знайдено, виводимо його, інакше виводимо -1
    if min_value == float('inf'):
        return -1
    else:
        return min_value

# Читання вхідних даних
N = int(input())  # кількість роботів
a = list(map(int, input().split()))  # числа, згенеровані роботами

# Виведення результату
print(find_president(N, a))
