def count_same_color_squares(N, grid):
    count = 0
    for i in range(N - 1):
        for j in range(N - 1):
            if grid[i][j] == grid[i+1][j] == grid[i][j+1] == grid[i+1][j+1]:
                count += 1
    return count

# Input processing
N = int(input())
grid = []
for _ in range(N):
    row = list(map(int, input().split()))
    grid.append(row)

# Count the number of squares with same color vertices
result = count_same_color_squares(N, grid)
print(result)

