#include <iostream>
#include <queue>

int main() {
    int N, K;
    std::cin >> N >> K;

    std::queue<int> queue;

    // Додаємо непарні номери кубиків в чергу
    for (int i = 1; i <= N; i += 2) {
        queue.push(i);
    }

    // Додаємо парні номери кубиків в чергу
    for (int i = 2; i <= N; i += 2) {
        queue.push(i);
    }

    // Знаходимо позицію кубика з номером K
    int position = 0;
    while (!queue.empty()) {
        if (queue.front() == K) {
            break;
        }
        queue.pop();
        position++;
    }

    // Виводимо висоту вежі
    std::cout << position + 1 << std::endl;

    return 0;
}
