from itertools import combinations

def find_stamps(N, M):
    stamps = list(range(1, N + 1))
    best_combination = None
    
    for r in range(1, N + 1):
        for combination in combinations(stamps, r):
            if sum(combination) == M:
                if best_combination is None or len(combination) < len(best_combination):
                    best_combination = combination

    if best_combination is None:
        print(0)
    else:
        print(*best_combination)

N = int(input())
M = int(input())
find_stamps(N, M)
