import sys

def find_stamps(N, M):
    max_sum = N * (N + 1) // 2
    
    if M > max_sum:
        return [0]
    
    result = []
    
    for i in range(N, 0, -1):
        if M <= 0:
            break
        if M >= i:
            result.append(i)
            M -= i
    
    if M > 0:
        return [0]
    
    return result

N = int(sys.stdin.readline().strip())
M = int(sys.stdin.readline().strip())

result = find_stamps(N, M)

if result == [0]:
    sys.stdout.write("0\n")
else:
    sys.stdout.write(" ".join(map(str, result)) + "\n")