#include <iostream>
#include <vector>
#include <sstream>

using namespace std;

vector<int> find_stamps(int N, int M) {
    vector<int> result;
    result.reserve(N);

    for (int i = N; i > 0; --i) {
        if (M <= 0) {
            break;
        }
        if (M >= i) {
            result.push_back(i);
            M -= i;
        }
    }

    if (M > 0) {
        return {0};
    }

    return result;
}

int main() {
    int N, M;
    cin >> N >> M;

    vector<int> result = find_stamps(N, M);

    if (result[0] == 0) {
        cout << "0\n";
    } else {
        ostringstream oss;
        for (size_t i = 0; i < result.size(); ++i) {
            oss << result[i];
            if (i < result.size() - 1) {
                oss << " ";
            }
        }
        cout << oss.str() << "\n";
    }

    return 0;
}