#include <iostream>
#include <cstdio>

using namespace std;

void find_stamps(int N, int M) {
    if (M > (N * (N + 1)) / 2) {
        printf("0\n");
        return;
    }

    int result[100];
    int count = 0;

    for (int i = N; i > 0 && M > 0; --i) {
        if (M >= i) {
            result[count++] = i;
            M -= i;
        }
    }

    if (M > 0) {
        printf("0\n");
    } else {
        for (int i = 0; i < count; ++i) {
            printf("%d", result[i]);
            if (i < count - 1) {
                printf(" ");
            }
        }
        printf("\n");
    }
}

int main() {
    int N, M;
    scanf("%d %d", &N, &M);
    find_stamps(N, M);
    return 0;
}