#include <iostream>
#include <cstdio>
#include <vector>

using namespace std;

void find_stamps(int N, int M) {
    if (M > (N * (N + 1)) / 2) {
        printf("0\n");
        return;
    }

    vector<int> result;
    for (int i = N; i > 0 && M > 0; --i) {
        if (M >= i) {
            result.push_back(i);
            M -= i;
        }
    }

    if (M > 0) {
        printf("0\n");
    } else {
        for (size_t i = 0; i < result.size(); ++i) {
            printf("%d", result[i]);
            if (i < result.size() - 1) {
                printf(" ");
            }
        }
        printf("\n");
    }
}

int main() {
    int N, M;
    scanf("%d %d", &N, &M);
    find_stamps(N, M);
    return 0;
}