N = int(input())  # Розмір сітки
grid = [list(map(int, input().split())) for _ in range(N)]  # Сітка з кольорами (0 - синій, 1 - червоний)

count = 0  # Лічильник квадратів

# Перебираємо всі можливі квадрати
for size in range(1, N):  # Розмір квадрата від 1 до N-1
    for i in range(N - size):  # Початковий рядок
        for j in range(N - size):  # Початковий стовпець
            # Перевіряємо, чи всі чотири вершини мають однаковий колір
            color = grid[i][j]
            if (grid[i][j] == grid[i + size][j] == grid[i][j + size] == grid[i + size][j + size]):
                count += 1

print(count)
