def count_uniform_squares(N, colors):
    count = 0
    
    for size in range(1, N):
        for i in range(N - size):
            for j in range(N - size):
                top_left = colors[i][j]
                top_right = colors[i][j + size]
                bottom_left = colors[i + size][j]
                bottom_right = colors[i + size][j + size]
                
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1
    
    return count

N = int(input())
colors = [list(map(int, input().split())) for _ in range(N)]

result = count_uniform_squares(N, colors)
print(result)