#include <iostream>
#include <vector>

using namespace std;

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int count = 0;

    for (int size = 1; size <= N; ++size) {
        for (int i = 0; i <= N - size; ++i) {
            for (int j = 0; j <= N - size; ++j) {
                int color = grid[i][j];
                if (grid[i][j + size - 1] == color &&
                    grid[i + size - 1][j] == color &&
                    grid[i + size - 1][j + size - 1] == color) {
                    count++;
                }
            }
        }
    }

    cout << count << endl;
    return 0;
}