def count_uniform_squares(N, grid):
    count = 0

    for size in range(1, N + 1):
        for i in range(N - size + 1):
            for j in range(N - size + 1):
                color = grid[i][j]
                if (grid[i][j + size - 1] == color and
                    grid[i + size - 1][j] == color and
                    grid[i + size - 1][j + size - 1] == color):
                    count += 1

    return count

if __name__ == "__main__":
    N = int(input())
    grid = [list(map(int, input().split())) for _ in range(N)]

    result = count_uniform_squares(N, grid)
    print(result)