def count_uniform_squares(N, grid):
    count = 0

    for size in range(1, N):
        for i in range(N - size):
            for j in range(N - size):
                color = grid[i][j]
                if (grid[i][j + size] == color and
                    grid[i + size][j] == color and
                    grid[i + size][j + size] == color):
                    count += 1

    return count

if __name__ == "__main__":
    N = int(input())
    grid = [list(map(int, input().split())) for _ in range(N)]

    result = count_uniform_squares(N, grid)
    print(result)