def connect_points(test_cases):
    results = []
    
    for case in test_cases:
        N, blue_points, red_points = case
        connections = []
        
        # З'єднуємо точки по порядку
        for i in range(N):
            connections.append((i + 1, i + 1))  # (номер синьої точки, номер червоної точки)
        
        results.append(connections)
    
    return results

def main():
    import sys
    input = sys.stdin.read
    data = input().splitlines()
    
    index = 0
    t = int(data[index])
    index += 1
    test_cases = []
    
    for _ in range(t):
        N = int(data[index])
        index += 1
        
        blue_points = []
        for _ in range(N):
            x, y = map(int, data[index].split())
            blue_points.append((x, y))
            index += 1
        
        red_points = []
        for _ in range(N):
            x, y = map(int, data[index].split())
            red_points.append((x, y))
            index += 1
        
        test_cases.append((N, blue_points, red_points))
    
    results = connect_points(test_cases)
    
    for connections in results:
        for blue_index, red_index in connections:
            print(blue_index, red_index)

if __name__ == "__main__":
    main()