def solve(test_cases):
    results = []
    for case in test_cases:
        N, blue_points, red_points = case
        
        # Сортуємо точки
        sorted_blue = sorted((blue_points[i], i + 1) for i in range(N))
        sorted_red = sorted((red_points[i], i + 1) for i in range(N))
        
        connections = []
        for i in range(N):
            blue_point, blue_index = sorted_blue[i]
            red_point, red_index = sorted_red[i]
            connections.append((blue_index, red_index))
        
        results.append(connections)
    return results

def main():
    import sys
    input = sys.stdin.read
    data = input().splitlines()
    
    index = 0
    t = int(data[index])
    index += 1
    test_cases = []
    
    for _ in range(t):
        N = int(data[index])
        index += 1
        blue_points = []
        red_points = []
        
        for _ in range(N):
            x, y = map(int, data[index].split())
            blue_points.append((x, y))
            index += 1
        
        for _ in range(N):
            x, y = map(int, data[index].split())
            red_points.append((x, y))
            index += 1
        
        test_cases.append((N, blue_points, red_points))
    
    results = solve(test_cases)
    
    for connections in results:
        for blue_index, red_index in connections:
            print(blue_index, red_index)

if __name__ == "__main__":
    main()