var scanf = require('scanf');
var n = scanf('%d');
n = 6;

function minTeleportationTime(N) {
    const gcd = (a, b) => (b === 0 ? a : gcd(b, a % b)); 
    if ((N - 1) % gcd(2, 3) !== 0) return -1;

    let alicePos = 1;
    let bobPos = N;
    let time = 0;

    while (bobPos - alicePos > 2) {
        alicePos = Math.max(alicePos + 2, alicePos + 3);
        bobPos = Math.min(bobPos - 1, bobPos - 2);

        time++;
    }

    return time;
}

console.log(minTeleportationTime(n));