#include <iostream>

using namespace std;

int minTeleportationTime(int N) {
    if (N == 2) return -1;
    int alicePos = 1;
    int bobPos = N;
    int time = 0;

    while (bobPos - alicePos > 2) {
        alicePos = max(alicePos + 2, alicePos + 3);
        bobPos = min(bobPos - 1, bobPos - 2);
        time++;
    }

    return time;
}

int main() {
    int n;
    cin >> n;
    cout << minTeleportationTime(n) << endl;
    return 0;
}