#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n;
    cin >> n;

    vector<vector<int>> grid(n, vector<int>(n));
    vector<vector<int>> horizontal(n, vector<int>(n));
    vector<vector<int>> vertical(n, vector<int>(n));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> grid[i][j];
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (j > 0) {
                horizontal[i][j] = (grid[i][j] == grid[i][j - 1]) ? horizontal[i][j - 1] + 1 : 1;
            } else {
                horizontal[i][j] = 1;
            }
            if (i > 0) {
                vertical[i][j] = (grid[i][j] == grid[i - 1][j]) ? vertical[i - 1][j] + 1 : 1;
            } else {
                vertical[i][j] = 1;
            }
        }
    }

    int count = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            for (int len = 1; len <= min(horizontal[i][j], vertical[i][j]); ++len) {
                count++;
            }
        }
    }

    cout << count << endl;
    return 0;
}