#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n;
    cin >> n;

    vector<vector<int>> grid(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> grid[i][j];
        }
    }

    int count = 0;
    for (int i = 0; i < n - 1; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            if (grid[i][j] == grid[i + 1][j] && grid[i][j] == grid[i][j + 1]) {
                int len = 1;
                while (i + len < n && j + len < n && grid[i + len][j] == grid[i][j] && grid[i][j + len] == grid[i][j]) {
                    len++;
                }
                count += len - 1;
            }
        }
    }

    cout << count << endl;
    return 0;
}