#include <iostream>
#include <vector>
using namespace std;

int main() {
    long long n;
    cin >> n;

    vector<vector<long long>> grid(n, vector<long long>(n));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> grid[i][j];
        }
    }

    long long squareCount = 0;

    for (int x = 0; x < n; x++) {
        for (int y = 0; y < n; y++) {
            for (int dx = -n; dx < n; dx++) {
                for (int dy = -n; dy < n; dy++) {
                    if (dx == 0 && dy == 0) continue;
                    if (x + dx >= 0 && x + dx < n && y + dy >= 0 && y + dy < n &&
                        x + dx + dy >= 0 && x + dx + dy < n && y + dy - dx >= 0 && y + dy - dx < n &&
                        x + dy >= 0 && x + dy < n && y - dx >= 0 && y - dx < n) {
                        if (grid[x][y] == grid[x + dx][y + dy] &&
                            grid[x][y] == grid[x + dx + dy][y + dy - dx] &&
                            grid[x][y] == grid[x + dy][y - dx]) {
                            squareCount++;
                        }
                    }
                }
            }
        }
    }

    cout << squareCount / 4;

    return 0;
}
