#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Point {
    int x, y, index;

    Point(int x, int y, int index) : x(x), y(y), index(index) {}
    
    bool operator<(const Point &other) const {
        if (x == other.x) {
            return y < other.y;
        }
        return x < other.x;
    }
};

int main() {
    int t; 
    cin >> t;
    
    while (t--) {
        int N;
        cin >> N;
        
        vector<Point> blue, red;
        
        for (int i = 0; i < N; ++i) {
            int x, y;
            cin >> x >> y;
            blue.push_back(Point(x, y, i + 1)); 
        }
        
        for (int i = 0; i < N; ++i) {
            int x, y;
            cin >> x >> y;
            red.push_back(Point(x, y, i + 1)); 
        }
        
        sort(blue.begin(), blue.end());
        sort(red.begin(), red.end());
        
        for (int i = 0; i < N; ++i) {
            cout << blue[i].index << " " << red[i].index << endl;
        }
    }
    
    return 0;
}
