#include <bits/stdc++.h>
using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int N; cin >> N;
    vector<vector<int>> color(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> color[i][j];
        }
    }

    long long ans = 0;
    for (int x1 = 0; x1 < N; ++x1) {
        for (int y1 = 0; y1 < N; ++y1) {
            for (int x2 = x1; x2 < N; ++x2) {
                int startY = (x2 == x1) ? y1+1 : 0;
                for (int y2 = startY; y2 < N; ++y2) {
                    if (color[x1][y1] != color[x2][y2]) continue;
                    if (((x1 + x2) % 2 != 0) || ((y1 + y2) % 2 != 0)) continue;
                    int mx = (x1 + x2) / 2; 
                    int my = (y1 + y2) / 2;
                    int dx = x2 - x1;
                    int dy = y2 - y1;
                    if (dx % 2 != 0 || dy % 2 != 0) continue;
                    int x3 = mx + dy/2;
                    int y3 = my - dx/2;
                    int x4 = mx - dy/2;
                    int y4 = my + dx/2;
                    if (x3 < 0 || x3 >= N || y3 < 0 || y3 >= N) continue;
                    if (x4 < 0 || x4 >= N || y4 < 0 || y4 >= N) continue;
                    if (color[x3][y3] == color[x1][y1] && color[x4][y4] == color[x1][y1]) ans++;
                }
            }
        }
    }

    cout << ans / 2 << "\n";
    return 0;
}