#include <bits/stdc++.h>
using namespace std;

struct Point {
    int x, y, idx;
};

bool cmp(Point a, Point b) {
    return atan2(a.y, a.x) < atan2(b.y, b.x);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        int n;
        cin >> n;

        vector<Point> blue(n), red(n);

        for (int i = 0; i < n; ++i) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].idx = i + 1;
        }
        for (int i = 0; i < n; ++i) {
            cin >> red[i].x >> red[i].y;
            red[i].idx = i + 1;
        }

        sort(blue.begin(), blue.end(), [](Point a, Point b) {
            return a.y == b.y ? a.x < b.x : a.y < b.y;
        });
        sort(red.begin(), red.end(), [](Point a, Point b) {
            return a.y == b.y ? a.x < b.x : a.y < b.y;
        });

        for (int i = 0; i < n; ++i) {
            cout << blue[i].idx << " " << red[i].idx << "\n";
        }
    }

    return 0;
}