import sys
input = sys.stdin.read

def solve():
    data = input().strip().split()
    idx = 0
    t = int(data[idx])
    idx += 1
    results = []

    for _ in range(t):
        N = int(data[idx])
        idx += 1
        blue_points = []
        red_points = []

        for i in range(N):
            x, y = int(data[idx]), int(data[idx + 1])
            blue_points.append((x, y, i + 1))
            idx += 2

        for i in range(N):
            x, y = int(data[idx]), int(data[idx + 1])
            red_points.append((x, y, i + 1))
            idx += 2

        blue_points.sort()
        red_points.sort()

        result = []
        for i in range(N):
            result.append((blue_points[i][2], red_points[i][2]))

        results.append(result)

    for result in results:
        if len(result) == 0:
            print(0)
        else:
            for blue_index, red_index in result:
                print(blue_index, red_index)

if __name__ == "__main__":
    solve()
