\#include <iostream>
#include <vector>
#include <algorithm>

struct Point {
    int x, y, id;
};

bool comparePoints(const Point& a, const Point& b) {
    return (a.x < b.x) || (a.x == b.x && a.y < b.y);
}

int main() {
    int t;
    std::cin >> t;
    while (t--) {
        int N;
        std::cin >> N;
        std::vector<Point> blue(N), red(N);
        for (int i = 0; i < N; ++i) {
            std::cin >> blue[i].x >> blue[i].y;
            blue[i].id = i + 1;
        }
        for (int i = 0; i < N; ++i) {
            std::cin >> red[i].x >> red[i].y;
            red[i].id = i + 1;
        }
        std::sort(blue.begin(), blue.end(), comparePoints);
        std::sort(red.begin(), red.end(), comparePoints);
        for (int i = 0; i < N; ++i) {
            std::cout << blue[i].id << " " << red[i].id << "\n";
        }
    }
    return 0;
}