from collections import deque
def min_time_to_meet(N):
    if N == 2:
        return -1
    a, b = deque([1]), deque([N])
    visited_a, visited_b = set([1]), set([N])
    t = 0
    while a and b:
        t += 1
        for _ in range(len(a)):
            x = a.popleft()
            if x + 2 <= N and x + 2 not in visited_a:
                visited_a.add(x + 2)
                a.append(x + 2)
            if x + 3 <= N and x + 3 not in visited_a:
                visited_a.add(x + 3)
                a.append(x + 3)
        for _ in range(len(b)):
            x = b.popleft()
            if x - 1 >= 1 and x - 1 not in visited_b:
                visited_b.add(x - 1)
                b.append(x - 1)
            if x - 2 >= 1 and x - 2 not in visited_b:
                visited_b.add(x - 2)
                b.append(x - 2)
        if visited_a & visited_b:
            return t
    return -1
N = int(input())
print(min_time_to_meet(N))
