#include <iostream>
#include <set>
using namespace std;
int min_time_to_meet(int N) {
    set<int> alice_positions = {1};
    set<int> bob_positions = {N}; 
    int t = 0;

    while (!alice_positions.empty() && !bob_positions.empty()) {
        t++;
        set<int> new_alice_positions;
        set<int> new_bob_positions;
        for (int pos : alice_positions) {
            if (pos + 2 <= N) new_alice_positions.insert(pos + 2);
            if (pos + 3 <= N) new_alice_positions.insert(pos + 3);
        }
        for (int pos : bob_positions) {
            if (pos - 1 >= 1) new_bob_positions.insert(pos - 1);
            if (pos - 2 >= 1) new_bob_positions.insert(pos - 2);
        }
        for (int pos : new_alice_positions) {
            if (new_bob_positions.count(pos)) {
                return t;
            }
        }
        alice_positions = new_alice_positions;
        bob_positions = new_bob_positions;
    }
    return -1; 
}
int main() {
    int N;
    cin >> N;
    cout << min_time_to_meet(N) << endl;
}
