def count_squares(N, grid):
    return sum(
        grid[x1][y1] == grid[x2][y2] == grid[x1][y2] == grid[x2][y1]
        for x1 in range(N) for y1 in range(N)
        for x2 in range(x1+1, N) for y2 in range(y1+1, N)
        if x2 - x1 == y2 - y1
    )

N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]
print(count_squares(N, grid))

