#include <iostream>
#include <vector>
using namespace std;
int count_uniform_squares(int N, const vector<vector<int>>& grid) {
    int count = 0;
    for (int i = 0; i < N - 1; ++i) { 
        for (int j = 0; j < N - 1; ++j){
            int top_left = grid[i][j];
            int top_right = grid[i][j + 1];
            int bottom_left = grid[i + 1][j];
            int bottom_right = grid[i + 1][j + 1];
            if (top_left == top_right && top_left == bottom_left && top_left == bottom_right) {
                ++count;
           }
        }
    }
    return count;
}
int main() {
    int N;
    cin >> N;
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
    }
    }
    cout << count_uniform_squares(N, grid) << endl;
    return 0;
}
