#include <iostream>
#include <vector>
using namespace std;
int count_uniform_squares(int N, const vector<vector<int>>& grid){
    int count = 0;
    for (int size = 2; size <= N; ++size) {
        for (int i = 0; i <= N - size; ++i){
            for (int j = 0; j <= N - size; ++j) {
                bool is_uniform = true;
                int color = grid[i][j];
                for (int x = i; x < i + size; ++x) {
                    for (int y = j; y < j + size; ++y) {
                        if (grid[x][y] != color) {
                            is_uniform = false;
                            break;
                        }
                    }
                    if (!is_uniform) break;
                 }
                if (is_uniform) {
                    ++count;
                }
            }
        }
    }
    return count;
}
int main(){
    int N;
    cin >> N;
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }
    cout << count_uniform_squares(N, grid) << endl;
    return 0;
}
