#include <iostream>
#include <queue>
#include <unordered_set>
using namespace std;


struct State {
    int alice_pos, bob_pos, seconds;
};

int main() {
    int N;
    cin >> N;

    
    if (N == 2) {
        cout << 1 << endl;
        return 0;
    }

    
    queue<State> q;
    q.push({1, N, 0});

    
    unordered_set<int> alice_visited;
    unordered_set<int> bob_visited;

    alice_visited.insert(1);
    bob_visited.insert(N);

   
    while (!q.empty()) {
        State state = q.front();
        q.pop();

        int alice_pos = state.alice_pos;
        int bob_pos = state.bob_pos;
        int seconds = state.seconds;

        
        if (alice_pos == bob_pos) {
            cout << seconds << endl;
            return 0;
        }

        
        if (alice_pos + 2 <= N && alice_visited.find(alice_pos + 2) == alice_visited.end()) {
            alice_visited.insert(alice_pos + 2);
            q.push({alice_pos + 2, bob_pos, seconds + 1});
        }
        if (alice_pos + 3 <= N && alice_visited.find(alice_pos + 3) == alice_visited.end()) {
            alice_visited.insert(alice_pos + 3);
            q.push({alice_pos + 3, bob_pos, seconds + 1});
        }

      
        if (bob_pos - 1 >= 1 && bob_visited.find(bob_pos - 1) == bob_visited.end()) {
            bob_visited.insert(bob_pos - 1);
            q.push({alice_pos, bob_pos - 1, seconds + 1});
        }
        if (bob_pos - 2 >= 1 && bob_visited.find(bob_pos - 2) == bob_visited.end()) {
            bob_visited.insert(bob_pos - 2);
            q.push({alice_pos, bob_pos - 2, seconds + 1});
        }
    }

   
    cout << -1 << endl;

    return 0;
}