#include <iostream>
#include <vector>
#include <climits>  
using namespace std;

int main() {
    int N, M;
    cin >> N >> M;


    vector<int> dp(M + 1, INT_MAX);
    vector<int> parent(M + 1, -1);   
    dp[0] = 0; 

    for (int i = 1; i <= N; ++i) {
        for (int j = M; j >= i; --j) {
            if (dp[j - i] != INT_MAX && dp[j - i] + 1 < dp[j]) {
                dp[j] = dp[j - i] + 1;  
                parent[j] = i;           
            }
        }
    }

   
    if (dp[M] == INT_MAX) {
        cout << 0 << endl;
    } else {
        vector<int> result;
        int sum = M;
        while (sum > 0) {
            result.push_back(parent[sum]);  
            sum -= parent[sum]; 
        }

        
        for (int i = 0; i < result.size(); ++i) {
            cout << result[i] << " ";
        }
        cout << endl;
    }

    return 0;
}