def find_president(N, numbers):
    from collections import Counter

    # Рахуємо кількість появ кожного числа
    counts = Counter(numbers)

    # Знаходимо всі унікальні числа
    unique_numbers = [num for num, count in counts.items() if count == 1]

    # Якщо немає унікальних чисел, вибори не відбудуться
    if not unique_numbers:
        return -1

    # Повертаємо мінімальне з унікальних чисел
    return min(unique_numbers)

# Ввід
N = int(input())
numbers = list(map(int, input().split()))

# Вивід
print(find_president(N, numbers))
