def count_uniform_squares(N, grid):
    count = 0
    
    # Перебираємо всі можливі квадрати
    for size in range(1, N):  # Розмір квадратів від 1 до N-1
        for i in range(N - size):  # Верхня ліва координата по y
            for j in range(N - size):  # Верхня ліва координата по x
                # Координати вершин квадрата
                top_left = grid[i][j]
                top_right = grid[i][j + size]
                bottom_left = grid[i + size][j]
                bottom_right = grid[i + size][j + size]
                
                # Перевіряємо, чи всі вершини одного кольору
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1
                    
    return count

# Ввід
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Вивід
print(count_uniform_squares(N, grid))
